/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],we=function(J){for(var e=[],m=0,i=J.length;m<i;m++)e[m]=ve[J[m]];return e};define(ve[56],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(i,y){if(!i)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=m}),define(ve[73],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(P){return P?P.replace(/\$\((.*?)\)/g,(D,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=m;class i{constructor(D,_,I){this.id=D,this.definition=_,this.description=I,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function y(P,D){const _=["codicon","codicon-"+P];return D&&_.push("codicon-modifier-"+D),_}e.getClassNamesArray=y;var C;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function _(T){if(T instanceof i)return["codicon","codicon-"+T.id];const l=D.exec(T.id);if(!l)return _(i.error);let[,E,h]=l;const p=["codicon","codicon-"+E];return h&&p.push("codicon-modifier-"+h.substr(1)),p}P.asClassNameArray=_;function I(T){return _(T).join(" ")}P.asClassName=I;function L(T){return"."+_(T).join(".")}P.asCSSSelector=L})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[74],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function i(L){const T=[];for(let l in L)m.call(L,l)&&T.push(L[l]);return T}e.values=i;function y(L,T){for(let l in L)if(m.call(L,l)&&T({key:l,value:L[l]},function(){delete L[l]})===!1)return}e.forEach=y;function C(L,T){const l=Object.create(null);for(const E of L){const h=T(E);let p=l[h];p||(p=l[h]=[]),p.push(E)}return l}e.groupBy=C;function P(L){const T=Object.create(null);return L&&L.forEach((l,E)=>{T[E]=l}),T}e.fromMap=P;function D(L,T){const l=[],E=[];for(let h of L)T.has(h)||l.push(h);for(let h of T)L.has(h)||E.push(h);return{removed:l,added:E}}e.diffSets=D;function _(L,T){const l=[],E=[];for(let[h,p]of L)T.has(h)||l.push(p);for(let[h,p]of T)L.has(h)||E.push(p);return{removed:l,added:E}}e.diffMaps=_;class I{constructor(){this.map=new Map}add(T,l){let E=this.map.get(T);E||(E=new Set,this.map.set(T,E)),E.add(l)}delete(T,l){const E=this.map.get(T);!E||(E.delete(l),E.size===0&&this.map.delete(T))}forEach(T,l){const E=this.map.get(T);!E||E.forEach(l)}}e.SetMap=I}),define(ve[57],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(P){return(D,_,I)=>{let L=null,T=null;if(typeof I.value=="function"?(L="value",T=I.value):typeof I.get=="function"&&(L="get",T=I.get),!T)throw new Error("not supported");I[L]=P(T,_)}}e.createDecorator=m;function i(P,D,_){let I=null,L=null;if(typeof _.value=="function"?(I="value",L=_.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",L=_.get),!L)throw new Error("not supported");const T=`$memoize$${D}`;_[I]=function(...l){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,l)}),this[T]}}e.memoize=i;function y(P,D,_){return m((I,L)=>{const T=`$debounce$${L}`,l=`$debounce$result$${L}`;return function(...E){this[l]||(this[l]=_?_():void 0),clearTimeout(this[T]),D&&(this[l]=D(this[l],...E),E=[this[l]]),this[T]=setTimeout(()=>{I.apply(this,E),this[l]=_?_():void 0},P)}})}e.debounce=y;function C(P,D,_){return m((I,L)=>{const T=`$throttle$timer$${L}`,l=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,h=`$throttle$pending$${L}`;return function(...p){if(this[l]||(this[l]=_?_():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),D&&(this[l]=D(this[l],...p)),this[h])return;const v=this[E]+P;v<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[l]]),this[l]=_?_():void 0):(this[h]=!0,this[T]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),I.apply(this,[this[l]]),this[l]=_?_():void 0},v-Date.now()))}})}e.throttle=C}),define(ve[15],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(S=>{S(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=m,e.errorHandler=new m;function i(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=i;function y(g){_(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=y;function C(g){_(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function P(g){if(g instanceof Error){let{name:a,message:S}=g;const n=g.stacktrace||g.stack;return{$isError:!0,name:a,message:S,stack:n}}return g}e.transformErrorForSerialization=P;const D="Canceled";function _(g){return g instanceof Error&&g.name===D&&g.message===D}e.isPromiseCanceledError=_;class I extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=I;function L(){const g=new Error(D);return g.name=g.message,g}e.canceled=L;function T(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=T;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function E(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(g){const a=new Error(`${g} has been disposed`);return a.name="DISPOSED",a}e.disposed=h;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class v extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=v;class A extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=A;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function s(g){const a=g;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=s;function o(g,a=Object.create(null)){const S=new Error(g);return a.actions&&(S.actions=a.actions),S}e.createErrorWithActions=o}),define(ve[16],we([0,1,15]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(Y,fe=0){return Y[Y.length-(1+fe)]}e.tail=i;function y(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.tail2=y;function C(Y,fe,me=(Se,Ie)=>Se===Ie){if(Y===fe)return!0;if(!Y||!fe||Y.length!==fe.length)return!1;for(let Se=0,Ie=Y.length;Se<Ie;Se++)if(!me(Y[Se],fe[Se]))return!1;return!0}e.equals=C;function P(Y,fe,me){let Se=0,Ie=Y.length-1;for(;Se<=Ie;){const Oe=(Se+Ie)/2|0,We=me(Y[Oe],fe);if(We<0)Se=Oe+1;else if(We>0)Ie=Oe-1;else return Oe}return-(Se+1)}e.binarySearch=P;function D(Y,fe){let me=0,Se=Y.length;if(Se===0)return 0;for(;me<Se;){const Ie=Math.floor((me+Se)/2);fe(Y[Ie])?Se=Ie:me=Ie+1}return me}e.findFirstInSorted=D;function _(Y,fe,me){if(Y=Y|0,Y>=fe.length)throw new TypeError("invalid index");let Se=fe[Math.floor(fe.length*Math.random())],Ie=[],Oe=[],We=[];for(let j of fe){const Z=me(j,Se);Z<0?Ie.push(j):Z>0?Oe.push(j):We.push(j)}return Y<Ie.length?_(Y,Ie,me):Y<Ie.length+We.length?We[0]:_(Y-(Ie.length+We.length),Oe,me)}e.quickSelect=_;function I(Y,fe){const me=[];let Se;for(const Ie of Y.slice(0).sort(fe))!Se||fe(Se[0],Ie)!==0?(Se=[Ie],me.push(Se)):Se.push(Ie);return me}e.groupBy=I;function L(Y,fe,me){const Se=[];function Ie(j,Z,re){if(Z===0&&re.length===0)return;const ue=Se[Se.length-1];ue&&ue.start+ue.deleteCount===j?(ue.deleteCount+=Z,ue.toInsert.push(...re)):Se.push({start:j,deleteCount:Z,toInsert:re})}let Oe=0,We=0;for(;;){if(Oe===Y.length){Ie(Oe,0,fe.slice(We));break}if(We===fe.length){Ie(Oe,Y.length-Oe,[]);break}const j=Y[Oe],Z=fe[We],re=me(j,Z);re===0?(Oe+=1,We+=1):re<0?(Ie(Oe,1,[]),Oe+=1):re>0&&(Ie(Oe,0,[Z]),We+=1)}return Se}e.sortedDiff=L;function T(Y,fe,me){const Se=L(Y,fe,me),Ie=[],Oe=[];for(const We of Se)Ie.push(...Y.slice(We.start,We.start+We.deleteCount)),Oe.push(...We.toInsert);return{removed:Ie,added:Oe}}e.delta=T;function l(Y,fe,me){if(me===0)return[];const Se=Y.slice(0,me).sort(fe);return h(Y,fe,Se,me,Y.length),Se}e.top=l;function E(Y,fe,me,Se,Ie){return me===0?Promise.resolve([]):new Promise((Oe,We)=>{(async()=>{const j=Y.length,Z=Y.slice(0,me).sort(fe);for(let re=me,ue=Math.min(me+Se,j);re<j;re=ue,ue=Math.min(ue+Se,j)){if(re>me&&await new Promise(te=>setTimeout(te)),Ie&&Ie.isCancellationRequested)throw(0,m.canceled)();h(Y,fe,Z,re,ue)}return Z})().then(Oe,We)})}e.topAsync=E;function h(Y,fe,me,Se,Ie){for(const Oe=me.length;Se<Ie;Se++){const We=Y[Se];if(fe(We,me[Oe-1])<0){me.pop();const j=D(me,Z=>fe(We,Z)<0);me.splice(j,0,We)}}}function p(Y){return Y.filter(fe=>!!fe)}e.coalesce=p;function v(Y){let fe=0;for(let me=0;me<Y.length;me++)Y[me]&&(Y[fe]=Y[me],fe+=1);Y.length=fe}e.coalesceInPlace=v;function A(Y,fe,me){Y.splice(me,0,Y.splice(fe,1)[0])}e.move=A;function w(Y){return!Array.isArray(Y)||Y.length===0}e.isFalsyOrEmpty=w;function s(Y){return Array.isArray(Y)&&Y.length>0}e.isNonEmptyArray=s;function o(Y,fe=me=>me){const me=new Set;return Y.filter(Se=>{const Ie=fe(Se);return me.has(Ie)?!1:(me.add(Ie),!0)})}e.distinct=o;function g(Y){const fe=Object.create(null);return me=>{const Se=Y(me);return fe[Se]?!1:(fe[Se]=!0,!0)}}e.uniqueFilter=g;function a(Y,fe){const me=S(Y,fe);if(me!==-1)return Y[me]}e.findLast=a;function S(Y,fe){for(let me=Y.length-1;me>=0;me--){const Se=Y[me];if(fe(Se))return me}return-1}e.lastIndex=S;function n(Y,fe){return Y.length>0?Y[0]:fe}e.firstOrDefault=n;function t(Y,fe,me=(Se,Ie)=>Se===Ie){let Se=0;for(let Ie=0,Oe=Math.min(Y.length,fe.length);Ie<Oe&&me(Y[Ie],fe[Ie]);Ie++)Se++;return Se}e.commonPrefixLength=t;function r(Y){return[].concat(...Y)}e.flatten=r;function u(Y,fe){let me=typeof fe=="number"?Y:0;typeof fe=="number"?me=Y:(me=0,fe=Y);const Se=[];if(me<=fe)for(let Ie=me;Ie<fe;Ie++)Se.push(Ie);else for(let Ie=me;Ie>fe;Ie--)Se.push(Ie);return Se}e.range=u;function c(Y,fe,me){return Y.reduce((Se,Ie)=>(Se[fe(Ie)]=me?me(Ie):Ie,Se),Object.create(null))}e.index=c;function f(Y,fe){return Y.push(fe),()=>b(Y,fe)}e.insert=f;function b(Y,fe){const me=Y.indexOf(fe);if(me>-1)return Y.splice(me,1),fe}e.remove=b;function d(Y,fe,me){const Se=Y.slice(0,fe),Ie=Y.slice(fe);return Se.concat(me,Ie)}e.arrayInsert=d;function k(Y,fe){let me;if(typeof fe=="number"){let Se=fe;me=()=>{const Ie=Math.sin(Se++)*179426549;return Ie-Math.floor(Ie)}}else me=Math.random;for(let Se=Y.length-1;Se>0;Se-=1){const Ie=Math.floor(me()*(Se+1)),Oe=Y[Se];Y[Se]=Y[Ie],Y[Ie]=Oe}}e.shuffle=k;function R(Y,fe){const me=Y.indexOf(fe);me>-1&&(Y.splice(me,1),Y.unshift(fe))}e.pushToStart=R;function N(Y,fe){const me=Y.indexOf(fe);me>-1&&(Y.splice(me,1),Y.push(fe))}e.pushToEnd=N;function B(Y,fe){return Array.isArray(Y)?Y.map(fe):fe(Y)}e.mapArrayOrNot=B;function F(Y){return Array.isArray(Y)?Y:[Y]}e.asArray=F;function U(Y){return Y[Math.floor(Math.random()*Y.length)]}e.getRandomElement=U;function H(Y,fe){for(const me of Y){const Se=fe(me);if(Se!==void 0)return Se}}e.mapFind=H;function x(Y,fe,me){const Se=W(Y,fe),Ie=Y.length,Oe=me.length;Y.length=Ie+Oe;for(let We=Ie-1;We>=Se;We--)Y[We+Oe]=Y[We];for(let We=0;We<Oe;We++)Y[We+Se]=me[We]}e.insertInto=x;function M(Y,fe,me,Se){const Ie=W(Y,fe),Oe=Y.splice(Ie,me);return x(Y,Ie,Se),Oe}e.splice=M;function W(Y,fe){return fe<0?Math.max(fe+Y.length,0):Math.min(fe,Y.length)}function z(Y,fe){return(me,Se)=>fe(Y(me),Y(Se))}e.compareBy=z;const O=(Y,fe)=>Y-fe;e.numberComparator=O;function V(Y,fe){if(Y.length===0)return;let me=Y[0];for(let Se=1;Se<Y.length;Se++){const Ie=Y[Se];fe(Ie,me)>0&&(me=Ie)}return me}e.findMaxBy=V;function K(Y,fe){if(Y.length===0)return;let me=Y[0];for(let Se=1;Se<Y.length;Se++){const Ie=Y[Se];fe(Ie,me)>=0&&(me=Ie)}return me}e.findLastMaxBy=K;function G(Y,fe){return V(Y,(me,Se)=>-fe(me,Se))}e.findMinBy=G;class Q{constructor(fe){this.items=fe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(fe){let me=this.firstIdx;for(;me<this.items.length&&fe(this.items[me]);)me++;const Se=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,Se}takeFromEndWhile(fe){let me=this.lastIdx;for(;me>=0&&fe(this.items[me]);)me--;const Se=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,Se}peek(){return this.items[this.firstIdx]}dequeue(){const fe=this.items[this.firstIdx];return this.firstIdx++,fe}takeCount(fe){const me=this.items.slice(this.firstIdx,this.firstIdx+fe);return this.firstIdx+=fe,me}}e.ArrayQueue=Q}),define(ve[75],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(i){const y=this;let C=!1,P;return function(){return C||(C=!0,P=i.apply(y,arguments)),P}}e.once=m}),define(ve[76],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(ve[77],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(i){function y(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}i.is=y;const C=Object.freeze([]);function P(){return C}i.empty=P;function*D(g){yield g}i.single=D;function _(g){return g||C}i.from=_;function I(g){return!g||g[Symbol.iterator]().next().done===!0}i.isEmpty=I;function L(g){return g[Symbol.iterator]().next().value}i.first=L;function T(g,a){for(const S of g)if(a(S))return!0;return!1}i.some=T;function l(g,a){for(const S of g)if(a(S))return S}i.find=l;function*E(g,a){for(const S of g)a(S)&&(yield S)}i.filter=E;function*h(g,a){let S=0;for(const n of g)yield a(n,S++)}i.map=h;function*p(...g){for(const a of g)for(const S of a)yield S}i.concat=p;function*v(g){for(const a of g)for(const S of a)yield S}i.concatNested=v;function A(g,a,S){let n=S;for(const t of g)n=a(n,t);return n}i.reduce=A;function*w(g,a,S=g.length){for(a<0&&(a+=g.length),S<0?S+=g.length:S>g.length&&(S=g.length);a<S;a++)yield g[a]}i.slice=w;function s(g,a=Number.POSITIVE_INFINITY){const S=[];if(a===0)return[S,g];const n=g[Symbol.iterator]();for(let t=0;t<a;t++){const r=n.next();if(r.done)return[S,i.empty()];S.push(r.value)}return[S,{[Symbol.iterator](){return n}}]}i.consume=s;function o(g,a,S=(n,t)=>n===t){const n=g[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const r=n.next(),u=t.next();if(r.done!==u.done)return!1;if(r.done)return!0;if(!S(r.value,u.value))return!1}}i.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(ve[58],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var i;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(a){a.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function P(a,S=!1){let n=0,t=a.length,r="",u=0,c=16,f=0;function b(U){let H=0,x=0;for(;H<U;){const M=a.charCodeAt(n);if(M>=48&&M<=57)x=x*16+M-48;else if(M>=65&&M<=70)x=x*16+M-65+10;else if(M>=97&&M<=102)x=x*16+M-97+10;else break;n++,H++}return H<U&&(x=-1),x}function d(U){n=U,r="",u=0,c=16,f=0}function k(){const U=n;if(a.charCodeAt(n)===48)n++;else for(n++;n<a.length&&I(a.charCodeAt(n));)n++;if(n<a.length&&a.charCodeAt(n)===46)if(n++,n<a.length&&I(a.charCodeAt(n)))for(n++;n<a.length&&I(a.charCodeAt(n));)n++;else return f=3,a.substring(U,n);let H=n;if(n<a.length&&(a.charCodeAt(n)===69||a.charCodeAt(n)===101))if(n++,(n<a.length&&a.charCodeAt(n)===43||a.charCodeAt(n)===45)&&n++,n<a.length&&I(a.charCodeAt(n))){for(n++;n<a.length&&I(a.charCodeAt(n));)n++;H=n}else f=3;return a.substring(U,H)}function R(){let U="",H=n;for(;;){if(n>=t){U+=a.substring(H,n),f=2;break}const x=a.charCodeAt(n);if(x===34){U+=a.substring(H,n),n++;break}if(x===92){if(U+=a.substring(H,n),n++,n>=t){f=2;break}switch(a.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const W=b(4);W>=0?U+=String.fromCharCode(W):f=4;break}default:f=5}H=n;continue}if(x>=0&&x<=31)if(_(x)){U+=a.substring(H,n),f=2;break}else f=6;n++}return U}function N(){if(r="",f=0,u=n,n>=t)return u=t,c=17;let U=a.charCodeAt(n);if(D(U)){do n++,r+=String.fromCharCode(U),U=a.charCodeAt(n);while(D(U));return c=15}if(_(U))return n++,r+=String.fromCharCode(U),U===13&&a.charCodeAt(n)===10&&(n++,r+=`
`),c=14;switch(U){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,r=R(),c=10;case 47:{const H=n-1;if(a.charCodeAt(n+1)===47){for(n+=2;n<t&&!_(a.charCodeAt(n));)n++;return r=a.substring(H,n),c=12}if(a.charCodeAt(n+1)===42){n+=2;const x=t-1;let M=!1;for(;n<x;){if(a.charCodeAt(n)===42&&a.charCodeAt(n+1)===47){n+=2,M=!0;break}n++}return M||(n++,f=1),r=a.substring(H,n),c=13}return r+=String.fromCharCode(U),n++,c=16}case 45:if(r+=String.fromCharCode(U),n++,n===t||!I(a.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=k(),c=11;default:for(;n<t&&B(U);)n++,U=a.charCodeAt(n);if(u!==n){switch(r=a.substring(u,n),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(U),n++,c=16}}function B(U){if(D(U)||_(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:d,getPosition:()=>n,scan:S?F:N,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>u,getTokenLength:()=>n-u,getTokenError:()=>f}}e.createScanner=P;function D(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function _(a){return a===10||a===13||a===8232||a===8233}function I(a){return a>=48&&a<=57}var L;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(L||(L={}));function T(a,S){const n=[],t=new Object;let r;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function f(b,d,k,R){u.value=b,u.offset=d,u.length=k,u.type=R,u.colonOffset=void 0,r=u}try{s(a,{onObjectBegin:(b,d)=>{if(S<=b)throw t;r=void 0,c=S>b,n.push("")},onObjectProperty:(b,d,k)=>{if(S<d||(f(b,d,k,"property"),n[n.length-1]=b,S<=d+k))throw t},onObjectEnd:(b,d)=>{if(S<=b)throw t;r=void 0,n.pop()},onArrayBegin:(b,d)=>{if(S<=b)throw t;r=void 0,n.push(0)},onArrayEnd:(b,d)=>{if(S<=b)throw t;r=void 0,n.pop()},onLiteralValue:(b,d,k)=>{if(S<d||(f(b,d,k,g(b)),S<=d+k))throw t},onSeparator:(b,d,k)=>{if(S<=d)throw t;if(b===":"&&r&&r.type==="property")r.colonOffset=d,c=!1,r=void 0;else if(b===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(b){if(b!==t)throw b}return{path:n,previousNode:r,isAtPropertyKey:c,matches:b=>{let d=0;for(let k=0;d<b.length&&k<n.length;k++)if(b[d]===n[k]||b[d]==="*")d++;else if(b[d]!=="**")return!1;return d===b.length}}}e.getLocation=T;function l(a,S=[],n=C.DEFAULT){let t=null,r=[];const u=[];function c(b){Array.isArray(r)?r.push(b):t!==null&&(r[t]=b)}return s(a,{onObjectBegin:()=>{const b={};c(b),u.push(r),r=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const b=[];c(b),u.push(r),r=b,t=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:c,onError:(b,d,k)=>{S.push({error:b,offset:d,length:k})}},n),r[0]}e.parse=l;function E(a,S=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(b){t.type==="property"&&(t.length=b-t.offset,t=t.parent)}function u(b){return t.children.push(b),b}s(a,{onObjectBegin:b=>{t=u({type:"object",offset:b,length:-1,parent:t,children:[]})},onObjectProperty:(b,d,k)=>{t=u({type:"property",offset:d,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:b,offset:d,length:k,parent:t})},onObjectEnd:(b,d)=>{t.length=b+d-t.offset,t=t.parent,r(b+d)},onArrayBegin:(b,d)=>{t=u({type:"array",offset:b,length:-1,parent:t,children:[]})},onArrayEnd:(b,d)=>{t.length=b+d-t.offset,t=t.parent,r(b+d)},onLiteralValue:(b,d,k)=>{u({type:g(b),offset:d,length:k,parent:t,value:b}),r(d+k)},onSeparator:(b,d,k)=>{t.type==="property"&&(b===":"?t.colonOffset=d:b===","&&r(d))},onError:(b,d,k)=>{S.push({error:b,offset:d,length:k})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=E;function h(a,S){if(!a)return;let n=a;for(let t of S)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const u of n.children)if(Array.isArray(u.children)&&u.children[0].value===t){n=u.children[1],r=!0;break}if(!r)return}else{const r=t;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=h;function p(a){if(!a.parent||!a.parent.children)return[];const S=p(a.parent);if(a.parent.type==="property"){const n=a.parent.children[0].value;S.push(n)}else if(a.parent.type==="array"){const n=a.parent.children.indexOf(a);n!==-1&&S.push(n)}return S}e.getNodePath=p;function v(a){switch(a.type){case"array":return a.children.map(v);case"object":{const S=Object.create(null);for(let n of a.children){const t=n.children[1];t&&(S[n.children[0].value]=v(t))}return S}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=v;function A(a,S,n=!1){return S>=a.offset&&S<a.offset+a.length||n&&S===a.offset+a.length}e.contains=A;function w(a,S,n=!1){if(A(a,S,n)){const t=a.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=S;r++){const u=w(t[r],S,n);if(u)return u}return a}}e.findNodeAtOffset=w;function s(a,S,n=C.DEFAULT){const t=P(a,!1);function r(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function u(Q){return Q?Y=>Q(Y,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=r(S.onObjectBegin),f=u(S.onObjectProperty),b=r(S.onObjectEnd),d=r(S.onArrayBegin),k=r(S.onArrayEnd),R=u(S.onLiteralValue),N=u(S.onSeparator),B=r(S.onComment),F=u(S.onError),U=n&&n.disallowComments,H=n&&n.allowTrailingComma;function x(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:U||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(Q){case 12:case 13:U?M(10):B();break;case 16:M(1);break;case 15:case 14:break;default:return Q}}}function M(Q,Y=[],fe=[]){if(F(Q),Y.length+fe.length>0){let me=t.getToken();for(;me!==17;){if(Y.indexOf(me)!==-1){x();break}else if(fe.indexOf(me)!==-1)break;me=x()}}}function W(Q){const Y=t.getTokenValue();return Q?R(Y):f(Y),x(),!0}function z(){switch(t.getToken()){case 11:{let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(M(2),Q=0)}catch{M(2)}R(Q);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return x(),!0}function O(){return t.getToken()!==10?(M(3,[],[2,5]),!1):(W(!1),t.getToken()===6?(N(":"),x(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function V(){c(),x();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||M(4,[],[]),N(","),x(),t.getToken()===2&&H)break}else Q&&M(6,[],[]);O()||M(4,[],[2,5]),Q=!0}return b(),t.getToken()!==2?M(7,[2],[]):x(),!0}function K(){d(),x();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||M(4,[],[]),N(","),x(),t.getToken()===4&&H)break}else Q&&M(6,[],[]);G()||M(4,[],[4,5]),Q=!0}return k(),t.getToken()!==4?M(8,[4],[]):x(),!0}function G(){switch(t.getToken()){case 3:return K();case 1:return V();case 10:return W(!0);default:return z()}}return x(),t.getToken()===17?n.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(t.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=s;function o(a,S){let n=P(a),t=[],r,u=0,c;do switch(c=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:u!==c&&t.push(a.substring(u,c)),S!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,S)),u=n.getPosition();break}while(r!==17);return t.join("")}e.stripComments=o;function g(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ve[138],we([0,1,58]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(I,L,T){let l,E,h,p,v;if(L){for(p=L.offset,v=p+L.length,h=p;h>0&&!_(I,h-1);)h--;let c=v;for(;c<I.length&&!_(I,c);)c++;E=I.substring(h,c),l=P(E,T)}else E=I,l=0,h=0,p=0,v=I.length;const A=D(T,I);let w=!1,s=0,o;T.insertSpaces?o=C(" ",T.tabSize||4):o="	";const g=(0,m.createScanner)(E,!1);let a=!1;function S(){return A+C(o,l+s)}function n(){let c=g.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=g.scan();return a=c===16||g.getTokenError()!==0,c}const t=[];function r(c,f,b){!a&&f<v&&b>p&&I.substring(f,b)!==c&&t.push({offset:f,length:b-f,content:c})}let u=n();if(u!==17){const c=g.getTokenOffset()+h,f=C(o,l);r(f,h,c)}for(;u!==17;){let c=g.getTokenOffset()+g.getTokenLength()+h,f=n(),b="";for(;!w&&(f===12||f===13);){const k=g.getTokenOffset()+h;r(" ",c,k),c=g.getTokenOffset()+g.getTokenLength()+h,b=f===12?S():"",f=n()}if(f===2)u!==1&&(s--,b=S());else if(f===4)u!==3&&(s--,b=S());else{switch(u){case 3:case 1:s++,b=S();break;case 5:case 12:b=S();break;case 13:w?b=S():b=" ";break;case 6:b=" ";break;case 10:if(f===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?b=" ":f!==5&&f!==17&&(a=!0);break;case 16:a=!0;break}w&&(f===12||f===13)&&(b=S())}const d=g.getTokenOffset()+h;r(b,c,d),u=f}return t}e.format=i;function y(I,L){const T=JSON.stringify(I,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?T.replace(/\r\n|\r|\n/g,L.eol):T}e.toFormattedString=y;function C(I,L){let T="";for(let l=0;l<L;l++)T+=I;return T}function P(I,L){let T=0,l=0;const E=L.tabSize||4;for(;T<I.length;){const h=I.charAt(T);if(h===" ")l++;else if(h==="	")l+=E;else break;T++}return Math.floor(l/E)}function D(I,L){for(let T=0;T<L.length;T++){const l=L.charAt(T);if(l==="\r")return T+1<L.length&&L.charAt(T+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=D;function _(I,L){return`\r
`.indexOf(I.charAt(L))!==-1}e.isEOL=_}),define(ve[139],we([0,1,58,138]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(I,L,T){return C(I,L,void 0,T)}e.removeProperty=y;function C(I,L,T,l,E){const h=L.slice(),p=[],v=(0,m.parseTree)(I,p);let A,w;for(;h.length>0&&(w=h.pop(),A=(0,m.findNodeAtLocation)(v,h),A===void 0&&T!==void 0);)typeof w=="string"?T={[w]:T}:T=[T];if(A)if(A.type==="object"&&typeof w=="string"&&Array.isArray(A.children)){const s=(0,m.findNodeAtLocation)(A,[w]);if(s!==void 0)if(T===void 0){if(!s.parent)throw new Error("Malformed AST");const o=A.children.indexOf(s.parent);let g,a=s.parent.offset+s.parent.length;if(o>0){const S=A.children[o-1];g=S.offset+S.length}else g=A.offset+1,A.children.length>1&&(a=A.children[1].offset);return P(I,{offset:g,length:a-g,content:""},l)}else return P(I,{offset:s.offset,length:s.length,content:JSON.stringify(T)},l);else{if(T===void 0)return[];const o=`${JSON.stringify(w)}: ${JSON.stringify(T)}`,g=E?E(A.children.map(S=>S.children[0].value)):A.children.length;let a;if(g>0){const S=A.children[g-1];a={offset:S.offset+S.length,length:0,content:","+o}}else A.children.length===0?a={offset:A.offset+1,length:0,content:o}:a={offset:A.offset+1,length:0,content:o+","};return P(I,a,l)}}else if(A.type==="array"&&typeof w=="number"&&Array.isArray(A.children))if(T!==void 0){const s=`${JSON.stringify(T)}`;let o;if(A.children.length===0||w===0)o={offset:A.offset+1,length:0,content:A.children.length===0?s:s+","};else{const g=w===-1||w>A.children.length?A.children.length:w,a=A.children[g-1];o={offset:a.offset+a.length,length:0,content:","+s}}return P(I,o,l)}else{const s=w,o=A.children[s];let g;if(A.children.length===1)g={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===s){const a=A.children[s-1],S=a.offset+a.length,n=A.offset+A.length;g={offset:S,length:n-2-S,content:""}}else g={offset:o.offset,length:A.children[s+1].offset-o.offset,content:""};return P(I,g,l)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${A.type}`);else{if(T===void 0)throw new Error("Can not delete in empty document");return P(I,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(T)},l)}}e.setProperty=C;function P(I,L,T){let l=D(I,L),E=L.offset,h=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;E>0&&!(0,i.isEOL)(l,E-1);)E--;for(;h<l.length&&!(0,i.isEOL)(l,h);)h++}const p=(0,i.format)(l,{offset:E,length:h-E},T);for(let A=p.length-1;A>=0;A--){const w=p[A];l=D(l,w),E=Math.min(E,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=I.length-(l.length-h)-E;return[{offset:E,length:v,content:l.substring(E,h)}]}e.withFormatting=P;function D(I,L){return I.substring(0,L.offset)+L.content+I.substring(L.offset+L.length)}e.applyEdit=D;function _(I,L){let T=L.slice(0).sort((E,h)=>{const p=E.offset-h.offset;return p===0?E.length-h.length:p}),l=I.length;for(let E=T.length-1;E>=0;E--){let h=T[E];if(h.offset+h.length<=l)I=D(I,h);else throw new Error("Overlapping edit");l=h.offset}return I}e.applyEdits=_}),define(ve[140],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new m(()=>y(this.getValue()))}}e.Lazy=m}),define(ve[6],we([0,1,75,77]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function P(t){C=t}if(e.setDisposableTracker=P,y){const t="__is_disposable_tracked__";P(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[t]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==w.None)try{r[t]=!0}catch{}}markAsDisposed(r){if(r&&r!==w.None)try{r[t]=!0}catch{}}markAsSingleton(r){}})}function D(t){return C?.trackDisposable(t),t}function _(t){C?.markAsDisposed(t)}function I(t,r){C?.setParent(t,r)}function L(t,r){if(!!C)for(const u of t)C.setParent(u,r)}function T(t){return C?.markAsSingleton(t),t}e.markAsSingleton=T;class l extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=l;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(i.Iterable.is(t)){let r=[];for(const u of t)if(u)try{u.dispose()}catch(c){r.push(c)}if(r.length===1)throw r[0];if(r.length>1)throw new l(r);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function p(...t){const r=v(()=>h(t));return L(t,r),r}e.combinedDisposable=p;function v(t){const r=D({dispose:(0,m.once)(()=>{_(r),t()})});return r}e.toDisposable=v;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return I(r,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new A,D(this),I(this._store,this)}dispose(){_(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&I(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&I(r,null),r}}e.MutableDisposable=s;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class g{constructor(){this.references=new Map}acquire(r,...u){let c=this.references.get(r);c||(c={counter:0,object:this.createReferencedObject(r,...u)},this.references.set(r,c));const{object:f}=c,b=(0,m.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(r,c.object),this.references.delete(r))});return c.counter++,{object:f,dispose:b}}}e.ReferenceCollection=g;class a{constructor(r){this.referenceCollection=r}async acquire(r,...u){const c=this.referenceCollection.acquire(r,...u);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(f){throw c.dispose(),f}}}e.AsyncReferenceCollection=a;class S{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=S;function n(t){const r=new A;try{t(r)}finally{r.dispose()}}e.disposeOnReturn=n}),define(ve[93],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class i{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const P=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=P}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,P){const D=new m(C);if(this._first===m.Undefined)this._first=D,this._last=D;else if(P){const I=this._last;this._last=D,D.prev=I,I.next=D}else{const I=this._first;this._first=D,D.next=I,I.prev=D}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(D))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const P=C.prev;P.next=C.next,C.next.prev=P}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=i}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ae,Pe){for(var ye=0;ye<Pe.length;ye++){var le=Pe[ye];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(Ae,le.key,le)}}function e(Ae,Pe,ye){return Pe&&J(Ae.prototype,Pe),ye&&J(Ae,ye),Ae}function m(Ae,Pe){if(!!Ae){if(typeof Ae=="string")return i(Ae,Pe);var ye=Object.prototype.toString.call(Ae).slice(8,-1);if(ye==="Object"&&Ae.constructor&&(ye=Ae.constructor.name),ye==="Map"||ye==="Set")return Array.from(Ae);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return i(Ae,Pe)}}function i(Ae,Pe){(Pe==null||Pe>Ae.length)&&(Pe=Ae.length);for(var ye=0,le=new Array(Pe);ye<Pe;ye++)le[ye]=Ae[ye];return le}function y(Ae,Pe){var ye=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ye)return(ye=ye.call(Ae)).next.bind(ye);if(Array.isArray(Ae)||(ye=m(Ae))||Pe&&Ae&&typeof Ae.length=="number"){ye&&(Ae=ye);var le=0;return function(){return le>=Ae.length?{done:!0}:{done:!1,value:Ae[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function D(Ae){C.exports.defaults=Ae}C.exports={defaults:P(),getDefaults:P,changeDefaults:D};var _=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Pe){return l[Pe]};function h(Ae,Pe){if(Pe){if(_.test(Ae))return Ae.replace(I,E)}else if(L.test(Ae))return Ae.replace(T,E);return Ae}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ae){return Ae.replace(p,function(Pe,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var A=/(^|[^\[])\^/g;function w(Ae,Pe){Ae=Ae.source||Ae,Pe=Pe||"";var ye={replace:function(de,be){return be=be.source||be,be=be.replace(A,"$1"),Ae=Ae.replace(de,be),ye},getRegex:function(){return new RegExp(Ae,Pe)}};return ye}var s=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Ae,Pe,ye){if(Ae){var le;try{le=decodeURIComponent(v(ye)).replace(s,"").toLowerCase()}catch{return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}Pe&&!o.test(ye)&&(ye=r(Pe,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var a={},S=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ae,Pe){a[" "+Ae]||(S.test(Ae)?a[" "+Ae]=Ae+"/":a[" "+Ae]=b(Ae,"/",!0)),Ae=a[" "+Ae];var ye=Ae.indexOf(":")===-1;return Pe.substring(0,2)==="//"?ye?Pe:Ae.replace(n,"$1")+Pe:Pe.charAt(0)==="/"?ye?Pe:Ae.replace(t,"$1")+Pe:Ae+Pe}var u={exec:function(){}};function c(Ae){for(var Pe=1,ye,le;Pe<arguments.length;Pe++){ye=arguments[Pe];for(le in ye)Object.prototype.hasOwnProperty.call(ye,le)&&(Ae[le]=ye[le])}return Ae}function f(Ae,Pe){var ye=Ae.replace(/\|/g,function(be,Ce,Me){for(var Ke=!1,He=Ce;--He>=0&&Me[He]==="\\";)Ke=!Ke;return Ke?"|":" |"}),le=ye.split(/ \|/),de=0;if(le[0].trim()||le.shift(),le[le.length-1].trim()||le.pop(),le.length>Pe)le.splice(Pe);else for(;le.length<Pe;)le.push("");for(;de<le.length;de++)le[de]=le[de].trim().replace(/\\\|/g,"|");return le}function b(Ae,Pe,ye){var le=Ae.length;if(le===0)return"";for(var de=0;de<le;){var be=Ae.charAt(le-de-1);if(be===Pe&&!ye)de++;else if(be!==Pe&&ye)de++;else break}return Ae.substr(0,le-de)}function d(Ae,Pe){if(Ae.indexOf(Pe[1])===-1)return-1;for(var ye=Ae.length,le=0,de=0;de<ye;de++)if(Ae[de]==="\\")de++;else if(Ae[de]===Pe[0])le++;else if(Ae[de]===Pe[1]&&(le--,le<0))return de;return-1}function k(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ae,Pe){if(Pe<1)return"";for(var ye="";Pe>1;)Pe&1&&(ye+=Ae),Pe>>=1,Ae+=Ae;return ye+Ae}var N={escape:h,unescape:v,edit:w,cleanUrl:g,resolveUrl:r,noopTest:u,merge:c,splitCells:f,rtrim:b,findClosingBracket:d,checkSanitizeDeprecation:k,repeatString:R},B=C.exports.defaults,F=N.rtrim,U=N.splitCells,H=N.escape,x=N.findClosingBracket;function M(Ae,Pe,ye,le){var de=Pe.href,be=Pe.title?H(Pe.title):null,Ce=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){le.state.inLink=!0;var Me={type:"link",raw:ye,href:de,title:be,text:Ce,tokens:le.inlineTokens(Ce,[])};return le.state.inLink=!1,Me}else return{type:"image",raw:ye,href:de,title:be,text:H(Ce)}}function W(Ae,Pe){var ye=Ae.match(/^(\s+)(?:```)/);if(ye===null)return Pe;var le=ye[1];return Pe.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var Ce=be[0];return Ce.length>=le.length?de.slice(le.length):de}).join(`
`)}var z=function(){function Ae(ye){this.options=ye||B}var Pe=Ae.prototype;return Pe.space=function(le){var de=this.rules.block.newline.exec(le);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Pe.code=function(le){var de=this.rules.block.code.exec(le);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},Pe.fences=function(le){var de=this.rules.block.fences.exec(le);if(de){var be=de[0],Ce=W(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:Ce}}},Pe.heading=function(le){var de=this.rules.block.heading.exec(le);if(de){var be=de[2].trim();if(/#$/.test(be)){var Ce=F(be,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(be=Ce.trim())}var Me={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Me.text,Me.tokens),Me}},Pe.hr=function(le){var de=this.rules.block.hr.exec(le);if(de)return{type:"hr",raw:de[0]}},Pe.blockquote=function(le){var de=this.rules.block.blockquote.exec(le);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Pe.list=function(le){var de=this.rules.block.list.exec(le);if(de){var be,Ce,Me,Ke,He,Qe,st,at,he,De,ce=de[1].trim(),X=ce.length>1,ke={type:"list",raw:"",ordered:X,start:X?+ce.slice(0,-1):"",loose:!1,items:[]};ce=X?"\\d{1,9}\\"+ce.slice(-1):"\\"+ce,this.options.pedantic&&(ce=X?ce:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ce+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");le&&!(this.rules.block.hr.test(le)||!(de=Le.exec(le)));){he=de[2].split(`
`),this.options.pedantic?(Ke=2,De=he[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),De=he[0].slice(Ke-de[1].length)),Qe=!1,be=de[0],!he[0]&&/^ *$/.test(he[1])&&(be=de[1]+he.slice(0,2).join(`
`)+`
`,ke.loose=!0,he=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<he.length;He++){if(at=he[He],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(at)){be=de[1]+he.slice(0,He).join(`
`)+`
`;break}if(!Qe){at.trim()||(Qe=!0),at.search(/[^ ]/)>=Ke?De+=`
`+at.slice(Ke):De+=`
`+at;continue}if(at.search(/[^ ]/)>=Ke||!at.trim()){De+=`
`+at.slice(Ke);continue}else{be=de[1]+he.slice(0,He).join(`
`)+`
`;break}}ke.loose||(st?ke.loose=!0:/\n *\n *$/.test(be)&&(st=!0)),this.options.gfm&&(Ce=/^\[[ xX]\] /.exec(De),Ce&&(Me=Ce[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:be,task:!!Ce,checked:Me,loose:!1,text:De}),ke.raw+=be,le=le.slice(be.length)}ke.items[ke.items.length-1].raw=be.trimRight(),ke.items[ke.items.length-1].text=De.trimRight(),ke.raw=ke.raw.trimRight();var qe=ke.items.length;for(He=0;He<qe;He++)this.lexer.state.top=!1,ke.items[He].tokens=this.lexer.blockTokens(ke.items[He].text,[]),ke.items[He].tokens.some(function(dt){return dt.type==="space"})&&(ke.loose=!0,ke.items[He].loose=!0);return ke}},Pe.html=function(le){var de=this.rules.block.html.exec(le);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):H(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Pe.def=function(le){var de=this.rules.block.def.exec(le);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},Pe.table=function(le){var de=this.rules.block.table.exec(le);if(de){var be={type:"table",header:U(de[1]).map(function(st){return{text:st}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var Ce=be.align.length,Me,Ke,He,Qe;for(Me=0;Me<Ce;Me++)/^ *-+: *$/.test(be.align[Me])?be.align[Me]="right":/^ *:-+: *$/.test(be.align[Me])?be.align[Me]="center":/^ *:-+ *$/.test(be.align[Me])?be.align[Me]="left":be.align[Me]=null;for(Ce=be.rows.length,Me=0;Me<Ce;Me++)be.rows[Me]=U(be.rows[Me],be.header.length).map(function(st){return{text:st}});for(Ce=be.header.length,Ke=0;Ke<Ce;Ke++)be.header[Ke].tokens=[],this.lexer.inlineTokens(be.header[Ke].text,be.header[Ke].tokens);for(Ce=be.rows.length,Ke=0;Ke<Ce;Ke++)for(Qe=be.rows[Ke],He=0;He<Qe.length;He++)Qe[He].tokens=[],this.lexer.inlineTokens(Qe[He].text,Qe[He].tokens);return be}}},Pe.lheading=function(le){var de=this.rules.block.lheading.exec(le);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Pe.paragraph=function(le){var de=this.rules.block.paragraph.exec(le);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Pe.text=function(le){var de=this.rules.block.text.exec(le);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Pe.escape=function(le){var de=this.rules.inline.escape.exec(le);if(de)return{type:"escape",raw:de[0],text:H(de[1])}},Pe.tag=function(le){var de=this.rules.inline.tag.exec(le);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):H(de[0]):de[0]}},Pe.link=function(le){var de=this.rules.inline.link.exec(le);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var Ce=F(be.slice(0,-1),"\\");if((be.length-Ce.length)%2==0)return}else{var Me=x(de[2],"()");if(Me>-1){var Ke=de[0].indexOf("!")===0?5:4,He=Ke+de[1].length+Me;de[2]=de[2].substring(0,Me),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Qe=de[2],st="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Qe);at&&(Qe=at[1],st=at[3])}else st=de[3]?de[3].slice(1,-1):"";return Qe=Qe.trim(),/^</.test(Qe)&&(this.options.pedantic&&!/>$/.test(be)?Qe=Qe.slice(1):Qe=Qe.slice(1,-1)),M(de,{href:Qe&&Qe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Pe.reflink=function(le,de){var be;if((be=this.rules.inline.reflink.exec(le))||(be=this.rules.inline.nolink.exec(le))){var Ce=(be[2]||be[1]).replace(/\s+/g," ");if(Ce=de[Ce.toLowerCase()],!Ce||!Ce.href){var Me=be[0].charAt(0);return{type:"text",raw:Me,text:Me}}return M(be,Ce,be[0],this.lexer)}},Pe.emStrong=function(le,de,be){be===void 0&&(be="");var Ce=this.rules.inline.emStrong.lDelim.exec(le);if(!!Ce&&!(Ce[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=Ce[1]||Ce[2]||"";if(!Me||Me&&(be===""||this.rules.inline.punctuation.exec(be))){var Ke=Ce[0].length-1,He,Qe,st=Ke,at=0,he=Ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,de=de.slice(-1*le.length+Ke);(Ce=he.exec(de))!=null;)if(He=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!!He){if(Qe=He.length,Ce[3]||Ce[4]){st+=Qe;continue}else if((Ce[5]||Ce[6])&&Ke%3&&!((Ke+Qe)%3)){at+=Qe;continue}if(st-=Qe,!(st>0)){if(Qe=Math.min(Qe,Qe+st+at),Math.min(Ke,Qe)%2){var De=le.slice(1,Ke+Ce.index+Qe);return{type:"em",raw:le.slice(0,Ke+Ce.index+Qe+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var ce=le.slice(2,Ke+Ce.index+Qe-1);return{type:"strong",raw:le.slice(0,Ke+Ce.index+Qe+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}}}}},Pe.codespan=function(le){var de=this.rules.inline.code.exec(le);if(de){var be=de[2].replace(/\n/g," "),Ce=/[^ ]/.test(be),Me=/^ /.test(be)&&/ $/.test(be);return Ce&&Me&&(be=be.substring(1,be.length-1)),be=H(be,!0),{type:"codespan",raw:de[0],text:be}}},Pe.br=function(le){var de=this.rules.inline.br.exec(le);if(de)return{type:"br",raw:de[0]}},Pe.del=function(le){var de=this.rules.inline.del.exec(le);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Pe.autolink=function(le,de){var be=this.rules.inline.autolink.exec(le);if(be){var Ce,Me;return be[2]==="@"?(Ce=H(this.options.mangle?de(be[1]):be[1]),Me="mailto:"+Ce):(Ce=H(be[1]),Me=Ce),{type:"link",raw:be[0],text:Ce,href:Me,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Pe.url=function(le,de){var be;if(be=this.rules.inline.url.exec(le)){var Ce,Me;if(be[2]==="@")Ce=H(this.options.mangle?de(be[0]):be[0]),Me="mailto:"+Ce;else{var Ke;do Ke=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ke!==be[0]);Ce=H(be[0]),be[1]==="www."?Me="http://"+Ce:Me=Ce}return{type:"link",raw:be[0],text:Ce,href:Me,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Pe.inlineText=function(le,de){var be=this.rules.inline.text.exec(le);if(be){var Ce;return this.lexer.state.inRawBlock?Ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):H(be[0]):be[0]:Ce=H(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:Ce}}},Ae}(),O=N.noopTest,V=N.edit,K=N.merge,G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=V(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=V(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=V(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=V(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=V(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=V(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=K({},G),G.gfm=K({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=V(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=K({},G.normal,{html:V(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:V(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=V(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=V(G._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=V(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=V(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=V(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=V(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=V(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=V(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=V(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=V(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=K({},Q),Q.pedantic=K({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:V(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:V(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=K({},Q.normal,{escape:V(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=V(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=K({},Q.gfm,{br:V(Q.br).replace("{2,}","*").getRegex(),text:V(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Y={block:G,inline:Q},fe=z,me=C.exports.defaults,Se=Y.block,Ie=Y.inline,Oe=N.repeatString;function We(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Ae){var Pe="",ye,le,de=Ae.length;for(ye=0;ye<de;ye++)le=Ae.charCodeAt(ye),Math.random()>.5&&(le="x"+le.toString(16)),Pe+="&#"+le+";";return Pe}var Z=function(){function Ae(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||me,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var le={block:Se.normal,inline:Ie.normal};this.options.pedantic?(le.block=Se.pedantic,le.inline=Ie.pedantic):this.options.gfm&&(le.block=Se.gfm,this.options.breaks?le.inline=Ie.breaks:le.inline=Ie.gfm),this.tokenizer.rules=le}Ae.lex=function(le,de){var be=new Ae(de);return be.lex(le)},Ae.lexInline=function(le,de){var be=new Ae(de);return be.inlineTokens(le)};var Pe=Ae.prototype;return Pe.lex=function(le){le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Pe.blockTokens=function(le,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var Ce,Me,Ke,He;le;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(Ce=st.call({lexer:be},le,de))?(le=le.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.space(le)){le=le.substring(Ce.raw.length),Ce.type&&de.push(Ce);continue}if(Ce=this.tokenizer.code(le)){le=le.substring(Ce.raw.length),Me=de[de.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(Ce);continue}if(Ce=this.tokenizer.fences(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.heading(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.hr(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.blockquote(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.list(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.html(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.def(le)){le=le.substring(Ce.raw.length),Me=de[de.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.lheading(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=le,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,at=le.slice(1),he=void 0;be.options.extensions.startBlock.forEach(function(De){he=De.call({lexer:this},at),typeof he=="number"&&he>=0&&(st=Math.min(st,he))}),st<1/0&&st>=0&&(Ke=le.substring(0,st+1))}(),this.state.top&&(Ce=this.tokenizer.paragraph(Ke))){Me=de[de.length-1],He&&Me.type==="paragraph"?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(Ce),He=Ke.length!==le.length,le=le.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(le)){le=le.substring(Ce.raw.length),Me=de[de.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(Ce);continue}if(le){var Qe="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Qe);break}else throw new Error(Qe)}}return this.state.top=!0,de},Pe.inline=function(le,de){this.inlineQueue.push({src:le,tokens:de})},Pe.inlineTokens=function(le,de){var be=this;de===void 0&&(de=[]);var Ce,Me,Ke,He=le,Qe,st,at;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;(Qe=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)he.includes(Qe[0].slice(Qe[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Qe.index)+"["+Oe("a",Qe[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Qe=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Qe.index)+"["+Oe("a",Qe[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Qe=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Qe.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;)if(st||(at=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(Ce=ce.call({lexer:be},le,de))?(le=le.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.escape(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.tag(le)){le=le.substring(Ce.raw.length),Me=de[de.length-1],Me&&Ce.type==="text"&&Me.type==="text"?(Me.raw+=Ce.raw,Me.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.link(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(Ce.raw.length),Me=de[de.length-1],Me&&Ce.type==="text"&&Me.type==="text"?(Me.raw+=Ce.raw,Me.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.emStrong(le,He,at)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.codespan(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.br(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.del(le)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.autolink(le,j)){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(!this.state.inLink&&(Ce=this.tokenizer.url(le,j))){le=le.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=le,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,X=le.slice(1),ke=void 0;be.options.extensions.startInline.forEach(function(Le){ke=Le.call({lexer:this},X),typeof ke=="number"&&ke>=0&&(ce=Math.min(ce,ke))}),ce<1/0&&ce>=0&&(Ke=le.substring(0,ce+1))}(),Ce=this.tokenizer.inlineText(Ke,We)){le=le.substring(Ce.raw.length),Ce.raw.slice(-1)!=="_"&&(at=Ce.raw.slice(-1)),st=!0,Me=de[de.length-1],Me&&Me.type==="text"?(Me.raw+=Ce.raw,Me.text+=Ce.text):de.push(Ce);continue}if(le){var De="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return de},e(Ae,null,[{key:"rules",get:function(){return{block:Se,inline:Ie}}}]),Ae}(),re=C.exports.defaults,ue=N.cleanUrl,te=N.escape,oe=function(){function Ae(ye){this.options=ye||re}var Pe=Ae.prototype;return Pe.code=function(le,de,be){var Ce=(de||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(le,Ce);Me!=null&&Me!==le&&(be=!0,le=Me)}return le=le.replace(/\n$/,"")+`
`,Ce?'<pre><code class="'+this.options.langPrefix+te(Ce,!0)+'">'+(be?le:te(le,!0))+`</code></pre>
`:"<pre><code>"+(be?le:te(le,!0))+`</code></pre>
`},Pe.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},Pe.html=function(le){return le},Pe.heading=function(le,de,be,Ce){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ce.slug(be)+'">'+le+"</h"+de+`>
`:"<h"+de+">"+le+"</h"+de+`>
`},Pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Pe.list=function(le,de,be){var Ce=de?"ol":"ul",Me=de&&be!==1?' start="'+be+'"':"";return"<"+Ce+Me+`>
`+le+"</"+Ce+`>
`},Pe.listitem=function(le){return"<li>"+le+`</li>
`},Pe.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Pe.paragraph=function(le){return"<p>"+le+`</p>
`},Pe.table=function(le,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+de+`</table>
`},Pe.tablerow=function(le){return`<tr>
`+le+`</tr>
`},Pe.tablecell=function(le,de){var be=de.header?"th":"td",Ce=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return Ce+le+"</"+be+`>
`},Pe.strong=function(le){return"<strong>"+le+"</strong>"},Pe.em=function(le){return"<em>"+le+"</em>"},Pe.codespan=function(le){return"<code>"+le+"</code>"},Pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},Pe.del=function(le){return"<del>"+le+"</del>"},Pe.link=function(le,de,be){if(le=ue(this.options.sanitize,this.options.baseUrl,le),le===null)return be;var Ce='<a href="'+te(le)+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=">"+be+"</a>",Ce},Pe.image=function(le,de,be){if(le=ue(this.options.sanitize,this.options.baseUrl,le),le===null)return be;var Ce='<img src="'+le+'" alt="'+be+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=this.options.xhtml?"/>":">",Ce},Pe.text=function(le){return le},Ae}(),Ee=function(){function Ae(){}var Pe=Ae.prototype;return Pe.strong=function(le){return le},Pe.em=function(le){return le},Pe.codespan=function(le){return le},Pe.del=function(le){return le},Pe.html=function(le){return le},Pe.text=function(le){return le},Pe.link=function(le,de,be){return""+be},Pe.image=function(le,de,be){return""+be},Pe.br=function(){return""},Ae}(),Ne=function(){function Ae(){this.seen={}}var Pe=Ae.prototype;return Pe.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Pe.getNextSafeSlug=function(le,de){var be=le,Ce=0;if(this.seen.hasOwnProperty(be)){Ce=this.seen[le];do Ce++,be=le+"-"+Ce;while(this.seen.hasOwnProperty(be))}return de||(this.seen[le]=Ce,this.seen[be]=0),be},Pe.slug=function(le,de){de===void 0&&(de={});var be=this.serialize(le);return this.getNextSafeSlug(be,de.dryrun)},Ae}(),Ve=oe,Ge=Ee,Je=Ne,tt=C.exports.defaults,ot=N.unescape,et=function(){function Ae(ye){this.options=ye||tt,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ge,this.slugger=new Je}Ae.parse=function(le,de){var be=new Ae(de);return be.parse(le)},Ae.parseInline=function(le,de){var be=new Ae(de);return be.parseInline(le)};var Pe=Ae.prototype;return Pe.parse=function(le,de){de===void 0&&(de=!0);var be="",Ce,Me,Ke,He,Qe,st,at,he,De,ce,X,ke,Le,Ze,qe,dt,wt,yt,bt,ft=le.length;for(Ce=0;Ce<ft;Ce++){if(ce=le[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(bt=this.options.extensions.renderers[ce.type].call({parser:this},ce),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){be+=bt||"";continue}switch(ce.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,ot(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(he="",at="",He=ce.header.length,Me=0;Me<He;Me++)at+=this.renderer.tablecell(this.parseInline(ce.header[Me].tokens),{header:!0,align:ce.align[Me]});for(he+=this.renderer.tablerow(at),De="",He=ce.rows.length,Me=0;Me<He;Me++){for(st=ce.rows[Me],at="",Qe=st.length,Ke=0;Ke<Qe;Ke++)at+=this.renderer.tablecell(this.parseInline(st[Ke].tokens),{header:!1,align:ce.align[Ke]});De+=this.renderer.tablerow(at)}be+=this.renderer.table(he,De);continue}case"blockquote":{De=this.parse(ce.tokens),be+=this.renderer.blockquote(De);continue}case"list":{for(X=ce.ordered,ke=ce.start,Le=ce.loose,He=ce.items.length,De="",Me=0;Me<He;Me++)qe=ce.items[Me],dt=qe.checked,wt=qe.task,Ze="",qe.task&&(yt=this.renderer.checkbox(dt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=yt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=yt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:yt}):Ze+=yt),Ze+=this.parse(qe.tokens,Le),De+=this.renderer.listitem(Ze,wt,dt);be+=this.renderer.list(De,X,ke);continue}case"html":{be+=this.renderer.html(ce.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(De=ce.tokens?this.parseInline(ce.tokens):ce.text;Ce+1<ft&&le[Ce+1].type==="text";)ce=le[++Ce],De+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);be+=de?this.renderer.paragraph(De):De;continue}default:{var vt='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return be},Pe.parseInline=function(le,de){de=de||this.renderer;var be="",Ce,Me,Ke,He=le.length;for(Ce=0;Ce<He;Ce++){if(Me=le[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(Ke=this.options.extensions.renderers[Me.type].call({parser:this},Me),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){be+=Ke||"";continue}switch(Me.type){case"escape":{be+=de.text(Me.text);break}case"html":{be+=de.html(Me.text);break}case"link":{be+=de.link(Me.href,Me.title,this.parseInline(Me.tokens,de));break}case"image":{be+=de.image(Me.href,Me.title,Me.text);break}case"strong":{be+=de.strong(this.parseInline(Me.tokens,de));break}case"em":{be+=de.em(this.parseInline(Me.tokens,de));break}case"codespan":{be+=de.codespan(Me.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Me.tokens,de));break}case"text":{be+=de.text(Me.text);break}default:{var Qe='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return be},Ae}(),it=Z,ct=et,pt=z,Pt=oe,xe=Ee,Rt=Ne,ee=N.merge,ne=N.checkSanitizeDeprecation,pe=N.escape,ie=C.exports.getDefaults,_e=C.exports.changeDefaults,Fe=C.exports.defaults;function Ue(Ae,Pe,ye){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof Pe=="function"&&(ye=Pe,Pe=null),Pe=ee({},Ue.defaults,Pe||{}),ne(Pe),ye){var le=Pe.highlight,de;try{de=it.lex(Ae,Pe)}catch(Ke){return ye(Ke)}var be=function(He){var Qe;if(!He)try{Pe.walkTokens&&Ue.walkTokens(de,Pe.walkTokens),Qe=ct.parse(de,Pe)}catch(st){He=st}return Pe.highlight=le,He?ye(He):ye(null,Qe)};if(!le||le.length<3||(delete Pe.highlight,!de.length))return be();var Ce=0;Ue.walkTokens(de,function(Ke){Ke.type==="code"&&(Ce++,setTimeout(function(){le(Ke.text,Ke.lang,function(He,Qe){if(He)return be(He);Qe!=null&&Qe!==Ke.text&&(Ke.text=Qe,Ke.escaped=!0),Ce--,Ce===0&&be()})},0))}),Ce===0&&be();return}try{var Me=it.lex(Ae,Pe);return Pe.walkTokens&&Ue.walkTokens(Me,Pe.walkTokens),ct.parse(Me,Pe)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Pe.silent)return"<p>An error occurred:</p><pre>"+pe(Ke.message+"",!0)+"</pre>";throw Ke}}Ue.options=Ue.setOptions=function(Ae){return ee(Ue.defaults,Ae),_e(Ue.defaults),Ue},Ue.getDefaults=ie,Ue.defaults=Fe,Ue.use=function(){for(var Ae=this,Pe=arguments.length,ye=new Array(Pe),le=0;le<Pe;le++)ye[le]=arguments[le];var de=ee.apply(void 0,[{}].concat(ye)),be=Ue.defaults.extensions||{renderers:{},childTokens:{}},Ce;ye.forEach(function(Me){if(Me.extensions&&(Ce=!0,Me.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Qe=be.renderers?be.renderers[He.name]:null;Qe?be.renderers[He.name]=function(){for(var st=arguments.length,at=new Array(st),he=0;he<st;he++)at[he]=arguments[he];var De=He.renderer.apply(this,at);return De===!1&&(De=Qe.apply(this,at)),De}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Me.renderer&&function(){var He=Ue.defaults.renderer||new Pt,Qe=function(he){var De=He[he];He[he]=function(){for(var ce=arguments.length,X=new Array(ce),ke=0;ke<ce;ke++)X[ke]=arguments[ke];var Le=Me.renderer[he].apply(He,X);return Le===!1&&(Le=De.apply(He,X)),Le}};for(var st in Me.renderer)Qe(st);de.renderer=He}(),Me.tokenizer&&function(){var He=Ue.defaults.tokenizer||new pt,Qe=function(he){var De=He[he];He[he]=function(){for(var ce=arguments.length,X=new Array(ce),ke=0;ke<ce;ke++)X[ke]=arguments[ke];var Le=Me.tokenizer[he].apply(He,X);return Le===!1&&(Le=De.apply(He,X)),Le}};for(var st in Me.tokenizer)Qe(st);de.tokenizer=He}(),Me.walkTokens){var Ke=Ue.defaults.walkTokens;de.walkTokens=function(He){Me.walkTokens.call(Ae,He),Ke&&Ke(He)}}Ce&&(de.extensions=be),Ue.setOptions(de)})},Ue.walkTokens=function(Ae,Pe){for(var ye=function(){var Ce=de.value;switch(Pe(Ce),Ce.type){case"table":{for(var Me=y(Ce.header),Ke;!(Ke=Me()).done;){var He=Ke.value;Ue.walkTokens(He.tokens,Pe)}for(var Qe=y(Ce.rows),st;!(st=Qe()).done;)for(var at=st.value,he=y(at),De;!(De=he()).done;){var ce=De.value;Ue.walkTokens(ce.tokens,Pe)}break}case"list":{Ue.walkTokens(Ce.items,Pe);break}default:Ue.defaults.extensions&&Ue.defaults.extensions.childTokens&&Ue.defaults.extensions.childTokens[Ce.type]?Ue.defaults.extensions.childTokens[Ce.type].forEach(function(X){Ue.walkTokens(Ce[X],Pe)}):Ce.tokens&&Ue.walkTokens(Ce.tokens,Pe)}},le=y(Ae),de;!(de=le()).done;)ye()},Ue.parseInline=function(Ae,Pe){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");Pe=ee({},Ue.defaults,Pe||{}),ne(Pe);try{var ye=it.lexInline(Ae,Pe);return Pe.walkTokens&&Ue.walkTokens(ye,Pe.walkTokens),ct.parseInline(ye,Pe)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,Pe.silent)return"<p>An error occurred:</p><pre>"+pe(le.message+"",!0)+"</pre>";throw le}},Ue.Parser=ct,Ue.parser=ct.parse,Ue.Renderer=Pt,Ue.TextRenderer=xe,Ue.Lexer=it,Ue.lexer=it.lex,Ue.Tokenizer=pt,Ue.Slugger=Rt,Ue.parse=Ue;var Xe=Ue;return Xe}),define(ve[78],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(P,D,_){return Math.min(Math.max(P,D),_)}e.clamp=m;function i(P,D){return(D+P%D)%D}e.rot=i;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function J(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function P(_){C.push(_,Date.now())}function D(){const _=[];for(let I=0;I<C.length;I+=2)_.push({name:C[I],startTime:C[I+1]});return _}return{mark:P,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const P of performance.getEntriesByType("mark"))C.push({name:P.name,startTime:Math.round(y+P.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function m(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=m(i))}(),define(ve[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let i=!1,y=!1,C=!1,P=!1,D=!1,_=!1,I=!1,L=!1,T,l=m,E,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const v=typeof p?.versions?.electron=="string",A=v&&p?.type==="renderer";if(e.isElectronSandboxed=A&&p?.sandboxed,typeof navigator=="object"&&!A)h=navigator.userAgent,i=h.indexOf("Windows")>=0,y=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,_=!0,T=navigator.language,l=T;else if(typeof p=="object"){i=p.platform==="win32",y=p.platform==="darwin",C=p.platform==="linux",P=C&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,I=v,T=m,l=m;const r=p.env.VSCODE_NLS_CONFIG;if(r)try{const u=JSON.parse(r),c=u.availableLanguages["*"];T=u.locale,l=c||m,E=u._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function s(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let o=0;y?o=1:i?o=3:C&&(o=2),e.isWindows=i,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=P,e.isNative=D,e.isElectron=I,e.isWeb=_,e.isIOS=L,e.platform=o,e.userAgent=h,e.language=l;var g;(function(r){function u(){return e.language}r.value=u;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=c;function f(){return e.language==="en"}r.isDefault=f})(g=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let f=0,b=r.length;f<b;f++){const d=r[f];if(d.id===c.data.vscodeScheduleAsyncWork){r.splice(f,1),d.callback();return}}});let u=0;return c=>{const f=++u;r.push({id:f,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return r=>setTimeout(r)})();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||L?2:i?1:3;let S=!0,n=!1;function t(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,S=new Uint16Array(r.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=t}),define(ve[40],we([0,1,12]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const y=m.globals.vscode.process;i={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ve[9],we([0,1,40]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,y=97,C=90,P=122,D=46,_=47,I=92,L=58,T=63;class l extends Error{constructor(o,g,a){let S;typeof g=="string"&&g.indexOf("not ")===0?(S="must not be",g=g.replace(/^not /,"")):S="must be";const n=o.indexOf(".")!==-1?"property":"argument";let t=`The "${o}" ${n} ${S} of type ${g}`;t+=`. Received type ${typeof a}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function E(s,o){if(typeof s!="string")throw new l(o,"string",s)}function h(s){return s===_||s===I}function p(s){return s===_}function v(s){return s>=i&&s<=C||s>=y&&s<=P}function A(s,o,g,a){let S="",n=0,t=-1,r=0,u=0;for(let c=0;c<=s.length;++c){if(c<s.length)u=s.charCodeAt(c);else{if(a(u))break;u=_}if(a(u)){if(!(t===c-1||r===1))if(r===2){if(S.length<2||n!==2||S.charCodeAt(S.length-1)!==D||S.charCodeAt(S.length-2)!==D){if(S.length>2){const f=S.lastIndexOf(g);f===-1?(S="",n=0):(S=S.slice(0,f),n=S.length-1-S.lastIndexOf(g)),t=c,r=0;continue}else if(S.length!==0){S="",n=0,t=c,r=0;continue}}o&&(S+=S.length>0?`${g}..`:"..",n=2)}else S.length>0?S+=`${g}${s.slice(t+1,c)}`:S=s.slice(t+1,c),n=c-t-1;t=c,r=0}else u===D&&r!==-1?++r:r=-1}return S}function w(s,o){if(o===null||typeof o!="object")throw new l("pathObject","Object",o);const g=o.dir||o.root,a=o.base||`${o.name||""}${o.ext||""}`;return g?g===o.root?`${g}${a}`:`${g}${s}${a}`:a}e.win32={resolve(...s){let o="",g="",a=!1;for(let S=s.length-1;S>=-1;S--){let n;if(S>=0){if(n=s[S],E(n,"path"),n.length===0)continue}else o.length===0?n=m.cwd():(n=m.env[`=${o}`]||m.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===I)&&(n=`${o}\\`));const t=n.length;let r=0,u="",c=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(r=1,c=!0);else if(h(f))if(c=!0,h(n.charCodeAt(1))){let b=2,d=b;for(;b<t&&!h(n.charCodeAt(b));)b++;if(b<t&&b!==d){const k=n.slice(d,b);for(d=b;b<t&&h(n.charCodeAt(b));)b++;if(b<t&&b!==d){for(d=b;b<t&&!h(n.charCodeAt(b));)b++;(b===t||b!==d)&&(u=`\\\\${k}\\${n.slice(d,b)}`,r=b)}}}else r=1;else v(f)&&n.charCodeAt(1)===L&&(u=n.slice(0,2),r=2,t>2&&h(n.charCodeAt(2))&&(c=!0,r=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(a){if(o.length>0)break}else if(g=`${n.slice(r)}\\${g}`,a=c,c&&o.length>0)break}return g=A(g,!a,"\\",h),a?`${o}\\${g}`:`${o}${g}`||"."},normalize(s){E(s,"path");const o=s.length;if(o===0)return".";let g=0,a,S=!1;const n=s.charCodeAt(0);if(o===1)return p(n)?"\\":s;if(h(n))if(S=!0,h(s.charCodeAt(1))){let r=2,u=r;for(;r<o&&!h(s.charCodeAt(r));)r++;if(r<o&&r!==u){const c=s.slice(u,r);for(u=r;r<o&&h(s.charCodeAt(r));)r++;if(r<o&&r!==u){for(u=r;r<o&&!h(s.charCodeAt(r));)r++;if(r===o)return`\\\\${c}\\${s.slice(u)}\\`;r!==u&&(a=`\\\\${c}\\${s.slice(u,r)}`,g=r)}}}else g=1;else v(n)&&s.charCodeAt(1)===L&&(a=s.slice(0,2),g=2,o>2&&h(s.charCodeAt(2))&&(S=!0,g=3));let t=g<o?A(s.slice(g),!S,"\\",h):"";return t.length===0&&!S&&(t="."),t.length>0&&h(s.charCodeAt(o-1))&&(t+="\\"),a===void 0?S?`\\${t}`:t:S?`${a}\\${t}`:`${a}${t}`},isAbsolute(s){E(s,"path");const o=s.length;if(o===0)return!1;const g=s.charCodeAt(0);return h(g)||o>2&&v(g)&&s.charCodeAt(1)===L&&h(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,g;for(let n=0;n<s.length;++n){const t=s[n];E(t,"path"),t.length>0&&(o===void 0?o=g=t:o+=`\\${t}`)}if(o===void 0)return".";let a=!0,S=0;if(typeof g=="string"&&h(g.charCodeAt(0))){++S;const n=g.length;n>1&&h(g.charCodeAt(1))&&(++S,n>2&&(h(g.charCodeAt(2))?++S:a=!1))}if(a){for(;S<o.length&&h(o.charCodeAt(S));)S++;S>=2&&(o=`\\${o.slice(S)}`)}return e.win32.normalize(o)},relative(s,o){if(E(s,"from"),E(o,"to"),s===o)return"";const g=e.win32.resolve(s),a=e.win32.resolve(o);if(g===a||(s=g.toLowerCase(),o=a.toLowerCase(),s===o))return"";let S=0;for(;S<s.length&&s.charCodeAt(S)===I;)S++;let n=s.length;for(;n-1>S&&s.charCodeAt(n-1)===I;)n--;const t=n-S;let r=0;for(;r<o.length&&o.charCodeAt(r)===I;)r++;let u=o.length;for(;u-1>r&&o.charCodeAt(u-1)===I;)u--;const c=u-r,f=t<c?t:c;let b=-1,d=0;for(;d<f;d++){const R=s.charCodeAt(S+d);if(R!==o.charCodeAt(r+d))break;R===I&&(b=d)}if(d!==f){if(b===-1)return a}else{if(c>f){if(o.charCodeAt(r+d)===I)return a.slice(r+d+1);if(d===2)return a.slice(r+d)}t>f&&(s.charCodeAt(S+d)===I?b=d:d===2&&(b=3)),b===-1&&(b=0)}let k="";for(d=S+b+1;d<=n;++d)(d===n||s.charCodeAt(d)===I)&&(k+=k.length===0?"..":"\\..");return r+=b,k.length>0?`${k}${a.slice(r,u)}`:(a.charCodeAt(r)===I&&++r,a.slice(r,u))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const g=o.charCodeAt(2);if(g!==T&&g!==D)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(v(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return s},dirname(s){E(s,"path");const o=s.length;if(o===0)return".";let g=-1,a=0;const S=s.charCodeAt(0);if(o===1)return h(S)?s:".";if(h(S)){if(g=a=1,h(s.charCodeAt(1))){let r=2,u=r;for(;r<o&&!h(s.charCodeAt(r));)r++;if(r<o&&r!==u){for(u=r;r<o&&h(s.charCodeAt(r));)r++;if(r<o&&r!==u){for(u=r;r<o&&!h(s.charCodeAt(r));)r++;if(r===o)return s;r!==u&&(g=a=r+1)}}}}else v(S)&&s.charCodeAt(1)===L&&(g=o>2&&h(s.charCodeAt(2))?3:2,a=g);let n=-1,t=!0;for(let r=o-1;r>=a;--r)if(h(s.charCodeAt(r))){if(!t){n=r;break}}else t=!1;if(n===-1){if(g===-1)return".";n=g}return s.slice(0,n)},basename(s,o){o!==void 0&&E(o,"ext"),E(s,"path");let g=0,a=-1,S=!0,n;if(s.length>=2&&v(s.charCodeAt(0))&&s.charCodeAt(1)===L&&(g=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,r=-1;for(n=s.length-1;n>=g;--n){const u=s.charCodeAt(n);if(h(u)){if(!S){g=n+1;break}}else r===-1&&(S=!1,r=n+1),t>=0&&(u===o.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=r))}return g===a?a=r:a===-1&&(a=s.length),s.slice(g,a)}for(n=s.length-1;n>=g;--n)if(h(s.charCodeAt(n))){if(!S){g=n+1;break}}else a===-1&&(S=!1,a=n+1);return a===-1?"":s.slice(g,a)},extname(s){E(s,"path");let o=0,g=-1,a=0,S=-1,n=!0,t=0;s.length>=2&&s.charCodeAt(1)===L&&v(s.charCodeAt(0))&&(o=a=2);for(let r=s.length-1;r>=o;--r){const u=s.charCodeAt(r);if(h(u)){if(!n){a=r+1;break}continue}S===-1&&(n=!1,S=r+1),u===D?g===-1?g=r:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||S===-1||t===0||t===1&&g===S-1&&g===a+1?"":s.slice(g,S)},format:w.bind(null,"\\"),parse(s){E(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const g=s.length;let a=0,S=s.charCodeAt(0);if(g===1)return h(S)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(h(S)){if(a=1,h(s.charCodeAt(1))){let b=2,d=b;for(;b<g&&!h(s.charCodeAt(b));)b++;if(b<g&&b!==d){for(d=b;b<g&&h(s.charCodeAt(b));)b++;if(b<g&&b!==d){for(d=b;b<g&&!h(s.charCodeAt(b));)b++;b===g?a=b:b!==d&&(a=b+1)}}}}else if(v(S)&&s.charCodeAt(1)===L){if(g<=2)return o.root=o.dir=s,o;if(a=2,h(s.charCodeAt(2))){if(g===3)return o.root=o.dir=s,o;a=3}}a>0&&(o.root=s.slice(0,a));let n=-1,t=a,r=-1,u=!0,c=s.length-1,f=0;for(;c>=a;--c){if(S=s.charCodeAt(c),h(S)){if(!u){t=c+1;break}continue}r===-1&&(u=!1,r=c+1),S===D?n===-1?n=c:f!==1&&(f=1):n!==-1&&(f=-1)}return r!==-1&&(n===-1||f===0||f===1&&n===r-1&&n===t+1?o.base=o.name=s.slice(t,r):(o.name=s.slice(t,n),o.base=s.slice(t,r),o.ext=s.slice(n,r))),t>0&&t!==a?o.dir=s.slice(0,t-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let o="",g=!1;for(let a=s.length-1;a>=-1&&!g;a--){const S=a>=0?s[a]:m.cwd();E(S,"path"),S.length!==0&&(o=`${S}/${o}`,g=S.charCodeAt(0)===_)}return o=A(o,!g,"/",p),g?`/${o}`:o.length>0?o:"."},normalize(s){if(E(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===_,g=s.charCodeAt(s.length-1)===_;return s=A(s,!o,"/",p),s.length===0?o?"/":g?"./":".":(g&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return E(s,"path"),s.length>0&&s.charCodeAt(0)===_},join(...s){if(s.length===0)return".";let o;for(let g=0;g<s.length;++g){const a=s[g];E(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(E(s,"from"),E(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const g=1,a=s.length,S=a-g,n=1,t=o.length-n,r=S<t?S:t;let u=-1,c=0;for(;c<r;c++){const b=s.charCodeAt(g+c);if(b!==o.charCodeAt(n+c))break;b===_&&(u=c)}if(c===r)if(t>r){if(o.charCodeAt(n+c)===_)return o.slice(n+c+1);if(c===0)return o.slice(n+c)}else S>r&&(s.charCodeAt(g+c)===_?u=c:c===0&&(u=0));let f="";for(c=g+u+1;c<=a;++c)(c===a||s.charCodeAt(c)===_)&&(f+=f.length===0?"..":"/..");return`${f}${o.slice(n+u)}`},toNamespacedPath(s){return s},dirname(s){if(E(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===_;let g=-1,a=!0;for(let S=s.length-1;S>=1;--S)if(s.charCodeAt(S)===_){if(!a){g=S;break}}else a=!1;return g===-1?o?"/":".":o&&g===1?"//":s.slice(0,g)},basename(s,o){o!==void 0&&E(o,"ext"),E(s,"path");let g=0,a=-1,S=!0,n;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,r=-1;for(n=s.length-1;n>=0;--n){const u=s.charCodeAt(n);if(u===_){if(!S){g=n+1;break}}else r===-1&&(S=!1,r=n+1),t>=0&&(u===o.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=r))}return g===a?a=r:a===-1&&(a=s.length),s.slice(g,a)}for(n=s.length-1;n>=0;--n)if(s.charCodeAt(n)===_){if(!S){g=n+1;break}}else a===-1&&(S=!1,a=n+1);return a===-1?"":s.slice(g,a)},extname(s){E(s,"path");let o=-1,g=0,a=-1,S=!0,n=0;for(let t=s.length-1;t>=0;--t){const r=s.charCodeAt(t);if(r===_){if(!S){g=t+1;break}continue}a===-1&&(S=!1,a=t+1),r===D?o===-1?o=t:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||a===-1||n===0||n===1&&o===a-1&&o===g+1?"":s.slice(o,a)},format:w.bind(null,"/"),parse(s){E(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const g=s.charCodeAt(0)===_;let a;g?(o.root="/",a=1):a=0;let S=-1,n=0,t=-1,r=!0,u=s.length-1,c=0;for(;u>=a;--u){const f=s.charCodeAt(u);if(f===_){if(!r){n=u+1;break}continue}t===-1&&(r=!1,t=u+1),f===D?S===-1?S=u:c!==1&&(c=1):S!==-1&&(c=-1)}if(t!==-1){const f=n===0&&g?1:n;S===-1||c===0||c===1&&S===t-1&&S===n+1?o.base=o.name=s.slice(f,t):(o.name=s.slice(f,S),o.base=s.slice(f,t),o.ext=s.slice(S,t))}return n>0?o.dir=s.slice(0,n-1):g&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[94],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var i;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...P){const D=P.reduce((L,T)=>(L[T]=!0,L),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(L=>!D[L]).forEach(L=>{for(let T=0;T<_.length;T++)if(L.search(_[T])!==-1){delete C[L];break}})}e.sanitizeProcessEnvironment=y}),define(ve[46],we([0,1,12]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=m.globals.performance&&typeof m.globals.performance.now=="function";class y{constructor(P){this._highResolution=i&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new y(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=y}),define(ve[3],we([0,1,15,75,6,93,46]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(o){o.None=()=>y.Disposable.None;function g(M){return(W,z=null,O)=>{let V=!1,K;return K=M(G=>{if(!V)return K?K.dispose():V=!0,W.call(z,G)},null,O),V&&K.dispose(),K}}o.once=g;function a(M,W){return c((z,O=null,V)=>M(K=>z.call(O,W(K)),null,V))}o.map=a;function S(M,W){return c((z,O=null,V)=>M(K=>{W(K),z.call(O,K)},null,V))}o.forEach=S;function n(M,W){return c((z,O=null,V)=>M(K=>W(K)&&z.call(O,K),null,V))}o.filter=n;function t(M){return M}o.signal=t;function r(...M){return(W,z=null,O)=>(0,y.combinedDisposable)(...M.map(V=>V(K=>W.call(z,K),null,O)))}o.any=r;function u(M,W,z){let O=z;return a(M,V=>(O=W(O,V),O))}o.reduce=u;function c(M){let W;const z=new l({onFirstListenerAdd(){W=M(z.fire,z)},onLastListenerRemove(){W.dispose()}});return z.event}function f(M,W,z,O=100,V=!1){let K,G,Q=0;return M(Y=>{Q++,K=z(K,Y),V&&!G&&(W(K),K=void 0),clearTimeout(G),G=setTimeout(()=>{const fe=K;K=void 0,G=void 0,(!V||Q>1)&&W(fe),Q=0},O)})}o.debouncedListener=f;function b(M,W,z=100,O=!1,V){let K,G,Q,Y=0;const fe=new l({leakWarningThreshold:V,onFirstListenerAdd(){K=M(me=>{Y++,G=W(G,me),O&&!Q&&(fe.fire(G),G=void 0),clearTimeout(Q),Q=setTimeout(()=>{const Se=G;G=void 0,Q=void 0,(!O||Y>1)&&fe.fire(Se),Y=0},z)})},onLastListenerRemove(){K.dispose()}});return fe.event}o.debounce=b;function d(M,W=(z,O)=>z===O){let z=!0,O;return n(M,V=>{const K=z||!W(V,O);return z=!1,O=V,K})}o.latch=d;function k(M,W){return[o.filter(M,W),o.filter(M,z=>!W(z))]}o.split=k;function R(M,W=!1,z=[]){let O=z.slice(),V=M(Q=>{O?O.push(Q):G.fire(Q)});const K=()=>{O&&O.forEach(Q=>G.fire(Q)),O=null},G=new l({onFirstListenerAdd(){V||(V=M(Q=>G.fire(Q)))},onFirstListenerDidAdd(){O&&(W?setTimeout(K):K())},onLastListenerRemove(){V&&V.dispose(),V=null}});return G.event}o.buffer=R;class N{constructor(W){this.event=W}map(W){return new N(a(this.event,W))}forEach(W){return new N(S(this.event,W))}filter(W){return new N(n(this.event,W))}reduce(W,z){return new N(u(this.event,W,z))}latch(){return new N(d(this.event))}debounce(W,z=100,O=!1,V){return new N(b(this.event,W,z,O,V))}on(W,z,O){return this.event(W,z,O)}once(W,z,O){return g(this.event)(W,z,O)}}function B(M){return new N(M)}o.chain=B;function F(M,W,z=O=>O){const O=(...Q)=>G.fire(z(...Q)),V=()=>M.on(W,O),K=()=>M.removeListener(W,O),G=new l({onFirstListenerAdd:V,onLastListenerRemove:K});return G.event}o.fromNodeEventEmitter=F;function U(M,W,z=O=>O){const O=(...Q)=>G.fire(z(...Q)),V=()=>M.addEventListener(W,O),K=()=>M.removeEventListener(W,O),G=new l({onFirstListenerAdd:V,onLastListenerRemove:K});return G.event}o.fromDOMEventEmitter=U;function H(M){return new Promise(W=>g(M)(W))}o.toPromise=H;function x(M,W){return W(void 0),M(z=>W(z))}o.runAndSubscribe=x})(D=e.Event||(e.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new P.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let I=-1;function L(o){const g=I;return I=o,{dispose(){I=g}}}e.setGlobalLeakWarningThreshold=L;class T{constructor(g,a=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let a=I;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||g<a)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(S)||0;if(this._stacks.set(S,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,r=0;for(const[u,c]of this._stacks)(!t||r<c)&&(t=u,r=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(S)||0;this._stacks.set(S,t-1)}}}class l{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=I>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,a,S)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(a?[g,a]:g);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,a);const r=this._leakageMon?.check(this._listeners.size),u=(0,y.toDisposable)(()=>{r&&r(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof y.DisposableStore?S.add(u):Array.isArray(S)&&S.push(u),u}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,S]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,S):a[0].call(a[1],S)}catch(n){(0,m.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class E extends l{async fireAsync(g,a,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,g]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),r=[],u={...t,token:a,waitUntil:c=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");S&&(c=S(c,typeof n=="function"?n:n[0])),r.push(c)}};try{typeof n=="function"?n.call(void 0,u):n[0].call(n[1],u)}catch(c){(0,m.onUnexpectedError)(c);continue}Object.freeze(r),await Promise.allSettled(r).then(c=>{for(const f of c)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class h extends l{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=h;class p extends h{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=p;class v extends l{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const a={event:g,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const S=()=>{this.hasListeners&&this.unhook(a);const n=this.events.indexOf(a);this.events.splice(n,1)};return(0,y.toDisposable)((0,i.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(a=>this.emitter.fire(a))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=A;class w{constructor(){this.buffers=[]}wrapEvent(g){return(a,S,n)=>g(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>a.call(S,t)):a.call(S,t)},void 0,n)}bufferEvents(g){const a=[];this.buffers.push(a);const S=g();return this.buffers.pop(),a.forEach(n=>n()),S}}e.EventBufferer=w;class s{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=y.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ve[21],we([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(D,_){const I=setTimeout(D.bind(_),0);return{dispose(){clearTimeout(I)}}});var y;(function(D){function _(I){return I===D.None||I===D.Cancelled||I instanceof C?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}D.isCancellationToken=_,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=P}),define(ve[95],we([0,1,15,6]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=y;function C(s){const o=s;return o?y(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(s,o){return new D(s,o)}e.newWriteableStream=P;class D{constructor(o,g){this.reducer=o,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(g=>g(o))}emitError(o){this.listeners.error.length===0?(0,m.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(g=>g(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,g){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(o,g){if(this.state.destroyed)return;let a;switch(o){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const S=a.indexOf(g);S>=0&&a.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(s,o){const g=[];let a;for(;(a=s.read())!==null;)g.push(a);return o(g)}e.consumeReadable=_;function I(s,o,g){const a=[];let S;for(;(S=s.read())!==null&&a.length<g;)a.push(S);return S===null&&a.length>0?o(a):{read:()=>{if(a.length>0)return a.shift();if(typeof S!="undefined"){const n=S;return S=void 0,n}return s.read()}}}e.peekReadable=I;function L(s,o){return new Promise((g,a)=>{const S=[];T(s,{onData:n=>{o&&S.push(n)},onError:n=>{o?a(n):g(void 0)},onEnd:()=>{g(o?o(S):void 0)}})})}e.consumeStream=L;function T(s,o){let g=!1;return s.on("error",a=>{g||o.onError(a)}),s.on("end",()=>{g||o.onEnd()}),s.on("data",a=>{g||o.onData(a)}),(0,i.toDisposable)(()=>g=!0)}e.listenStream=T;function l(s,o){return new Promise((g,a)=>{const S=new i.DisposableStore,n=[],t=c=>{if(n.push(c),n.length>o)return S.dispose(),s.pause(),g({stream:s,buffer:n,ended:!1})},r=c=>a(c),u=()=>g({stream:s,buffer:n,ended:!0});S.add((0,i.toDisposable)(()=>s.removeListener("error",r))),s.on("error",r),S.add((0,i.toDisposable)(()=>s.removeListener("end",u))),s.on("end",u),S.add((0,i.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=l;function E(s,o){const g=P(o);return g.end(s),g}e.toStream=E;function h(){const s=P(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=h;function p(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}e.toReadable=p;function v(s,o,g){const a=P(g);return T(s,{onData:S=>a.write(o.data(S)),onError:S=>a.error(o.error?o.error(S):S),onEnd:()=>a.end()}),a}e.transform=v;function A(s,o,g){let a=!1;return{read:()=>{const S=o.read();return a?S:(a=!0,S!==null?g([s,S]):s)}}}e.prefixedReadable=A;function w(s,o,g){let a=!1;const S=P(g);return T(o,{onData:n=>a?S.write(n):(a=!0,S.write(g([s,n]))),onError:n=>S.error(n),onEnd:()=>{a||(a=!0,S.write(s)),S.end()}}),S}e.prefixedStream=w}),define(ve[22],we([0,1,95]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let y,C;class P{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new P(Buffer.allocUnsafe(t)):new P(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new P(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&i?new P(Buffer.from(t)):(y||(y=new TextEncoder),new P(y.encode(t)))}static fromByteArray(t){const r=P.alloc(t.length);for(let u=0,c=t.length;u<c;u++)r.buffer[u]=t[u];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let f=0,b=t.length;f<b;f++)r+=t[f].byteLength}const u=P.alloc(r);let c=0;for(let f=0,b=t.length;f<b;f++){const d=t[f];u.set(d,c),c+=d.byteLength}return u}clone(){const t=P.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,r){return new P(this.buffer.subarray(t,r))}set(t,r){if(t instanceof P)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,r){L(this.buffer,t,r)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,r){l(this.buffer,t,r)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,r){h(this.buffer,t,r)}}e.VSBuffer=P;function D(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=D;function _(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255}e.writeUInt16LE=_;function I(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=I;function L(n,t,r){n[r+3]=t,t=t>>>8,n[r+2]=t,t=t>>>8,n[r+1]=t,t=t>>>8,n[r]=t}e.writeUInt32BE=L;function T(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=T;function l(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255,t=t>>>8,n[r+2]=t&255,t=t>>>8,n[r+3]=t&255}e.writeUInt32LE=l;function E(n,t){return n[t]}e.readUInt8=E;function h(n,t,r){n[r]=t}e.writeUInt8=h;function p(n){return m.consumeReadable(n,t=>P.concat(t))}e.readableToBuffer=p;function v(n){return m.toReadable(n)}e.bufferToReadable=v;function A(n){return m.consumeStream(n,t=>P.concat(t))}e.streamToBuffer=A;async function w(n){return n.ended?P.concat(n.buffer):P.concat([...n.buffer,await A(n.stream)])}e.bufferedStreamToBuffer=w;function s(n){return m.toStream(n,t=>P.concat(t))}e.bufferToStream=s;function o(n){return m.transform(n,{data:t=>typeof t=="string"?P.fromString(t):P.wrap(t)},t=>P.concat(t))}e.streamToBufferReadableStream=o;function g(n){return m.newWriteableStream(t=>P.concat(t),n)}e.newWriteableBufferStream=g;function a(n,t){return m.prefixedReadable(n,t,r=>P.concat(r))}e.prefixedBufferReadable=a;function S(n,t){return m.prefixedStream(n,t,r=>P.concat(r))}e.prefixedBufferStream=S}),define(ve[8],we([0,1,12]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function i(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=i;const y=/{(\d+)}/g;function C(ie,..._e){return _e.length===0?ie:ie.replace(y,function(Fe,Ue){const Xe=parseInt(Ue,10);return isNaN(Xe)||Xe<0||Xe>=_e.length?Fe:_e[Xe]})}e.format=C;const P=/{([^}]+)}/g;function D(ie,_e){return ie.replace(P,(Fe,Ue)=>_e[Ue]??Fe)}e.format2=D;function _(ie){return ie.replace(/[<>&]/g,function(_e){switch(_e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _e}})}e.escape=_;function I(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function L(ie,_e){let Fe=0;const Ue=_e.charCodeAt(0);for(let Xe=ie.length-1;Xe>=0;Xe--)ie.charCodeAt(Xe)===Ue&&Fe++;return Fe}e.count=L;function T(ie,_e,Fe="\u2026"){return ie.length<=_e?ie:`${ie.substr(0,_e)}${Fe}`}e.truncate=T;function l(ie,_e=" "){const Fe=E(ie,_e);return h(Fe,_e)}e.trim=l;function E(ie,_e){if(!ie||!_e)return ie;const Fe=_e.length;if(Fe===0||ie.length===0)return ie;let Ue=0;for(;ie.indexOf(_e,Ue)===Ue;)Ue=Ue+Fe;return ie.substring(Ue)}e.ltrim=E;function h(ie,_e){if(!ie||!_e)return ie;const Fe=_e.length,Ue=ie.length;if(Fe===0||Ue===0)return ie;let Xe=Ue,Ae=-1;for(;Ae=ie.lastIndexOf(_e,Xe-1),!(Ae===-1||Ae+Fe!==Xe);){if(Ae===0)return"";Xe=Ae}return ie.substring(0,Xe)}e.rtrim=h;function p(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(ie){return ie.replace(/\*/g,"")}e.stripWildcards=v;function A(ie,_e,Fe={}){if(!ie)throw new Error("Cannot create regex from empty string");_e||(ie=I(ie)),Fe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Ue="";return Fe.global&&(Ue+="g"),Fe.matchCase||(Ue+="i"),Fe.multiline&&(Ue+="m"),Fe.unicode&&(Ue+="u"),new RegExp(ie,Ue)}e.createRegExp=A;function w(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function s(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=s;function o(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=o;function g(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=g;function a(ie){for(let _e=0,Fe=ie.length;_e<Fe;_e++){const Ue=ie.charCodeAt(_e);if(Ue!==32&&Ue!==9)return _e}return-1}e.firstNonWhitespaceIndex=a;function S(ie,_e=0,Fe=ie.length){for(let Ue=_e;Ue<Fe;Ue++){const Xe=ie.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return ie.substring(_e,Ue)}return ie.substring(_e,Fe)}e.getLeadingWhitespace=S;function n(ie,_e=ie.length-1){for(let Fe=_e;Fe>=0;Fe--){const Ue=ie.charCodeAt(Fe);if(Ue!==32&&Ue!==9)return Fe}return-1}e.lastNonWhitespaceIndex=n;function t(ie,_e){return ie<_e?-1:ie>_e?1:0}e.compare=t;function r(ie,_e,Fe=0,Ue=ie.length,Xe=0,Ae=_e.length){for(;Fe<Ue&&Xe<Ae;Fe++,Xe++){let le=ie.charCodeAt(Fe),de=_e.charCodeAt(Xe);if(le<de)return-1;if(le>de)return 1}const Pe=Ue-Fe,ye=Ae-Xe;return Pe<ye?-1:Pe>ye?1:0}e.compareSubstring=r;function u(ie,_e){return c(ie,_e,0,ie.length,0,_e.length)}e.compareIgnoreCase=u;function c(ie,_e,Fe=0,Ue=ie.length,Xe=0,Ae=_e.length){for(;Fe<Ue&&Xe<Ae;Fe++,Xe++){let le=ie.charCodeAt(Fe),de=_e.charCodeAt(Xe);if(le===de)continue;if(le>=128||de>=128)return r(ie.toLowerCase(),_e.toLowerCase(),Fe,Ue,Xe,Ae);f(le)&&(le-=32),f(de)&&(de-=32);const be=le-de;if(be!==0)return be}const Pe=Ue-Fe,ye=Ae-Xe;return Pe<ye?-1:Pe>ye?1:0}e.compareSubstringIgnoreCase=c;function f(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=f;function b(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=b;function d(ie,_e){return ie.length===_e.length&&c(ie,_e)===0}e.equalsIgnoreCase=d;function k(ie,_e){const Fe=_e.length;return _e.length>ie.length?!1:c(ie,_e,0,Fe)===0}e.startsWithIgnoreCase=k;function R(ie,_e){let Fe,Ue=Math.min(ie.length,_e.length);for(Fe=0;Fe<Ue;Fe++)if(ie.charCodeAt(Fe)!==_e.charCodeAt(Fe))return Fe;return Ue}e.commonPrefixLength=R;function N(ie,_e){let Fe,Ue=Math.min(ie.length,_e.length);const Xe=ie.length-1,Ae=_e.length-1;for(Fe=0;Fe<Ue;Fe++)if(ie.charCodeAt(Xe-Fe)!==_e.charCodeAt(Ae-Fe))return Fe;return Ue}e.commonSuffixLength=N;function B(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=B;function F(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=F;function U(ie,_e){return(ie-55296<<10)+(_e-56320)+65536}e.computeCodePoint=U;function H(ie,_e,Fe){const Ue=ie.charCodeAt(Fe);if(B(Ue)&&Fe+1<_e){const Xe=ie.charCodeAt(Fe+1);if(F(Xe))return U(Ue,Xe)}return Ue}e.getNextCodePoint=H;function x(ie,_e){const Fe=ie.charCodeAt(_e-1);if(F(Fe)&&_e>1){const Ue=ie.charCodeAt(_e-2);if(B(Ue))return U(Ue,Fe)}return Fe}function M(ie,_e){const Fe=it.getInstance(),Ue=_e,Xe=ie.length,Ae=H(ie,Xe,_e);_e+=Ae>=65536?2:1;let Pe=Fe.getGraphemeBreakType(Ae);for(;_e<Xe;){const ye=H(ie,Xe,_e),le=Fe.getGraphemeBreakType(ye);if(ot(Pe,le))break;_e+=ye>=65536?2:1,Pe=le}return _e-Ue}e.nextCharLength=M;function W(ie,_e){const Fe=it.getInstance(),Ue=_e,Xe=x(ie,_e);_e-=Xe>=65536?2:1;let Ae=Fe.getGraphemeBreakType(Xe);for(;_e>0;){const Pe=x(ie,_e),ye=Fe.getGraphemeBreakType(Pe);if(ot(ye,Ae))break;_e-=Pe>=65536?2:1,Ae=ye}return Ue-_e}e.prevCharLength=W;function z(ie,_e){const Fe=it.getInstance(),Ue=ie.length,Xe=_e,Ae=H(ie,Ue,_e),Pe=Fe.getGraphemeBreakType(Ae);_e+=Ae>=65536?2:1;let ye=Pe;for(;_e<Ue;){const de=H(ie,Ue,_e),be=Fe.getGraphemeBreakType(de);if(ot(ye,be))break;_e+=de>=65536?2:1,ye=be}const le=_e;for(_e=Xe,ye=Pe;_e>0;){const de=x(ie,_e),be=Fe.getGraphemeBreakType(de);if(ot(be,ye))break;_e-=de>=65536?2:1,ye=be}return[_e,le]}function O(ie,_e){return _e>0&&F(ie.charCodeAt(_e))?z(ie,_e-1):z(ie,_e)}e.getCharContainingOffset=O;const V=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(ie){return V.test(ie)}e.containsRTL=K;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function Q(ie){return G.test(ie)}e.containsEmoji=Q;const Y=/^[\t\n\r\x20-\x7E]*$/;function fe(ie){return Y.test(ie)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function me(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=me;function Se(ie){for(let _e=0,Fe=ie.length;_e<Fe;_e++)if(Ie(ie.charCodeAt(_e)))return!0;return!1}e.containsFullWidthCharacter=Se;function Ie(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=Ie;function Oe(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=Oe;function We(ie,_e){if(ie.length<_e)return ie;const Fe=/\b/g;let Ue=0;for(;Fe.test(ie)&&!(ie.length-Fe.lastIndex<_e);)Ue=Fe.lastIndex,Fe.lastIndex+=1;return ie.substring(Ue).replace(/^\s/,"")}e.lcut=We;const j=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(ie){return ie&&(ie=ie.replace(j,""),ie=ie.replace(Z,""),ie=ie.replace(re,"")),ie}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function te(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=te;function oe(ie){return te(ie)?ie.substr(1):ie}e.stripUTF8BOM=oe;function Ee(ie,_e){if(!ie||!_e||ie.length<_e.length)return!1;const Fe=_e.length,Ue=ie.toLowerCase();let Xe=0,Ae=-1;for(;Xe<Fe;){const Pe=Ue.indexOf(_e[Xe],Ae+1);if(Pe<0)return!1;Ae=Pe,Xe++}return!0}e.fuzzyContains=Ee;function Ne(ie,_e=!1){return ie?(_e&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Ne;function Ve(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Ve;function Ge(ie,_e=1){if(_e===0)return"";let Fe=-1;do Fe=ie.indexOf(`
`,Fe+1),_e--;while(_e>0&&Fe>=0);return Fe===-1?ie:(ie[Fe-1]==="\r"&&Fe--,ie.substr(0,Fe))}e.getNLines=Ge;function Je(ie){const _e=90-65+1;return ie=ie%(2*_e),ie<_e?String.fromCharCode(97+ie):String.fromCharCode(65+ie-_e)}e.singleLetterHash=Je;function tt(ie){return it.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=tt;function ot(ie,_e){return ie===0?_e!==5&&_e!==7:ie===2&&_e===3?!1:ie===4||ie===2||ie===3||_e===4||_e===2||_e===3?!0:!(ie===8&&(_e===8||_e===9||_e===11||_e===12)||(ie===11||ie===9)&&(_e===9||_e===10)||(ie===12||ie===10)&&_e===10||_e===5||_e===13||_e===7||ie===1||ie===13&&_e===14||ie===6&&_e===6)}e.breakBetweenGraphemeBreakType=ot;var et;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class it{constructor(){this._data=ct()}static getInstance(){return it._INSTANCE||(it._INSTANCE=new it),it._INSTANCE}getGraphemeBreakType(_e){if(_e<32)return _e===10?3:_e===13?2:4;if(_e<127)return 0;const Fe=this._data,Ue=Fe.length/3;let Xe=1;for(;Xe<=Ue;)if(_e<Fe[3*Xe])Xe=2*Xe;else if(_e>Fe[3*Xe+1])Xe=2*Xe+1;else return Fe[3*Xe+2];return 0}}it._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pt(ie,_e){if(ie===0)return 0;const Fe=Pt(ie,_e);if(Fe!==void 0)return Fe;const Ue=x(_e,ie);return ie-=xe(Ue),ie}e.getLeftDeleteOffset=pt;function Pt(ie,_e){let Fe=x(_e,ie);for(ie-=xe(Fe);Rt(Fe)||Fe===65039||Fe===8419;){if(ie===0)return;Fe=x(_e,ie),ie-=xe(Fe)}if(!!Oe(Fe)){if(ie>=0){const Ue=x(_e,ie);Ue===8205&&(ie-=xe(Ue))}return ie}}function xe(ie){return ie>=65536?2:1}function Rt(ie){return 127995<=ie&&ie<=127999}var ee;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ne{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!ne.map){let Ue=function(Pe){const ye=new Map;for(let le=0;le<Pe.length;le+=2)ye.set(Pe[le],Pe[le+1]);return ye};const _e=ne.getData();let Fe=m.locale;(!Fe||!(Fe in _e))&&(Fe=m.language),(!Fe||!(Fe in _e))&&(Fe="_default");const Xe=Ue(_e._common),Ae=Ue(_e[Fe]);for(const[Pe,ye]of Ae)Xe.set(Pe,ye);ne.map=Xe}return ne.map}static isAmbiguous(_e){return ne.getConfusablesForCurrentLocale().has(_e)}static getPrimaryConfusable(_e){return ne.getConfusablesForCurrentLocale().get(_e)}static getPrimaryConfusableCodePoints(){return new Set(ne.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=ne;class pe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(pe.getRawData())),this._data}static isInvisibleCharacter(_e){return pe.getData().has(_e)}static get codePoints(){return pe.getData()}}e.InvisibleCharacters=pe,pe._data=void 0}),define(ve[47],we([0,1,8]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(A){return y(A,0)}e.hash=i;function y(A,w){switch(typeof A){case"object":return A===null?C(349,w):Array.isArray(A)?_(A,w):I(A,w);case"string":return D(A,w);case"boolean":return P(A,w);case"number":return C(A,w);case"undefined":return C(937,w);default:return C(617,w)}}e.doHash=y;function C(A,w){return(w<<5)-w+A|0}e.numberHash=C;function P(A,w){return C(A?433:863,w)}function D(A,w){w=C(149417,w);for(let s=0,o=A.length;s<o;s++)w=C(A.charCodeAt(s),w);return w}e.stringHash=D;function _(A,w){return w=C(104579,w),A.reduce((s,o)=>y(o,s),w)}function I(A,w){return w=C(181387,w),Object.keys(A).sort().reduce((s,o)=>(s=D(o,s),y(A[o],s)),w)}class L{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=y(w,this._value),this._value}}e.Hasher=L;var T;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function l(A,w,s=32){const o=s-w,g=~((1<<o)-1);return(A<<w|(g&A)>>>o)>>>0}function E(A,w=0,s=A.byteLength,o=0){for(let g=0;g<s;g++)A[w+g]=o}function h(A,w,s="0"){for(;A.length<w;)A=s+A;return A}function p(A,w=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(s=>s.toString(16).padStart(2,"0")).join(""):h((A>>>0).toString(16),w/4)}e.toHexString=p;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const s=w.length;if(s===0)return;const o=this._buff;let g=this._buffLen,a=this._leftoverHighSurrogate,S,n;for(a!==0?(S=a,n=-1,a=0):(S=w.charCodeAt(0),n=0);;){let t=S;if(m.isHighSurrogate(S))if(n+1<s){const r=w.charCodeAt(n+1);m.isLowSurrogate(r)?(n++,t=m.computeCodePoint(S,r)):t=65533}else{a=S;break}else m.isLowSurrogate(S)&&(t=65533);if(g=this._push(o,g,t),n++,n<s)S=w.charCodeAt(n);else break}this._buffLen=g,this._leftoverHighSurrogate=a}_push(w,s,o){return o<128?w[s++]=o:o<2048?(w[s++]=192|(o&1984)>>>6,w[s++]=128|(o&63)>>>0):o<65536?(w[s++]=224|(o&61440)>>>12,w[s++]=128|(o&4032)>>>6,w[s++]=128|(o&63)>>>0):(w[s++]=240|(o&1835008)>>>18,w[s++]=128|(o&258048)>>>12,w[s++]=128|(o&4032)>>>6,w[s++]=128|(o&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,s=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,s.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,l(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let o=this._h0,g=this._h1,a=this._h2,S=this._h3,n=this._h4,t,r,u;for(let c=0;c<80;c++)c<20?(t=g&a|~g&S,r=1518500249):c<40?(t=g^a^S,r=1859775393):c<60?(t=g&a|g&S|a&S,r=2400959708):(t=g^a^S,r=3395469782),u=l(o,5)+t+n+r+w.getUint32(c*4,!1)&4294967295,n=S,S=a,a=l(g,30),g=o,o=u;this._h0=this._h0+o&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[24],we([0,1,16,8]),function(J,e,m,i){"use strict";var y,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(n,t,r){let u=n.get(t);return u===void 0&&(u=r,n.set(t,u)),u}e.getOrSet=D;function _(n){const t=[];return n.forEach((r,u)=>{t.push(`${u} => ${r}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=_;function I(n){const t=[];return n.forEach(r=>{t.push(r)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=I;class L{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),u=this._value.charCodeAt(this._pos);return r-u}value(){return this._value[this._pos]}}e.StringIterator=L;class T{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class l{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const u=this._value.charCodeAt(r);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var E;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class A{constructor(t){this._iter=t}static forUris(t=()=>!1){return new A(new h(t))}static forPaths(){return new A(new l)}static forStrings(){return new A(new L)}static forConfigKeys(){return new A(new T)}clear(){this._root=void 0}fill(t,r){if(r){const u=r.slice(0);(0,m.shuffle)(u);for(let c of u)this.set(c,t)}else{const u=t.slice(0);(0,m.shuffle)(u);for(let c of u)this.set(c[0],c[1])}}set(t,r){const u=this._iter.reset(t);let c;this._root||(this._root=new p,this._root.segment=u.value());const f=[];for(c=this._root;;){const d=u.cmp(c.segment);if(d>0)c.left||(c.left=new p,c.left.segment=u.value()),f.push([-1,c]),c=c.left;else if(d<0)c.right||(c.right=new p,c.right.segment=u.value()),f.push([1,c]),c=c.right;else if(u.hasNext())u.next(),c.mid||(c.mid=new p,c.mid.segment=u.value()),f.push([0,c]),c=c.mid;else break}const b=c.value;c.value=r,c.key=t;for(let d=f.length-1;d>=0;d--){const k=f[d][1];k.updateHeight();const R=k.balanceFactor();if(R<-1||R>1){const N=f[d][0],B=f[d+1][0];if(N===1&&B===1)f[d][1]=k.rotateLeft();else if(N===-1&&B===-1)f[d][1]=k.rotateRight();else if(N===1&&B===-1)k.right=f[d+1][1]=f[d+1][1].rotateRight(),f[d][1]=k.rotateLeft();else if(N===-1&&B===1)k.left=f[d+1][1]=f[d+1][1].rotateLeft(),f[d][1]=k.rotateRight();else throw new Error;if(d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this._root=f[0][1]}}return b}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let u=this._root;for(;u;){const c=r.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else break}return u}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const u=this._iter.reset(t),c=[];let f=this._root;for(;f;){const b=u.cmp(f.segment);if(b>0)c.push([-1,f]),f=f.left;else if(b<0)c.push([1,f]),f=f.right;else if(u.hasNext())u.next(),c.push([0,f]),f=f.mid;else break}if(!!f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const b=this._min(f.right),{key:d,value:k,segment:R}=b;this._delete(b.key,!1),f.key=d,f.value=k,f.segment=R}else{const b=f.left??f.right;if(c.length>0){const[d,k]=c[c.length-1];switch(d){case-1:k.left=b;break;case 0:k.mid=b;break;case 1:k.right=b;break}}else this._root=b}for(let b=c.length-1;b>=0;b--){const d=c[b][1];d.updateHeight();const k=d.balanceFactor();if(k>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),c[b][1]=d.rotateLeft()):k<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),c[b][1]=d.rotateRight()),b>0)switch(c[b-1][0]){case-1:c[b-1][1].left=c[b][1];break;case 1:c[b-1][1].right=c[b][1];break;case 0:c[b-1][1].mid=c[b][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let u=this._root,c;for(;u;){const f=r.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(r.hasNext())r.next(),c=u.value||c,u=u.mid;else break}return u&&u.value||c}findSuperstr(t){const r=this._iter.reset(t);let u=this._root;for(;u;){const c=r.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(t){for(const[r,u]of this)t(u,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const u=r.balanceFactor();return u<-1||u>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=A;class w{constructor(t,r){this.uri=t,this.value=r}}class s{constructor(t,r){this[y]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=r??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new w(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[u,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=n=>n.toString();var o;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const u=this._map.get(t);if(!!u)return r!==0&&this.touch(u,r),u.value}set(t,r,u=0){let c=this._map.get(t);if(c)c.value=r,u!==0&&this.touch(c,u);else{switch(c={key:t,value:r,next:void 0,previous:void 0},u){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const u=this._state;let c=this._head;for(;c;){if(r?t.bind(r)(c.value,c.key,this):t(c.value,c.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,r=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return c}values(){const t=this,r=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return c}entries(){const t=this,r=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return c}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,u=this.size;for(;r&&u>t;)this._map.delete(r.key),r=r.next,u--;this._head=r,this._size=u,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,u=t.previous;if(!r||!u)throw new Error("Invalid list");r.previous=u,u.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const u=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(u.previous=c,c.next=u),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const u=t.next,c=t.previous;t===this._head?(u.previous=void 0,this._head=u):(u.previous=c,c.next=u),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,u)=>{t.push([u,r])}),t}fromJSON(t){this.clear();for(const[r,u]of t)this.set(r,u)}}e.LinkedMap=g;class a extends g{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class S{constructor(t){P.set(this,void 0),nt(this,P,t,"f")}get size(){return Be(this,P,"f").size}forEach(t,r){Be(this,P,"f").forEach(t,r)}get(t){return Be(this,P,"f").get(t)}has(t){return Be(this,P,"f").has(t)}entries(){return Be(this,P,"f").entries()}keys(){return Be(this,P,"f").keys()}values(){return Be(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Be(this,P,"f").entries()}}e.ReadonlyMapView=S}),define(ve[96],we([0,1,24,8]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...te){return function(oe,Ee){for(let Ne=0,Ve=te.length;Ne<Ve;Ne++){const Ge=te[Ne](oe,Ee);if(Ge)return Ge}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(te,oe,Ee){if(!Ee||Ee.length<oe.length)return null;let Ne;return te?Ne=i.startsWithIgnoreCase(Ee,oe):Ne=Ee.indexOf(oe)===0,Ne?oe.length>0?[{start:0,end:oe.length}]:[]:null}function P(te,oe){const Ee=oe.toLowerCase().indexOf(te.toLowerCase());return Ee===-1?null:[{start:Ee,end:Ee+te.length}]}e.matchesContiguousSubString=P;function D(te,oe){return _(te.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function _(te,oe,Ee,Ne){if(Ee===te.length)return[];if(Ne===oe.length)return null;if(te[Ee]===oe[Ne]){let Ve=null;return(Ve=_(te,oe,Ee+1,Ne+1))?A({start:Ne,end:Ne+1},Ve):null}return _(te,oe,Ee,Ne+1)}function I(te){return 97<=te&&te<=122}function L(te){return 65<=te&&te<=90}e.isUpper=L;function T(te){return 48<=te&&te<=57}function l(te){return te===32||te===9||te===10||te===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>E.add(te.charCodeAt(0)));function h(te){return l(te)||E.has(te)}function p(te,oe){return te===oe||h(te)&&h(oe)}function v(te){return I(te)||L(te)||T(te)}function A(te,oe){return oe.length===0?oe=[te]:te.end===oe[0].start?oe[0].start=te.start:oe.unshift(te),oe}function w(te,oe){for(let Ee=oe;Ee<te.length;Ee++){const Ne=te.charCodeAt(Ee);if(L(Ne)||T(Ne)||Ee>0&&!v(te.charCodeAt(Ee-1)))return Ee}return te.length}function s(te,oe,Ee,Ne){if(Ee===te.length)return[];if(Ne===oe.length)return null;if(te[Ee]!==oe[Ne].toLowerCase())return null;{let Ve=null,Ge=Ne+1;for(Ve=s(te,oe,Ee+1,Ne+1);!Ve&&(Ge=w(oe,Ge))<oe.length;)Ve=s(te,oe,Ee+1,Ge),Ge++;return Ve===null?null:A({start:Ne,end:Ne+1},Ve)}}function o(te){let oe=0,Ee=0,Ne=0,Ve=0,Ge=0;for(let it=0;it<te.length;it++)Ge=te.charCodeAt(it),L(Ge)&&oe++,I(Ge)&&Ee++,v(Ge)&&Ne++,T(Ge)&&Ve++;const Je=oe/te.length,tt=Ee/te.length,ot=Ne/te.length,et=Ve/te.length;return{upperPercent:Je,lowerPercent:tt,alphaPercent:ot,numericPercent:et}}function g(te){const{upperPercent:oe,lowerPercent:Ee}=te;return Ee===0&&oe>.6}function a(te){const{upperPercent:oe,lowerPercent:Ee,alphaPercent:Ne,numericPercent:Ve}=te;return Ee>.2&&oe<.8&&Ne>.6&&Ve<.2}function S(te){let oe=0,Ee=0,Ne=0,Ve=0;for(let Ge=0;Ge<te.length;Ge++)Ne=te.charCodeAt(Ge),L(Ne)&&oe++,I(Ne)&&Ee++,l(Ne)&&Ve++;return(oe===0||Ee===0)&&Ve===0?te.length<=30:oe<=5}function n(te,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!S(te)||oe.length>60)return null;const Ee=o(oe);if(!a(Ee)){if(!g(Ee))return null;oe=oe.toLowerCase()}let Ne=null,Ve=0;for(te=te.toLowerCase();Ve<oe.length&&(Ne=s(te,oe,0,Ve))===null;)Ve=w(oe,Ve+1);return Ne}e.matchesCamelCase=n;function t(te,oe,Ee=!1){if(!oe||oe.length===0)return null;let Ne=null,Ve=0;for(te=te.toLowerCase(),oe=oe.toLowerCase();Ve<oe.length&&(Ne=r(te,oe,0,Ve,Ee))===null;)Ve=u(oe,Ve+1);return Ne}e.matchesWords=t;function r(te,oe,Ee,Ne,Ve){if(Ee===te.length)return[];if(Ne===oe.length)return null;if(p(te.charCodeAt(Ee),oe.charCodeAt(Ne))){let Ge=null,Je=Ne+1;if(Ge=r(te,oe,Ee+1,Ne+1,Ve),!Ve)for(;!Ge&&(Je=u(oe,Je))<oe.length;)Ge=r(te,oe,Ee+1,Je,Ve),Je++;return Ge===null?null:A({start:Ne,end:Ne+1},Ge)}else return null}function u(te,oe){for(let Ee=oe;Ee<te.length;Ee++)if(h(te.charCodeAt(Ee))||Ee>0&&h(te.charCodeAt(Ee-1)))return Ee;return te.length}const c=y(e.matchesPrefix,n,P),f=y(e.matchesPrefix,n,D),b=new m.LRUCache(1e4);function d(te,oe,Ee=!1){if(typeof te!="string"||typeof oe!="string")return null;let Ne=b.get(te);Ne||(Ne=new RegExp(i.convertSimple2RegExpPattern(te),"i"),b.set(te,Ne));const Ve=Ne.exec(oe);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:Ee?f(te,oe):c(te,oe)}e.matchesFuzzy=d;function k(te,oe){const Ee=Ie(te,te.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return Ee?N(Ee):null}e.matchesFuzzy2=k;function R(te,oe,Ee,Ne,Ve,Ge){const Je=Math.min(13,te.length);for(;Ee<Je;Ee++){const tt=Ie(te,oe,Ee,Ne,Ve,Ge,!1);if(tt)return tt}return[0,Ge]}e.anyScore=R;function N(te){if(typeof te=="undefined")return[];const oe=[],Ee=te[1];for(let Ne=te.length-1;Ne>1;Ne--){const Ve=te[Ne]+Ee,Ge=oe[oe.length-1];Ge&&Ge.end===Ve?Ge.end=Ve+1:oe.push({start:Ve,end:Ve+1})}return oe}e.createMatches=N;const B=128;function F(){const te=[],oe=[];for(let Ee=0;Ee<=B;Ee++)oe[Ee]=0;for(let Ee=0;Ee<=B;Ee++)te.push(oe.slice(0));return te}function U(te){const oe=[];for(let Ee=0;Ee<=te;Ee++)oe[Ee]=0;return oe}const H=U(2*B),x=U(2*B),M=F(),W=F(),z=F(),O=!1;function V(te,oe,Ee,Ne,Ve){function Ge(tt,ot,et=" "){for(;tt.length<ot;)tt=et+tt;return tt}let Je=` |   |${Ne.split("").map(tt=>Ge(tt,3)).join("|")}
`;for(let tt=0;tt<=Ee;tt++)tt===0?Je+=" |":Je+=`${oe[tt-1]}|`,Je+=te[tt].slice(0,Ve+1).map(ot=>Ge(ot.toString(),3)).join("|")+`
`;return Je}function K(te,oe,Ee,Ne){te=te.substr(oe),Ee=Ee.substr(Ne),console.log(V(W,te,te.length,Ee,Ee.length)),console.log(V(z,te,te.length,Ee,Ee.length)),console.log(V(M,te,te.length,Ee,Ee.length))}function G(te,oe){if(oe<0||oe>=te.length)return!1;const Ee=te.codePointAt(oe);switch(Ee){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(Ee)}}function Q(te,oe){if(oe<0||oe>=te.length)return!1;switch(te.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function Y(te,oe,Ee){return oe[te]!==Ee[te]}function fe(te,oe,Ee,Ne,Ve,Ge,Je=!1){for(;oe<Ee&&Ve<Ge;)te[oe]===Ne[Ve]&&(Je&&(H[oe]=Ve),oe+=1),Ve+=1;return oe===Ee}e.isPatternInWord=fe;var me;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(me||(me={}));var Se;(function(te){te.Default=[-100,0];function oe(Ee){return!Ee||Ee.length===2&&Ee[0]===-100&&Ee[1]===0}te.isDefault=oe})(Se=e.FuzzyScore||(e.FuzzyScore={}));function Ie(te,oe,Ee,Ne,Ve,Ge,Je){const tt=te.length>B?B:te.length,ot=Ne.length>B?B:Ne.length;if(Ee>=tt||Ge>=ot||tt-Ee>ot-Ge||!fe(oe,Ee,tt,Ve,Ge,ot,!0))return;Oe(tt,ot,Ee,Ge,oe,Ve);let et=1,it=1,ct=Ee,pt=Ge;const Pt=[!1];for(et=1,ct=Ee;ct<tt;et++,ct++){const pe=H[ct],ie=x[ct],_e=ct+1<tt?x[ct+1]:ot;for(it=pe-Ge+1,pt=pe;pt<_e;it++,pt++){let Fe=Number.MIN_SAFE_INTEGER,Ue=!1;pt<=ie&&(Fe=We(te,oe,ct,Ee,Ne,Ve,pt,ot,Ge,M[et-1][it-1]===0,Pt));let Xe=0;Fe!==Number.MAX_SAFE_INTEGER&&(Ue=!0,Xe=Fe+W[et-1][it-1]);const Ae=pt>pe,Pe=Ae?W[et][it-1]+(M[et][it-1]>0?-5:0):0,ye=pt>pe+1&&M[et][it-1]>0,le=ye?W[et][it-2]+(M[et][it-2]>0?-5:0):0;if(ye&&(!Ae||le>=Pe)&&(!Ue||le>=Xe))W[et][it]=le,z[et][it]=3,M[et][it]=0;else if(Ae&&(!Ue||Pe>=Xe))W[et][it]=Pe,z[et][it]=2,M[et][it]=0;else if(Ue)W[et][it]=Xe,z[et][it]=1,M[et][it]=M[et-1][it-1]+1;else throw new Error("not possible")}}if(O&&K(te,Ee,Ne,Ge),!Pt[0]&&!Je)return;et--,it--;const xe=[W[et][it],Ge];let Rt=0,ee=0;for(;et>=1;){let pe=it;do{const ie=z[et][pe];if(ie===3)pe=pe-2;else if(ie===2)pe=pe-1;else break}while(pe>=1);Rt>1&&oe[Ee+et-1]===Ve[Ge+it-1]&&!Y(pe+Ge-1,Ne,Ve)&&Rt+1>M[et][pe]&&(pe=it),pe===it?Rt++:Rt=1,ee||(ee=pe),et--,it=pe-1,xe.push(it)}ot===tt&&(xe[0]+=2);const ne=ee-tt;return xe[0]-=ne,xe}e.fuzzyScore=Ie;function Oe(te,oe,Ee,Ne,Ve,Ge){let Je=te-1,tt=oe-1;for(;Je>=Ee&&tt>=Ne;)Ve[Je]===Ge[tt]&&(x[Je]=tt,Je--),tt--}function We(te,oe,Ee,Ne,Ve,Ge,Je,tt,ot,et,it){if(oe[Ee]!==Ge[Je])return Number.MIN_SAFE_INTEGER;let ct=1,pt=!1;return Je===Ee-Ne?ct=te[Ee]===Ve[Je]?7:5:Y(Je,Ve,Ge)&&(Je===0||!Y(Je-1,Ve,Ge))?(ct=te[Ee]===Ve[Je]?7:5,pt=!0):G(Ge,Je)&&(Je===0||!G(Ge,Je-1))?ct=5:(G(Ge,Je-1)||Q(Ge,Je-1))&&(ct=5,pt=!0),ct>1&&Ee===Ne&&(it[0]=!0),pt||(pt=Y(Je,Ve,Ge)||G(Ge,Je-1)||Q(Ge,Je-1)),Ee===Ne?Je>ot&&(ct-=pt?3:5):et?ct+=pt?2:0:ct+=pt?0:1,Je+1===tt&&(ct-=pt?3:5),ct}function j(te,oe,Ee,Ne,Ve,Ge,Je){return re(te,oe,Ee,Ne,Ve,Ge,!0,Je)}e.fuzzyScoreGracefulAggressive=j;function Z(te,oe,Ee,Ne,Ve,Ge,Je){return re(te,oe,Ee,Ne,Ve,Ge,!1,Je)}e.fuzzyScoreGraceful=Z;function re(te,oe,Ee,Ne,Ve,Ge,Je,tt){let ot=Ie(te,oe,Ee,Ne,Ve,Ge,tt);if(ot&&!Je)return ot;if(te.length>=3){const et=Math.min(7,te.length-1);for(let it=Ee+1;it<et;it++){const ct=ue(te,it);if(ct){const pt=Ie(ct,ct.toLowerCase(),Ee,Ne,Ve,Ge,tt);pt&&(pt[0]-=3,(!ot||pt[0]>ot[0])&&(ot=pt))}}}return ot}function ue(te,oe){if(oe+1>=te.length)return;const Ee=te[oe],Ne=te[oe+1];if(Ee!==Ne)return te.slice(0,oe)+Ne+Ee+te.slice(oe+2)}}),define(ve[141],we([0,1,73,96,8]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(m.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${C.source}`,"g");function _(v){return v.replace(D,(A,w)=>w?A:`\\${A}`)}e.escapeIcons=_;const I=new RegExp(`\\\\${C.source}`,"g");function L(v){return v.replace(I,A=>`\\${A}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function l(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(T,(A,w,s,o)=>s?A:w||o||"")}e.stripIcons=l;function E(v){const A=v.indexOf(e.iconStartMarker);return A===-1?{text:v}:h(v,A)}e.parseLabelWithIcons=E;function h(v,A){const w=[];let s="";function o(c){if(c){s+=c;for(const f of c)w.push(S)}}let g=-1,a="",S=0,n,t,r=A;const u=v.length;for(o(v.substr(0,A));r<u;)n=v[r],t=v[r+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=r,o(a),a=e.iconStartMarker,r++):n===")"&&g!==-1?(S+=r-g+1,g=-1,a=""):g!==-1?P.test(n)?a+=n:(o(a),g=-1,a=""):o(n),r++;return o(a),{text:s,iconOffsets:w}}function p(v,A,w=!1){const{text:s,iconOffsets:o}=A;if(!o||o.length===0)return(0,i.matchesFuzzy)(v,s,w);const g=(0,y.ltrim)(s," "),a=s.length-g.length,S=(0,i.matchesFuzzy)(v,g,w);if(S)for(const n of S){const t=o[n.start+a]+a;n.start+=t,n.end+=t}return S}e.matchesFuzzyIconAware=p}),define(ve[97],we([0,1,15,141]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(E="",h=!1){if(this.value=E,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(E,h=0){return this.value+=I(this.supportThemeIcons?(0,i.escapeIcons)(E):E).replace(/([ \t]+)/g,(p,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,h){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function P(l){return D(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function D(l){return l instanceof C?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function _(l,E){return l===E?!0:!l||!E?!1:l.value===E.value&&l.isTrusted===E.isTrusted&&l.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=_;function I(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function L(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function T(l){const E=[],h=l.split("|").map(v=>v.trim());l=h[0];const p=h[1];if(p){const v=/height=(\d+)/.exec(p),A=/width=(\d+)/.exec(p),w=v?v[1]:"",s=A?A[1]:"",o=isFinite(parseInt(s)),g=isFinite(parseInt(w));o&&E.push(`width="${s}"`),g&&E.push(`height="${w}"`)}return{href:l,dimensions:E}}e.parseHrefAndDimensions=T}),define(ve[79],we([0,1,24]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new m.LRUCache(1e4);function y(I){return _(I,"NFC",i)}e.normalizeNFC=y;const C=new m.LRUCache(1e4);function P(I){return _(I,"NFD",C)}e.normalizeNFD=P;const D=/[^\u0000-\u0080]/;function _(I,L,T){if(!I)return I;const l=T.get(I);if(l)return l;let E;return D.test(I)?E=I.normalize(L):E=I,T.set(I,E),E}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return P(L).replace(I,"")}}()}),define(ve[48],we([0,1,8]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(i||(i={})),function(y){const C="error",P="warning",D="warn",_="info",I="ignore";function L(l){return l?m.equalsIgnoreCase(C,l)?y.Error:m.equalsIgnoreCase(P,l)||m.equalsIgnoreCase(D,l)?y.Warning:m.equalsIgnoreCase(_,l)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function T(l){switch(l){case y.Error:return C;case y.Warning:return P;case y.Info:return _;default:return I}}y.toString=T}(i||(i={})),e.default=i}),define(ve[13],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function i(f){return typeof f=="string"}e.isString=i;function y(f){return Array.isArray(f)&&f.every(b=>i(b))}e.isStringArray=y;function C(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=C;function P(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=P;function D(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=D;function _(f){return f===!0||f===!1}e.isBoolean=_;function I(f){return typeof f=="undefined"}e.isUndefined=I;function L(f){return!T(f)}e.isDefined=L;function T(f){return I(f)||f===null}e.isUndefinedOrNull=T;function l(f,b){if(!f)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=l;function E(f){if(T(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=E;function h(...f){const b=[];for(let d=0;d<f.length;d++){const k=f[d];if(T(k))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);b.push(k)}return b}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function v(f){if(!C(f))return!1;for(let b in f)if(p.call(f,b))return!1;return!0}e.isEmptyObject=v;function A(f){return typeof f=="function"}e.isFunction=A;function w(...f){return f.length>0&&f.every(A)}e.areFunctions=w;function s(f,b){const d=Math.min(f.length,b.length);for(let k=0;k<d;k++)o(f[k],b[k])}e.validateConstraints=s;function o(f,b){if(i(b)){if(typeof f!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(A(b)){try{if(f instanceof b)return}catch{}if(!T(f)&&f.constructor===b||b.length===1&&b.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function g(f){let b=[],d=Object.getPrototypeOf(f);for(;Object.prototype!==d;)b=b.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return b}e.getAllPropertyNames=g;function a(f){const b=[];for(const d of g(f))typeof f[d]=="function"&&b.push(d);return b}e.getAllMethodNames=a;function S(f,b){const d=R=>function(){const N=Array.prototype.slice.call(arguments,0);return b(R,N)};let k={};for(const R of f)k[R]=d(R);return k}e.createProxyObject=S;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function r(f){return class{constructor(){return new Proxy({},{get(b,d){if(b[d])return b[d];throw new Error(`Not Implemented: ${f}->${String(d)}`)}})}}}e.NotImplementedProxy=r;function u(f,b="Unreachable"){throw new Error(b)}e.assertNever=u;function c(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=c}),define(ve[30],we([0,1,9,12,8,13]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(n){return n===47||n===92}e.isPathSeparator=P;function D(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=D;function _(n){return n.indexOf("/")===-1&&(n=D(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=_;function I(n,t=m.posix.sep){if(!n)return"";const r=n.length,u=n.charCodeAt(0);if(P(u)){if(P(n.charCodeAt(1))&&!P(n.charCodeAt(2))){let f=3;const b=f;for(;f<r&&!P(n.charCodeAt(f));f++);if(b!==f&&!P(n.charCodeAt(f+1))){for(f+=1;f<r;f++)if(P(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(A(u)&&n.charCodeAt(1)===58)return P(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<r;c++)if(P(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=I;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let r=2;const u=r;for(;r<n.length&&(t=n.charCodeAt(r),t!==92);r++);return!(u===r||(t=n.charCodeAt(r+1),isNaN(t)||t===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=i.isWindows){const r=t?T:l;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||t&&E.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function p(n,t,r){const u=n===t;return!r||u?u:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=p;function v(n,t,r,u=m.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(r){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let f=t.length;return t.charAt(t.length-1)===u&&f--,n.charAt(f)===u}return t.charAt(t.length-1)!==u&&(t+=u),n.indexOf(t)===0}e.isEqualOrParent=v;function A(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=A;function w(n,t){return i.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(t,n)),n=(0,m.normalize)(n),i.isWindows?(n=(0,y.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,y.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=w;function s(n){const t=(0,m.normalize)(n);return i.isWindows?n.length>3?!1:o(t)&&(n.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=s;function o(n,t){return(t!==void 0?t:i.isWindows)?A(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function g(n){return o(n)?n[0]:void 0}e.getDriveLetter=g;function a(n,t,r){return t.length>n.length?-1:n===t?0:(r&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=a;function S(n){const t=n.split(":");let r,u,c;if(t.forEach(f=>{const b=Number(f);(0,C.isNumber)(b)?u===void 0?u=b:c===void 0&&(c=b):r=r?[r,f].join(":"):f}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:u!==void 0?u:void 0,column:c!==void 0?c:u!==void 0?1:void 0}}e.parseLineAndColumnAware=S}),define(ve[25],we([0,1,13]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.keys(p).forEach(A=>{p[A]&&typeof p[A]=="object"?v[A]=i(p[A]):v[A]=p[A]}),v}e.deepClone=i;function y(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const A=v.shift();Object.freeze(A);for(const w in A)if(C.call(A,w)){const s=A[w];typeof s=="object"&&!Object.isFrozen(s)&&v.push(s)}}return p}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function P(p,v){return D(p,v,new Set)}e.cloneAndChange=P;function D(p,v,A){if((0,m.isUndefinedOrNull)(p))return p;const w=v(p);if(typeof w!="undefined")return w;if((0,m.isArray)(p)){const s=[];for(const o of p)s.push(D(o,v,A));return s}if((0,m.isObject)(p)){if(A.has(p))throw new Error("Cannot clone recursive data-structure");A.add(p);const s={};for(let o in p)C.call(p,o)&&(s[o]=D(p[o],v,A));return A.delete(p),s}return p}function _(p,v,A=!0){return(0,m.isObject)(p)?((0,m.isObject)(v)&&Object.keys(v).forEach(w=>{w in p?A&&((0,m.isObject)(p[w])&&(0,m.isObject)(v[w])?_(p[w],v[w],A):p[w]=v[w]):p[w]=v[w]}),p):v}e.mixin=_;function I(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let A,w;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(A=0;A<p.length;A++)if(!I(p[A],v[A]))return!1}else{const s=[];for(w in p)s.push(w);s.sort();const o=[];for(w in v)o.push(w);if(o.sort(),!I(s,o))return!1;for(A=0;A<s.length;A++)if(!I(p[s[A]],v[s[A]]))return!1}return!0}e.equals=I;function L(p){const v=new Set;return JSON.stringify(p,(A,w)=>{if((0,m.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=L;function T(p,v,A){const w=v(p);return typeof w=="undefined"?A:w}e.getOrDefault=T;function l(p,v){const A=Object.create(null);return!p||!v||Object.keys(v).forEach(s=>{const o=p[s],g=v[s];I(o,g)||(A[s]=g)}),A}e.distinct=l;function E(p,v){const A=v.toLowerCase(),w=Object.keys(p).find(s=>s.toLowerCase()===A);return w?p[w]:p[v]}e.getCaseInsensitive=E;function h(p,v){const A=Object.create(null);for(const[w,s]of Object.entries(p))v(w,s)&&(A[w]=s);return A}e.filter=h}),define(ve[98],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function i(C){return C<0?0:C>255?255:C|0}e.toUint8=i;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(ve[2],we([0,1,9,12]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,P=/^\/\//;function D(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!y.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(n,t){return!n&&!t?"file":n}function I(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==T&&(t=T+t):t=T;break}return t}const L="",T="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,r,u,c,f,b=!1){typeof t=="object"?(this.scheme=t.scheme||L,this.authority=t.authority||L,this.path=t.path||L,this.query=t.query||L,this.fragment=t.fragment||L):(this.scheme=_(t,b),this.authority=r||L,this.path=I(this.scheme,u||L),this.query=c||L,this.fragment=f||L,D(this,b))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:u,path:c,query:f,fragment:b}=t;return r===void 0?r=this.scheme:r===null&&(r=L),u===void 0?u=this.authority:u===null&&(u=L),c===void 0?c=this.path:c===null&&(c=L),f===void 0?f=this.query:f===null&&(f=L),b===void 0?b=this.fragment:b===null&&(b=L),r===this.scheme&&u===this.authority&&c===this.path&&f===this.query&&b===this.fragment?this:new p(r,u,c,f,b)}static parse(t,r=!1){const u=l.exec(t);return u?new p(u[2]||L,S(u[4]||L),S(u[5]||L),S(u[7]||L),S(u[9]||L),r):new p(L,L,L,L,L)}static file(t){let r=L;if(i.isWindows&&(t=t.replace(/\\/g,T)),t[0]===T&&t[1]===T){const u=t.indexOf(T,2);u===-1?(r=t.substring(2),t=T):(r=t.substring(2,u),t=t.substring(u)||T)}return new p("file",r,t,L,L)}static from(t){const r=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return D(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return i.isWindows&&t.scheme==="file"?u=E.file(m.win32.join(s(t,!0),...r)).path:u=m.posix.join(t.path,...r),t.with({path:u})}toString(t=!1){return o(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const r=new p(t);return r._formatted=t.external,r._fsPath=t._sep===h?t.fsPath:null,r}}else return t}}e.URI=E;const h=i.isWindows?1:void 0;class p extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(n,t){let r,u=-1;for(let c=0;c<n.length;c++){const f=n.charCodeAt(c);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)u!==-1&&(r+=encodeURIComponent(n.substring(u,c)),u=-1),r!==void 0&&(r+=n.charAt(c));else{r===void 0&&(r=n.substr(0,c));const b=v[f];b!==void 0?(u!==-1&&(r+=encodeURIComponent(n.substring(u,c)),u=-1),r+=b):u===-1&&(u=c)}}return u!==-1&&(r+=encodeURIComponent(n.substring(u))),r!==void 0?r:n}function w(n){let t;for(let r=0;r<n.length;r++){const u=n.charCodeAt(r);u===35||u===63?(t===void 0&&(t=n.substr(0,r)),t+=v[u]):t!==void 0&&(t+=n[r])}return t!==void 0?t:n}function s(n,t){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=s;function o(n,t){const r=t?w:A;let u="",{scheme:c,authority:f,path:b,query:d,fragment:k}=n;if(c&&(u+=c,u+=":"),(f||c==="file")&&(u+=T,u+=T),f){let R=f.indexOf("@");if(R!==-1){const N=f.substr(0,R);f=f.substr(R+1),R=N.indexOf(":"),R===-1?u+=r(N,!1):(u+=r(N.substr(0,R),!1),u+=":",u+=r(N.substr(R+1),!1)),u+="@"}f=f.toLowerCase(),R=f.indexOf(":"),R===-1?u+=r(f,!1):(u+=r(f.substr(0,R),!1),u+=f.substr(R))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const R=b.charCodeAt(1);R>=65&&R<=90&&(b=`/${String.fromCharCode(R+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const R=b.charCodeAt(0);R>=65&&R<=90&&(b=`${String.fromCharCode(R+32)}:${b.substr(2)}`)}u+=r(b,!0)}return d&&(u+="?",u+=r(d,!1)),k&&(u+="#",u+=t?k:A(k,!1)),u}function g(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+g(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(n){return n.match(a)?n.replace(a,t=>g(t)):n}}),define(ve[59],we([0,1,22,8,2]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(L){return JSON.stringify(L,_)}e.stringify=C;function P(L){let T=JSON.parse(L);return T=I(T),T}e.parse=P;var D;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function _(L,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,i.regExpFlags)(T)}:T}function I(L,T=0){if(!L||T>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return y.URI.revive(L);case 2:return new RegExp(L.source,L.flags)}if(L instanceof m.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let l=0;l<L.length;++l)L[l]=I(L[l],T+1);else for(const l in L)Object.hasOwnProperty.call(L,l)&&(L[l]=I(L[l],T+1))}return L}e.revive=I}),define(ve[10],we([0,1,12,2]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,I,L){this._hosts[_]=I,this._ports[_]=L}setConnectionToken(_,I){this._connectionTokens[_]=I}rewrite(_){if(this._delegate)return this._delegate(_);const I=_.authority;let L=this._hosts[I];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const T=this._ports[I],l=this._connectionTokens[I];let E=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(E+=`&tkn=${encodeURIComponent(l)}`),i.URI.from({scheme:m.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${L}:${T}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new C;class P{asBrowserUri(_,I){const L=this.toUri(_,I);return L.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===y.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${y.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:y.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(_,I){const L=this.toUri(_,I);return L.scheme===y.vscodeFileResource?L.with({scheme:y.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(_,I){return i.URI.isUri(_)?_:i.URI.parse(I.toUrl(_))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(ve[23],we([0,1,30,10,9,12,8,2]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(E){return(0,D.uriToFsPath)(E,!0)}e.originalFSPath=_;class I{constructor(h){this._ignorePathCasing=h}compare(h,p,v=!1){return h===p?0:(0,P.compare)(this.getComparisonKey(h,v),this.getComparisonKey(p,v))}isEqual(h,p,v=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,v)===this.getComparisonKey(p,v)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,v=!1){if(h.scheme===p.scheme){if(h.scheme===i.Schemas.file)return m.isEqualOrParent(_(h),_(p),this._ignorePathCasing(h))&&h.query===p.query&&(v||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return m.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(v||h.fragment===p.fragment)}return!1}joinPath(h,...p){return D.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===i.Schemas.file?p=D.URI.file(y.dirname(_(h))).path:(p=y.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===i.Schemas.file?p=D.URI.file(y.normalize(_(h))).path:p=y.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===i.Schemas.file){const w=y.relative(_(h),_(p));return C.isWindows?m.toSlashes(w):w}let v=h.path||"/",A=p.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const s=Math.min(v.length,A.length);w<s&&!(v.charCodeAt(w)!==A.charCodeAt(w)&&v.charAt(w).toLowerCase()!==A.charAt(w).toLowerCase());w++);v=A.substr(0,w)+v.substr(w)}return y.posix.relative(v,A)}resolvePath(h,p){if(h.scheme===i.Schemas.file){const v=D.URI.file(y.resolve(_(h),p));return h.with({authority:v.authority,path:v.path})}return p=m.toPosixPath(p),h.with({path:y.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||h!==void 0&&p!==void 0&&(0,P.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=y.sep){if(h.scheme===i.Schemas.file){const v=_(h);return v.length>m.getRoot(v).length&&v[v.length-1]===p}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=y.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=y.sep){let v=!1;if(h.scheme===i.Schemas.file){const A=_(h);v=A!==void 0&&A.length===m.getRoot(A).length&&A[A.length-1]===p}else{p="/";const A=h.path;v=A.length===1&&A.charCodeAt(A.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===i.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(E,h){const p=[];for(let v=0;v<E.length;v++){const A=h(E[v]);E.some((w,s)=>s===v?!1:(0,e.isEqualOrParent)(A,h(w)))||p.push(E[v])}return p}e.distinctParents=L;var T;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(s=>{const[o,g]=s.split(":");o&&g&&v.set(o,g)});const w=p.path.substring(0,p.path.indexOf(";"));return w&&v.set(E.META_DATA_MIME,w),v}E.parseMetaData=h})(T=e.DataUri||(e.DataUri={}));function l(E,h,p){if(h){let v=E.path;return v&&v[0]!==y.posix.sep&&(v=y.posix.sep+v),E.with({scheme:p,authority:h,path:v})}return E.with({scheme:p})}e.toLocalResource=l}),define(ve[18],we([0,1,21,15,3,6,23,12]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(K){return!!K&&typeof K.then=="function"}e.isThenable=_;function I(K){const G=new m.CancellationTokenSource,Q=K(G.token),Y=new Promise((fe,me)=>{const Se=G.token.onCancellationRequested(()=>{Se.dispose(),G.dispose(),me((0,i.canceled)())});Promise.resolve(Q).then(Ie=>{Se.dispose(),G.dispose(),fe(Ie)},Ie=>{Se.dispose(),G.dispose(),me(Ie)})});return new class{cancel(){G.cancel()}then(fe,me){return Y.then(fe,me)}catch(fe){return this.then(void 0,fe)}finally(fe){return Y.finally(fe)}}}e.createCancelablePromise=I;function L(K,G,Q){return Promise.race([K,new Promise(Y=>G.onCancellationRequested(()=>Y(Q)))])}e.raceCancellation=L;async function T(K){let G=-1;const Q=K.map((fe,me)=>fe.then(Se=>(G=me,Se))),Y=await Promise.race(Q);return K.forEach((fe,me)=>{me!==G&&fe.cancel()}),Y}e.raceCancellablePromises=T;function l(K,G,Q){let Y;const fe=setTimeout(()=>{Y?.(void 0),Q?.()},G);return Promise.race([K.finally(()=>clearTimeout(fe)),new Promise(me=>Y=me)])}e.raceTimeout=l;function E(K){return new Promise((G,Q)=>{const Y=K();_(Y)?Y.then(G,Q):G(Y)})}e.asPromise=E;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const Q=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(Q,Q).then(Y)})}return new Promise((Q,Y)=>{this.queuedPromise.then(Q,Y)})}return this.activePromise=G(),new Promise((Q,Y)=>{this.activePromise.then(fe=>{this.activePromise=null,Q(fe)},fe=>{this.activePromise=null,Y(fe)})})}}e.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=p;class v{constructor(){this.promiseMap=new Map}queue(G,Q){const fe=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(G)===fe&&this.promiseMap.delete(G)});return this.promiseMap.set(G,fe),fe}}e.SequencerByKey=v;class A{constructor(G){this.defaultDelay=G,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,Q=this.defaultDelay){return this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,fe)=>{this.doResolve=Y,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=A;class w{constructor(G){this.delayer=new A(G),this.throttler=new h}trigger(G,Q){return this.delayer.trigger(()=>this.throttler.queue(G),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this._isOpen=!1,this._promise=new Promise((G,Q)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class o extends s{constructor(G){super();this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function g(K,G){return G?new Promise((Q,Y)=>{const fe=setTimeout(()=>{me.dispose(),Q()},K),me=G.onCancellationRequested(()=>{clearTimeout(fe),me.dispose(),Y((0,i.canceled)())})}):I(Q=>g(K,Q))}e.timeout=g;function a(K,G=0){const Q=setTimeout(K,G);return(0,C.toDisposable)(()=>clearTimeout(Q))}e.disposableTimeout=a;function S(K){const G=[];let Q=0;const Y=K.length;function fe(){return Q<Y?K[Q++]():null}function me(Se){Se!=null&&G.push(Se);const Ie=fe();return Ie?Ie.then(me):Promise.resolve(G)}return Promise.resolve(null).then(me)}e.sequence=S;function n(K,G=Y=>!!Y,Q=null){let Y=0;const fe=K.length,me=()=>{if(Y>=fe)return Promise.resolve(Q);const Se=K[Y++];return Promise.resolve(Se()).then(Oe=>G(Oe)?Promise.resolve(Oe):me())};return me()}e.first=n;function t(K,G=Y=>!!Y,Q=null){if(K.length===0)return Promise.resolve(Q);let Y=K.length;const fe=()=>{Y=-1;for(const me of K)me.cancel?.()};return new Promise((me,Se)=>{for(const Ie of K)Ie.then(Oe=>{--Y>=0&&G(Oe)?(fe(),me(Oe)):Y===0&&me(Q)}).catch(Oe=>{--Y>=0&&(fe(),Se(Oe))})})}e.firstParallel=t;class r{constructor(G){this._size=0,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(G){return this._size++,new Promise((Q,Y)=>{this.outstandingPromises.push({factory:G,c:Q,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const Q=G.factory();Q.then(G.c,G.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class u extends r{constructor(){super(1)}}e.Queue=u;class c{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const G=new x;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueFor(G,Q=P.extUri){const Y=Q.getComparisonKey(G);let fe=this.queues.get(Y);return fe||(fe=new u,y.Event.once(fe.onFinished)(()=>{fe?.dispose(),this.queues.delete(Y),this.onDidQueueFinish()}),this.queues.set(Y,fe)),fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=c;class f{constructor(G,Q){this._token=-1,typeof G=="function"&&typeof Q=="number"&&this.setIfNotSet(G,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},Q)}setIfNotSet(G,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},Q))}}e.TimeoutTimer=f;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(G,Q){this.cancel(),this._token=setInterval(()=>{G()},Q)}}e.IntervalTimer=b;class d{constructor(G,Q){this.timeoutToken=-1,this.runner=G,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=d;class k{constructor(G,Q){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=Q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class R extends d{constructor(G,Q){super(G,Q);this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner&&this.runner(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class N extends C.Disposable{constructor(G,Q,Y,fe){super();this.maxWorkChunkSize=G,this.maxPendingWork=Q,this.throttleDelay=Y,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.maxPendingWork)return!1}else if(this.pending+G.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...G),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new d(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,D.setTimeout0)(()=>{if(G)return;const Q=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(K,G)=>{const Q=requestIdleCallback(K,typeof G=="number"?{timeout:G}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(Q))}}}}();class B{constructor(G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function F(K,G,Q){let Y;for(let fe=0;fe<Q;fe++)try{return await K()}catch(me){Y=me,await g(G)}throw Y}e.retry=F;class U{hasPending(G){return this._pending?typeof G=="number"?this._pending.taskId===G:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(G,Q,Y){return this._pending={taskId:G,cancel:()=>Y?.(),promise:Q},Q.then(()=>this.donePending(G),()=>this.donePending(G)),Q}donePending(G){this._pending&&G===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const G=this._next;this._next=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this._next)this._next.run=G;else{let Q,Y;const fe=new Promise((me,Se)=>{Q=me,Y=Se});this._next={run:G,promise:fe,promiseResolve:Q,promiseReject:Y}}return this._next.promise}}e.TaskSequentializer=U;class H{constructor(G,Q=()=>Date.now()){this.interval=G,this.nowFn=Q,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((G,Q)=>{this.completeCallback=G,this.errorCallback=Q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(G){return new Promise(Q=>{this.completeCallback(G),this.resolved=!0,Q()})}error(G){return new Promise(Q=>{this.errorCallback(G),this.rejected=!0,Q()})}cancel(){new Promise(G=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,G()})}}e.DeferredPromise=x;var M;(function(K){async function G(Y){let fe;const me=await Promise.all(Y.map(Se=>Se.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe!="undefined")throw fe;return me}K.settled=G;function Q(Y){return new Promise(async(fe,me)=>{try{await Y(fe,me)}catch(Se){me(Se)}})}K.withAsyncBody=Q})(M=e.Promises||(e.Promises={}));var W;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(G){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const Q={emitOne:Y=>this.emitOne(Y),emitMany:Y=>this.emitMany(Y),reject:Y=>this.reject(Y)};try{await Promise.resolve(G(Q)),this.resolve()}catch(Y){this.reject(Y)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}static fromArray(G){return new z(Q=>{Q.emitMany(G)})}static fromPromise(G){return new z(async Q=>{Q.emitMany(await G)})}static fromPromises(G){return new z(async Q=>{await Promise.all(G.map(async Y=>Q.emitOne(await Y)))})}static merge(G){return new z(async Q=>{await Promise.all(G.map(async Y=>{for await(const fe of Y)Q.emitOne(fe)}))})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(G,Q){return new z(async Y=>{for await(const fe of G)Y.emitOne(Q(fe))})}map(G){return z.map(this,G)}static filter(G,Q){return new z(async Y=>{for await(const fe of G)Q(fe)&&Y.emitOne(fe)})}filter(G){return z.filter(this,G)}static coalesce(G){return z.filter(G,Q=>!!Q)}coalesce(){return z.coalesce(this)}static async toPromise(G){const Q=[];for await(const Y of G)Q.push(Y);return Q}toPromise(){return z.toPromise(this)}emitOne(G){this._state===0&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===0&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(G){this._state===0&&(this._state=2,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class O extends z{constructor(G,Q){super(Q);this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=O;function V(K){const G=new m.CancellationTokenSource,Q=K(G.token);return new O(G,async Y=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),G.dispose(),Y.reject((0,i.canceled)())});try{for await(const me of Q){if(G.token.isCancellationRequested)return;Y.emitOne(me)}fe.dispose(),G.dispose()}catch(me){fe.dispose(),G.dispose(),Y.reject(me)}})}e.createCancelableAsyncIterable=V}),define(ve[99],we([0,1,18,9]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new m.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(b,d,k=!1){const R=b||"",N=d||"",B=y.value.collator.compare(R,N);return y.value.collatorIsNumeric&&B===0&&R!==N?R<N?-1:1:B}e.compareFileNames=D;function _(b,d){const k=C.value.collator;return b=b||"",d=d||"",g(k,b,d)}e.compareFileNamesDefault=_;function I(b,d){const k=C.value.collator;return b=b||"",d=d||"",t(b,d)||g(k,b,d)}e.compareFileNamesUpper=I;function L(b,d){const k=C.value.collator;return b=b||"",d=d||"",n(b,d)||g(k,b,d)}e.compareFileNamesLower=L;function T(b,d){return b=b||"",d=d||"",b===d?0:b<d?-1:1}e.compareFileNamesUnicode=T;function l(b,d,k=!1){k||(b=b&&b.toLowerCase(),d=d&&d.toLowerCase());const[R,N]=s(b),[B,F]=s(d);return R!==B?R<B?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=l;function E(b,d){const[k,R]=s(b),[N,B]=s(d);let F=y.value.collator.compare(R,B);if(F===0){if(y.value.collatorIsNumeric&&R!==B)return R<B?-1:1;if(F=y.value.collator.compare(k,N),y.value.collatorIsNumeric&&F===0&&k!==N)return k<N?-1:1}return F}e.compareFileExtensions=E;function h(b,d){b=b||"",d=d||"";const k=o(b),R=o(d),N=C.value.collator,B=P.value.collator;return g(B,k,R)||g(N,b,d)}e.compareFileExtensionsDefault=h;function p(b,d){b=b||"",d=d||"";const k=o(b),R=o(d),N=C.value.collator,B=P.value.collator;return g(B,k,R)||t(b,d)||g(N,b,d)}e.compareFileExtensionsUpper=p;function v(b,d){b=b||"",d=d||"";const k=o(b),R=o(d),N=C.value.collator,B=P.value.collator;return g(B,k,R)||n(b,d)||g(N,b,d)}e.compareFileExtensionsLower=v;function A(b,d){b=b||"",d=d||"";const k=o(b).toLowerCase(),R=o(d).toLowerCase();return k!==R?k<R?-1:1:b!==d?b<d?-1:1:0}e.compareFileExtensionsUnicode=A;const w=/^(.*?)(\.([^.]*))?$/;function s(b,d=!1){const k=b?w.exec(b):[];let R=[k&&k[1]||"",k&&k[3]||""];return d&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function o(b){const d=b?w.exec(b):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function g(b,d,k){let R=b.compare(d,k);return R!==0?R:d.length!==k.length?d.length<k.length?-1:1:0}function a(b){const d=b.charAt(0);return d.toLocaleUpperCase()!==d}function S(b){const d=b.charAt(0);return d.toLocaleLowerCase()!==d}function n(b,d){return a(b)&&S(d)?-1:S(b)&&a(d)?1:0}function t(b,d){return S(b)&&a(d)?-1:a(b)&&S(d)?1:0}function r(b,d,k=!1){return k||(b=b&&b.toLowerCase(),d=d&&d.toLowerCase()),b===d?0:b<d?-1:1}function u(b,d,k=!1){const R=b.split(i.sep),N=d.split(i.sep),B=R.length-1,F=N.length-1;let U,H;for(let x=0;;x++){if(U=B===x,H=F===x,U&&H)return D(R[x],N[x],k);if(U)return-1;if(H)return 1;const M=r(R[x],N[x],k);if(M!==0)return M}}e.comparePaths=u;function c(b,d,k){const R=b.toLowerCase(),N=d.toLowerCase(),B=f(b,d,k);if(B)return B;const F=R.endsWith(k),U=N.endsWith(k);if(F!==U)return F?-1:1;const H=D(R,N);return H!==0?H:R.localeCompare(N)}e.compareAnything=c;function f(b,d,k){const R=b.toLowerCase(),N=d.toLowerCase(),B=R.startsWith(k),F=N.startsWith(k);if(B!==F)return B?-1:1;if(B&&F){if(R.length<N.length)return-1;if(R.length>N.length)return 1}return 0}e.compareByPrefix=f}),define(ve[100],we([0,1,99,96,47,9,12,8]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,I=[_,[]];function L(M,W,z,O){if(!M||!W)return I;const V=M.length,K=W.length;if(V<K)return I;const G=M.toLowerCase();return T(W,z,K,M,G,V,O)}e.scoreFuzzy=L;function T(M,W,z,O,V,K,G){const Q=[],Y=[];for(let Ie=0;Ie<z;Ie++){const Oe=Ie*K,We=Oe-K,j=Ie>0,Z=M[Ie],re=W[Ie];for(let ue=0;ue<K;ue++){const te=ue>0,oe=Oe+ue,Ee=oe-1,Ne=We+ue-1,Ve=te?Q[Ee]:0,Ge=j&&te?Q[Ne]:0,Je=j&&te?Y[Ne]:0;let tt;!Ge&&j?tt=0:tt=l(Z,re,O,V,ue,Je),tt&&Ge+tt>=Ve&&(G||j||V.startsWith(W,ue))?(Y[oe]=Je+1,Q[oe]=Ge+tt):(Y[oe]=_,Q[oe]=Ve)}}const fe=[];let me=z-1,Se=K-1;for(;me>=0&&Se>=0;){const Ie=me*K+Se;Y[Ie]===_||(fe.push(Se),me--),Se--}return[Q[z*K-1],fe.reverse()]}function l(M,W,z,O,V,K){let G=0;if(!E(W,O[V]))return G;if(G+=1,K>0&&(G+=K*5),M===z[V]&&(G+=1),V===0)G+=8;else{const Q=h(z.charCodeAt(V-1));Q?G+=Q:(0,i.isUpper)(z.charCodeAt(V))&&K===0&&(G+=2)}return G}function E(M,W){return M===W?!0:M==="/"||M==="\\"?W==="/"||W==="\\":!1}function h(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function v(M,W,z=0,O=0){const V=W;return V.values&&V.values.length>1?A(M,V.values,z,O):w(M,W,z,O)}e.scoreFuzzy2=v;function A(M,W,z,O){let V=0;const K=[];for(const G of W){const[Q,Y]=w(M,G,z,O);if(typeof Q!="number")return p;V+=Q,K.push(...Y)}return[V,f(K)]}function w(M,W,z,O){const V=(0,i.fuzzyScore)(W.original,W.originalLowercase,z,M,M.toLowerCase(),O,!0);return V?[V[0],(0,i.createMatches)(V)]:p}const s=Object.freeze({score:0}),o=1<<18,g=1<<17,a=1<<16;function S(M,W,z,O){const V=O.values?O.values:[O];return(0,y.hash)({[O.normalized]:{values:V.map(G=>({value:G.normalized,expectContiguousMatch:G.expectContiguousMatch})),label:M,description:W,allowNonContiguousMatches:z}})}function n(M,W,z,O,V){if(!M||!W.normalized)return s;const K=O.getItemLabel(M);if(!K)return s;const G=O.getItemDescription(M),Q=S(K,G,z,W),Y=V[Q];if(Y)return Y;const fe=t(K,G,O.getItemPath(M),W,z);return V[Q]=fe,fe}e.scoreItemFuzzy=n;function t(M,W,z,O,V){const K=!z||!O.containsPathSeparator;return z&&(P.isLinux?O.pathNormalized===z:(0,D.equalsIgnoreCase)(O.pathNormalized,z))?{score:o,labelMatch:[{start:0,end:M.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:O.values&&O.values.length>1?r(M,W,z,O.values,K,V):u(M,W,z,O,K,V)}function r(M,W,z,O,V,K){let G=0;const Q=[],Y=[];for(const fe of O){const{score:me,labelMatch:Se,descriptionMatch:Ie}=u(M,W,z,fe,V,K);if(me===_)return s;G+=me,Se&&Q.push(...Se),Ie&&Y.push(...Ie)}return{score:G,labelMatch:f(Q),descriptionMatch:f(Y)}}function u(M,W,z,O,V,K){if(V||!W){const[G,Q]=L(M,O.normalized,O.normalizedLowercase,K&&!O.expectContiguousMatch);if(G){const Y=(0,i.matchesPrefix)(O.normalized,M);let fe;return Y?(fe=g,fe+=Math.round(O.normalized.length/M.length*100)):fe=a,{score:fe+G,labelMatch:Y||c(Q)}}}if(W){let G=W;z&&(G=`${W}${C.sep}`);const Q=G.length,Y=`${G}${M}`,[fe,me]=L(Y,O.normalized,O.normalizedLowercase,K&&!O.expectContiguousMatch);if(fe){const Se=c(me),Ie=[],Oe=[];return Se.forEach(We=>{We.start<Q&&We.end>Q?(Ie.push({start:0,end:We.end-Q}),Oe.push({start:We.start,end:Q})):We.start>=Q?Ie.push({start:We.start-Q,end:We.end-Q}):Oe.push(We)}),{score:fe,labelMatch:Ie,descriptionMatch:Oe}}}return s}function c(M){const W=[];if(!M)return W;let z;for(const O of M)z&&z.end===O?z.end+=1:(z={start:O,end:O+1},W.push(z));return W}function f(M){const W=M.sort((V,K)=>V.start-K.start),z=[];let O;for(const V of W)!O||!b(O,V)?(O=V,z.push(V)):(O.start=Math.min(O.start,V.start),O.end=Math.max(O.end,V.end));return z}function b(M,W){return!(M.end<W.start||W.end<M.start)}function d(M,W,z,O,V,K){const G=n(M,z,O,V,K),Q=n(W,z,O,V,K),Y=G.score,fe=Q.score;if((Y===o||fe===o)&&Y!==fe)return Y===o?-1:1;if(Y>a||fe>a){if(Y!==fe)return Y>fe?-1:1;if(Y<g&&fe<g){const Z=R(G.labelMatch,Q.labelMatch);if(Z!==0)return Z}const We=V.getItemLabel(M)||"",j=V.getItemLabel(W)||"";if(We.length!==j.length)return We.length-j.length}if(Y!==fe)return Y>fe?-1:1;const me=Array.isArray(G.labelMatch)&&G.labelMatch.length>0,Se=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(me&&!Se)return-1;if(Se&&!me)return 1;const Ie=k(M,G,V),Oe=k(W,Q,V);return Ie&&Oe&&Ie!==Oe?Oe>Ie?-1:1:N(M,W,z,V)}e.compareItemsByFuzzyScore=d;function k(M,W,z){let O=-1,V=-1;if(W.descriptionMatch&&W.descriptionMatch.length?O=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(O=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(V=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const K=z.getItemDescription(M);K&&(V+=K.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(V=W.descriptionMatch[W.descriptionMatch.length-1].end);return V-O}function R(M,W){if(!M&&!W||(!M||!M.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!M||!M.length)return 1;const z=M[0].start,V=M[M.length-1].end-z,K=W[0].start,Q=W[W.length-1].end-K;return V===Q?0:Q<V?1:-1}function N(M,W,z,O){const V=O.getItemLabel(M)||"",K=O.getItemLabel(W)||"",G=O.getItemDescription(M),Q=O.getItemDescription(W),Y=V.length+(G?G.length:0),fe=K.length+(Q?Q.length:0);if(Y!==fe)return Y-fe;const me=O.getItemPath(M),Se=O.getItemPath(W);return me&&Se&&me.length!==Se.length?me.length-Se.length:V!==K?(0,m.compareAnything)(V,K,z.normalized):G&&Q&&G!==Q?(0,m.compareAnything)(G,Q,z.normalized):me&&Se&&me!==Se?(0,m.compareAnything)(me,Se,z.normalized):0}function B(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function U(M){typeof M!="string"&&(M="");const W=M.toLowerCase(),{pathNormalized:z,normalized:O,normalizedLowercase:V}=H(M),K=z.indexOf(C.sep)>=0,G=B(M);let Q;const Y=M.split(F);if(Y.length>1)for(const fe of Y){const me=B(fe),{pathNormalized:Se,normalized:Ie,normalizedLowercase:Oe}=H(fe);Ie&&(Q||(Q=[]),Q.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:Se,normalized:Ie,normalizedLowercase:Oe,expectContiguousMatch:me}))}return{original:M,originalLowercase:W,pathNormalized:z,normalized:O,normalizedLowercase:V,values:Q,containsPathSeparator:K,expectContiguousMatch:G}}e.prepareQuery=U;function H(M){let W;P.isWindows?W=M.replace(/\//g,C.sep):W=M.replace(/\\/g,C.sep);const z=(0,D.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:z,normalizedLowercase:z.toLowerCase()}}function x(M){return Array.isArray(M)?U(M.map(W=>W.original).join(F)):U(M.original)}e.pieceToQuery=x}),define(ve[31],we([0,1,18,30,24,9,8]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const _="**",I="/",L="[/\\\\]",T="[^/\\\\]",l=/\//g;function E(O){switch(O){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}|${L}${T}+)*?`}}function h(O,V){if(!O)return[];const K=[];let G=!1,Q=!1,Y="";for(const fe of O){switch(fe){case V:if(!G&&!Q){K.push(Y),Y="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}Y+=fe}return Y&&K.push(Y),K}e.splitGlobAware=h;function p(O){if(!O)return"";let V="";const K=h(O,I);if(K.every(G=>G===_))V=".*";else{let G=!1;K.forEach((Q,Y)=>{if(Q===_){G||(V+=E(2),G=!0);return}let fe=!1,me="",Se=!1,Ie="";for(const Oe of Q){if(Oe!=="}"&&fe){me+=Oe;continue}if(Se&&(Oe!=="]"||!Ie)){let We;Oe==="-"?We=Oe:(Oe==="^"||Oe==="!")&&!Ie?We="^":Oe===I?We="":We=P.escapeRegExpCharacters(Oe),Ie+=We;continue}switch(Oe){case"{":fe=!0;continue;case"[":Se=!0;continue;case"}":{V+=`(?:${h(me,",").map(Z=>p(Z)).join("|")})`,fe=!1,me="";break}case"]":V+="["+Ie+"]",Se=!1,Ie="";break;case"?":V+=T;continue;case"*":V+=E(1);continue;default:V+=P.escapeRegExpCharacters(Oe)}}Y<K.length-1&&(K[Y+1]!==_||Y+2<K.length)&&(V+=L),G=!1})}return V}const v=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new y.LRUCache(1e4),S=function(){return!1},n=function(){return null};function t(O,V){if(!O)return n;let K;typeof O!="string"?K=O.pattern:K=O,K=K.trim();const G=`${K}_${!!V.trimForExclusions}`;let Q=a.get(G);if(Q)return r(Q,O);let Y;if(v.test(K)){const fe=K.substr(4);Q=function(me,Se){return typeof me=="string"&&me.endsWith(fe)?K:null}}else(Y=A.exec(u(K,V)))?Q=c(Y[1],K):(V.trimForExclusions?s:w).test(K)?Q=f(K,V):(Y=o.exec(u(K,V)))?Q=b(Y[1].substr(1),K,!0):(Y=g.exec(u(K,V)))?Q=b(Y[1],K,!1):Q=d(K);return a.set(G,Q),r(Q,O)}function r(O,V){return typeof V=="string"?O:function(K,G){return i.isEqualOrParent(K,V.base)?O(C.relative(V.base,K),G):null}}function u(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,V){const K=`/${O}`,G=`\\${O}`,Q=function(fe,me){return typeof fe!="string"?null:me?me===O?V:null:fe===O||fe.endsWith(K)||fe.endsWith(G)?V:null},Y=[O];return Q.basenames=Y,Q.patterns=[V],Q.allBasenames=Y,Q}function f(O,V){const K=z(O.slice(1,-1).split(",").map(me=>t(me,V)).filter(me=>me!==n),O),G=K.length;if(!G)return n;if(G===1)return K[0];const Q=function(me,Se){for(let Ie=0,Oe=K.length;Ie<Oe;Ie++)if(K[Ie](me,Se))return O;return null},Y=K.find(me=>!!me.allBasenames);Y&&(Q.allBasenames=Y.allBasenames);const fe=K.reduce((me,Se)=>Se.allPaths?me.concat(Se.allPaths):me,[]);return fe.length&&(Q.allPaths=fe),Q}function b(O,V,K){const G=C.sep===C.posix.sep,Q=G?O:O.replace(l,C.sep),Y=C.sep+Q,fe=C.posix.sep+O,me=K?function(Se,Ie){return typeof Se=="string"&&(Se===Q||Se.endsWith(Y)||!G&&(Se===O||Se.endsWith(fe)))?V:null}:function(Se,Ie){return typeof Se=="string"&&(Se===Q||!G&&Se===O)?V:null};return me.allPaths=[(K?"*/":"./")+O],me}function d(O){try{const V=new RegExp(`^${p(O)}$`);return function(K){return V.lastIndex=0,typeof K=="string"&&V.test(K)?O:null}}catch{return n}}function k(O,V,K){return!O||typeof V!="string"?!1:R(O)(V,void 0,K)}e.match=k;function R(O,V={}){if(!O)return S;if(typeof O=="string"||U(O)){const K=t(O,V);if(K===n)return S;const G=function(Q,Y){return!!K(Q,Y)};return K.allBasenames&&(G.allBasenames=K.allBasenames),K.allPaths&&(G.allPaths=K.allPaths),G}return M(O,V)}e.parse=R;function N(O){if(!O)return;let V;return K=>(V||(V=(O()||Promise.resolve([])).then(G=>G?F(G):{})),V.then(G=>!!G[K]))}e.hasSiblingPromiseFn=N;function B(O){if(!O)return;let V;return K=>{if(!V){const G=O();V=G?F(G):{}}return!!V[K]}}e.hasSiblingFn=B;function F(O){const V={};for(const K of O)V[K]=!0;return V}function U(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=U;function H(O){return O.allBasenames||[]}e.getBasenameTerms=H;function x(O){return O.allPaths||[]}e.getPathTerms=x;function M(O,V){const K=z(Object.getOwnPropertyNames(O).map(me=>W(me,O[me],V)).filter(me=>me!==n)),G=K.length;if(!G)return n;if(!K.some(me=>!!me.requiresSiblings)){if(G===1)return K[0];const me=function(Oe,We){for(let j=0,Z=K.length;j<Z;j++){const re=K[j](Oe,We);if(re)return re}return null},Se=K.find(Oe=>!!Oe.allBasenames);Se&&(me.allBasenames=Se.allBasenames);const Ie=K.reduce((Oe,We)=>We.allPaths?Oe.concat(We.allPaths):Oe,[]);return Ie.length&&(me.allPaths=Ie),me}const Q=function(me,Se,Ie){let Oe;for(let We=0,j=K.length;We<j;We++){const Z=K[We];Z.requiresSiblings&&Ie&&(Se||(Se=C.basename(me)),Oe||(Oe=Se.substr(0,Se.length-C.extname(me).length)));const re=Z(me,Se,Oe,Ie);if(re)return re}return null},Y=K.find(me=>!!me.allBasenames);Y&&(Q.allBasenames=Y.allBasenames);const fe=K.reduce((me,Se)=>Se.allPaths?me.concat(Se.allPaths):me,[]);return fe.length&&(Q.allPaths=fe),Q}function W(O,V,K){if(V===!1)return n;const G=t(O,K);if(G===n)return n;if(typeof V=="boolean")return G;if(V){const Q=V.when;if(typeof Q=="string"){const Y=(fe,me,Se,Ie)=>{if(!Ie||!G(fe,me))return null;const Oe=Q.replace("$(basename)",Se),We=Ie(Oe);return(0,m.isThenable)(We)?We.then(j=>j?O:null):We?O:null};return Y.requiresSiblings=!0,Y}}return G}function z(O,V){const K=O.filter(me=>!!me.basenames);if(K.length<2)return O;const G=K.reduce((me,Se)=>{const Ie=Se.basenames;return Ie?me.concat(Ie):me},[]);let Q;if(V){Q=[];for(let me=0,Se=G.length;me<Se;me++)Q.push(V)}else Q=K.reduce((me,Se)=>{const Ie=Se.patterns;return Ie?me.concat(Ie):me},[]);const Y=function(me,Se){if(typeof me!="string")return null;if(!Se){let Oe;for(Oe=me.length;Oe>0;Oe--){const We=me.charCodeAt(Oe-1);if(We===47||We===92)break}Se=me.substr(Oe)}const Ie=G.indexOf(Se);return Ie!==-1?Q[Ie]:null};Y.basenames=G,Y.patterns=Q,Y.allBasenames=G;const fe=O.filter(me=>!me.basenames);return fe.push(Y),fe}}),define(ve[80],we([0,1,30,10,9,12,23,8,2]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(t,r,u){if(typeof t=="string"&&(t=_.URI.file(t)),u){const f=u.getWorkspaceFolder(t);if(f){const b=u.getWorkspace().folders.length>1;let d;if((0,P.isEqual)(f.uri,t)?d="":d=(0,P.relativePath)(f.uri,t),b){const k=f.name?f.name:(0,P.basename)(f.uri);d=d?k+" \u2022 "+d:k}return d}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,y.normalize)(T(t.fsPath));let c=(0,y.normalize)(t.fsPath);return!C.isWindows&&r?.userHome&&(c=E(c,r.userHome.fsPath)),c}e.getPathLabel=I;function L(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const r=(0,P.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(r)?T(r):r}e.getBaseLabel=L;function T(t,r){return(0,m.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=T;let l=Object.create(null);function E(t,r){if(C.isWindows||!t||!r)return t;let u=l.original===r?l.normalized:void 0;return u||(u=`${(0,D.rtrim)(r,y.posix.sep)}${y.posix.sep}`,l={original:r,normalized:u}),(C.isLinux?t.startsWith(u):(0,D.startsWithIgnoreCase)(t,u))&&(t=`~/${t.substr(u.length)}`),t}e.tildify=E;function h(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=h;const p="\u2026",v="\\\\",A="~";function w(t,r=y.sep){const u=new Array(t.length);let c=!1;for(let f=0;f<t.length;f++){let b=t[f];if(b===""){u[f]=`.${r}`;continue}if(!b){u[f]=b;continue}c=!0;let d="";b.indexOf(v)===0?(d=b.substr(0,b.indexOf(v)+v.length),b=b.substr(b.indexOf(v)+v.length)):b.indexOf(r)===0?(d=b.substr(0,b.indexOf(r)+r.length),b=b.substr(b.indexOf(r)+r.length)):b.indexOf(A)===0&&(d=b.substr(0,b.indexOf(A)+A.length),b=b.substr(b.indexOf(A)+A.length));const k=b.split(r);for(let R=1;c&&R<=k.length;R++)for(let N=k.length-R;c&&N>=0;N--){c=!1;let B=k.slice(N,N+R).join(r);for(let F=0;!c&&F<t.length;F++)if(F!==f&&t[F]&&t[F].indexOf(B)>-1){const U=N+R===k.length,H=N>0&&t[F].indexOf(r)>-1?r+B:B,x=t[F].endsWith(H);c=!U||x}if(!c){let F="";(k[0].endsWith(":")||d!=="")&&(N===1&&(N=0,R++,B=k[0]+r+B),N>0&&(F=k[0]+r),F=d+F),N>0&&(F=F+p+r),F=F+B,N+R<k.length&&(F=F+r+p),u[f]=F}}c&&(u[f]=b)}return u}e.shorten=w;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(t,r=Object.create(null)){const u=[];let c=!1,f="";for(const b of t)if(b==="$"||c&&b==="{")f&&u.push({value:f,type:s.TEXT}),f="",c=!0;else if(b==="}"&&c){const d=r[f];if(typeof d=="string")d.length&&u.push({value:d,type:s.VARIABLE});else if(d){const k=u[u.length-1];(!k||k.type!==s.SEPARATOR)&&u.push({value:d.label,type:s.SEPARATOR})}f="",c=!1}else f+=b;return f&&!c&&u.push({value:f,type:s.TEXT}),u.filter((b,d)=>{if(b.type===s.SEPARATOR){const k=u[d-1],R=u[d+1];return[k,R].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=o;function g(t,r){return C.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function a(t,r){return C.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,u=>u==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function S(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=S;function n(t){const r=t.indexOf("/")!==-1?y.posix:y.win32,u=r.basename(t),c=r.dirname(t);return u.length?{name:u,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(ve[101],we([0,1,31,10,9,23,8]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(D=e.Mimes||(e.Mimes={}));let _=[],I=[],L=[];function T(t,r=!1){const u=l(t);_.push(u),u.userConfigured?L.push(u):I.push(u),r&&!u.userConfigured&&_.forEach(c=>{c.mime===u.mime||c.userConfigured||(u.extension&&c.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&c.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&c.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&c.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=T;function l(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function E(t){t?(_=_.filter(r=>!r.userConfigured),L=[]):(_=[],I=[],L=[])}e.clearTextMimes=E;function h(t,r){let u;if(t)switch(t.scheme){case i.Schemas.file:u=t.fsPath;break;case i.Schemas.data:{u=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break}default:u=t.path}if(!u)return[D.unknown];u=u.toLowerCase();const c=(0,y.basename)(u),f=p(u,c,L);if(f)return[f,D.text];const b=p(u,c,I);if(b)return[b,D.text];if(r){const d=v(r);if(d)return[d,D.text]}return[D.unknown]}e.guessMimeTypes=h;function p(t,r,u){let c=null,f=null,b=null;for(let d=u.length-1;d>=0;d--){const k=u[d];if(r===k.filenameLowercase){c=k;break}if(k.filepattern&&(!f||k.filepattern.length>f.filepattern.length)){const R=k.filepatternOnPath?t:r;k.filepatternLowercase?.(R)&&(f=k)}k.extension&&(!b||k.extension.length>b.extension.length)&&r.endsWith(k.extensionLowercase)&&(b=k)}return c?c.mime:f?f.mime:b?b.mime:null}function v(t){if((0,P.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let r=_.length-1;r>=0;r--){const u=_[r];if(!u.firstline)continue;const c=t.match(u.firstline);if(c&&c.length>0)return u.mime}return null}function A(t){return t?typeof t=="string"?t===D.binary||t===D.text||t===D.unknown:t.length===1&&A(t[0]):!0}e.isUnspecific=A;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(t){const r=(0,y.extname)(t),u=w[r.toLowerCase()];return u!==void 0?u:g(t)}e.getMediaOrTextMime=o;function g(t){const r=(0,y.extname)(t);return s[r.toLowerCase()]}e.getMediaMime=g;function a(t){for(const r in s)if(s[r]===t)return r}e.getExtensionForMimeType=a;const S=/^(.+)\/(.+?)(;.+)?$/;function n(t,r){const u=S.exec(t);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:r?void 0:t}e.normalizeMimeType=n}),define(ve[102],we([0,1,2]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class y{constructor(T){this._uriTransformer=T}transformIncoming(T){const l=this._uriTransformer.transformIncoming(T);return l===T?T:i(m.URI.from(l))}transformOutgoing(T){const l=this._uriTransformer.transformOutgoing(T);return l===T?T:i(m.URI.from(l))}transformOutgoingURI(T){const l=this._uriTransformer.transformOutgoing(T);return l===T?T:m.URI.from(l)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function C(L,T,l){if(!L||l>200)return null;if(typeof L=="object"){if(L instanceof m.URI)return T.transformOutgoing(L);for(let E in L)if(Object.hasOwnProperty.call(L,E)){const h=C(L[E],T,l+1);h!==null&&(L[E]=h)}}return null}function P(L,T){const l=C(L,T,0);return l===null?L:l}e.transformOutgoingURIs=P;function D(L,T,l,E){if(!L||E>200)return null;if(typeof L=="object"){if(L.$mid===1)return l?m.URI.revive(T.transformIncoming(L)):T.transformIncoming(L);for(let h in L)if(Object.hasOwnProperty.call(L,h)){const p=D(L[h],T,l,E+1);p!==null&&(L[h]=p)}}return null}function _(L,T){const l=D(L,T,!1,0);return l===null?L:l}e.transformIncomingURIs=_;function I(L,T){const l=D(L,T,!0,0);return l===null?L:l}e.transformAndReviveIncomingURIs=I}),define(ve[32],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(_){return m.test(_)}e.isUUID=i;const y=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(_){for(let I=0;I<_.length;I++)_[I]=Math.floor(Math.random()*256);return _};function D(){P(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let _=0,I="";return I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I}e.generateUuid=D}),define(ve[142],we([0,1,103]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const P=[],D=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(D.length<1)return P;let _=0,I,L=_;for(;L<D.length;)if(I=D.charCodeAt(L),I===13||I===10){if(P.push(D.substring(_,L)),L++,L<D.length){const T=I;I=D.charCodeAt(L),(T===13&&I===10||T===10&&I===13)&&L++}_=L}else L++;return this.remaining=_<D.length?D.substr(_):null,P}end(){return this.remaining}}e.LineDecoder=i}),define(ve[28],we([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(J,e,m,i,y,C,P,D,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(H,x=E.UNLINK){if((0,P.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return x===E.UNLINK?v(H):p(H)}async function p(H){try{const x=(0,_.join)((0,i.tmpdir)(),(0,l.generateUuid)());try{await e.Promises.rename(H,x)}catch{return v(H)}v(x).catch(M=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function v(H){return e.Promises.rmdir(H,{recursive:!0,maxRetries:3})}function A(H){if((0,P.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(H,{recursive:!0})}e.rimrafSync=A;async function w(H,x){return g(await(x?s(H):(0,y.promisify)(m.readdir)(H)))}async function s(H){try{return await(0,y.promisify)(m.readdir)(H,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const x=[],M=await w(H);for(const W of M){let z=!1,O=!1,V=!1;try{const K=await e.Promises.lstat((0,_.join)(H,W));z=K.isFile(),O=K.isDirectory(),V=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}x.push({name:W,isFile:()=>z,isDirectory:()=>O,isSymbolicLink:()=>V})}return x}function o(H){return g(m.readdirSync(H))}e.readdirSync=o;function g(H){return H.map(x=>typeof x=="string"?I.isMacintosh?(0,D.normalizeNFC)(x):x:(x.name=I.isMacintosh?(0,D.normalizeNFC)(x.name):x.name,x))}async function a(H){const x=await w(H),M=[];for(const W of x)await n.existsDirectory((0,_.join)(H,W))&&M.push(W);return M}function S(H,x=1e3){return new Promise(M=>{let W=!1;const z=setInterval(()=>{W||(W=!0,m.access(H,O=>{W=!1,O&&(clearInterval(z),M(void 0))}))},x)})}e.whenDeleted=S;var n;(function(H){async function x(z){let O;try{if(O=await e.Promises.lstat(z),!O.isSymbolicLink())return{stat:O}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(I.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw K}throw V}}H.stat=x;async function M(z){try{const{stat:O,symbolicLink:V}=await H.stat(z);return O.isFile()&&V?.dangling!==!0}catch{}return!1}H.existsFile=M;async function W(z){try{const{stat:O,symbolicLink:V}=await H.stat(z);return O.isDirectory()&&V?.dangling!==!0}catch{}return!1}H.existsDirectory=W})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function r(H,x,M){return t.queueFor(T.URI.file(H),L.extUriBiasedIgnorePathCase).queue(()=>{const W=b(M);return new Promise((z,O)=>c(H,x,W,V=>V?O(V):z()))})}let u=!0;function c(H,x,M,W){if(!u)return m.writeFile(H,x,{mode:M.mode,flag:M.flag},W);m.open(H,M.flag,M.mode,(z,O)=>{if(z)return W(z);m.writeFile(O,x,V=>{if(V)return m.close(O,()=>W(V));m.fdatasync(O,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),u=!1),m.close(O,G=>W(G))))})})}function f(H,x,M){const W=b(M);if(!u)return m.writeFileSync(H,x,{mode:W.mode,flag:W.flag});const z=m.openSync(H,W.flag,W.mode);try{m.writeFileSync(z,x);try{m.fdatasyncSync(z)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),u=!1}}finally{m.closeSync(z)}}e.writeFileSync=f;function b(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function d(H,x){if(H===x)return;async function M(W){try{const z=await e.Promises.lstat(W);if(z.isDirectory()||z.isSymbolicLink())return;await e.Promises.utimes(W,z.atime,new Date)}catch{}}try{await e.Promises.rename(H,x),await M(x)}catch(W){if(H.toLowerCase()!==x.toLowerCase()&&W.code==="EXDEV"||H.endsWith("."))await k(H,x,{preserveSymlinks:!1}),await h(H,E.MOVE),await M(x);else throw W}}async function k(H,x,M){return N(H,x,{root:{source:H,target:x},options:M,handledSourcePaths:new Set})}const R=511;async function N(H,x,M){if(M.handledSourcePaths.has(H))return;M.handledSourcePaths.add(H);const{stat:W,symbolicLink:z}=await n.stat(H);if(z){if(M.options.preserveSymlinks)try{return await U(H,x,M)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(z.dangling)return}return W.isDirectory()?B(H,x,W.mode&R,M):F(H,x,W.mode&R)}async function B(H,x,M,W){await e.Promises.mkdir(x,{recursive:!0,mode:M});const z=await w(H);for(const O of z)await N((0,_.join)(H,O),(0,_.join)(x,O),W)}async function F(H,x,M){await e.Promises.copyFile(H,x),await e.Promises.chmod(x,M)}async function U(H,x,M){let W=await e.Promises.readlink(H);(0,P.isEqualOrParent)(W,M.root.source,!I.isLinux)&&(W=(0,_.join)(M.root.target,W.substr(M.root.source.length+1))),await e.Promises.symlink(W,x)}e.Promises=new class{get access(){return(0,y.promisify)(m.access)}get stat(){return(0,y.promisify)(m.stat)}get lstat(){return(0,y.promisify)(m.lstat)}get utimes(){return(0,y.promisify)(m.utimes)}get read(){return(0,y.promisify)(m.read)}get readFile(){return(0,y.promisify)(m.readFile)}get write(){return(0,y.promisify)(m.write)}get appendFile(){return(0,y.promisify)(m.appendFile)}get fdatasync(){return(0,y.promisify)(m.fdatasync)}get truncate(){return(0,y.promisify)(m.truncate)}get rename(){return(0,y.promisify)(m.rename)}get copyFile(){return(0,y.promisify)(m.copyFile)}get open(){return(0,y.promisify)(m.open)}get close(){return(0,y.promisify)(m.close)}get symlink(){return(0,y.promisify)(m.symlink)}get readlink(){return(0,y.promisify)(m.readlink)}get chmod(){return(0,y.promisify)(m.chmod)}get mkdir(){return(0,y.promisify)(m.mkdir)}get unlink(){return(0,y.promisify)(m.unlink)}get rmdir(){return(0,y.promisify)(m.rmdir)}get realpath(){return(0,y.promisify)(m.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return a}get writeFile(){return r}get rm(){return h}get move(){return d}get copy(){return k}}}),define(ve[104],we([0,1,60,9,8,28]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(L){const T=(0,i.dirname)(L);if(L===T)return L;const l=((0,i.basename)(L)||L).toLowerCase();try{const h=(0,C.readdirSync)(T).filter(p=>p.toLowerCase()===l);if(h.length===1){const p=P(T);if(p)return(0,i.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(l);if(p>=0){const v=P(T);if(v)return(0,i.join)(v,h[p])}}}catch{}return null}e.realcaseSync=P;async function D(L){try{return await C.Promises.realpath(L)}catch{const l=I(L);return await C.Promises.access(l,m.constants.R_OK),l}}e.realpath=D;function _(L){try{return m.realpathSync(L)}catch{const l=I(L);return m.accessSync(l,m.constants.R_OK),l}}e.realpathSync=_;function I(L){return(0,y.rtrim)((0,i.normalize)(L),i.sep)}});var je=this&&this.__decorate||function(J,e,m,i){var y=arguments.length,C=y<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,m):i,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,m,i);else for(var D=J.length-1;D>=0;D--)(P=J[D])&&(C=(y<3?P(C):y>3?P(e,m,C):P(e,m))||C);return y>3&&C&&Object.defineProperty(e,m,C),C};define(ve[105],we([0,1,16,18,22,21,57,15,3,6,59,8,13]),function(J,e,m,i,y,C,P,D,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function v(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(A||(A={}));class w{constructor(O){this.buffer=O,this.pos=0}read(O){const V=this.buffer.slice(this.pos,this.pos+O);return this.pos+=V.byteLength,V}}class s{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function g(z){const O=y.VSBuffer.alloc(4);return O.writeUInt32BE(z,0),O}function a(z){return z.read(4).readUInt32BE(0)}function S(z){const O=y.VSBuffer.alloc(1);return O.writeUInt8(z,0),O}const n={Undefined:S(o.Undefined),String:S(o.String),Buffer:S(o.Buffer),VSBuffer:S(o.VSBuffer),Array:S(o.Array),Object:S(o.Object)},t=typeof Buffer!="undefined";function r(z,O){if(typeof O=="undefined")z.write(n.Undefined);else if(typeof O=="string"){const V=y.VSBuffer.fromString(O);z.write(n.String),z.write(g(V.byteLength)),z.write(V)}else if(t&&Buffer.isBuffer(O)){const V=y.VSBuffer.wrap(O);z.write(n.Buffer),z.write(g(V.byteLength)),z.write(V)}else if(O instanceof y.VSBuffer)z.write(n.VSBuffer),z.write(g(O.byteLength)),z.write(O);else if(Array.isArray(O)){z.write(n.Array),z.write(g(O.length));for(const V of O)r(z,V)}else{const V=y.VSBuffer.fromString(JSON.stringify(O));z.write(n.Object),z.write(g(V.byteLength)),z.write(V)}}function u(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(a(z)).toString();case o.Buffer:return z.read(a(z)).buffer;case o.VSBuffer:return z.read(a(z));case o.Array:{const V=a(z),K=[];for(let G=0;G<V;G++)K.push(u(z));return K}case o.Object:return JSON.parse(z.read(a(z)).toString())}}class c{constructor(O,V,K=null,G=1e3){this.protocol=O,this.ctx=V,this.logger=K,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,V){this.channels.set(O,V),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const V=this.send([O.type]);this.logger&&this.logger.logOutgoing(V,0,1,v(O.type));return}case 201:case 202:case 204:case 203:{const V=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(V,O.id,1,v(O.type),O.data);return}}}send(O,V=void 0){const K=new s;return r(K,O),r(K,V),this.sendBuffer(K.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const V=new w(O),K=u(V),G=u(V),Q=K[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,K[1],1,`${h(Q)}: ${K[2]}.${K[3]}`,G),this.onPromise({type:Q,id:K[1],channelName:K[2],name:K[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,K[1],1,`${h(Q)}: ${K[2]}.${K[3]}`,G),this.onEventListen({type:Q,id:K[1],channelName:K[2],name:K[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,K[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:K[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,K[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:K[1]})}}onPromise(O){const V=this.channels.get(O.channelName);if(!V){this.collectPendingRequest(O);return}const K=new C.CancellationTokenSource;let G;try{G=V.call(this.ctx,O.name,O.arg,K.token)}catch(fe){G=Promise.reject(fe)}const Q=O.id;G.then(fe=>{this.sendResponse({id:Q,data:fe,type:201}),this.activeRequests.delete(O.id)},fe=>{fe instanceof Error?this.sendResponse({id:Q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:Q,data:fe,type:203}),this.activeRequests.delete(O.id)});const Y=(0,I.toDisposable)(()=>K.cancel());this.activeRequests.set(O.id,Y)}onEventListen(O){const V=this.channels.get(O.channelName);if(!V){this.collectPendingRequest(O);return}const K=O.id,Q=V.listen(this.ctx,O.name,O.arg)(Y=>this.sendResponse({id:K,data:Y,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const V=this.activeRequests.get(O.id);V&&(V.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let V=this.pendingRequests.get(O.channelName);V||(V=[],this.pendingRequests.set(O.channelName,V));const K=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:O,timeoutTimer:K})}flushPendingRequests(O){const V=this.pendingRequests.get(O);if(V){for(const K of V)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var f;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(O,V=null){this.protocol=O,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=V}getChannel(O){const V=this;return{call(K,G,Q){return V.isDisposed?Promise.reject(D.canceled()):V.requestPromise(O,K,G,Q)},listen(K,G){return V.isDisposed?Promise.reject(D.canceled()):V.requestEvent(O,K,G)}}}requestPromise(O,V,K,G=C.CancellationToken.None){const Q=this.lastRequestId++,fe={id:Q,type:100,channelName:O,name:V,arg:K};if(G.isCancellationRequested)return Promise.reject(D.canceled());let me;return new Promise((Ie,Oe)=>{if(G.isCancellationRequested)return Oe(D.canceled());const We=()=>{const ue=te=>{switch(te.type){case 201:this.handlers.delete(Q),Ie(te.data);break;case 202:{this.handlers.delete(Q);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,Oe(oe);break}case 203:this.handlers.delete(Q),Oe(te.data);break}};this.handlers.set(Q,ue),this.sendRequest(fe)};let j=null;this.state===A.Idle?We():(j=(0,i.createCancelablePromise)(ue=>this.whenInitialized()),j.then(()=>{j=null,We()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:Q,type:101}),Oe(D.canceled())},re=G.onCancellationRequested(Z);me=(0,I.combinedDisposable)((0,I.toDisposable)(Z),re),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent(O,V,K){const G=this.lastRequestId++,Y={id:G,type:102,channelName:O,name:V,arg:K};let fe=null;const me=new _.Emitter({onFirstListenerAdd:()=>{fe=(0,i.createCancelablePromise)(Ie=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(me),this.sendRequest(Y)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(me),this.sendRequest({id:G,type:103}))}}),Se=Ie=>me.fire(Ie.data);return this.handlers.set(G,Se),me.event}sendRequest(O){switch(O.type){case 100:case 102:{const V=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(V,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const V=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(V,O.id,0,h(O.type));return}}}send(O,V=void 0){const K=new s;return r(K,O),r(K,V),this.sendBuffer(K.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const V=new w(O),K=u(V),G=u(V),Q=K[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,v(Q)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,K[1],0,v(Q),G),this.onResponse({type:K[0],id:K[1],data:G})}}onResponse(O){if(O.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(O.id);V&&V(O)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}je([P.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class d{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:V,onDidClientDisconnect:K})=>{_.Event.once(V.onMessage)(Q=>{const Y=new w(Q),fe=u(Y),me=new c(V,fe),Se=new b(V);this.channels.forEach((Oe,We)=>me.registerChannel(We,Oe));const Ie={channelServer:me,channelClient:Se,ctx:fe};this._connections.add(Ie),this._onDidAddConnection.fire(Ie),K(()=>{me.dispose(),Se.dispose(),this._connections.delete(Ie),this._onDidRemoveConnection.fire(Ie)})})})}get connections(){const O=[];return this._connections.forEach(V=>O.push(V)),O}getChannel(O,V){const K=this;return{call(G,Q,Y){let fe;if((0,l.isFunction)(V)){let Se=(0,m.getRandomElement)(K.connections.filter(V));fe=Se?Promise.resolve(Se):_.Event.toPromise(_.Event.filter(K.onDidAddConnection,V))}else fe=V.routeCall(K,G,Q);const me=fe.then(Se=>Se.channelClient.getChannel(O));return R(me).call(G,Q,Y)},listen(G,Q){if((0,l.isFunction)(V))return K.getMulticastEvent(O,V,G,Q);const Y=V.routeEvent(K,G,Q).then(fe=>fe.channelClient.getChannel(O));return R(Y).listen(G,Q)}}}getMulticastEvent(O,V,K,G){const Q=this;let Y=new I.DisposableStore;const fe=new _.Emitter({onFirstListenerAdd:()=>{Y=new I.DisposableStore;const me=new _.EventMultiplexer,Se=new Map,Ie=We=>{const Z=We.channelClient.getChannel(O).listen(K,G),re=me.add(Z);Se.set(We,re)},Oe=We=>{const j=Se.get(We);!j||(j.dispose(),Se.delete(We))};Q.connections.filter(V).forEach(Ie),_.Event.filter(Q.onDidAddConnection,V)(Ie,void 0,Y),Q.onDidRemoveConnection(Oe,void 0,Y),me.event(fe.fire,fe,Y),Y.add(me)},onLastListenerRemove:()=>{Y.dispose()}});return fe.event}registerChannel(O,V){this.channels.set(O,V),this._connections.forEach(K=>{K.channelServer.registerChannel(O,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class k{constructor(O,V,K=null){const G=new s;r(G,V),O.send(G.buffer),this.channelClient=new b(O,K),this.channelServer=new c(O,V,K)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,V){this.channelServer.registerChannel(O,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function R(z){return{call(O,V,K){return z.then(G=>G.call(O,V,K))},listen(O,V){const K=new _.Relay;return z.then(G=>K.input=G.listen(O,V)),K.event}}}e.getDelayedChannel=R;function N(z){let O=!1;return{call(V,K,G){return O?z.call(V,K,G):(0,i.timeout)(0).then(()=>O=!0).then(()=>z.call(V,K,G))},listen(V,K){if(O)return z.listen(V,K);const G=new _.Relay;return(0,i.timeout)(0).then(()=>O=!0).then(()=>G.input=z.listen(V,K)),G.event}}}e.getNextTickChannel=N;class B{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const V of O.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await _.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=B;var F;(function(z){function O(Q,Y){const fe=Q,me=Y&&Y.disableMarshalling,Se=new Map;for(const Ie in fe)K(Ie)&&Se.set(Ie,_.Event.buffer(fe[Ie],!0));return new class{listen(Ie,Oe,We){const j=Se.get(Oe);if(j)return j;if(G(Oe)){const Z=fe[Oe];if(typeof Z=="function")return Z.call(fe,We)}throw new Error(`Event not found: ${Oe}`)}call(Ie,Oe,We){const j=fe[Oe];if(typeof j=="function"){if(!me&&Array.isArray(We))for(let Z=0;Z<We.length;Z++)We[Z]=(0,L.revive)(We[Z]);return j.apply(fe,We)}throw new Error(`Method not found: ${Oe}`)}}}z.fromService=O;function V(Q,Y){const fe=Y&&Y.disableMarshalling;return new Proxy({},{get(me,Se){if(typeof Se=="string")return Y?.properties?.has(Se)?Y.properties.get(Se):G(Se)?function(Ie){return Q.listen(Se,Ie)}:K(Se)?Q.listen(Se):async function(...Ie){let Oe;Y&&!(0,l.isUndefinedOrNull)(Y.context)?Oe=[Y.context,...Ie]:Oe=Ie;const We=await Q.call(Se,Oe);return fe?We:(0,L.revive)(We)};throw new Error(`Property not found: ${String(Se)}`)}})}z.toService=V;function K(Q){return Q[0]==="o"&&Q[1]==="n"&&T.isUpperAsciiLetter(Q.charCodeAt(2))}function G(Q){return/^onDynamic/.test(Q)&&T.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let O=z.toString();if(O!=="[object Object]")return O}return z}function x(z){return Array.isArray(z)?z.map(H):H(z)}function M(z,O,V,K,G,Q,Y){Y=x(Y);const fe=U[G],me=fe[K%fe.length];let Se=[`%c[${z}]%c[${String(O).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(Q)?(Se=Se.concat(Y),Se.push(")")):Se.push(Y),console.log.apply(console,Se)}e.logWithColors=M;class W{constructor(O,V){this._outgoingPrefix=O,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,V,K,G,Q){this._totalOutgoing+=O,M(this._outgoingPrefix,this._totalOutgoing,O,V,K,G,Q)}logIncoming(O,V,K,G,Q){this._totalIncoming+=O,M(this._incomingPrefix,this._totalIncoming,O,V,K,G,Q)}}e.IPCLogger=W}),define(ve[106],we([0,1,22,3,6,105]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let u=0;function c(b,d){if(!r.has(b)){const k=String(++u);r.set(b,k)}return r.get(b)}function f(b,d,k,R){if(!t.enableDiagnostics)return;const N=c(b,d);if(R instanceof m.VSBuffer||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const B=m.VSBuffer.alloc(R.byteLength);B.set(R),t.records.push({timestamp:Date.now(),id:N,label:d,type:k,buff:B})}else t.records.push({timestamp:Date.now(),id:N,label:d,type:k,data:R})}t.traceSocketEvent=f})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var _;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function L(){return I||(I=m.VSBuffer.alloc(0)),I}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,u){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const d=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=r),d}if(this._chunks[0].byteLength>r){const d=this._chunks[0].slice(0,r);return u&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),d}let c=m.VSBuffer.alloc(r),f=0,b=0;for(;r>0;){const d=this._chunks[b];if(d.byteLength>r){const k=d.slice(0,r);c.set(k,f),f+=r,u&&(this._chunks[b]=d.slice(r),this._totalLength-=r),r-=r}else c.set(d,f),f+=d.byteLength,u?(this._chunks.shift(),this._totalLength-=d.byteLength):b++,r-=d.byteLength}return c}}e.ChunkStream=T;var l;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(l||(l={}));function E(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(r,u,c,f){this.type=r,this.id=u,this.ack=c,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends y.Disposable{constructor(r){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,f=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new p(c,f,b,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class A{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=m.VSBuffer.alloc(13);u.writeUInt8(r.type,0),u.writeUInt32BE(r.id,1),u.writeUInt32BE(r.ack,5),u.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(u,r.data)}_bufferAdd(r,u){const c=this._totalLength===0;return this._data.push(r,u),this._totalLength+=r.byteLength+u.byteLength,c}_bufferTake(){const r=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,u){this._bufferAdd(r,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class w extends y.Disposable{constructor(r){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new A(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new p(1,0,0,r))}}e.Protocol=w;class s extends C.IPCClient{constructor(r,u,c=null){super(r,u,c);this.protocol=r}static fromSocket(r,u){return new s(new w(r),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=s;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class g{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],u=0,c=this._first;for(;c;)r[u++]=c.data,c=c.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const u=new g(r);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class S{constructor(){this.lastRuns=[];const r=Date.now();for(let u=0;u<S._HISTORY_LENGTH;u++)this.lastRuns[u]=r-1e3*u;setInterval(()=>{for(let u=S._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const r=Date.now(),u=(1+S._HISTORY_LENGTH)*1e3;let c=0;for(let f=0;f<S._HISTORY_LENGTH;f++)r-this.lastRuns[f]<=u&&c++;return 1-c/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class n{constructor(r,u=null,c=S.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new p(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new p(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new p(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,u){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r);const u=this._outgoingUnackMsg.toArray();for(let c=0,f=u.length;c<f;c++)this._socketWriter.write(u[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let c=0,f=u.length;c<f;c++)this._socketWriter.write(u[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new p(1,u,this._incomingAckId,r);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(r){const u=new p(2,0,0,r);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),u=Date.now()-r.writtenTime,c=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&c>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const b=Math.max(2e4-u,2e4-c,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},b)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(ve[107],we([0,1,98]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(D){let _=(0,m.toUint8)(D);this._defaultValue=_,this._asciiMap=i._createAsciiMap(_),this._map=new Map}static _createAsciiMap(D){let _=new Uint8Array(256);for(let I=0;I<256;I++)_[I]=D;return _}set(D,_){let I=(0,m.toUint8)(_);D>=0&&D<256?this._asciiMap[D]=I:this._map.set(D,I)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=i;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new i(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=C}),define(ve[143],we([0,1,107]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends m.CharacterClassifier{constructor(D){super(0);for(let _=0,I=D.length;_<I;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(P){let D={};return _=>(D.hasOwnProperty(_)||(D[_]=P(_)),D[_])}e.getMapForWordSeparators=C(P=>new y(P))}),define(ve[49],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new m(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return m.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return m.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return m.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let P=y.lineNumber|0,D=C.lineNumber|0;if(P===D){let _=y.column|0,I=C.column|0;return _-I}return P-D}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new m(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=m}),define(ve[41],we([0,1,49]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(C,P,D,_){C>D||C===D&&P>_?(this.startLineNumber=D,this.startColumn=_,this.endLineNumber=C,this.endColumn=P):(this.startLineNumber=C,this.startColumn=P,this.endLineNumber=D,this.endColumn=_)}isEmpty(){return i.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return i.containsPosition(this,C)}static containsPosition(C,P){return!(P.lineNumber<C.startLineNumber||P.lineNumber>C.endLineNumber||P.lineNumber===C.startLineNumber&&P.column<C.startColumn||P.lineNumber===C.endLineNumber&&P.column>C.endColumn)}static strictContainsPosition(C,P){return!(P.lineNumber<C.startLineNumber||P.lineNumber>C.endLineNumber||P.lineNumber===C.startLineNumber&&P.column<=C.startColumn||P.lineNumber===C.endLineNumber&&P.column>=C.endColumn)}containsRange(C){return i.containsRange(this,C)}static containsRange(C,P){return!(P.startLineNumber<C.startLineNumber||P.endLineNumber<C.startLineNumber||P.startLineNumber>C.endLineNumber||P.endLineNumber>C.endLineNumber||P.startLineNumber===C.startLineNumber&&P.startColumn<C.startColumn||P.endLineNumber===C.endLineNumber&&P.endColumn>C.endColumn)}strictContainsRange(C){return i.strictContainsRange(this,C)}static strictContainsRange(C,P){return!(P.startLineNumber<C.startLineNumber||P.endLineNumber<C.startLineNumber||P.startLineNumber>C.endLineNumber||P.endLineNumber>C.endLineNumber||P.startLineNumber===C.startLineNumber&&P.startColumn<=C.startColumn||P.endLineNumber===C.endLineNumber&&P.endColumn>=C.endColumn)}plusRange(C){return i.plusRange(this,C)}static plusRange(C,P){let D,_,I,L;return P.startLineNumber<C.startLineNumber?(D=P.startLineNumber,_=P.startColumn):P.startLineNumber===C.startLineNumber?(D=P.startLineNumber,_=Math.min(P.startColumn,C.startColumn)):(D=C.startLineNumber,_=C.startColumn),P.endLineNumber>C.endLineNumber?(I=P.endLineNumber,L=P.endColumn):P.endLineNumber===C.endLineNumber?(I=P.endLineNumber,L=Math.max(P.endColumn,C.endColumn)):(I=C.endLineNumber,L=C.endColumn),new i(D,_,I,L)}intersectRanges(C){return i.intersectRanges(this,C)}static intersectRanges(C,P){let D=C.startLineNumber,_=C.startColumn,I=C.endLineNumber,L=C.endColumn,T=P.startLineNumber,l=P.startColumn,E=P.endLineNumber,h=P.endColumn;return D<T?(D=T,_=l):D===T&&(_=Math.max(_,l)),I>E?(I=E,L=h):I===E&&(L=Math.min(L,h)),D>I||D===I&&_>L?null:new i(D,_,I,L)}equalsRange(C){return i.equalsRange(this,C)}static equalsRange(C,P){return!!C&&!!P&&C.startLineNumber===P.startLineNumber&&C.startColumn===P.startColumn&&C.endLineNumber===P.endLineNumber&&C.endColumn===P.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,P){return new i(this.startLineNumber,this.startColumn,C,P)}setStartPosition(C,P){return new i(C,P,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(C){return new i(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,P=C){return new i(C.lineNumber,C.column,P.lineNumber,P.column)}static lift(C){return C?new i(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,P){return!(C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn||P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn)}static areIntersecting(C,P){return!(C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn||P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,P){if(C&&P){const I=C.startLineNumber|0,L=P.startLineNumber|0;if(I===L){const T=C.startColumn|0,l=P.startColumn|0;if(T===l){const E=C.endLineNumber|0,h=P.endLineNumber|0;if(E===h){const p=C.endColumn|0,v=P.endColumn|0;return p-v}return E-h}return T-l}return I-L}return(C?1:0)-(P?1:0)}static compareRangesUsingEnds(C,P){return C.endLineNumber===P.endLineNumber?C.endColumn===P.endColumn?C.startLineNumber===P.startLineNumber?C.startColumn-P.startColumn:C.startLineNumber-P.startLineNumber:C.endColumn-P.endColumn:C.endLineNumber-P.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=i}),define(ve[144],we([0,1,49,41]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends i.Range{constructor(D,_,I,L){super(D,_,I,L);this.selectionStartLineNumber=D,this.selectionStartColumn=_,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return C.selectionsEqual(this,D)}static selectionsEqual(D,_){return D.selectionStartLineNumber===_.selectionStartLineNumber&&D.selectionStartColumn===_.selectionStartColumn&&D.positionLineNumber===_.positionLineNumber&&D.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,D,_):new C(D,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,_){return this.getDirection()===0?new C(D,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,D,_)}static fromPositions(D,_=D){return new C(D.lineNumber,D.column,_.lineNumber,_.column)}static fromRange(D,_){return _===0?new C(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new C(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new C(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,_){if(D&&!_||!D&&_)return!1;if(!D&&!_)return!0;if(D.length!==_.length)return!1;for(let I=0,L=D.length;I<L;I++)if(!this.selectionsEqual(D[I],_[I]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,_,I,L,T){return T===0?new C(D,_,I,L):new C(I,L,D,_)}}e.Selection=C}),define(ve[108],we([0,1,25]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class I{constructor(v,A){this._findMatchBrand=void 0,this.range=v,this.matches=A}}e.FindMatch=I;var L;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(T=e.PositionAffinity||(e.PositionAffinity={}));var l;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l=e.ModelConstants||(e.ModelConstants={}));class E{constructor(v,A,w,s,o,g){this.identifier=v,this.range=A,this.text=w,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=o,this._isTracked=g}}e.ValidAnnotatedEditOperation=E;class h{constructor(v,A,w){this.reverseEdits=v,this.changes=A,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(ve[145],we([0,1,8,143,49,41,108]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(s,o,g,a){this.searchString=s,this.isRegex=o,this.matchCase=g,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=I(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!o)return null;let g=!this.isRegex&&!s;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L(o,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function I(w){if(!w||w.length===0)return!1;for(let s=0,o=w.length;s<o;s++)if(w.charCodeAt(s)===92){if(s++,s>=o)break;const a=w.charCodeAt(s);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=I;class L{constructor(s,o,g){this.regex=s,this.wordSeparators=o,this.simpleSearch=g}}e.SearchData=L;function T(w,s,o){if(!o)return new P.FindMatch(w,null);let g=[];for(let a=0,S=s.length;a<S;a++)g[a]=s[a];return new P.FindMatch(w,g)}e.createFindMatch=T;class l{constructor(s){let o=[],g=0;for(let a=0,S=s.length;a<S;a++)s.charCodeAt(a)===10&&(o[g++]=a);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(s){const o=this._lineFeedsOffsets;let g=0,a=o.length-1;if(a===-1||s<=o[0])return 0;for(;g<a;){const S=g+((a-g)/2>>0);o[S]>=s?a=S-1:o[S+1]>=s?(g=S,a=S):g=S+1}return g+1}}class E{static findMatches(s,o,g,a,S){const n=o.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(s,g,new A(n.wordSeparators,n.regex),a,S):this._doFindMatchesLineByLine(s,g,n,a,S):[]}static _getMultilineMatchRange(s,o,g,a,S,n){let t,r=0;a?(r=a.findLineFeedCountBeforeOffset(S),t=o+S+r):t=o+S;let u;if(a){let d=a.findLineFeedCountBeforeOffset(S+n.length)-r;u=t+n.length+d}else u=t+n.length;const c=s.getPositionAt(t),f=s.getPositionAt(u);return new C.Range(c.lineNumber,c.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(s,o,g,a,S){const n=s.getOffsetAt(o.getStartPosition()),t=s.getValueInRange(o,1),r=s.getEOL()===`\r
`?new l(t):null,u=[];let c=0,f;for(g.reset(0);f=g.next(t);)if(u[c++]=T(this._getMultilineMatchRange(s,n,t,r,f.index,f[0]),f,a),c>=S)return u;return u}static _doFindMatchesLineByLine(s,o,g,a,S){const n=[];let t=0;if(o.startLineNumber===o.endLineNumber){const u=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return t=this._findMatchesInLine(g,u,o.startLineNumber,o.startColumn-1,t,n,a,S),n}const r=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);t=this._findMatchesInLine(g,r,o.startLineNumber,o.startColumn-1,t,n,a,S);for(let u=o.startLineNumber+1;u<o.endLineNumber&&t<S;u++)t=this._findMatchesInLine(g,s.getLineContent(u),u,0,t,n,a,S);if(t<S){const u=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);t=this._findMatchesInLine(g,u,o.endLineNumber,0,t,n,a,S)}return n}static _findMatchesInLine(s,o,g,a,S,n,t,r){const u=s.wordSeparators;if(!t&&s.simpleSearch){const b=s.simpleSearch,d=b.length,k=o.length;let R=-d;for(;(R=o.indexOf(b,R+d))!==-1;)if((!u||v(u,o,k,R,d))&&(n[S++]=new P.FindMatch(new C.Range(g,R+1+a,g,R+1+d+a),null),S>=r))return S;return S}const c=new A(s.wordSeparators,s.regex);let f;c.reset(0);do if(f=c.next(o),f&&(n[S++]=T(new C.Range(g,f.index+1+a,g,f.index+1+f[0].length+a),f,t),S>=r))return S;while(f);return S}static findNextMatch(s,o,g,a){const S=o.parseSearchRequest();if(!S)return null;const n=new A(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(s,g,n,a):this._doFindNextMatchLineByLine(s,g,n,a)}static _doFindNextMatchMultiline(s,o,g,a){const S=new y.Position(o.lineNumber,1),n=s.getOffsetAt(S),t=s.getLineCount(),r=s.getValueInRange(new C.Range(S.lineNumber,S.column,t,s.getLineMaxColumn(t)),1),u=s.getEOL()===`\r
`?new l(r):null;g.reset(o.column-1);let c=g.next(r);return c?T(this._getMultilineMatchRange(s,n,r,u,c.index,c[0]),c,a):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(s,new y.Position(1,1),g,a):null}static _doFindNextMatchLineByLine(s,o,g,a){const S=s.getLineCount(),n=o.lineNumber,t=s.getLineContent(n),r=this._findFirstMatchInLine(g,t,n,o.column,a);if(r)return r;for(let u=1;u<=S;u++){const c=(n+u-1)%S,f=s.getLineContent(c+1),b=this._findFirstMatchInLine(g,f,c+1,1,a);if(b)return b}return null}static _findFirstMatchInLine(s,o,g,a,S){s.reset(a-1);const n=s.next(o);return n?T(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,S):null}static findPreviousMatch(s,o,g,a){const S=o.parseSearchRequest();if(!S)return null;const n=new A(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(s,g,n,a):this._doFindPreviousMatchLineByLine(s,g,n,a)}static _doFindPreviousMatchMultiline(s,o,g,a){const S=this._doFindMatchesMultiline(s,new C.Range(1,1,o.lineNumber,o.column),g,a,10*D);if(S.length>0)return S[S.length-1];const n=s.getLineCount();return o.lineNumber!==n||o.column!==s.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(s,new y.Position(n,s.getLineMaxColumn(n)),g,a):null}static _doFindPreviousMatchLineByLine(s,o,g,a){const S=s.getLineCount(),n=o.lineNumber,t=s.getLineContent(n).substring(0,o.column-1),r=this._findLastMatchInLine(g,t,n,a);if(r)return r;for(let u=1;u<=S;u++){const c=(S+n-u-1)%S,f=s.getLineContent(c+1),b=this._findLastMatchInLine(g,f,c+1,a);if(b)return b}return null}static _findLastMatchInLine(s,o,g,a){let S=null,n;for(s.reset(0);n=s.next(o);)S=T(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,a);return S}}e.TextModelSearch=E;function h(w,s,o,g,a){if(g===0)return!0;const S=s.charCodeAt(g-1);if(w.get(S)!==0||S===13||S===10)return!0;if(a>0){const n=s.charCodeAt(g);if(w.get(n)!==0)return!0}return!1}function p(w,s,o,g,a){if(g+a===o)return!0;const S=s.charCodeAt(g+a);if(w.get(S)!==0||S===13||S===10)return!0;if(a>0){const n=s.charCodeAt(g+a-1);if(w.get(n)!==0)return!0}return!1}function v(w,s,o,g,a){return h(w,s,o,g,a)&&p(w,s,o,g,a)}e.isValidMatch=v;class A{constructor(s,o){this._wordSeparators=s,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const o=s.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(g=this._searchRegex.exec(s),!g))return null;const a=g.index,S=g[0].length;if(a===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){m.getNextCodePoint(s,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=S,!this._wordSeparators||v(this._wordSeparators,s,o,a,S))return g}while(g);return null}}e.Searcher=A}),define(ve[109],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(D=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)D.indexOf(I)>=0||(_+="\\"+I);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function i(D){let _=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)_=D;else{let I="g";D.ignoreCase&&(I+="i"),D.multiline&&(I+="m"),D.unicode&&(I+="u"),_=new RegExp(D.source,I)}return _.lastIndex=0,_}e.ensureValidWordDefinition=i;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(D,_,I,L,T=y){if(I.length>T.maxLen){let v=D-T.maxLen/2;return v<0?v=0:L+=v,I=I.substring(v,D+T.maxLen/2),C(D,_,I,L,T)}const l=Date.now(),E=D-1-L;let h=-1,p=null;for(let v=1;!(Date.now()-l>=T.timeBudget);v++){const A=E-T.windowSize*v;_.lastIndex=Math.max(0,A);const w=P(_,I,E,h);if(!w&&p||(p=w,A<=0))break;h=A}if(p){let v={word:p[0],startColumn:L+1+p.index,endColumn:L+1+p.index+p[0].length};return _.lastIndex=0,v}return null}e.getWordAtText=C;function P(D,_,I,L){let T;for(;T=D.exec(_);){const l=T.index||0;if(l<=I&&D.lastIndex>=I)return T;if(L>0&&l>L)return null}return null}}),define(ve[146],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class i{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let _=0,I=D.notIn.length;_<I;_++)switch(D.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}shouldAutoClose(D,_){if(D.getTokenCount()===0)return!0;const I=D.findTokenIndexAtOffset(_-2),L=D.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(D,_){for(let I=D;I<=_;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class y{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function C(P,D,_){P.has(D)?P.get(D).push(_):P.set(D,[_])}}),define(ve[82],we([0,1,31,9]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,P,D,_){if(Array.isArray(C)){let I=0;for(const L of C){const T=y(L,P,D,_);if(T===10)return T;T>I&&(I=T)}return I}else{if(typeof C=="string")return _?C==="*"?5:C===D?10:0:0;if(C){const{language:I,pattern:L,scheme:T,hasAccessToAllModels:l}=C;if(!_&&!l)return 0;let E=0;if(T)if(T===P.scheme)E=10;else if(T==="*")E=5;else return 0;if(I)if(I===D)E=10;else if(I==="*")E=Math.max(E,5);else return 0;if(L){let h;if(typeof L=="string"?h=L:h={...L,base:(0,i.normalize)(L.base)},h===P.fsPath||(0,m.match)(h,P.fsPath))E=10;else return 0}return E}else return 0}}e.score=y}),define(ve[147],we([0,1,107]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class y{constructor(h,p,v){const A=new Uint8Array(h*p);for(let w=0,s=h*p;w<s;w++)A[w]=v;this._data=A,this.rows=h,this.cols=p}get(h,p){return this._data[h*this.cols+p]}set(h,p,v){this._data[h*this.cols+p]=v}}e.Uint8Matrix=y;class C{constructor(h){let p=0,v=0;for(let w=0,s=h.length;w<s;w++){let[o,g,a]=h[w];g>p&&(p=g),o>v&&(v=o),a>v&&(v=a)}p++,v++;let A=new y(v,p,0);for(let w=0,s=h.length;w<s;w++){let[o,g,a]=h[w];A.set(o,g,a)}this._states=A,this._maxCharCode=p}nextState(h,p){return p<0||p>=this._maxCharCode?0:this._states.get(h,p)}}e.StateMachine=C;let P=null;function D(){return P===null&&(P=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var _;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let I=null;function L(){if(I===null){I=new m.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<E.length;p++)I.set(E.charCodeAt(p),1);const h=".,;";for(let p=0;p<h.length;p++)I.set(h.charCodeAt(p),2)}return I}class T{static _createLink(h,p,v,A,w){let s=w-1;do{const o=p.charCodeAt(s);if(h.get(o)!==2)break;s--}while(s>A);if(A>0){const o=p.charCodeAt(A-1),g=p.charCodeAt(s);(o===40&&g===41||o===91&&g===93||o===123&&g===125)&&s--}return{range:{startLineNumber:v,startColumn:A+1,endLineNumber:v,endColumn:s+2},url:p.substring(A,s+1)}}static computeLinks(h,p=D()){const v=L();let A=[];for(let w=1,s=h.getLineCount();w<=s;w++){const o=h.getLineContent(w),g=o.length;let a=0,S=0,n=0,t=1,r=!1,u=!1,c=!1,f=!1;for(;a<g;){let b=!1;const d=o.charCodeAt(a);if(t===13){let k;switch(d){case 40:r=!0,k=0;break;case 41:k=r?0:1;break;case 91:c=!0,u=!0,k=0;break;case 93:c=!1,k=u?0:1;break;case 123:f=!0,k=0;break;case 125:k=f?0:1;break;case 39:k=n===34||n===96?0:1;break;case 34:k=n===39||n===96?0:1;break;case 96:k=n===39||n===34?0:1;break;case 42:k=n===42?1:0;break;case 124:k=n===124?1:0;break;case 32:k=c?0:1;break;default:k=v.get(d)}k===1&&(A.push(T._createLink(v,o,w,S,a)),b=!0)}else if(t===12){let k;d===91?(u=!0,k=0):k=v.get(d),k===1?b=!0:t=13}else t=p.nextState(t,d),t===0&&(b=!0);b&&(t=1,r=!1,u=!1,f=!1,S=a+1,n=d),a++}t===13&&A.push(T._createLink(v,o,w,S,g))}return A}}e.LinkComputer=T;function l(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:T.computeLinks(E)}e.computeLinks=l}),define(ve[148],we([0,1,3,6]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,D){return this._map.set(P,D),this.fire([P]),(0,i.toDisposable)(()=>{this._map.get(P)===D&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,D){let _=null,I=!1;return this._promises.set(P,D.then(L=>{this._promises.delete(P),!(I||!L)&&(_=this.register(P,L))})),(0,i.toDisposable)(()=>{I=!0,_&&_.dispose()})}getPromise(P){const D=this.get(P);if(D)return Promise.resolve(D);const _=this._promises.get(P);return _?_.then(I=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(ve[110],we([0,1,22,12]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(y||(y={}));function C(T){for(let l=0,E=T.length;l<E;l+=4){const h=T[l+0],p=T[l+1],v=T[l+2],A=T[l+3];T[l+0]=A,T[l+1]=v,T[l+2]=p,T[l+3]=h}}function P(T){const l=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return i.isLittleEndian()||C(l),m.VSBuffer.wrap(l)}function D(T){const l=T.buffer;if(i.isLittleEndian()||C(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const E=new Uint8Array(l.byteLength);return E.set(l),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function _(T){const l=new Uint32Array(I(T));let E=0;if(l[E++]=T.id,T.type==="full")l[E++]=1,l[E++]=T.data.length,l.set(T.data,E),E+=T.data.length;else{l[E++]=2,l[E++]=T.deltas.length;for(const h of T.deltas)l[E++]=h.start,l[E++]=h.deleteCount,h.data?(l[E++]=h.data.length,l.set(h.data,E),E+=h.data.length):l[E++]=0}return P(l)}e.encodeSemanticTokensDto=_;function I(T){let l=0;if(l+=1+1,T.type==="full")l+=1+T.data.length;else{l+=1,l+=(1+1+1)*T.deltas.length;for(const E of T.deltas)E.data&&(l+=E.data.length)}return l}function L(T){const l=D(T);let E=0;const h=l[E++];if(l[E++]===1){const w=l[E++],s=l.subarray(E,E+w);return E+=w,{id:h,type:"full",data:s}}const v=l[E++];let A=[];for(let w=0;w<v;w++){const s=l[E++],o=l[E++],g=l[E++];let a;g>0&&(a=l.subarray(E,E+g),E+=g),A[w]={start:s,deleteCount:o,data:a}}return{id:h,type:"delta",deltas:A}}e.decodeSemanticTokensDto=L}),define(ve[111],we([0,1,16,98]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,I){_=(0,i.toUint32)(_);const L=this.values,T=this.prefixSum,l=I.length;return l===0?!1:(this.values=new Uint32Array(L.length+l),this.values.set(L.subarray(0,_),0),this.values.set(L.subarray(_),_+l),this.values.set(I,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,I){return _=(0,i.toUint32)(_),I=(0,i.toUint32)(I),this.values[_]===I?!1:(this.values[_]=I,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,I){_=(0,i.toUint32)(_),I=(0,i.toUint32)(I);const L=this.values,T=this.prefixSum;if(_>=L.length)return!1;let l=L.length-_;return I>=l&&(I=l),I===0?!1:(this.values=new Uint32Array(L.length-I),this.values.set(L.subarray(0,_),0),this.values.set(L.subarray(_+I),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,i.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),_>=this.values.length&&(_=this.values.length-1);for(let L=I;L<=_;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let I=0,L=this.values.length-1,T=0,l=0,E=0;for(;I<=L;)if(T=I+(L-I)/2|0,l=this.prefixSum[T],E=l-this.values[T],_<E)L=T-1;else if(_>=l)I=T+1;else break;return new P(T,_-E)}}e.PrefixSumComputer=y;class C{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const I=this._indexBySum[_],L=I>0?this._prefixSum[I-1]:0;return new P(I,_-L)}removeValues(_,I){this._values.splice(_,I),this._invalidate(_)}insertValues(_,I){this._values=(0,m.arrayInsert)(this._values,_,I),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,I=this._values.length;_<I;_++){const L=this._values[_],T=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=T+L;for(let l=0;l<L;l++)this._indexBySum[T+l]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,I){this._values[_]!==I&&(this._values[_]=I,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=C;class P{constructor(_,I){this.index=_,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=I}}e.PrefixSumIndexOfResult=P}),define(ve[149],we([0,1,8,49,111]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(D,_,I,L){this._uri=D,this._lines=_,this._eol=I,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const _=D.changes;for(const I of _)this._acceptDeleteRange(I.range),this._acceptInsertText(new i.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,_=this._lines.length,I=new Uint32Array(_);for(let L=0;L<_;L++)I[L]=this._lines[L].length+D;this._lineStarts=new y.PrefixSumComputer(I)}}_setLineText(D,_){this._lines[D]=_,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,_){if(_.length===0)return;let I=(0,m.splitLines)(_);if(I.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+I[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}I[I.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+I[0]);let L=new Uint32Array(I.length-1);for(let T=1;T<I.length;T++)this._lines.splice(D.lineNumber+T-1,0,I[T]),L[T-1]=I[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=C}),define(ve[150],we([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(ve[151],we([0,1,150]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,y=i*60,C=y*24,P=C*7,D=C*30,_=C*365;function I(T,l){typeof T!="number"&&(T=T.getTime());const E=Math.round((new Date().getTime()-T)/1e3);if(E<-30)return(0,m.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,m.localize)(1,null);let h;return E<i?(h=E,l?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):E<y?(h=Math.floor(E/i),l?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):E<C?(h=Math.floor(E/y),l?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):E<P?(h=Math.floor(E/C),l?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):E<D?(h=Math.floor(E/P),l?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):E<_?(h=Math.floor(E/D),l?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(E/_),l?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=I;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ve[152],we([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[50],we([0,1,16,13,152]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(I,L){return L&&(I.stack||I.stacktrace)?y.localize(0,null,D(I),P(I.stack)||P(I.stacktrace)):D(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function D(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?y.localize(1,null,I.message):I.message||y.localize(2,null)}function _(I=null,L=!1){if(!I)return y.localize(3,null);if(Array.isArray(I)){const T=m.coalesce(I),l=_(T[0],L);return T.length>1?y.localize(4,null,l,T.length):l}if(i.isString(I))return I;if(I.detail){const T=I.detail;if(T.error)return C(T.error,L);if(T.exception)return C(T.exception,L)}return I.stack?C(I,L):I.message?I.message:y.localize(5,null)}e.toErrorMessage=_}),define(ve[153],we([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ve[112],we([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(a,S){if(D.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};S&&(n.cwd=S);const t=m.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(r=>{t.once("error",u=>{r({success:!1,error:u})}),t.once("exit",(u,c)=>{r(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(D.isLinux||D.isMacintosh)try{const n=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{m.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,u,c)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function v(a){!a||(delete a.DEBUG,D.isMacintosh&&delete a.DYLD_LIBRARY_PATH,D.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function A(a=_.env){return a.comspec||"cmd.exe"}e.getWindowsShell=A;class w{constructor(S,n,t,r){if(n!==void 0&&t!==void 0&&r!==void 0)this.cmd=S,this.args=n,this.shell=t,this.options=r;else{const u=S;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(_.env).forEach(c=>{u[c]=_.env[c]}),Object.keys(this.options.env).forEach(c=>{u[c]=this.options.env[c]}),this.options.env=u}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const n=S.lastIndexOf(P.sep);return n!==-1&&(S=S.substring(n+1)),w.WellKnowCommands[S]?S:"other"}start(S){return D.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(_.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let t,r;const u=new Promise((c,f)=>{t=c,r=f});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=m.exec(c,this.options,(f,b,d)=>{this.childProcess=null;const k=f;k&&k.killed?r({killed:this.terminateRequested,stdout:b.toString(),stderr:d.toString()}):this.handleExec(t,S,f,b,d)})}else{let c=null;const f=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,t,S,r);const d={terminated:this.terminateRequested};L.isNumber(b)&&(d.cmdCode=b),t(d)};if(this.shell&&D.isWindows){const b=C.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let d=!1,k=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),d=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),R.push(N.value),k=k&&N.quoted});const B=["/s","/c"];d?k?B.push('"'+R.join(" ")+'"'):R.length>1?B.push('"'+R[0]+'" '+R.slice(1).join(" ")):B.push('"'+R[0]+'"'):B.push(R.join(" ")),c=m.spawn(A(),B,b)}else this.cmd&&(c=m.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(L.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",b=>{this.childProcess=null,r({terminated:this.terminateRequested,error:b})}),c.pid&&(this.childProcess.on("close",f),this.handleSpawn(c,t,S,r,!0)))}return u})}handleClose(S,n,t,r){}ensureQuotes(S){return w.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,p(S,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!D.isWindows)return S(!1);const n=m.spawn(A(),["/s","/c"]);n.on("error",t=>S(!0)),n.on("exit",t=>S(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class s extends w{constructor(S,n,t,r){super(S,n,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,n,t,r,u){[r,u].forEach((c,f)=>{const b=new T.LineDecoder;b.write(c).forEach(R=>{n({line:R,source:f===0?0:1})});const k=b.end();k&&n({line:k,source:f===0?0:1})}),S({terminated:this.terminateRequested,error:t})}handleSpawn(S,n,t,r,u){const c=new T.LineDecoder,f=new T.LineDecoder;S.stdout.on("data",b=>{c.write(b).forEach(k=>t({line:k,source:0}))}),S.stderr.on("data",b=>{f.write(b).forEach(k=>t({line:k,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=f}handleClose(S,n,t,r){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&t({line:u,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=s;function o(a){let S=[],n=!1;const t=function(r){if(n){S.push(r);return}(!a.send(r,c=>{if(c&&console.error(c),n=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(b=>t(b))}})||D.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=o;var g;(function(a){async function S(n,t,r){if(P.isAbsolute(n))return n;if(t===void 0&&(t=_.cwd()),P.dirname(n)!=="."||(r===void 0&&L.isString(_.env.PATH)&&(r=_.env.PATH.split(P.delimiter)),r===void 0||r.length===0))return P.join(t,n);async function c(f){if(await l.Promises.exists(f)){let b;try{b=await l.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(b=await l.Promises.lstat(f))}return b?!b.isDirectory():!1}return!1}for(let f of r){let b;if(P.isAbsolute(f)?b=P.join(f,n):b=P.join(t,f,n),await c(b))return b;let d=b+".com";if(await c(d)||(d=b+".exe",await c(d)))return d}return P.join(t,n)}a.findExecutable=S})(g=e.win32||(e.win32={}))}),define(ve[154],we([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[113],we([0,1,154,12,109,16,25]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=_;class I{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,pe){this._values[ne]=pe}}e.ValidatedEditorOptions=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(ne,pe,ie,_e){this.id=ne,this.name=pe,this.defaultValue=ie,this.schema=_e}applyUpdate(ne,pe){return E(ne,pe)}compute(ne,pe,ie){return ie}}class l{constructor(ne,pe){this.newValue=ne,this.didChange=pe}}e.ApplyUpdateResult=l;function E(ee,ne){if(typeof ee!="object"||typeof ne!="object"||!ee||!ne)return new l(ne,ee!==ne);if(Array.isArray(ee)||Array.isArray(ne)){const ie=Array.isArray(ee)&&Array.isArray(ne)&&C.equals(ee,ne);return new l(ne,ie)}let pe=!1;for(let ie in ne)if(ne.hasOwnProperty(ie)){const _e=E(ee[ie],ne[ie]);_e.didChange&&(ee[ie]=_e.newValue,pe=!0)}return new l(ee,pe)}class h{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,pe){return E(ne,pe)}validate(ne){return this.defaultValue}}class p{constructor(ne,pe,ie,_e){this.id=ne,this.name=pe,this.defaultValue=ie,this.schema=_e}applyUpdate(ne,pe){return E(ne,pe)}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,pe,ie){return ie}}function v(ee,ne){return typeof ee=="undefined"?ne:ee==="false"?!1:Boolean(ee)}e.boolean=v;class A extends p{constructor(ne,pe,ie,_e=void 0){typeof _e!="undefined"&&(_e.type="boolean",_e.default=ie);super(ne,pe,ie,_e)}validate(ne){return v(ne,this.defaultValue)}}function w(ee,ne,pe,ie){if(typeof ee=="undefined")return ne;let _e=parseInt(ee,10);return isNaN(_e)?ne:(_e=Math.max(pe,_e),_e=Math.min(ie,_e),_e|0)}e.clampedInt=w;class s extends p{constructor(ne,pe,ie,_e,Fe,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="integer",Ue.default=ie,Ue.minimum=_e,Ue.maximum=Fe);super(ne,pe,ie,Ue);this.minimum=_e,this.maximum=Fe}static clampedInt(ne,pe,ie,_e){return w(ne,pe,ie,_e)}validate(ne){return s.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class o extends p{constructor(ne,pe,ie,_e,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=ie);super(ne,pe,ie,Fe);this.validationFn=_e}static clamp(ne,pe,ie){return ne<pe?pe:ne>ie?ie:ne}static float(ne,pe){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return pe;const ie=parseFloat(ne);return isNaN(ie)?pe:ie}validate(ne){return this.validationFn(o.float(ne,this.defaultValue))}}class g extends p{static string(ne,pe){return typeof ne!="string"?pe:ne}constructor(ne,pe,ie,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.default=ie);super(ne,pe,ie,_e)}validate(ne){return g.string(ne,this.defaultValue)}}function a(ee,ne,pe){return typeof ee!="string"||pe.indexOf(ee)===-1?ne:ee}e.stringSet=a;class S extends p{constructor(ne,pe,ie,_e,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=_e,Fe.default=ie);super(ne,pe,ie,Fe);this._allowedValues=_e}validate(ne){return a(ne,this.defaultValue,this._allowedValues)}}class n extends T{constructor(ne,pe,ie,_e,Fe,Ue,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Fe,Xe.default=_e);super(ne,pe,ie,Xe);this._allowedValues=Fe,this._convert=Ue}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function t(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,pe,ie){return ie===0?ne.accessibilitySupport:ie}}class u extends T{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{insertSpace:v(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(b=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(ee){switch(ee){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function k(ee){switch(ee){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class R extends h{constructor(){super(127)}compute(ne,pe,ie){const _e=["monaco-editor"];return pe.get(33)&&_e.push(pe.get(33)),ne.extraEditorClassName&&_e.push(ne.extraEditorClassName),pe.get(65)==="default"?_e.push("mouse-default"):pe.get(65)==="copy"&&_e.push("mouse-copy"),pe.get(99)&&_e.push("showUnused"),pe.get(125)&&_e.push("showDeprecated"),_e.join(" ")}}class N extends A{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ne,pe,ie){return ie&&ne.emptySelectionClipboard}}class B extends T{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:m.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:m.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{cursorMoveOnType:v(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":a(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":a(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(pe.loop,this.defaultValue.loop)}}}class F extends T{constructor(){super(44,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?F.OFF:ne==="true"?F.ON:ne:Boolean(ne)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class U extends h{constructor(){super(43)}compute(ne,pe,ie){return ne.fontInfo}}class H extends p{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ne){let pe=o.float(ne,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(pe,6,100)}compute(ne,pe,ie){return ne.fontInfo.fontSize}}class x extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(s.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class M extends T{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:ie,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:ie,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:ie,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:ie,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:ie,description:m.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{multiple:a(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??a(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??a(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??a(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??a(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??a(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends T{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:m.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),delay:s.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:v(pe.sticky,this.defaultValue.sticky),above:v(pe.above,this.defaultValue.above)}}}var z;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class O extends h{constructor(){super(130)}compute(ne,pe,ie){return O.computeLayout(pe,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const pe=ne.height/ne.lineHeight,ie=ne.scrollBeyondLastLine?pe-1:0,_e=(ne.viewLineCount+ie)/(ne.pixelRatio*ne.height),Fe=Math.floor(ne.viewLineCount/_e);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:ie,desiredRatio:_e,minimapLineCount:Fe}}static _computeMinimapLayout(ne,pe){const ie=ne.outerWidth,_e=ne.outerHeight,Fe=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const Ue=pe.stableMinimapLayoutInput,Xe=Ue&&ne.outerHeight===Ue.outerHeight&&ne.lineHeight===Ue.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ue.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ue.pixelRatio&&ne.scrollBeyondLastLine===Ue.scrollBeyondLastLine&&ne.minimap.enabled===Ue.minimap.enabled&&ne.minimap.side===Ue.minimap.side&&ne.minimap.size===Ue.minimap.size&&ne.minimap.showSlider===Ue.minimap.showSlider&&ne.minimap.renderCharacters===Ue.minimap.renderCharacters&&ne.minimap.maxColumn===Ue.minimap.maxColumn&&ne.minimap.scale===Ue.minimap.scale&&ne.verticalScrollbarWidth===Ue.verticalScrollbarWidth&&ne.isViewportWrapping===Ue.isViewportWrapping,Ae=ne.lineHeight,Pe=ne.typicalHalfwidthCharacterWidth,ye=ne.scrollBeyondLastLine,le=ne.minimap.renderCharacters;let de=Fe>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const be=ne.minimap.maxColumn,Ce=ne.minimap.size,Me=ne.minimap.side,Ke=ne.verticalScrollbarWidth,He=ne.viewLineCount,Qe=ne.remainingWidth,st=ne.isViewportWrapping,at=le?2:3;let he=Math.floor(Fe*_e);const De=he/Fe;let ce=!1,X=!1,ke=at*de,Le=de/Fe,Ze=1;if(Ce==="fill"||Ce==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:_t,desiredRatio:Ot,minimapLineCount:It}=O.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:ye,height:_e,lineHeight:Ae,pixelRatio:Fe});if(He/It>1)ce=!0,X=!0,de=1,ke=1,Le=de/Fe;else{let Lt=!1,St=de+1;if(Ce==="fit"){const Mt=Math.ceil((He+_t)*ke);st&&Xe&&Qe<=pe.stableFitRemainingWidth?(Lt=!0,St=pe.stableFitMaxMinimapScale):Lt=Mt>he}if(Ce==="fill"||Lt){ce=!0;const Mt=de;ke=Math.min(Ae*Fe,Math.max(1,Math.floor(1/Ot))),st&&Xe&&Qe<=pe.stableFitRemainingWidth&&(St=pe.stableFitMaxMinimapScale),de=Math.min(St,Math.max(1,Math.floor(ke/at))),de>Mt&&(Ze=Math.min(2,de/Mt)),Le=de/Fe/Ze,he=Math.ceil(Math.max(vt,He+_t)*ke),st?(pe.stableMinimapLayoutInput=ne,pe.stableFitRemainingWidth=Qe,pe.stableFitMaxMinimapScale=de):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const qe=Math.floor(be*Le),dt=Math.min(qe,Math.max(0,Math.floor((Qe-Ke-2)*Le/(Pe+Le)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Fe*dt);const yt=wt/Fe;wt=Math.floor(wt*Ze);const bt=le?1:2,ft=Me==="left"?0:ie-dt-Ke;return{renderMinimap:bt,minimapLeft:ft,minimapWidth:dt,minimapHeightIsEditorHeight:ce,minimapIsSampling:X,minimapScale:de,minimapLineHeight:ke,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:he,minimapCanvasOuterWidth:yt,minimapCanvasOuterHeight:De}}static computeLayout(ne,pe){const ie=pe.outerWidth|0,_e=pe.outerHeight|0,Fe=pe.lineHeight|0,Ue=pe.lineNumbersDigitCount|0,Xe=pe.typicalHalfwidthCharacterWidth,Ae=pe.maxDigitWidth,Pe=pe.pixelRatio,ye=pe.viewLineCount,le=ne.get(122),de=le==="inherit"?ne.get(121):le,be=de==="inherit"?ne.get(117):de,Ce=ne.get(120),Me=ne.get(2),Ke=pe.isDominatedByLongLines,He=ne.get(49),Qe=ne.get(59).renderType!==0,st=ne.get(60),at=ne.get(93),he=ne.get(64),De=ne.get(91),ce=De.verticalScrollbarSize,X=De.verticalHasArrows,ke=De.arrowSize,Le=De.horizontalScrollbarSize,Ze=ne.get(57),qe=ne.get(37);let dt;if(typeof Ze=="string"&&/^\d+(\.\d+)?ch$/.test(Ze)){const Wt=parseFloat(Ze.substr(0,Ze.length-2));dt=s.clampedInt(Wt*Xe,0,0,1e3)}else dt=s.clampedInt(Ze,0,0,1e3);qe&&(dt+=16);let wt=0;if(Qe){const Wt=Math.max(Ue,st);wt=Math.round(Wt*Ae)}let yt=0;He&&(yt=Fe);let bt=0,ft=bt+yt,vt=ft+wt,_t=vt+dt;const Ot=ie-yt-wt-dt;let It=!1,Tt=!1,Lt=-1;Me!==2&&(de==="inherit"&&Ke?(It=!0,Tt=!0):be==="on"||be==="bounded"?Tt=!0:be==="wordWrapColumn"&&(Lt=Ce));const St=O._computeMinimapLayout({outerWidth:ie,outerHeight:_e,lineHeight:Fe,typicalHalfwidthCharacterWidth:Xe,pixelRatio:Pe,scrollBeyondLastLine:at,minimap:he,verticalScrollbarWidth:ce,viewLineCount:ye,remainingWidth:Ot,isViewportWrapping:Tt},pe.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(bt+=St.minimapWidth,ft+=St.minimapWidth,vt+=St.minimapWidth,_t+=St.minimapWidth);const Mt=Ot-St.minimapWidth,Nt=Math.max(1,Math.floor((Mt-ce-2)/Xe)),Et=X?ke:0;return Tt&&(Lt=Math.max(1,Nt),be==="bounded"&&(Lt=Math.min(Lt,Ce))),{width:ie,height:_e,glyphMarginLeft:bt,glyphMarginWidth:yt,lineNumbersLeft:ft,lineNumbersWidth:wt,decorationsLeft:vt,decorationsWidth:dt,contentLeft:_t,contentWidth:Mt,minimap:St,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Tt,wrappingColumn:Lt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:Le,overviewRuler:{top:Et,width:ce,height:_e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=O;class V extends T{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:m.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class K extends T{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class G extends o{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>o.clamp(ne,0,150),{markdownDescription:m.localize(47,null)})}compute(ne,pe,ie){return ne.fontInfo.lineHeight}}class Q extends T{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ne.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:m.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),size:a(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(pe.side,this.defaultValue.side,["right","left"]),showSlider:a(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(pe.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(pe.scale,1,1,3),maxColumn:s.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(ee){return ee==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{top:s.clampedInt(pe.top,0,0,1e3),bottom:s.clampedInt(pe.bottom,0,0,1e3)}}}class me extends T{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:m.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),cycle:v(pe.cycle,this.defaultValue.cycle)}}}class Se extends h{constructor(){super(128)}compute(ne,pe,ie){return ne.pixelRatio}}class Ie extends T{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:m.localize(63,null)},other:{type:"boolean",default:ne.other,description:m.localize(64,null)}}}],default:ne,description:m.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const pe=ne,ie={other:v(pe.other,this.defaultValue.other),comments:v(pe.comments,this.defaultValue.comments),strings:v(pe.strings,this.defaultValue.strings)};return ie.other&&ie.comments&&ie.strings?!0:!ie.other&&!ie.comments&&!ie.strings?!1:ie}return this.defaultValue}}var Oe;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Oe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ne){let pe=this.defaultValue.renderType,ie=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(pe=4,ie=ne):ne==="interval"?pe=3:ne==="relative"?pe=2:ne==="on"?pe=1:pe=0),{renderType:pe,renderFn:ie}}}function j(ee){const ne=ee.get(86);return ne==="editable"?ee.get(80):ne!=="on"}e.filterValidationDecorations=j;class Z extends T{constructor(){const ne=[],pe={type:"number",description:m.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ne,description:m.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let pe=[];for(let ie of ne)if(typeof ie=="number")pe.push({column:s.clampedInt(ie,0,0,1e4),color:null});else if(ie&&typeof ie=="object"){const _e=ie;pe.push({column:s.clampedInt(_e.column,0,0,1e4),color:_e.color})}return pe.sort((ie,_e)=>ie.column-_e.column),pe}return this.defaultValue}}function re(ee,ne){if(typeof ee!="string")return ne;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends T{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:m.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne,ie=s.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=s.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(pe.vertical,this.defaultValue.vertical),horizontal:re(pe.horizontal,this.defaultValue.horizontal),useShadows:v(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ie,horizontalSliderSize:s.clampedInt(pe.horizontalSliderSize,ie,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:s.clampedInt(pe.verticalSliderSize,_e,0,1e3),scrollByPage:v(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings"};class te extends T{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{}};super(112,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeStrings,description:m.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:m.localize(90,null),additionalProperties:{type:"boolean"}}})}applyUpdate(ne,pe){let ie=!1;pe.allowedCharacters&&(P.equals(ne.allowedCharacters,pe.allowedCharacters)||(ne={...ne,allowedCharacters:pe.allowedCharacters},ie=!0));const _e=super.applyUpdate(ne,pe);return ie?new l(_e.newValue,!0):_e}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{nonBasicASCII:Ve(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ve(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ve(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(ne.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(ne,pe){if(typeof ne!="object"||!ne)return pe;const ie={};for(const[_e,Fe]of Object.entries(ne))Fe===!0&&(ie[_e]=!0);return ie}}class oe extends T{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:m.localize(91,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),mode:a(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Ee extends T{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:m.localize(92,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class Ne extends T{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:ne.bracketPairs,description:m.localize(96,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:ne.bracketPairsHorizontal,description:m.localize(100,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:m.localize(101,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:m.localize(102,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:m.localize(103,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{bracketPairs:Ve(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ve(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ve(ee,ne,pe){const ie=pe.indexOf(ee);return ie===-1?ne:pe[ie]}class Ge extends T{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(104,null),m.localize(105,null)],default:ne.insertMode,description:m.localize(106,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:m.localize(107,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:m.localize(108,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:m.localize(109,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:m.localize(110,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:m.localize(111,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:m.localize(112,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:m.localize(113,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:m.localize(114,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(115,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(116,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(145,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{insertMode:a(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(pe.showIcons,this.defaultValue.showIcons),showStatusBar:v(pe.showStatusBar,this.defaultValue.showStatusBar),preview:v(pe.preview,this.defaultValue.preview),previewMode:a(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(pe.showMethods,this.defaultValue.showMethods),showFunctions:v(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:v(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:v(pe.showFields,this.defaultValue.showFields),showVariables:v(pe.showVariables,this.defaultValue.showVariables),showClasses:v(pe.showClasses,this.defaultValue.showClasses),showStructs:v(pe.showStructs,this.defaultValue.showStructs),showInterfaces:v(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:v(pe.showModules,this.defaultValue.showModules),showProperties:v(pe.showProperties,this.defaultValue.showProperties),showEvents:v(pe.showEvents,this.defaultValue.showEvents),showOperators:v(pe.showOperators,this.defaultValue.showOperators),showUnits:v(pe.showUnits,this.defaultValue.showUnits),showValues:v(pe.showValues,this.defaultValue.showValues),showConstants:v(pe.showConstants,this.defaultValue.showConstants),showEnums:v(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:v(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(pe.showKeywords,this.defaultValue.showKeywords),showWords:v(pe.showWords,this.defaultValue.showWords),showColors:v(pe.showColors,this.defaultValue.showColors),showFiles:v(pe.showFiles,this.defaultValue.showFiles),showReferences:v(pe.showReferences,this.defaultValue.showReferences),showFolders:v(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:v(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(pe.showSnippets,this.defaultValue.showSnippets),showUsers:v(pe.showUsers,this.defaultValue.showUsers),showIssues:v(pe.showIssues,this.defaultValue.showIssues)}}}class Je extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(146,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class tt extends h{constructor(){super(129)}compute(ne,pe,ie){return pe.get(80)?!0:ne.tabFocusMode}}var ot;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(ot=e.WrappingIndent||(e.WrappingIndent={}));function et(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class it extends h{constructor(){super(131)}compute(ne,pe,ie){const _e=pe.get(130);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}const ct="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?pt:i.isLinux?Pt:ct,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function xe(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Rt;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:xe(new A(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(147,null)})),acceptSuggestionOnEnter:xe(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(148,null),""],markdownDescription:m.localize(149,null)})),accessibilitySupport:xe(new r),accessibilityPageSize:xe(new s(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(150,null)})),ariaLabel:xe(new g(4,"ariaLabel",m.localize(151,null))),autoClosingBrackets:xe(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(152,null),m.localize(153,null),""],description:m.localize(154,null)})),autoClosingDelete:xe(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(155,null),""],description:m.localize(156,null)})),autoClosingOvertype:xe(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(157,null),""],description:m.localize(158,null)})),autoClosingQuotes:xe(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(159,null),m.localize(160,null),""],description:m.localize(161,null)})),autoIndent:xe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null),m.localize(166,null)],description:m.localize(167,null)})),automaticLayout:xe(new A(10,"automaticLayout",!1)),autoSurround:xe(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(168,null),m.localize(169,null),m.localize(170,null),""],description:m.localize(171,null)})),bracketPairColorization:xe(new Ee),bracketPairGuides:xe(new Ne),stickyTabStops:xe(new A(103,"stickyTabStops",!1,{description:m.localize(172,null)})),codeLens:xe(new A(14,"codeLens",!0,{description:m.localize(173,null)})),codeLensFontFamily:xe(new g(15,"codeLensFontFamily","",{description:m.localize(174,null)})),codeLensFontSize:xe(new s(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(175,null)})),colorDecorators:xe(new A(17,"colorDecorators",!0,{description:m.localize(176,null)})),columnSelection:xe(new A(18,"columnSelection",!1,{description:m.localize(177,null)})),comments:xe(new u),contextmenu:xe(new A(20,"contextmenu",!0)),copyWithSyntaxHighlighting:xe(new A(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(178,null)})),cursorBlinking:xe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(179,null)})),cursorSmoothCaretAnimation:xe(new A(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(180,null)})),cursorStyle:xe(new n(24,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:m.localize(181,null)})),cursorSurroundingLines:xe(new s(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(182,null)})),cursorSurroundingLinesStyle:xe(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(183,null),m.localize(184,null)],description:m.localize(185,null)})),cursorWidth:xe(new s(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(186,null)})),disableLayerHinting:xe(new A(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:xe(new A(29,"disableMonospaceOptimizations",!1)),domReadOnly:xe(new A(30,"domReadOnly",!1)),dragAndDrop:xe(new A(31,"dragAndDrop",!0,{description:m.localize(187,null)})),emptySelectionClipboard:xe(new N),extraEditorClassName:xe(new g(33,"extraEditorClassName","")),fastScrollSensitivity:xe(new o(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(188,null)})),find:xe(new B),fixedOverflowWidgets:xe(new A(36,"fixedOverflowWidgets",!1)),folding:xe(new A(37,"folding",!0,{description:m.localize(189,null)})),foldingStrategy:xe(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(190,null),m.localize(191,null)],description:m.localize(192,null)})),foldingHighlight:xe(new A(39,"foldingHighlight",!0,{description:m.localize(193,null)})),foldingImportsByDefault:xe(new A(40,"foldingImportsByDefault",!1,{description:m.localize(194,null)})),unfoldOnClickAfterEndOfLine:xe(new A(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(195,null)})),fontFamily:xe(new g(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(196,null)})),fontInfo:xe(new U),fontLigatures2:xe(new F),fontSize:xe(new H),fontWeight:xe(new x),formatOnPaste:xe(new A(47,"formatOnPaste",!1,{description:m.localize(197,null)})),formatOnType:xe(new A(48,"formatOnType",!1,{description:m.localize(198,null)})),glyphMargin:xe(new A(49,"glyphMargin",!0,{description:m.localize(199,null)})),gotoLocation:xe(new M),hideCursorInOverviewRuler:xe(new A(51,"hideCursorInOverviewRuler",!1,{description:m.localize(200,null)})),hover:xe(new W),inDiffEditor:xe(new A(53,"inDiffEditor",!1)),letterSpacing:xe(new o(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>o.clamp(ee,-5,20),{description:m.localize(201,null)})),lightbulb:xe(new V),lineDecorationsWidth:xe(new p(57,"lineDecorationsWidth",10)),lineHeight:xe(new G),lineNumbers:xe(new We),lineNumbersMinChars:xe(new s(60,"lineNumbersMinChars",5,1,300)),linkedEditing:xe(new A(61,"linkedEditing",!1,{description:m.localize(202,null)})),links:xe(new A(62,"links",!0,{description:m.localize(203,null)})),matchBrackets:xe(new S(63,"matchBrackets","always",["always","near","never"],{description:m.localize(204,null)})),minimap:xe(new Q),mouseStyle:xe(new S(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:xe(new o(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(205,null)})),mouseWheelZoom:xe(new A(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(206,null)})),multiCursorMergeOverlapping:xe(new A(68,"multiCursorMergeOverlapping",!0,{description:m.localize(207,null)})),multiCursorModifier:xe(new n(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[m.localize(208,null),m.localize(209,null)],markdownDescription:m.localize(210,null)})),multiCursorPaste:xe(new S(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(211,null),m.localize(212,null)],markdownDescription:m.localize(213,null)})),occurrencesHighlight:xe(new A(71,"occurrencesHighlight",!0,{description:m.localize(214,null)})),overviewRulerBorder:xe(new A(72,"overviewRulerBorder",!0,{description:m.localize(215,null)})),overviewRulerLanes:xe(new s(73,"overviewRulerLanes",3,0,3)),padding:xe(new fe),parameterHints:xe(new me),peekWidgetDefaultFocus:xe(new S(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(216,null),m.localize(217,null)],description:m.localize(218,null)})),definitionLinkOpensInPeek:xe(new A(77,"definitionLinkOpensInPeek",!1,{description:m.localize(219,null)})),quickSuggestions:xe(new Ie),quickSuggestionsDelay:xe(new s(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(220,null)})),readOnly:xe(new A(80,"readOnly",!1)),renameOnType:xe(new A(81,"renameOnType",!1,{description:m.localize(221,null),markdownDeprecationMessage:m.localize(222,null)})),renderControlCharacters:xe(new A(82,"renderControlCharacters",!0,{description:m.localize(223,null),restricted:!0})),renderFinalNewline:xe(new A(83,"renderFinalNewline",!0,{description:m.localize(224,null)})),renderLineHighlight:xe(new S(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(225,null)],description:m.localize(226,null)})),renderLineHighlightOnlyWhenFocus:xe(new A(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(227,null)})),renderValidationDecorations:xe(new S(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:xe(new S(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(228,null),m.localize(229,null),m.localize(230,null),""],description:m.localize(231,null)})),revealHorizontalRightPadding:xe(new s(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:xe(new A(89,"roundedSelection",!0,{description:m.localize(232,null)})),rulers:xe(new Z),scrollbar:xe(new ue),scrollBeyondLastColumn:xe(new s(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(233,null)})),scrollBeyondLastLine:xe(new A(93,"scrollBeyondLastLine",!0,{description:m.localize(234,null)})),scrollPredominantAxis:xe(new A(94,"scrollPredominantAxis",!0,{description:m.localize(235,null)})),selectionClipboard:xe(new A(95,"selectionClipboard",!0,{description:m.localize(236,null),included:i.isLinux})),selectionHighlight:xe(new A(96,"selectionHighlight",!0,{description:m.localize(237,null)})),selectOnLineNumbers:xe(new A(97,"selectOnLineNumbers",!0)),showFoldingControls:xe(new S(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(238,null),m.localize(239,null)],description:m.localize(240,null)})),showUnused:xe(new A(99,"showUnused",!0,{description:m.localize(241,null)})),showDeprecated:xe(new A(125,"showDeprecated",!0,{description:m.localize(242,null)})),inlayHints:xe(new K),snippetSuggestions:xe(new S(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),smartSelect:xe(new Je),smoothScrolling:xe(new A(102,"smoothScrolling",!1,{description:m.localize(248,null)})),stopRenderingLineAfter:xe(new s(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:xe(new Ge),inlineSuggest:xe(new oe),suggestFontSize:xe(new s(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestLineHeight:xe(new s(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(250,null)})),suggestOnTriggerCharacters:xe(new A(108,"suggestOnTriggerCharacters",!0,{description:m.localize(251,null)})),suggestSelection:xe(new S(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(252,null),m.localize(253,null),m.localize(254,null)],description:m.localize(255,null)})),tabCompletion:xe(new S(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),tabIndex:xe(new s(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:xe(new te),unusualLineTerminators:xe(new S(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(260,null),m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),useShadowDOM:xe(new A(114,"useShadowDOM",!0)),useTabStops:xe(new A(115,"useTabStops",!0,{description:m.localize(264,null)})),wordSeparators:xe(new g(116,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:m.localize(265,null)})),wordWrap:xe(new S(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(266,null),m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),wordWrapBreakAfterCharacters:xe(new g(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:xe(new g(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:xe(new s(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(271,null)})),wordWrapOverride1:xe(new S(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:xe(new S(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:xe(new n(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],et,{enumDescriptions:[m.localize(272,null),m.localize(273,null),m.localize(274,null),m.localize(275,null)],description:m.localize(276,null)})),wrappingStrategy:xe(new S(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(277,null),m.localize(278,null)],description:m.localize(279,null)})),editorClassName:xe(new R),pixelRatio:xe(new Se),tabFocusMode:xe(new tt),layoutInfo:xe(new O),wrappingInfo:xe(new it)}}),define(ve[155],we([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[156],we([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[157],we([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[158],we([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[159],we([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[160],we([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[161],we([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[162],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[163],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[164],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[165],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[166],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[167],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[168],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[169],we([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[170],we([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[171],we([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ve[172],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[173],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[174],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[175],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[176],we([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[177],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var i;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var y;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[178],we([0,1,157]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||i.test(l)}e.isValidVersionStr=C;function P(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=l.match(i);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=P;function D(l){if(!l)return null;let E=l.majorBase,h=l.majorMustEqual,p=l.minorBase,v=l.minorMustEqual,A=l.patchBase,w=l.patchMustEqual;l.hasCaret&&(E===0||(v=!1),w=!1);let s=0;if(l.preRelease){const o=y.exec(l.preRelease);if(o){const[,g,a,S]=o;s=Date.UTC(Number(g),Number(a)-1,Number(S))}}return{majorBase:E,majorMustEqual:h,minorBase:p,minorMustEqual:v,patchBase:A,patchMustEqual:w,isMinimum:l.hasGreaterEquals,notBefore:s}}e.normalizeVersion=D;function _(l,E,h){let p;typeof l=="string"?p=D(P(l)):p=l;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let A;if(typeof h=="string"?A=D(P(h)):A=h,!p||!A)return!1;let w=p.majorBase,s=p.minorBase,o=p.patchBase,g=A.majorBase,a=A.minorBase,S=A.patchBase,n=A.notBefore,t=A.majorMustEqual,r=A.minorMustEqual,u=A.patchMustEqual;return A.isMinimum?w>g?!0:w<g?!1:s>a?!0:s<a||v&&v<n?!1:o>=S:(w===1&&g===0&&(!t||!r||!u)&&(g=1,a=0,S=0,t=!0,r=!1,u=!1),w<g?!1:w>g?!t:s<a?!1:s>a?!r:o<S?!1:o>S?!u:!(v&&v<n))}e.isValidVersion=_;function I(l,E,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:T(l,E,h.engines.vscode,p)}e.isValidExtensionVersion=I;function L(l,E,h){return l==="*"||T(E,h,l)}e.isEngineValid=L;function T(l,E,h,p=[]){let v=D(P(h));if(!v)return p.push(m.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return p.push(m.localize(1,null,h)),!1}else if(!v.majorMustEqual)return p.push(m.localize(2,null,h)),!1;return _(l,E,v)?!0:(p.push(m.localize(3,null,l,h)),!1)}}),define(ve[114],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(y,C=[],P=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=m}),define(ve[83],we([0,1,114]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function y(P,D,_){D instanceof m.SyncDescriptor||(D=new m.SyncDescriptor(D,[],_)),i.push([P,D])}e.registerSingleton=y;function C(){return i}e.getSingletonServiceDescriptors=C}),define(ve[179],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class i{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let P of this._nodes.values())P.outgoing.size===0&&C.push(P);return C}insertEdge(C,P){const D=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(P);D.outgoing.set(this._hashFn(P),_),_.incoming.set(this._hashFn(C),D)}removeNode(C){const P=this._hashFn(C);this._nodes.delete(P);for(let D of this._nodes.values())D.outgoing.delete(P),D.incoming.delete(P)}lookupOrInsertNode(C){const P=this._hashFn(C);let D=this._nodes.get(P);return D||(D=new m(C),this._nodes.set(P,D)),D}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[P,D]of this._nodes)C.push(`${P}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,P]of this._nodes){const D=new Set([C]),_=this._findCycle(P,D);if(_)return _}}_findCycle(C,P){for(let[D,_]of C.outgoing){if(P.has(D))return[...P,D].join(" -> ");P.add(D);const I=this._findCycle(_,P);if(I)return I;P.delete(D)}}}e.Graph=i}),define(ve[4],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(_){return _[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(m=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function i(P,D,_,I){D[m.DI_TARGET]===D?D[m.DI_DEPENDENCIES].push({id:P,index:_,optional:I}):(D[m.DI_DEPENDENCIES]=[{id:P,index:_,optional:I}],D[m.DI_TARGET]=D)}function y(P){if(m.serviceIds.has(P))return m.serviceIds.get(P);const D=function(_,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,_,L,!1)};return D.toString=()=>P,m.serviceIds.set(P,D),D}e.createDecorator=y;function C(P){return P}e.refineServiceDecorator=C}),define(ve[180],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function i(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=i}),define(ve[181],we([0,1,3,47,6,24,78,82,180]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(I):!!p.exclusive}class L{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(v,A){let w={selector:v,provider:A,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(w){let s=this._entries.indexOf(w);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const A=[];for(let w of this._entries)w._score>0&&A.push(w.provider);return A}ordered(v){const A=[];return this._orderedForEach(v,w=>A.push(w.provider)),A}orderedGroups(v){const A=[];let w,s;return this._orderedForEach(v,o=>{w&&s===o._score?w.push(o.provider):(s=o._score,w=[o.provider],A.push(w))}),A}_orderedForEach(v,A){if(!!v){this._updateScores(v);for(const w of this._entries)w._score>0&&A(w)}}_updateScores(v){let A={uri:v.uri.toString(),language:v.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let w of this._entries)if(w._score=(0,D.score)(w.selector,v.uri,v.getLanguageId(),(0,_.shouldSynchronizeModel)(v)),I(w.selector)&&w._score>0){for(let s of this._entries)s._score=0;w._score=1e3;break}this._entries.sort(L._compareByScoreAndTime)}}static _compareByScoreAndTime(v,A){return v._score<A._score?1:v._score>A._score?-1:v._time<A._time?1:v._time>A._time?-1:0}}e.LanguageFeatureRegistry=L;const T=new WeakMap;let l=0;function E(p){let v=T.get(p);return v===void 0&&(v=++l,T.set(p,v)),v}class h{constructor(v,A,w=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=A,this.max=w,this._cache=new C.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((A,w)=>(0,i.doHash)(E(w),A),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const A=this._key(v),w=this._cache.get(A);return this._clamp(w?.value)}update(v,A){const w=this._key(v);let s=this._cache.get(w);return s||(s=new P.MovingAverage,this._cache.set(w,s)),s.update(A),this.get(v)}}e.LanguageFeatureRequestDelays=h}),define(ve[84],we([0,1,2,41,181,148,73]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var D;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));var _;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(_=e.FontStyle||(e.FontStyle={}));var I;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(I=e.ColorId||(e.ColorId={}));var L;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var T;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(T=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let R=this.getForeground(k),N="mtk"+R,B=this.getFontStyle(k);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(k,R){const N=this.getForeground(k),B=this.getFontStyle(k);let F=`color: ${R[N]};`;return B&1&&(F+="font-style: italic;"),B&2&&(F+="font-weight: bold;"),B&4&&(F+="text-decoration: underline;"),F}}e.TokenMetadata=l;var E;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var h;(function(d){const k=new Map;k.set(0,P.Codicon.symbolMethod),k.set(1,P.Codicon.symbolFunction),k.set(2,P.Codicon.symbolConstructor),k.set(3,P.Codicon.symbolField),k.set(4,P.Codicon.symbolVariable),k.set(5,P.Codicon.symbolClass),k.set(6,P.Codicon.symbolStruct),k.set(7,P.Codicon.symbolInterface),k.set(8,P.Codicon.symbolModule),k.set(9,P.Codicon.symbolProperty),k.set(10,P.Codicon.symbolEvent),k.set(11,P.Codicon.symbolOperator),k.set(12,P.Codicon.symbolUnit),k.set(13,P.Codicon.symbolValue),k.set(15,P.Codicon.symbolEnum),k.set(14,P.Codicon.symbolConstant),k.set(15,P.Codicon.symbolEnum),k.set(16,P.Codicon.symbolEnumMember),k.set(17,P.Codicon.symbolKeyword),k.set(27,P.Codicon.symbolSnippet),k.set(18,P.Codicon.symbolText),k.set(19,P.Codicon.symbolColor),k.set(20,P.Codicon.symbolFile),k.set(21,P.Codicon.symbolReference),k.set(22,P.Codicon.symbolCustomColor),k.set(23,P.Codicon.symbolFolder),k.set(24,P.Codicon.symbolTypeParameter),k.set(25,P.Codicon.account),k.set(26,P.Codicon.issues);function R(F){let U=k.get(F);return U||(console.info("No codicon found for CompletionItemKind "+F),U=P.Codicon.symbolProperty),U}d.toIcon=R;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(F,U){let H=N.get(F);return typeof H=="undefined"&&!U&&(H=9),H}d.fromString=B})(h=e.CompletionItemKinds||(e.CompletionItemKinds={}));var p;(function(d){d[d.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var A;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(d){return d&&m.URI.isUri(d.uri)&&i.Range.isIRange(d.range)&&(i.Range.isIRange(d.originSelectionRange)||i.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=a;var S;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var n;(function(d){d[d.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var t;(function(d){const k=new Map;k.set(0,P.Codicon.symbolFile),k.set(1,P.Codicon.symbolModule),k.set(2,P.Codicon.symbolNamespace),k.set(3,P.Codicon.symbolPackage),k.set(4,P.Codicon.symbolClass),k.set(5,P.Codicon.symbolMethod),k.set(6,P.Codicon.symbolProperty),k.set(7,P.Codicon.symbolField),k.set(8,P.Codicon.symbolConstructor),k.set(9,P.Codicon.symbolEnum),k.set(10,P.Codicon.symbolInterface),k.set(11,P.Codicon.symbolFunction),k.set(12,P.Codicon.symbolVariable),k.set(13,P.Codicon.symbolConstant),k.set(14,P.Codicon.symbolString),k.set(15,P.Codicon.symbolNumber),k.set(16,P.Codicon.symbolBoolean),k.set(17,P.Codicon.symbolArray),k.set(18,P.Codicon.symbolObject),k.set(19,P.Codicon.symbolKey),k.set(20,P.Codicon.symbolNull),k.set(21,P.Codicon.symbolEnumMember),k.set(22,P.Codicon.symbolStruct),k.set(23,P.Codicon.symbolEvent),k.set(24,P.Codicon.symbolOperator),k.set(25,P.Codicon.symbolTypeParameter);function R(N){let B=k.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=P.Codicon.symbolProperty),B}d.toIcon=R})(t=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(k){this.value=k}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var u;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var f;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var b;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[115],we([0,1,13,2,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationOverrides=C;function P(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||m.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=P;var D;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=_;function I(v,A){const w=Object.create(null);for(let s in v)L(w,s,v[s],A);return w}e.toValuesTree=I;function L(v,A,w,s){const o=A.split("."),g=o.pop();let a=v;for(let S=0;S<o.length;S++){let n=o[S],t=a[n];switch(typeof t){case"undefined":t=a[n]=Object.create(null);break;case"object":break;default:s(`Ignoring ${A} as ${o.slice(0,S+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[g]=w}catch{s(`Ignoring ${A} as ${o.join(".")} is ${JSON.stringify(a)}`)}else s(`Ignoring ${A} as ${o.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=L;function T(v,A){const w=A.split(".");l(v,w)}e.removeFromValueTree=T;function l(v,A){const w=A.shift();if(A.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const s=v[w];typeof s=="object"&&!Array.isArray(s)&&(l(s,A),Object.keys(s).length===0&&delete v[w])}}function E(v,A,w){function s(a,S){let n=a;for(const t of S){if(typeof n!="object"||n===null)return;n=n[t]}return n}const o=A.split("."),g=s(v,o);return typeof g=="undefined"?w:g}e.getConfigurationValue=E;function h(v,A,w){Object.keys(A).forEach(s=>{s!=="__proto__"&&(s in v?m.isObject(v[s])&&m.isObject(A[s])?h(v[s],A[s],w):w&&(v[s]=A[s]):v[s]=A[s])})}e.merge=h;function p(v,A,w){const s=v.inspect(A),o=v.inspect(w);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:s.defaultValue}e.getMigratedSettingValue=p}),define(ve[61],we([0,1,12,8,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",m.isMacintosh),P.set("isLinux",m.isLinux),P.set("isWindows",m.isWindows),P.set("isWeb",m.isWeb),P.set("isMacNative",m.isMacintosh&&!m.isWeb),P.set("isEdge",C.indexOf("Edg/")>=0),P.set("isFirefox",C.indexOf("Firefox")>=0),P.set("isChrome",C.indexOf("Chrome")>=0),P.set("isSafari",C.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var _;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return l.INSTANCE}static true(){return E.INSTANCE}static has(F){return h.create(F)}static equals(F,U){return p.create(F,U)}static notEquals(F,U){return w.create(F,U)}static regex(F,U){return t.create(F,U)}static in(F,U){return v.create(F,U)}static not(F){return s.create(F)}static and(...F){return c.create(F,null)}static or(...F){return f.create(F,null,!0)}static greater(F,U){return g.create(F,U)}static greaterEquals(F,U){return a.create(F,U)}static smaller(F,U){return S.create(F,U)}static smallerEquals(F,U){return n.create(F,U)}static deserialize(F,U=!1){if(!!F)return this._deserializeOrExpression(F,U)}static _deserializeOrExpression(F,U){let H=F.split("||");return f.create(H.map(x=>this._deserializeAndExpression(x,U)),null,!0)}static _deserializeAndExpression(F,U){let H=F.split("&&");return c.create(H.map(x=>this._deserializeOne(x,U)),null)}static _deserializeOne(F,U){if(F=F.trim(),F.indexOf("!=")>=0){let H=F.split("!=");return w.create(H[0].trim(),this._deserializeValue(H[1],U))}if(F.indexOf("==")>=0){let H=F.split("==");return p.create(H[0].trim(),this._deserializeValue(H[1],U))}if(F.indexOf("=~")>=0){let H=F.split("=~");return t.create(H[0].trim(),this._deserializeRegexValue(H[1],U))}if(F.indexOf(" in ")>=0){let H=F.split(" in ");return v.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const H=F.split(">=");return a.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const H=F.split(">");return g.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const H=F.split("<=");return n.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const H=F.split("<");return S.create(H[0].trim(),H[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,U){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let H=/^'([^']*)'$/.exec(F);return H?H[1].trim():F}static _deserializeRegexValue(F,U){if((0,i.isFalsyOrWhitespace)(F)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let H=F.indexOf("/"),x=F.lastIndexOf("/");if(H===x||H<0){if(U)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let M=F.slice(H+1,x),W=F[x+1]==="i"?"i":"";try{return new RegExp(M,W)}catch(z){if(U)throw new Error(`bad regexp-value '${F}', parse error: ${z}`);return console.warn(`bad regexp-value '${F}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function L(B,F){const U=B?B.substituteConstants():void 0,H=F?F.substituteConstants():void 0;return!U&&!H?!0:!U||!H?!1:U.equals(H)}e.expressionsAreEqualWithConstantSubstitution=L;function T(B,F){return B.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class E{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(F,U){this.key=F,this.negated=U,this.type=2}static create(F,U=null){const H=P.get(F);return typeof H=="boolean"?H?E.INSTANCE:l.INSTANCE:new h(F,U)}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?E.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class p{constructor(F,U,H){this.key=F,this.value=U,this.negated=H,this.type=4}static create(F,U,H=null){if(typeof U=="boolean")return U?h.create(F,H):s.create(F,H);const x=P.get(F);return typeof x=="boolean"?U===(x?"true":"false")?E.INSTANCE:l.INSTANCE:new p(F,U,H)}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const U=F?"true":"false";return this.value===U?E.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class v{constructor(F,U){this.key=F,this.valueKey=U,this.type=10,this.negated=null}static create(F,U){return new v(F,U)}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.valueKey),H=F.getValue(this.key);return Array.isArray(U)?U.indexOf(H)>=0:typeof H=="string"&&typeof U=="object"&&U!==null?D.call(U,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this)),this.negated}}e.ContextKeyInExpr=v;class A{constructor(F){this._actual=F,this.type=11}static create(F){return new A(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new A(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=A;class w{constructor(F,U,H){this.key=F,this.value=U,this.negated=H,this.type=5}static create(F,U,H=null){if(typeof U=="boolean")return U?s.create(F,H):h.create(F,H);const x=P.get(F);return typeof x=="boolean"?U===(x?"true":"false")?l.INSTANCE:E.INSTANCE:new w(F,U,H)}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const U=F?"true":"false";return this.value===U?l.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class s{constructor(F,U){this.key=F,this.negated=U,this.type=3}static create(F,U=null){const H=P.get(F);return typeof H=="boolean"?H?l.INSTANCE:E.INSTANCE:new s(F,U)}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?l.INSTANCE:E.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function o(B,F){if(typeof B=="string"){const U=parseFloat(B);isNaN(U)||(B=U)}return typeof B=="string"||typeof B=="number"?F(B):l.INSTANCE}class g{constructor(F,U,H){this.key=F,this.value=U,this.negated=H,this.type=12}static create(F,U,H=null){return o(U,x=>new g(F,x,H))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class a{constructor(F,U,H){this.key=F,this.value=U,this.negated=H,this.type=13}static create(F,U,H=null){return o(U,x=>new a(F,x,H))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class S{constructor(F,U,H){this.key=F,this.value=U,this.negated=H,this.type=14}static create(F,U,H=null){return o(U,x=>new S(F,x,H))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class n{constructor(F,U,H){this.key=F,this.value=U,this.negated=H,this.type=15}static create(F,U,H=null){return o(U,x=>new n(F,x,H))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,U){this.key=F,this.regexp=U,this.type=7,this.negated=null}static create(F,U){return new t(F,U)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const U=this.regexp?this.regexp.source:"",H=F.regexp?F.regexp.source:"";return U<H?-1:U>H?1:0}equals(F){if(F.type===this.type){const U=this.regexp?this.regexp.source:"",H=F.regexp?F.regexp.source:"";return this.key===F.key&&U===H}return!1}substituteConstants(){return this}evaluate(F){let U=F.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{constructor(F){this._actual=F,this.type=8}static create(F){return new r(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new r(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function u(B){let F=null;for(let U=0,H=B.length;U<H;U++){const x=B[U].substituteConstants();if(B[U]!==x&&F===null){F=[];for(let M=0;M<U;M++)F[M]=B[M]}F!==null&&(F[U]=x)}return F===null?B:F}class c{constructor(F,U){this.expr=F,this.negated=U,this.type=6}static create(F,U){return c._normalizeArr(F,U)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,H=this.expr.length;U<H;U++){const x=T(this.expr[U],F.expr[U]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,H=this.expr.length;U<H;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let U=0,H=this.expr.length;U<H;U++)if(!this.expr[U].evaluate(F))return!1;return!0}static _normalizeArr(F,U){const H=[];let x=!1;for(const M of F)if(!!M){if(M.type===1){x=!0;continue}if(M.type===0)return l.INSTANCE;if(M.type===6){H.push(...M.expr);continue}H.push(M)}if(H.length===0&&x)return E.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(T);for(let M=1;M<H.length;M++)H[M-1].equals(H[M])&&(H.splice(M,1),M--);if(H.length===1)return H[0];for(;H.length>1;){const M=H[H.length-1];if(M.type!==9)break;H.pop();const W=H.pop(),z=H.length===0,O=f.create(M.expr.map(V=>c.create([V,W],null)),null,z);O&&(H.push(O),H.sort(T))}return H.length===1?H[0]:new c(H,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let U of this.expr)F.push(...U.keys());return F}map(F){return new c(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.negated){const F=[];for(let U of this.expr)F.push(U.negate());this.negated=f.create(F,this,!0)}return this.negated}}class f{constructor(F,U){this.expr=F,this.negated=U,this.type=9}static create(F,U,H){return f._normalizeArr(F,U,H)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,H=this.expr.length;U<H;U++){const x=T(this.expr[U],F.expr[U]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,H=this.expr.length;U<H;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:f.create(F,this.negated,!1)}evaluate(F){for(let U=0,H=this.expr.length;U<H;U++)if(this.expr[U].evaluate(F))return!0;return!1}static _normalizeArr(F,U,H){let x=[],M=!1;if(F){for(let W=0,z=F.length;W<z;W++){const O=F[W];if(!!O){if(O.type===0){M=!0;continue}if(O.type===1)return E.INSTANCE;if(O.type===9){x=x.concat(O.expr);continue}x.push(O)}}if(x.length===0&&M)return l.INSTANCE;x.sort(T)}if(x.length!==0){if(x.length===1)return x[0];for(let W=1;W<x.length;W++)x[W-1].equals(x[W])&&(x.splice(W,1),W--);if(x.length===1)return x[0];if(H){for(let W=0;W<x.length;W++)for(let z=W+1;z<x.length;z++)R(x[W],x[z])&&(x.splice(z,1),z--);if(x.length===1)return x[0]}return new f(x,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let U of this.expr)F.push(...U.keys());return F}map(F){return new f(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.negated){let F=[];for(let U of this.expr)F.push(U.negate());for(;F.length>1;){const U=F.shift(),H=F.shift(),x=[];for(const W of N(U))for(const z of N(H))x.push(c.create([W,z],null));const M=F.length===0;F.unshift(f.create(x,null,M))}this.negated=F[0]}return this.negated}}class b extends h{constructor(F,U,H){super(F,null);this._defaultValue=U,typeof H=="object"?b._info.push({...H,key:F}):H!==!0&&b._info.push({key:F,description:H,type:U!=null?typeof U:void 0})}static all(){return b._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return p.create(this.key,F)}notEqualsTo(F){return w.create(this.key,F)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(B,F){return B<F?-1:B>F?1:0}function k(B,F,U,H){return B<U?-1:B>U?1:F<H?-1:F>H?1:0}function R(B,F){if(F.type===6&&B.type!==9&&B.type!==6){for(const x of F.expr)if(B.equals(x))return!0}const U=B.negate(),H=N(U).concat(N(F));H.sort(T);for(let x=0;x<H.length;x++){const W=H[x].negate();for(let z=x+1;z<H.length;z++){const O=H[z];if(W.equals(O))return!0}}return!1}e.implies=R;function N(B){return B.type===9?B.expr:[B]}}),define(ve[182],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[183],we([0,1,10,156,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function P(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function D(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function _(s,o){switch(s){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function I(s,o){return o==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function L(s,o,g){return I(o,g)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===g?!0:T(g).includes(s)}e.isTargetPlatformCompatible=L;function T(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=l;var E;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(s){s.Install="install",s.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var A;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(o,g){super(o);this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(ve[184],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(ve[185],we([0,1,37,10,9,12,94,28,112,158,184]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=I.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends l{openTerminal(o,g){return this.spawnTerminal(m,o,_.getWindowsShell(),g)}spawnTerminal(o,g,a,S){const n=g.windowsExec||E.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const t=y.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return o.spawn(n,S?[S]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return n.indexOf(" ")>=0&&r.push('""'),r.push(n),(t==="wt"||t==="wt.exe")&&r.push("-d ."),new Promise((u,c)=>{const f=v(process),b=o.spawn(a,r,{cwd:S,env:f});b.on("error",c),b.on("exit",()=>u())})}runInTerminal(o,g,a,S,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:E.getDefaultTerminalWindows();return new Promise((r,u)=>{const c=`"${g} - ${T}"`,f=`""${a.join('" "')}" & pause"`,b=["/c","start",c,"/wait",t,"/c",f],d=Object.assign({},v(process),S);Object.keys(d).filter(N=>d[N]===null).forEach(N=>delete d[N]);const k={cwd:g,env:d,windowsVerbatimArguments:!0};m.spawn(E.CMD,b,k).on("error",N=>{u(A(N))}),r(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class h extends l{openTerminal(o,g){return this.spawnTerminal(m,o,g)}runInTerminal(o,g,a,S,n){const t=n.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,u)=>{if(t===L.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const c=t===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",b=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,J).fsPath,"-t",o||T,"-w",g];for(let R of a)b.push("-a"),b.push(R);if(S){const R=Object.assign({},v(process),S);for(let N in R){const B=R[N];B===null?(b.push("-u"),b.push(N)):(b.push("-e"),b.push(`${N}=${B}`))}}let d="";const k=m.spawn(h.OSASCRIPT,b);k.on("error",R=>{u(A(R))}),k.stderr.on("data",R=>{d+=R.toString()}),k.on("exit",R=>{if(R===0)r(void 0);else if(d){const N=d.split(`
`,1);u(new Error(N[0]))}else u(new Error(I.localize(1,null,c,R)))})}else u(new Error(I.localize(2,null,t)))})}spawnTerminal(o,g,a){const S=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const r=["-a",S];a&&r.push(a);const u=v(process),c=o.spawn("/usr/bin/open",r,{cwd:a,env:u});c.on("error",t),c.on("exit",()=>n())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class p extends l{openTerminal(o,g){return this.spawnTerminal(m,o,g)}runInTerminal(o,g,a,S,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,u)=>{let c=[];t.then(f=>{f.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const b=`${w(a)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;c.push(`''${b}''`);const d=Object.assign({},v(process),S);Object.keys(d).filter(B=>d[B]===null).forEach(B=>delete d[B]);const k={cwd:g,env:d};let R="";const N=m.spawn(f,c,k);N.on("error",B=>{u(A(B))}),N.stderr.on("data",B=>{R+=B.toString()}),N.on("exit",B=>{if(B===0)r(void 0);else if(R){const F=R.split(`
`,1);u(new Error(F[0]))}else u(new Error(I.localize(4,null,f,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await D.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{o?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,g,a){const S=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{S.then(r=>{const u=v(process),c=o.spawn(r,[],{cwd:a,env:u});c.on("error",t),c.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=I.localize(3,null);function v(s){const o={...s.env};return(0,P.sanitizeProcessEnvironment)(o),o}function A(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(5,null,s.path)):s}function w(s){let o="";for(let g of s)g.indexOf(" ")>=0?o+='"'+g+'"':o+=g,o+=" ";return o}}),define(ve[42],we([0,1,24,9,8,13,2,159,4]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function I(x){return x.create===!0}e.isFileOpenForWriteOptions=I;var L;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var T;(function(x){x[x.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var l;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=E;function h(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function v(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=v;function A(x){return E(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=A;var w;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class s extends Error{constructor(M,W){super(M);this.code=W}}e.FileSystemProviderError=s;function o(x,M){const W=new s(x.toString(),M);return a(W,M),W}e.createFileSystemProviderError=o;function g(x){return x||o((0,D.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=g;function a(x,M){return x.name=M?`${M} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=a;function S(x){if(!x)return w.Unknown;if(x instanceof s)return x.code;const M=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!M)return w.Unknown;switch(M[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=S;function n(x){if(x instanceof b)return x.fileOperationResult;switch(S(x)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(M,W,z){this.resource=M,this.operation=W,this.target=z}isOperation(M){return this.operation===M}}e.FileOperationEvent=r;var u;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(M,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const z=new Map;for(const O of M){const V=z.get(O.type);V?V.push([O.resource,O]):z.set(O.type,[[O.resource,O]])}for(const[O,V]of z)switch(O){case 1:this.added=m.TernarySearchTree.forUris(()=>W),this.added.fill(V);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>W),this.updated.fill(V);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>W),this.deleted.fill(V);break}}contains(M,...W){return this.doContains(M,{includeChildren:!1},...W)}affects(M,...W){return this.doContains(M,{includeChildren:!0},...W)}doContains(M,W,...z){if(!M)return!1;const O=z.length>0;return!!((!O||z.includes(1))&&(this.added?.get(M)||W.includeChildren&&this.added?.findSuperstr(M))||(!O||z.includes(0))&&(this.updated?.get(M)||W.includeChildren&&this.updated?.findSuperstr(M))||(!O||z.includes(2))&&(this.deleted?.findSubstr(M)||W.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function f(x,M,W){return!x||!M||x===M||M.length>x.length?!1:(M.charAt(M.length-1)!==i.sep&&(M+=i.sep),W?(0,y.startsWithIgnoreCase)(x,M):x.indexOf(M)===0)}e.isParent=f;class b extends Error{constructor(M,W,z){super(M);this.fileOperationResult=W,this.options=z}}e.FileOperationError=b;class d extends b{constructor(M,W,z){super(M,2,z);this.stat=W}}e.NotModifiedSinceFileOperationError=d;var k;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=N;async function B(x,M){if(!M.hasProvider(P.URI.from({scheme:x.scheme})))return new Promise(W=>{const z=M.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===x.scheme&&O.added&&(z.dispose(),W())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(M){return(0,C.isNumber)(M)||(M=0),M<F.KB?(0,D.localize)(1,null,M.toFixed(0)):M<F.MB?(0,D.localize)(2,null,(M/F.KB).toFixed(2)):M<F.GB?(0,D.localize)(3,null,(M/F.MB).toFixed(2)):M<F.TB?(0,D.localize)(4,null,(M/F.GB).toFixed(2)):(0,D.localize)(5,null,(M/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var U;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function H(x){return{maxFileSize:x===0?300*F.MB:16*F.GB,maxHeapSize:x===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=H}),define(ve[85],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...y){this._entries=new Map;for(let[C,P]of y)this.set(C,P)}set(y,C){const P=this._entries.get(y);return this._entries.set(y,C),P}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=m}),define(ve[186],we([0,1,18,15,114,179,4,85]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class L{constructor(h=new D.ServiceCollection,p=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=v,this._services.set(P.IInstantiationService,this)}createChild(h){return new L(h,this._strict,this)}invokeFunction(h,...p){let v=l.traceInvocation(h),A=!1;try{return h({get:s=>{if(A)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(s,v);if(!o)throw new Error(`[invokeFunction] unknown service '${s}'`);return o}},...p)}finally{A=!0,v.stop()}}createInstance(h,...p){let v,A;return h instanceof y.SyncDescriptor?(v=l.traceCreation(h.ctor),A=this._createInstance(h.ctor,h.staticArguments.concat(p),v)):(v=l.traceCreation(h),A=this._createInstance(h,p,v)),v.stop(),A}_createInstance(h,p=[],v){let A=P._util.getServiceDependencies(h).sort((o,g)=>o.index-g.index),w=[];for(const o of A){let g=this._getOrCreateServiceInstance(o.id,v);if(!g&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);w.push(g)}let s=A.length>0?A[0].index:p.length;if(p.length!==s){console.warn(`[createInstance] First service dependency of ${h.name} at position ${s+1} conflicts with ${p.length} static arguments`);let o=s-p.length;o>0?p=p.concat(new Array(o)):p=p.slice(0,s)}return new h(...[...p,...w])}_setServiceInstance(h,p){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,p.branch(h,!0)):(p.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,p,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,v){const A=new C.Graph(o=>o.id.toString());let w=0;const s=[{id:h,desc:p,_trace:v}];for(;s.length;){const o=s.pop();if(A.lookupOrInsertNode(o),w++>1e3)throw new I(A);for(let g of P._util.getServiceDependencies(o.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(g.id);if(!a&&!g.optional&&console.warn(`[createInstance] ${h} depends on ${g.id} which is NOT registered.`),a instanceof y.SyncDescriptor){const S={id:g.id,desc:a,_trace:o._trace.branch(g.id,!0)};A.insertEdge(o,S),s.push(S)}}}for(;;){const o=A.roots();if(o.length===0){if(!A.isEmpty())throw new I(A);break}for(const{data:g}of o){if(this._getServiceInstanceOrDescriptor(g.id)instanceof y.SyncDescriptor){const S=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,S)}A.removeNode(g)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,v=[],A,w){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(p,v,A,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,v,A,w);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],v,A){if(v){const w=new m.IdleValue(()=>this._createInstance(h,p,A));return new Proxy(Object.create(null),{get(s,o){if(o in s)return s[o];let g=w.value,a=g[o];return typeof a!="function"||(a=a.bind(g),s[o]=a),a},set(s,o,g){return w.value[o]=g,!0}})}else return this._createInstance(h,p,A)}}e.InstantiationService=L;var T;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(T||(T={}));class l{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return _?new l(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(h){return _?new l(0,h.name):l._None}branch(h,p){let v=new l(2,h.toString());return this._dep.push([h,p,v]),v}stop(){let h=Date.now()-this._start;l._totals+=h;let p=!1;function v(w,s){let o=[],g=new Array(w+1).join("	");for(const[a,S,n]of s._dep)if(S&&n){p=!0,o.push(`${g}CREATES -> ${a}`);let t=v(w+1,n);t&&o.push(t)}else o.push(`${g}uses -> ${a}`);return o.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(A.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ve[11],we([0,1,50,3,6,12,4]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function D(){return new Date().toISOString()}var _;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function I(S,n,t){switch(n){case _.Trace:S.trace(t);break;case _.Debug:S.debug(t);break;case _.Info:S.info(t);break;case _.Warning:S.warn(t);break;case _.Error:S.error(t);break;case _.Critical:S.critical(t);break;default:throw new Error("Invalid log level")}}e.log=I;function L(S){let n="";for(let t=0;t<S.length;t++){let r=S[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(t>0?" ":"")+r}return n}e.format=L;class T extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class l extends T{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(_.Trace)&&this.log(_.Trace,L([n,...t]))}debug(n,...t){this.checkLogLevel(_.Debug)&&this.log(_.Debug,L([n,...t]))}info(n,...t){this.checkLogLevel(_.Info)&&this.log(_.Info,L([n,...t]))}warn(n,...t){this.checkLogLevel(_.Warning)&&this.log(_.Warning,L([n,...t]))}error(n,...t){if(this.checkLogLevel(_.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(_.Error,L(r))}else this.log(_.Error,L([n,...t]))}critical(n,...t){this.checkLogLevel(_.Critical)&&this.log(_.Critical,L([n,...t]))}flush(){}}e.AbstractMessageLogger=l;class E extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}debug(n,...t){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}info(n,...t){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}warn(n,...t){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,n,...t):console.warn(`[main ${D()}]`,n,...t))}error(n,...t){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,n,...t):console.error(`[main ${D()}]`,n,...t))}critical(n,...t){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,n,...t):console.error(`[main ${D()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class h extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends T{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,m.toErrorMessage)(n,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class v extends T{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const r of this.logServices)r.trace(n,...t)}debug(n,...t){for(const r of this.logServices)r.debug(n,...t)}info(n,...t){for(const r of this.logServices)r.info(n,...t)}warn(n,...t){for(const r of this.logServices)r.warn(n,...t)}error(n,...t){for(const r of this.logServices)r.error(n,...t)}critical(n,...t){for(const r of this.logServices)r.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class A extends y.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=A;class w extends y.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,t?.always?_.Trace:this.logLevel,t),this.loggers.set(n.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class s{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return _.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=s;function o(S){if(S.verbose)return _.Trace;if(typeof S.logLevel=="string"){const n=g(S.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function g(S){switch(S){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=g;function a(S){switch(S){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=a}),define(ve[187],we([0,1,42,11]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(D,_,I,L,T){try{const l=await new Promise((h,p)=>{J(["spdlog"],h,p)});l.setFlushOn(i.LogLevel.Trace);const E=await l.createAsyncRotatingLogger(D,_,I,L);return T&&E.clearFormatters(),E}catch(l){console.error(l)}return null}function C(D,_,I){switch(_){case i.LogLevel.Trace:D.trace(I);break;case i.LogLevel.Debug:D.debug(I);break;case i.LogLevel.Info:D.info(I);break;case i.LogLevel.Warning:D.warn(I);break;case i.LogLevel.Error:D.error(I);break;case i.LogLevel.Critical:D.critical(I);break;default:throw new Error("Invalid log level")}}class P extends i.AbstractMessageLogger{constructor(_,I,L,T,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(_,I,L,T),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(_,I,L,T){const l=L?6:1,E=30/l*m.ByteSize.MB,h=await y(_,I,E,l,T);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:p,message:v}of this.buffer)C(this._logger,p,v);this.buffer=[]}}log(_,I){this._logger?C(this._logger,_,I):this.getLevel()<=_&&this.buffer.push({level:_,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ve[116],we([0,1,48,160,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var P;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(h,p){return p-h}_.compare=I;const L=Object.create(null);L[_.Error]=(0,i.localize)(0,null),L[_.Warning]=(0,i.localize)(1,null),L[_.Info]=(0,i.localize)(2,null);function T(h){return L[h]||""}_.toString=T;function l(h){switch(h){case m.default.Error:return _.Error;case m.default.Warning:return _.Warning;case m.default.Info:return _.Info;case m.default.Ignore:return _.Hint}}_.fromSeverity=l;function E(h){switch(h){case _.Error:return m.default.Error;case _.Warning:return m.default.Warning;case _.Info:return m.default.Info;case _.Hint:return m.default.Ignore}}_.toSeverity=E}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const I="";function L(l){return T(l,!0)}_.makeKey=L;function T(l,E){let h=[I];return l.source?h.push(l.source.replace("\xA6","\\\xA6")):h.push(I),l.code?typeof l.code=="string"?h.push(l.code.replace("\xA6","\\\xA6")):h.push(l.code.value.replace("\xA6","\\\xA6")):h.push(I),l.severity!==void 0&&l.severity!==null?h.push(P.toString(l.severity)):h.push(I),l.message&&E?h.push(l.message.replace("\xA6","\\\xA6")):h.push(I),l.startLineNumber!==void 0&&l.startLineNumber!==null?h.push(l.startLineNumber.toString()):h.push(I),l.startColumn!==void 0&&l.startColumn!==null?h.push(l.startColumn.toString()):h.push(I),l.endLineNumber!==void 0&&l.endLineNumber!==null?h.push(l.endLineNumber.toString()):h.push(I),l.endColumn!==void 0&&l.endColumn!==null?h.push(l.endColumn.toString()):h.push(I),h.push(I),h.join("\xA6")}_.makeKeyOptionalMessage=T})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(ve[188],we([0,1,3,48,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=_}),define(ve[189],we([0,1,6,8,2,4]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function P(_,I){return y.URI.isUri(_)?(0,i.equalsIgnoreCase)(_.scheme,I):(0,i.startsWithIgnoreCase)(_,I+":")}e.matchesScheme=P;function D(_,...I){return I.some(L=>P(_,L))}e.matchesSomeScheme=D}),define(ve[190],we([0,1,10,12,40,23]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const D=i.globals.vscode.context.configuration();if(D)P=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const D=(0,C.dirname)(m.FileAccess.asFileUri("",J));P=J.__$__nodeRequire((0,C.joinPath)(D,"product.json").fsPath);const _=J.__$__nodeRequire((0,C.joinPath)(D,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:_.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P});var ze=this&&this.__param||function(J,e){return function(m,i){e(m,i,J)}};define(ve[117],we([0,1,18,21,6,4]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends y.Disposable{constructor(T,l){super();this.deferred=new m.DeferredPromise,l.withProgress(T,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};_=je([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends y.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(T){this.stop();const l=++this.currentOperationId,E=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:E.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ve[51],we([0,1,56,13]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(P,D){m.ok(i.isString(P)),m.ok(i.isObject(D)),m.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,D)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new y}),define(ve[191],we([0,1,3,51]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[y(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new C;i.Registry.add(e.Extensions.JSONContribution,P)}),define(ve[118],we([0,1,16,3,13,155,191,51]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=D.Registry.as(P.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,a=!0){this.registerConfigurations([g],a)}registerConfigurations(g,a=!0){const S=this.doRegisterConfigurations(g,a);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(g){const a=this.doDeregisterConfigurations(g);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:g,remove:a}){const S=[];S.push(...this.doDeregisterConfigurations(a)),S.push(...this.doRegisterConfigurations(g,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(S)})}registerDefaultConfigurations(g){const a=[],S=[];for(const{overrides:n,source:t}of g)for(const r in n)if(a.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const u={...this.configurationDefaultsOverrides.get(r)?.value||{},...n[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:u});const c={type:"object",default:u,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:y.isString(t)?void 0:t};S.push(...h(r)),this.configurationProperties[r]=c,this.defaultLanguageConfigurationOverridesNode.properties[r]=c}else{this.configurationDefaultsOverrides.set(r,{value:n[r],source:t});const u=this.configurationProperties[r];u&&(this.updatePropertyDefaultValue(r,u),this.updateSchema(r,u))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const a=[];for(const{overrides:S,source:n}of g)for(const t in S){const r=this.configurationDefaultsOverrides.get(t),u=y.isString(n)?n:n?.id,c=y.isString(r?.source)?r?.source:r?.source?.id;if(u===c)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const a of g)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,a){const S=[];return g.forEach(n=>{S.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),S}doDeregisterConfigurations(g){const a=[],S=n=>{if(n.properties)for(const t in n.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>S(t))};for(const n of g){S(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(g,a=!0,S,n,t=3){t=y.isUndefinedOrNull(g.scope)?t:g.scope;let r=[],u=g.properties;if(u)for(let f in u){if(a&&w(f)){delete u[f];continue}const b=u[f];if(b.source=S,b.defaultDefaultValue=u[f].default,this.updatePropertyDefaultValue(f,b),e.OVERRIDE_PROPERTY_REGEX.test(f)?b.scope=void 0:(b.scope=y.isUndefinedOrNull(b.scope)?t:b.scope,b.restricted=y.isUndefinedOrNull(b.restricted)?!!n?.includes(f):b.restricted),u[f].hasOwnProperty("included")&&!u[f].included){this.excludedConfigurationProperties[f]=u[f],delete u[f];continue}else this.configurationProperties[f]=u[f];!u[f].deprecationMessage&&u[f].markdownDeprecationMessage&&(u[f].deprecationMessage=u[f].markdownDeprecationMessage),r.push(f)}let c=g.allOf;if(c)for(let f of c)r.push(...this.validateAndRegisterProperties(f,a,S,n,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const a=S=>{let n=S.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let t=S.allOf;t&&t.forEach(a)};a(g)}updateSchema(g,a){switch(e.allSettings.properties[g]=a,a.scope){case 1:e.applicationSettings.properties[g]=a;break;case 2:e.machineSettings.properties[g]=a;break;case 6:e.machineOverridableSettings.properties[g]=a;break;case 3:e.windowSettings.properties[g]=a;break;case 4:e.resourceSettings.properties[g]=a;break;case 5:e.resourceSettings.properties[g]=a,this.resourceLanguageSettingsSchema.properties[g]=a;break}}removeFromSchema(g,a){switch(delete e.allSettings.properties[g],a.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const a=`[${g}]`,S={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,S),e.allSettings.properties[a]=S,e.applicationSettings.properties[a]=S,e.machineSettings.properties[a]=S,e.machineOverridableSettings.properties[a]=S,e.windowSettings.properties[a]=S,e.resourceSettings.properties[a]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,a){const S=this.configurationDefaultsOverrides.get(g);let n=S?.value,t=S?.source;y.isUndefined(n)&&(n=a.defaultDefaultValue,t=void 0),y.isUndefined(n)&&(n=v(a.type)),a.default=n,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",E=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(o){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let a=E.exec(o);for(;a?.length;){const S=a[1].trim();S&&g.push(S),a=E.exec(o)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=h;function p(o){return o.reduce((g,a)=>`${g}[${a}]`,"")}e.keyFromOverrideIdentifiers=p;function v(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const A=new T;D.Registry.add(e.Extensions.Configuration,A);function w(o){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?C.localize(7,null,o):A.getConfigurationProperties()[o]!==void 0?C.localize(8,null,o):null:C.localize(6,null)}e.validateProperty=w;function s(){const o=[],g=A.getConfigurationProperties();for(const a of Object.keys(g))o.push([a,g[a].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=s}),define(ve[192],we([0,1,16,3,58,6,24,25,13,2,115,118,51]),function(J,e,m,i,y,C,P,D,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,L.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,L.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return m.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=D.deepClone(this.contents),r=D.deepClone(this.overrides),u=[...this.keys];for(const c of n){this.mergeContents(t,c.contents);for(const f of c.overrides){const[b]=r.filter(d=>m.equals(d.identifiers,f.identifiers));b?(this.mergeContents(b.contents,f.contents),b.keys.push(...f.keys),b.keys=m.distinct(b.keys)):r.push(D.deepClone(f))}for(const f of c.keys)u.indexOf(f)===-1&&u.push(f)}return new E(t,u,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const u of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[u],f=t[u];f&&(typeof c=="object"&&typeof f=="object"?(c=D.deepClone(c),this.mergeContents(c,f)):c=f),r[u]=c}return new E(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&_.isObject(n[r])&&_.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=D.deepClone(t[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?D.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const u=c=>{c&&(r?this.mergeContents(r,c):r=D.deepClone(c))};for(const c of this.overrides)m.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&u(c.contents);return u(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,L.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,L.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(n={}){const t=l.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),u=Object.create(null),c=[];for(const f in t){const b=n[f],d=b!==void 0?b:t[f].default;(0,L.addToValueTree)(u,f,d,k=>console.error(`Conflict in default settings: ${k}`))}for(const f of Object.keys(u))T.OVERRIDE_PROPERTY_REGEX.test(f)&&c.push({identifiers:(0,T.overrideIdentifiersFromKey)(f),keys:Object.keys(u[f]),contents:(0,L.toValuesTree)(u[f],b=>console.error(`Conflict in default settings file: ${b}`))});super(u,r,c)}}e.DefaultConfigurationModel=h;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!_.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:u,overrides:c,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new E(r,u,c),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},r=null,u=[],c=[],f=[];function b(k){Array.isArray(u)?u.push(k):r!==null&&(u[r]=k)}let d={onObjectBegin:()=>{let k={};b(k),c.push(u),u=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{let k=[];b(k),c.push(u),u=k,r=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:b,onError:(k,R,N)=>{f.push({error:k,offset:R,length:N})}};if(n)try{y.visit(n,d),t=u[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return t}doParseRaw(n,t){const r=l.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=this.filter(n,r,!0,t);n=u.raw;const c=(0,L.toValuesTree)(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),f=Object.keys(n),b=this.toOverrides(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:f,overrides:b,restricted:u.restricted}}filter(n,t,r,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:n,restricted:[]};const c={},f=[];for(let b in n)if(T.OVERRIDE_PROPERTY_REGEX.test(b)&&r){const d=this.filter(n[b],t,!1,u);c[b]=d.raw,f.push(...d.restricted)}else{const d=t[b],k=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&f.push(b),(k===void 0||u.scopes===void 0||u.scopes.includes(k))&&(u.skipRestricted&&d?.restricted||(c[b]=n[b]))}return{raw:c,restricted:f}}toOverrides(n,t){const r=[];for(const u of Object.keys(n))if(T.OVERRIDE_PROPERTY_REGEX.test(u)){const c={};for(const f in n[u])c[f]=n[u][f];r.push({identifiers:(0,T.overrideIdentifiersFromKey)(u),keys:Object.keys(c),contents:(0,L.toValuesTree)(c,t)})}return r}}e.ConfigurationModelParser=p;class v extends C.Disposable{constructor(n,t,r,u){super();this.userSettingsResource=n,this.scopes=t,this.fileService=u,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class A{constructor(n,t,r=new E,u=new E,c=new P.ResourceMap,f=new E,b=new P.ResourceMap,d=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=u,this._folderConfigurations=c,this._memoryConfiguration=f,this._memoryConfigurationByResource=b,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(n)}updateValue(n,t,r={}){let u;r.resource?(u=this._memoryConfigurationByResource.get(r.resource),u||(u=new E,this._memoryConfigurationByResource.set(r.resource,u))):u=this._memoryConfiguration,t===void 0?u.removeValue(n):u.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const u=this.getConsolidateConfigurationModel(t,r),c=this.getFolderConfigurationModelForResource(t.resource,r),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,b=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),d=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),k=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,B=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(n):c.freeze().getValue(n):void 0,F=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),U=u.getValue(n),H=m.distinct(m.flatten(u.overrides.map(x=>x.identifiers))).filter(x=>u.getOverrideValue(n,x)!==void 0);return{defaultValue:b,userValue:d,userLocalValue:k,userRemoteValue:R,workspaceValue:N,workspaceFolderValue:B,memoryValue:F,value:U,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:c?.freeze().getValue(n),override:t.overrideIdentifier?c?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:u,updated:c,removed:f}=g(this._defaultConfiguration,n);t=[...u,...c,...f]}for(const u of t)for(const c of(0,T.overrideIdentifiersFromKey)(u)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(c),b=n.getKeysForOverrideIdentifier(c),d=[...b.filter(k=>f.indexOf(k)===-1),...f.filter(k=>b.indexOf(k)===-1),...f.filter(k=>!D.equals(this._defaultConfiguration.override(c).getValue(k),n.override(c).getValue(k)))];r.push([c,d])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:u,overrides:c}=g(this.localUserConfiguration,n),f=[...t,...r,...u];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:u,overrides:c}=g(this.remoteUserConfiguration,n);let f=[...t,...r,...u];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:u,overrides:c}=g(this.workspaceConfiguration,n);let f=[...t,...r,...u];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:u,updated:c,removed:f,overrides:b}=g(r,t);let d=[...u,...c,...f];return(d.length||!r)&&this.updateFolderConfiguration(n,t),{keys:d,overrides:b}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:u,removed:c,overrides:f}=g(t,void 0);return{keys:[...r,...u,...c],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const u=t.getFolder(n);u&&(r=this.getFolderConsolidatedConfiguration(u.uri)||r);const c=this._memoryConfigurationByResource.get(n);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(n);u?(t=r.merge(u),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:u,keys:c}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:u,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(u=>t.add(u))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),c=n.folders.reduce((f,b)=>(f.set(I.URI.revive(b[0]),this.parseConfigurationModel(b[1])),f),new P.ResourceMap);return new A(t,r,new E,u,c,new E,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=A;function w(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const n=new Set,t=new Map;for(const u of S)u.keys.forEach(c=>n.add(c)),u.overrides.forEach(([c,f])=>{const b=(0,P.getOrSet)(t,c,new Set);f.forEach(d=>b.add(d))});const r=[];return t.forEach((u,c)=>r.push([c,[...u.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=w;class s{constructor(n,t,r,u){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=u,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(b=>c.add(b)),n.overrides.forEach(([,b])=>b.forEach(d=>c.add(d))),this.affectedKeys=[...c.values()];const f=new E;this.affectedKeys.forEach(b=>f.setValue(b,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!D.equals(r,u)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,L.toValuesTree)({[t]:!0},()=>{}),u;for(;typeof r=="object"&&(u=Object.keys(r)[0]);){if(n=n[u],!n)return!1;r=r[u]}return!0}}e.ConfigurationChangeEvent=s;class o extends s{constructor(n,t,r,u){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=o;function g(S,n){const{added:t,removed:r,updated:u}=a(n,S),c=[],f=S?.getAllOverrideIdentifiers()||[],b=n?.getAllOverrideIdentifiers()||[];if(n){const d=b.filter(k=>!f.includes(k));for(const k of d)c.push([k,n.getKeysForOverrideIdentifier(k)])}if(S){const d=f.filter(k=>!b.includes(k));for(const k of d)c.push([k,S.getKeysForOverrideIdentifier(k)])}if(n&&S){for(const d of f)if(b.includes(d)){const k=a({contents:S.getOverrideValue(void 0,d)||{},keys:S.getKeysForOverrideIdentifier(d)},{contents:n.getOverrideValue(void 0,d)||{},keys:n.getKeysForOverrideIdentifier(d)});c.push([d,[...k.added,...k.removed,...k.updated]])}}return{added:t,removed:r,updated:u,overrides:c}}function a(S,n){const t=S?n?S.keys.filter(c=>n.keys.indexOf(c)===-1):[...S.keys]:[],r=n?S?n.keys.filter(c=>S.keys.indexOf(c)===-1):[...n.keys]:[],u=[];if(S&&n){for(const c of n.keys)if(S.keys.indexOf(c)!==-1){const f=(0,L.getConfigurationValue)(n.contents,c),b=(0,L.getConfigurationValue)(S.contents,c);D.equals(f,b)||u.push(c)}}return{added:t,removed:r,updated:u}}}),define(ve[119],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var i;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(P,D=i.Unknown,_){super(P);this._message=P,this._code=D,this._detail=_,this.isHandled=D===i.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===i.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===i.NoResolverFound}static isHandled(P){return P instanceof y&&P.isHandled}}e.RemoteAuthorityResolverError=y}),define(ve[62],we([0,1,10]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(I){return I.scheme===m.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=i;function y(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=y;function C(I){return I.scheme!==m.Schemas.file&&I.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function P(I){if(I.folders.length)return I.folders.every(L=>C(L.uri))?I.folders[0].uri:void 0;if(I.configuration&&C(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=P;function D(I){return P(I)?.scheme}e.getVirtualWorkspaceScheme=D;function _(I){return P(I)!==void 0}e.isVirtualWorkspace=_}),define(ve[27],we([0,1,8,4,62]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=C;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));class _{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let p=typeof E=="string"?E:E.value,v=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(p,v)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=_;function I(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function L(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function T(l,E){if(E){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(E)}`;return l.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[193],we([0,1,8,27]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,m.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=y;class C{constructor(p,v){this.version=v,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?y(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function P(h,p){return`${h}.${p}`}e.getExtensionId=P;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(h,p){return D(P(h,p))}e.getGalleryExtensionId=_;function I(h,p){const v=[],A=w=>{for(const s of v)if(s.some(o=>y(p(o),p(w))))return s;return null};for(const w of h){const s=A(w);s?s.push(w):v.push([w])}return v}e.groupByExtension=I;function L(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function T(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function l(h){const p=new Set;if(h.malicious)for(const v of h.malicious)p.add(v.id);return p}e.getMaliciousExtensionsSet=l;function E(h,p){const v=[],A=p.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const w=A.shift();if(w&&v.every(s=>!y(s.identifier,{id:w}))){const s=h.filter(o=>y(o.identifier,{id:w}));s.length===1&&(v.push(s[0]),A.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=E}),define(ve[120],we([0,1,3,12,4,11]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var P;(function(h){h.Http="http",h.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=T;function l(h,p){return p?p!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=l;let E=class{constructor(p){this.logService=p,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,v){return this._tunnelProvider=p,p?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],v=Array.from(this._tunnels.values());for(let A of v){const w=Array.from(A.values());for(let s of w){const o=await s.value;o&&p.push(o)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:v}of p.values())await v.then(A=>A?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,v,A,w,s=!1,o=D.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${A} on local port ${w}.`),!p)return;v||(v="localhost");const a=this.retainOrCreateTunnel(p,v,A,w,s,o,g);return a?a.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,A);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(S);return(S.tunnelRemoteHost!==v||S.tunnelRemotePort!==A)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const v=this._tunnels.get(p.tunnelRemoteHost);if(v){const A=v.get(p.tunnelRemotePort);A&&(A.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,A))}}}}async tryDisposeTunnel(p,v,A){if(A.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${v}.`);const w=A.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(v),w}}async closeTunnel(p,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${v} `);const A=this._tunnels.get(p);if(A&&A.has(v)){const w=A.get(v);w.refcount=0,await this.tryDisposeTunnel(p,v,w)}}addTunnelToMap(p,v,A){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(v,{refcount:1,value:A})}async removeEmptyTunnelFromMap(p,v){const A=this._tunnels.get(p);A&&(await A.get(v)||A.delete(v),A.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,v){let A=[p];L(p)?(A.push(...e.LOCALHOST_ADDRESSES),A.push(...e.ALL_INTERFACES_ADDRESSES)):T(p)&&A.push(...e.ALL_INTERFACES_ADDRESSES);const w=A.map(s=>this._tunnels.get(s));for(const s of w){const o=s?.get(v);if(o)return o}}canTunnel(p){return!!I(p)}createWithProvider(p,v,A,w,s,o,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${A} on local port ${w}.`);const S={elevationRequired:s?l(w===void 0?A:w):!1},n={remoteAddress:{host:v,port:A},localAddressPort:w,privacy:o,public:o!==D.Private,protocol:g},t=p.forwardPort(n,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,A,t),t}};E=je([ze(0,C.ILogService)],E),e.AbstractTunnelService=E}),define(ve[194],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>J(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),P=new C.validator;if(P){const D=String(m._nextId++);return this.validators.set(D,P),{id:D,data:P.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const P=this.validators.get(y.id);if(!P)return!1;this.validators.delete(y.id);try{return P.validate(C)==="ok"}catch{return!1}}async sign(y){try{const C=await this.vsda(),P=new C.signer;if(P)return P.sign(y)}catch{}return y}}e.SignService=m,m._nextId=1}),define(ve[195],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,P=5){let D;return D=C(_=>{const I=typeof _=="string"?_:_.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(I);return}const T=setTimeout(()=>this.flushBuffer(y),P);L={data:[I],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(y),D.dispose()}},this._terminalBufferMap.set(y,L)}),D}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=m}),define(ve[196],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(ve[86],we([0,1,73,3,6,4,51,196]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(v){function A(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=A})(_=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var L;(function(v){function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||_.isThemeColor(t.color))}v.isThemeIcon=A;const w=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function s(t){const r=w.exec(t);if(!r)return;let[,u]=r;return{id:u}}v.fromString=s;function o(t){return{id:t}}v.fromId=o;function g(t,r){let u=t.id;const c=u.lastIndexOf("~");return c!==-1&&(u=u.substring(0,c)),r&&(u=`${u}~${r}`),{id:u}}v.modify=g;function a(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}v.getModifier=a;function S(t,r){return t.id===r.id&&t.color?.id===r.color?.id}v.isEqual=S;function n(t,r){return{id:t.id,color:r?I(r):void 0}}v.asThemeIcon=n,v.asClassNameArray=m.CSSIcon.asClassNameArray,v.asClassName=m.CSSIcon.asClassName,v.asCSSSelector=m.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function T(v){switch(v){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,y.toDisposable)(()=>{const w=this.themingParticipants.indexOf(A);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new l;P.Registry.add(e.Extensions.ThemingContribution,E);function h(v){return E.onColorThemeChange(v)}e.registerThemingParticipant=h;class p extends y.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,w){let s=this.theme.getColor(A);return s&&w&&(s=w(s,this.theme)),s?s.toString():null}}e.Themable=p}),define(ve[43],we([0,1,24,23,2,4]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var P;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function D(l){const E=l;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=D;function _(l){const E=l;return!!(E&&typeof E=="object"&&y.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=_;class I{constructor(E,h,p,v,A){this._id=E,this._transient=p,this._configuration=v,this._ignorePathCasing=A,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=I;class L{constructor(E,h){this.raw=h,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,i.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function T(l){return new L({uri:l,index:0,name:(0,i.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=T}),define(ve[197],we([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(M){return(typeof M=="string"?(0,D.extname)(M):(0,I.extname)(M))===p}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function A(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function w(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=w;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function o(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=o;function g(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=g;function a(M){const W=M;return typeof W?.id=="string"&&L.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=a;function S(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=S;function n(M){const W=M;return typeof W?.id=="string"&&L.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=n;function t(M){const W=M;if(W?.uri)return{id:W.id,uri:L.URI.revive(W.uri)};const z=M;if(z?.configPath)return{id:z.id,configPath:L.URI.revive(z.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=t;function r(M,W){return I.extUriBiasedIgnorePathCase.isEqualOrParent(M,W.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function u(M){return c(M)||f(M)}e.isStoredWorkspaceFolder=u;function c(M){const W=M;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=c;function f(M){const W=M;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=f;function b(M,W,z,O,V=!_.isWindows,K){if(M.scheme!==O.scheme)return{name:z,uri:M.toString(!0)};let G=W?void 0:K.relativePath(O,M);if(G!==void 0)G.length===0?G=".":_.isWindows&&M.scheme===P.Schemas.file&&!V&&(G=G.replace(/\//g,"\\"));else if(M.scheme===P.Schemas.file)G=M.fsPath,_.isWindows&&(G=(0,C.normalizeDriveLetter)(G),V&&(G=(0,m.toSlashes)(G)));else{if(!K.isEqualAuthority(M.authority,O.authority))return{name:z,uri:M.toString(!0)};G=M.path}return{name:z,path:G}}e.getStoredWorkspaceFolder=b;function d(M,W,z){let O=[],V=new Set;const K=z.dirname(W);for(let G of M){let Q;if(c(G))G.path&&(Q=z.resolvePath(K,G.path));else if(f(G))try{Q=L.URI.parse(G.uri),Q.path[0]!=="/"&&(Q=Q.with({path:"/"+Q.path}))}catch(Y){console.warn(Y)}if(Q){let Y=z.getComparisonKey(Q);if(!V.has(Y)){V.add(Y);const fe=G.name||z.basenameOrAuthority(Q);O.push(new h.WorkspaceFolder({uri:Q,name:fe,index:O.length},G))}}}return O}e.toWorkspaceFolders=d;function k(M,W,z,O,V){let K=R(W,M);const G=V.dirname(W),Q=V.dirname(O),Y=[],fe=N(K.folders);for(const Oe of K.folders){const We=c(Oe)?V.resolvePath(G,Oe.path):L.URI.parse(Oe.uri);let j;z?j=!1:j=!c(Oe)||(0,D.isAbsolute)(Oe.path),Y.push(b(We,j,Oe.name,Q,fe,V))}const me={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},Se=y.setProperty(M,["folders"],Y,me);let Ie=y.applyEdits(M,Se);return(0,I.isEqualAuthority)(K.remoteAuthority,(0,E.getRemoteAuthority)(O))&&(Ie=y.applyEdits(Ie,y.removeProperty(Ie,["remoteAuthority"],me))),Ie}e.rewriteWorkspaceFileForNewLocation=k;function R(M,W){let z=i.parse(W);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(O=>u(O));else throw new Error(`${M} looks like an invalid workspace file.`);return z}function N(M){return _.isWindows?M.some(W=>c(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function B(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function U(M){return typeof M.fileUri=="string"}function H(M,W){const z={workspaces:[],files:[]};if(M){const O=function(K,G){for(let Q=0;Q<K.length;Q++)try{G(K[Q],Q)}catch(Y){W.warn(`Error restoring recent entry ${JSON.stringify(K[Q])}: ${Y.toString()}. Skip entry.`)}},V=M;if(Array.isArray(V.entries))O(V.entries,K=>{const G=K.label,Q=K.remoteAuthority;B(K)?z.workspaces.push({label:G,remoteAuthority:Q,workspace:{id:K.workspace.id,configPath:L.URI.parse(K.workspace.configPath)}}):F(K)?z.workspaces.push({label:G,remoteAuthority:Q,folderUri:L.URI.parse(K.folderUri)}):U(K)&&z.files.push({label:G,remoteAuthority:Q,fileUri:L.URI.parse(K.fileUri)})});else{const K=M;Array.isArray(K.workspaces3)&&O(K.workspaces3,(G,Q)=>{const Y=Array.isArray(K.workspaceLabels)&&K.workspaceLabels[Q]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?z.workspaces.push({label:Y,workspace:{id:G.id,configPath:L.URI.parse(G.configURIPath)}}):typeof G=="string"&&z.workspaces.push({label:Y,folderUri:L.URI.parse(G)})}),Array.isArray(K.files2)&&O(K.files2,(G,Q)=>{const Y=Array.isArray(K.fileLabels)&&K.fileLabels[Q]||void 0;typeof G=="string"&&z.files.push({label:Y,fileUri:L.URI.parse(G)})})}}return z}e.restoreRecentlyOpened=H;function x(M){const W={entries:[]};for(const z of M.workspaces)w(z)?W.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):W.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of M.files)W.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return W}e.toStoreData=x}),define(ve[87],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(ve[44],we([0,1,10,23,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(D=>{const _=this._providerInfo.get(D.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(D,_){_===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,_)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(ve[198],we([0,1,18]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(P,D,_){this._deferredPromises=new Map,this._id=P,this._shared=D,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const T of I.values())T.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,D){let _=this._value[P];return typeof _=="undefined"&&(_=D),_}update(P,D){this._value[P]=D;let _=this._deferredPromises.get(P);if(_!==void 0)return _.p;const I=new m.DeferredPromise;return this._deferredPromises.set(P,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class y extends i{constructor(P,D){super(P.identifier.value,!0,D);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=y}),define(ve[199],we([0,1,3,2,11]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,I){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D)).acceptModelChanged(_.value,I)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const I=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D));I.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};C=je([ze(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ve[14],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class i{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=i});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[200],we([0,1,27,3]),function(J,e,m,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(D,_){y.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(D.identifier),nt(this,y,_,"f"),Be(this,y,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(D){return Be(this,y,"f").get(this._id,D)}store(D,_){return Be(this,y,"f").store(this._id,D,_)}delete(D){return Be(this,y,"f").delete(this._id,D)}}e.ExtensionSecrets=C,y=new WeakMap}),define(ve[121],we([0,1,4,3]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(ve[63],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,y=(w,s)=>{const o={controllerId:s};return i.set(w,o),o};e.createPrivateApiFor=y;const C=w=>i.get(w);e.getPrivateApiFor=C;const P=(w,s,o,g)=>{let a=o;return{enumerable:!0,configurable:!1,get(){return a},set(S){if(!g(a,S)){const n=a;a=S,w.listener?.({op:3,key:s,value:S,previous:n})}}}},D=(w,s)=>w===s,_={range:(w,s)=>w===s?!0:!w||!s?!1:w.isEqual(s),label:D,description:D,busy:D,error:D,canResolveChildren:D,tags:(w,s)=>!(w.length!==s.length||w.some(o=>!s.find(g=>o.id===g.id)))},I=Object.keys(_),L=(w,s)=>({range:P(w,"range",void 0,_.range),label:P(w,"label",s,_.label),description:P(w,"description",void 0,_.description),canResolveChildren:P(w,"canResolveChildren",!1,_.canResolveChildren),busy:P(w,"busy",!1,_.busy),error:P(w,"error",void 0,_.error),tags:P(w,"tags",[],_.tags)}),T=(w,s)=>{const o=new Map;for(const g of I)_[g](w[g],s[g])||o.set(g,s[g]);return o};e.diffTestItems=T;class l extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=l;class E extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class h extends Error{constructor(s,o,g){super(`TestItem with ID "${s}" is from controller "${o}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const p=w=>{const s=(0,e.getPrivateApiFor)(w);let o=new Map;return{get size(){return o.size},forEach(g,a){for(const S of o.values())g.call(a,S,this)},replace(g){const a=new Map,S=new Set(o.keys()),n={op:4,ops:[]};for(const t of g){if(!(t instanceof v))throw new E(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==s.controllerId)throw new h(t.id,r,s.controllerId);if(a.has(t.id))throw new l(t.id);a.set(t.id,t),S.delete(t.id),n.ops.push({op:0,item:t})}for(const t of S.keys())n.ops.push({op:1,id:t});s.listener?.(n),o=a},add(g){if(!(g instanceof v))throw new E(g.id);o.set(g.id,g),s.listener?.({op:0,item:g})},delete(g){o.delete(g)&&s.listener?.({op:1,id:g})},get(g){return o.get(g)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class v{constructor(s,o,g,a){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const S=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof A?void 0:S.parent}},children:{value:p(this),enumerable:!0,writable:!1},...L(S,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class A extends v{constructor(s,o){super(s,s,o,void 0)}}e.TestItemRootImpl=A}),define(ve[52],we([0,1,4,120,3,14]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(_){function I(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:T.protocol}}_.fromApiTunnel=I;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==i.TunnelPrivacyId.ConstantPrivate&&T.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}_.fromServiceTunnel=L})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let D=class{constructor(I){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,T,l,E){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([ze(0,C.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[7],we([0,1,16,15,97,24,101,8,13,2,32,42,119]),function(J,e,m,i,y,C,P,D,_,I,L,T,l){"use strict";var E,h,p,v,A,w,s,o,g,a,S,n,t,r,u,c,f,b,d,k;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function $(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf($,q),Object.setPrototypeOf($.prototype,q.prototype),$}let N=A=class{constructor($){E.set(this,void 0),nt(this,E,$,"f")}static from(...$){let ae=$;return new A(function(){if(ae){for(const Te of ae)Te&&typeof Te.dispose=="function"&&Te.dispose();ae=void 0}})}dispose(){typeof Be(this,E,"f")=="function"&&(Be(this,E,"f").call(this),nt(this,E,void 0,"f"))}};E=new WeakMap,N=A=je([R],N),e.Disposable=N;let B=w=class{constructor($,ae){if($<0)throw(0,i.illegalArgument)("line must be non-negative");if(ae<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=$,this._character=ae}static Min(...$){if($.length===0)throw new TypeError;let ae=$[0];for(let Te=1;Te<$.length;Te++){const Ye=$[Te];Ye.isBefore(ae)&&(ae=Ye)}return ae}static Max(...$){if($.length===0)throw new TypeError;let ae=$[0];for(let Te=1;Te<$.length;Te++){const Ye=$[Te];Ye.isAfter(ae)&&(ae=Ye)}return ae}static isPosition($){if(!$)return!1;if($ instanceof w)return!0;let{line:ae,character:Te}=$;return typeof ae=="number"&&typeof Te=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ae=0){if($===null||ae===null)throw(0,i.illegalArgument)();let Te;return typeof $=="undefined"?Te=0:typeof $=="number"?Te=$:(Te=typeof $.lineDelta=="number"?$.lineDelta:0,ae=typeof $.characterDelta=="number"?$.characterDelta:0),Te===0&&ae===0?this:new w(this.line+Te,this.character+ae)}with($,ae=this.character){if($===null||ae===null)throw(0,i.illegalArgument)();let Te;return typeof $=="undefined"?Te=this.line:typeof $=="number"?Te=$:(Te=typeof $.line=="number"?$.line:this.line,ae=typeof $.character=="number"?$.character:this.character),Te===this.line&&ae===this.character?this:new w(Te,ae)}toJSON(){return{line:this.line,character:this.character}}};B=w=je([R],B),e.Position=B;let F=s=class{constructor($,ae,Te,Ye){let rt,lt;if(typeof $=="number"&&typeof ae=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new B($,ae),lt=new B(Te,Ye)):$ instanceof B&&ae instanceof B&&(rt=$,lt=ae),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange($){return $ instanceof s?!0:$?B.isPosition($.start)&&B.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof s?this.contains($._start)&&this.contains($._end):$ instanceof B?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ae=B.Max($.start,this._start),Te=B.Min($.end,this._end);if(!ae.isAfter(Te))return new s(ae,Te)}union($){if(this.contains($))return this;if($.contains(this))return $;const ae=B.Min($.start,this._start),Te=B.Max($.end,this.end);return new s(ae,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ae=this.end){if($===null||ae===null)throw(0,i.illegalArgument)();let Te;return $?B.isPosition($)?Te=$:(Te=$.start||this.start,ae=$.end||this.end):Te=this.start,Te.isEqual(this._start)&&ae.isEqual(this.end)?this:new s(Te,ae)}toJSON(){return[this.start,this.end]}};F=s=je([R],F),e.Range=F;let U=o=class extends F{constructor($,ae,Te,Ye){let rt,lt;if(typeof $=="number"&&typeof ae=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new B($,ae),lt=new B(Te,Ye)):$ instanceof B&&ae instanceof B&&(rt=$,lt=ae),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection($){return $ instanceof o?!0:$?F.isRange($)&&B.isPosition($.anchor)&&B.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=o=je([R],U),e.Selection=U;class H{constructor($,ae,Te){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,i.illegalArgument)("port");if(typeof Te!="undefined"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,i.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(ae),this.connectionToken=Te}}e.ResolvedAuthority=H;class x extends Error{constructor($,ae=l.RemoteAuthorityResolverErrorCode.Unknown,Te){super($);this._message=$,this._code=ae,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable($,ae){return new x($,l.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable($){return new x($,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var M;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(M=e.EndOfLine||(e.EndOfLine={}));var W;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=g=class{constructor($,ae){this._range=$,this._newText=ae}static isTextEdit($){return $ instanceof g?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,ae){return new g($,ae)}static insert($,ae){return g.replace(new F($,$),ae)}static delete($){return g.replace($,"")}static setEndOfLine($){const ae=new g(new F(new B(0,0),new B(0,0)),"");return ae.newEol=$,ae}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,i.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,i.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,i.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=g=je([R],z),e.TextEdit=z;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ae,Te,Ye){this._edits.push({_type:1,from:$,to:ae,options:Te,metadata:Ye})}createFile($,ae,Te){this._edits.push({_type:1,from:void 0,to:$,options:ae,metadata:Te})}deleteFile($,ae,Te){this._edits.push({_type:1,from:$,to:void 0,options:ae,metadata:Te})}replaceNotebookMetadata($,ae,Te){this._edits.push({_type:3,metadata:Te,uri:$,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells($,ae,Te,Ye,rt){let lt,ht,kt=[],Ft;if($e.isNotebookRange(ae)&&Bt.isNotebookCellDataArray(Te)&&!Bt.isNotebookCellDataArray(Ye)?(lt=ae.start,ht=ae.end,kt=Te,Ft=Ye):typeof ae=="number"&&typeof Te=="number"&&Bt.isNotebookCellDataArray(Ye)&&(lt=ae,ht=Te,kt=Ye,Ft=rt),lt===void 0||ht===void 0)throw new Error("Invalid arguments");(lt!==ht||kt.length>0)&&this._edits.push({_type:5,uri:$,index:lt,count:ht-lt,cells:kt,metadata:Ft})}replaceNotebookCellMetadata($,ae,Te,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:ae,metadata:Te}})}replace($,ae,Te,Ye){this._edits.push({_type:2,uri:$,edit:new z(ae,Te),metadata:Ye})}insert($,ae,Te,Ye){this.replace($,new F(ae,ae),Te,Ye)}delete($,ae,Te){this.replace($,ae,"",Te)}has($){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===$.toString())}set($,ae){if(ae)for(const Te of ae)Te&&this._edits.push({_type:2,uri:$,edit:Te});else{for(let Te=0;Te<this._edits.length;Te++){const Ye=this._edits[Te];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Te]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const ae=[];for(let Te of this._edits)Te._type===2&&Te.uri.toString()===$.toString()&&ae.push(Te.edit);return ae}entries(){const $=new C.ResourceMap;for(let ae of this._edits)if(ae._type===2){let Te=$.get(ae.uri);Te||(Te=[ae.uri,[]],$.set(ae.uri,Te)),Te[1].push(ae.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=je([R],V),e.WorkspaceEdit=V;let K=a=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ae=this._tabstop++){if(typeof $=="function"){const Te=new a;Te._tabstop=this._tabstop,$(Te),this._tabstop=Te._tabstop,$=Te.value}else $=a._escape($);return this.value+="${",this.value+=ae,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ae=this._tabstop++){const Te=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable($,ae){if(typeof ae=="function"){const Te=new a;Te._tabstop=this._tabstop,ae(Te),this._tabstop=Te._tabstop,ae=Te.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};K=a=je([R],K),e.SnippetString=K;var G;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=S=class{constructor($,ae){if(this.uri=$,ae)if(ae instanceof F)this.range=ae;else if(ae instanceof B)this.range=new F(ae,ae);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof S?!0:$?F.isRange($.range)&&I.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=S=je([R],Y),e.Location=Y;let fe=class{constructor($,ae){this.location=$,this.message=ae}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&I.URI.isUri($.location.uri):!1}static isEqual($,ae){return $===ae?!0:!$||!ae?!1:$.message===ae.message&&$.location.range.isEqual(ae.location.range)&&$.location.uri.toString()===ae.location.uri.toString()}};fe=je([R],fe),e.DiagnosticRelatedInformation=fe;let me=class{constructor($,ae,Te=Q.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=$,this.message=ae,this.severity=Te}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ae){return $===ae?!0:!$||!ae?!1:$.message===ae.message&&$.severity===ae.severity&&$.code===ae.code&&$.severity===ae.severity&&$.source===ae.source&&$.range.isEqual(ae.range)&&(0,m.equals)($.tags,ae.tags)&&(0,m.equals)($.relatedInformation,ae.relatedInformation,fe.isEqual)}};me=je([R],me),e.Diagnostic=me;let Se=class{constructor($,ae){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=ae}};Se=je([R],Se),e.Hover=Se;var Ie;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor($,ae=Ie.Text){this.range=$,this.kind=ae}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Oe=je([R],Oe),e.DocumentHighlight=Oe;var We;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var j;(function(q){q[q.Deprecated=1]="Deprecated"})(j=e.SymbolTag||(e.SymbolTag={}));let Z=n=class{constructor($,ae,Te,Ye,rt){this.name=$,this.kind=ae,this.containerName=rt,typeof Te=="string"&&(this.containerName=Te),Ye instanceof Y?this.location=Ye:Te instanceof F&&(this.location=new Y(Ye,Te)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};Z=n=je([R],Z),e.SymbolInformation=Z;let re=t=class{constructor($,ae,Te,Ye,rt){this.name=$,this.detail=ae,this.kind=Te,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};re=t=je([R],re),e.DocumentSymbol=re;var ue;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor($,ae){this.title=$,this.kind=ae}};te=je([R],te),e.CodeAction=te;let oe=r=class{constructor($){this.value=$}append($){return new r(this.value?this.value+r.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+r.sep)}};oe.sep=".",oe=r=je([R],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let Ee=class{constructor($,ae){if(this.range=$,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=je([R],Ee),e.SelectionRange=Ee;class Ne{constructor($,ae,Te,Ye,rt,lt){this.kind=$,this.name=ae,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Ne;class Ve{constructor($,ae){this.fromRanges=ae,this.from=$}}e.CallHierarchyIncomingCall=Ve;class Ge{constructor($,ae){this.fromRanges=ae,this.to=$}}e.CallHierarchyOutgoingCall=Ge;var Je;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor($,ae){this.range=$,this.command=ae}get isResolved(){return!!this.command}};tt=je([R],tt),e.CodeLens=tt;let ot=u=class{constructor($,ae=!1){h.set(this,void 0),nt(this,h,new y.MarkdownString($,{supportThemeIcons:ae}),"f")}static isMarkdownString($){return $ instanceof u?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Be(this,h,"f").value}set value($){Be(this,h,"f").value=$}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted($){Be(this,h,"f").isTrusted=$}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons($){Be(this,h,"f").supportThemeIcons=$}get supportHtml(){return Be(this,h,"f").supportHtml}set supportHtml($){Be(this,h,"f").supportHtml=$}appendText($){return Be(this,h,"f").appendText($),this}appendMarkdown($){return Be(this,h,"f").appendMarkdown($),this}appendCodeblock($,ae){return Be(this,h,"f").appendCodeblock(ae??"",$),this}};h=new WeakMap,ot=u=je([R],ot),e.MarkdownString=ot;let et=class{constructor($,ae){this.label=$,this.documentation=ae}};et=je([R],et),e.ParameterInformation=et;let it=class{constructor($,ae){this.label=$,this.documentation=ae,this.parameters=[]}};it=je([R],it),e.SignatureInformation=it;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=je([R],ct),e.SignatureHelp=ct;var pt;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Pt;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Pt=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor($,ae,Te){this.text=$,this.position=ae,this.kind=Te}};xe=je([R],xe),e.InlayHint=xe;var Rt;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ee;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(q){q[q.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor($,ae){this.label=$,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=je([R],pe),e.CompletionItem=pe;let ie=class{constructor($=[],ae=!1){this.items=$,this.isIncomplete=ae}};ie=je([R],ie),e.CompletionList=ie;let _e=class{constructor($,ae,Te){this.text=$,this.range=ae,this.command=Te}};_e=je([R],_e),e.InlineSuggestion=_e;let Fe=class{constructor($){this.items=$}};Fe=je([R],Fe),e.InlineSuggestions=Fe;var Ue;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(Ue=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function $(ae){switch(ae){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=$}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ce=class{constructor($,ae){if(ae&&!I.URI.isUri(ae))throw(0,i.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.target=ae}};Ce=je([R],Ce),e.DocumentLink=Ce;let Me=class{constructor($,ae,Te,Ye){this.red=$,this.green=ae,this.blue=Te,this.alpha=Ye}};Me=je([R],Me),e.Color=Me;let Ke=class{constructor($,ae){if(ae&&!(ae instanceof Me))throw(0,i.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.color=ae}};Ke=je([R],Ke),e.ColorInformation=Ke;let He=class{constructor($){if(!$||typeof $!="string")throw(0,i.illegalArgument)("label");this.label=$}};He=je([R],He),e.ColorPresentation=He;var Qe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var st;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor($,ae,Te){if(this.startIndex=$,this.length=ae,this.tooltip=Te,typeof $!="number"||$<0)throw(0,i.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,i.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=at;var he;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(he=e.TerminalLocation||(e.TerminalLocation={}));class De{constructor($){this.options=$,typeof $!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=De;var ce;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=c=class{constructor($,ae){if(this.label=ae,typeof $!="string"||typeof ae!="string")throw(0,i.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ke.Clean=new c("clean","Clean"),ke.Build=new c("build","Build"),ke.Rebuild=new c("rebuild","Rebuild"),ke.Test=new c("test","Test"),ke=c=je([R],ke),e.TaskGroup=ke;function Le(q){let $="";for(let ae=0;ae<q.length;ae++)$+=q[ae].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,ae,Te){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=$,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=Te):this._options=ae)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)$.push(ae);return Le($)}};Ze=je([R],Ze),e.ProcessExecution=Ze;let qe=class{constructor($,ae,Te){if(this._args=[],Array.isArray(ae)){if(!$)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$,this._args=ae,this._options=Te}else{if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$,this._options=ae}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)$.push(typeof ae=="string"?ae:ae.value);return Le($)}};qe=je([R],qe),e.ShellExecution=qe;var dt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class yt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=yt;let bt=f=class{constructor($,ae,Te,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=Te,this.execution=Ye,ht=rt,this.__deprecated=!0):ae===wt.Global||ae===wt.Workspace?(this.target=ae,this._name=this.name=Te,this._source=this.source=Ye,this.execution=rt,ht=lt):(this.target=ae,this._name=this.name=Te,this._source=this.source=Ye,this.execution=rt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ae=this._definition.type;(f.EmptyType===ae||f.ProcessType===ae||f.ShellType===ae||f.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=f=je([R],bt),e.Task=bt;var ft;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,ae=_t.None){this.collapsibleState=ae,I.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=je([R],vt),e.TreeItem=vt;var _t;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Ot=je([R],Ot),e.TreeDataTransferItem=Ot;let It=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,ae){this._items.set($,ae)}forEach($){this._items.forEach($)}};It=je([R],It),e.TreeDataTransfer=It;let Tt=class{constructor($,ae){this.id=$,this.color=ae}};Tt=je([R],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Lt=class{constructor($){this.id=$}};Lt=je([R],Lt),e.ThemeColor=Lt;var St;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor($,ae){if(typeof $!="string"&&(!$||!I.URI.isUri($)&&!I.URI.isUri($.uri)))throw(0,i.illegalArgument)("base");if(typeof ae!="string")throw(0,i.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=I.URI.file($),this.base=$):I.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=ae}};Mt=je([R],Mt),e.RelativePattern=Mt;let Nt=class{constructor($,ae,Te,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof ae=="string"&&(this.condition=ae),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Nt=je([R],Nt),e.Breakpoint=Nt;let Et=class extends Nt{constructor($,ae,Te,Ye,rt){super(ae,Te,Ye,rt);if($===null)throw(0,i.illegalArgument)("location");this.location=$}};Et=je([R],Et),e.SourceBreakpoint=Et;let Wt=class extends Nt{constructor($,ae,Te,Ye,rt){super(ae,Te,Ye,rt);this.functionName=$}};Wt=je([R],Wt),e.FunctionBreakpoint=Wt;let jt=class extends Nt{constructor($,ae,Te,Ye,rt,lt,ht){super(Ye,rt,lt,ht);if(!ae)throw(0,i.illegalArgument)("dataId");this.label=$,this.dataId=ae,this.canPersist=Te}};jt=je([R],jt),e.DataBreakpoint=jt;let si=class{constructor($,ae,Te){this.command=$,this.args=ae||[],this.options=Te}};si=je([R],si),e.DebugAdapterExecutable=si;let oi=class{constructor($,ae){this.port=$,this.host=ae}};oi=je([R],oi),e.DebugAdapterServer=oi;let At=class{constructor($){this.path=$}};At=je([R],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor($){this.implementation=$}};Xt=je([R],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor($,ae){this.range=$,this.expression=ae}};ai=je([R],ai),e.EvaluatableExpression=ai;var Yt;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor($,ae){this.range=$,this.text=ae}};Vt=je([R],Vt),e.InlineValueText=Vt;let gt=class{constructor($,ae,Te=!0){this.range=$,this.variableName=ae,this.caseSensitiveLookup=Te}};gt=je([R],gt),e.InlineValueVariableLookup=gt;let ci=class{constructor($,ae){this.range=$,this.expression=ae}};ci=je([R],ci),e.InlineValueEvaluatableExpression=ci;let Ut=class{constructor($,ae){this.frameId=$,this.stoppedLocation=ae}};Ut=je([R],Ut),e.InlineValueContext=Ut;var qt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=b=class extends Error{constructor($,ae=T.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri($)?$.toString(!0):$);this.code=Te?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}static FileExists($){return new b($,T.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,T.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,T.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,T.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,T.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,T.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Jt=b=je([R],Jt),e.FileSystemError=Jt;let li=class{constructor($,ae,Te){this.start=$,this.end=ae,this.kind=Te}};li=je([R],li),e.FoldingRange=li;var fi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor($,ae=[]){this.tokenTypes=$,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function Si(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class Gt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ae=0,Te=$.tokenTypes.length;ae<Te;ae++)this._tokenTypeStrToInt.set($.tokenTypes[ae],ae);for(let ae=0,Te=$.tokenModifiers.length;ae<Te;ae++)this._tokenModifierStrToInt.set($.tokenModifiers[ae],ae)}}push($,ae,Te,Ye,rt){if(typeof $=="number"&&typeof ae=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,ae,Te,Ye,rt);if(F.isRange($)&&typeof ae=="string"&&Si(Te))return this._push($,ae,Te);throw(0,i.illegalArgument)()}_push($,ae,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,rt=$.start.character,lt=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(ae);let kt=0;if(Te)for(const Ft of Te){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Ft);kt|=1<<xt>>>0}this._pushEncoded(Ye,rt,lt,ht,kt)}_pushEncoded($,ae,Te,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Ft=0,xt=0;for(let $t=0;$t<kt;$t++){let Ht=this._data[5*$t],di=this._data[5*$t+1];Ht===0?(Ht=Ft,di+=xt):Ht+=Ft,this._data[5*$t]=Ht,this._data[5*$t+1]=di,Ft=Ht,xt=di}}let lt=$,ht=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=ae}static _sortAndDeltaEncode($){let ae=[];const Te=$.length/5|0;for(let ht=0;ht<Te;ht++)ae[ht]=ht;ae.sort((ht,kt)=>{const Ft=$[5*ht],xt=$[5*kt];if(Ft===xt){const $t=$[5*ht+1],Ht=$[5*kt+1];return $t-Ht}return Ft-xt});const Ye=new Uint32Array($.length);let rt=0,lt=0;for(let ht=0;ht<Te;ht++){const kt=5*ae[ht],Ft=$[kt+0],xt=$[kt+1],$t=$[kt+2],Ht=$[kt+3],di=$[kt+4],$i=Ft-rt,Xi=$i===0?xt-lt:xt,hi=5*ht;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=$t,Ye[hi+3]=Ht,Ye[hi+4]=di,rt=Ft,lt=xt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),$):new Kt(Gt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Gt;class Kt{constructor($,ae){this.resultId=ae,this.data=$}}e.SemanticTokens=Kt;class _i{constructor($,ae,Te){this.start=$,this.deleteCount=ae,this.data=Te}}e.SemanticTokensEdit=_i;class Ci{constructor($,ae){this.resultId=ae,this.edits=$}}e.SemanticTokensEdits=Ci;var Qt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},ei=je([R],ei),e.QuickInputButtons=ei;var Di;(function(q){q[q.Default=1]="Default",q[q.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,ae,Te){this.badge=$,this.tooltip=ae,this.color=Te}static validate($){if($.badge){let ae=(0,D.nextCharLength)($.badge,0);if(ae<$.badge.length&&(ae+=(0,D.nextCharLength)($.badge,ae)),$.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor($){this.kind=$}};ti=je([R],ti),e.ColorTheme=ti;var gi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class $e{constructor($,ae){if($<0)throw(0,i.illegalArgument)("start must be positive");if(ae<0)throw(0,i.illegalArgument)("end must be positive");$<=ae?(this._start=$,this._end=ae):(this._start=ae,this._end=$)}static isNotebookRange($){return $ instanceof $e?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ae=this._start,Te=this._end;return $.start!==void 0&&(ae=$.start),$.end!==void 0&&(Te=$.end),ae===this._start&&Te===this._end?this:new $e(ae,Te)}}e.NotebookRange=$e;class Bt{constructor($,ae,Te,Ye,rt,lt,ht){this.kind=$,this.value=ae,this.languageId=Te,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ht,Bt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ae=>Bt.isNotebookCellData(ae))}static isNotebookCellData($){return!0}}e.NotebookCellData=Bt;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class mt{constructor($,ae){this.data=$,this.mime=ae;const Te=(0,P.normalizeMimeType)(ae,!0);if(!Te)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}static isNotebookCellOutputItem($){return $ instanceof mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const ae={name:$.name,message:$.message,stack:$.stack};return mt.json(ae,"application/vnd.code.notebook.error")}static stdout($){return mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,ae="application/octet-stream"){return new mt($,ae)}static text($,ae=P.Mimes.text){const Te=Be(mt,p,"f",v).encode(String($));return new mt(Te,ae)}static json($,ae="application/json"){const Te=JSON.stringify($,void 0,"	");return mt.text(Te,ae)}}e.NotebookCellOutputItem=mt,p=mt,v={value:new TextEncoder};class ii{constructor($,ae,Te){this.items=ii.ensureUniqueMimeTypes($,!0),typeof ae=="string"?(this.id=ae,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=ae??Te)}static isNotebookCellOutput($){return $ instanceof ii?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,_.isArray)($.items)}static ensureUniqueMimeTypes($,ae=!1){const Te=new Set,Ye=new Set;for(let rt=0;rt<$.length;rt++){const lt=$[rt],ht=(0,P.normalizeMimeType)(lt.mime);if(!Te.has(ht)){Te.add(ht);continue}Ye.add(rt),ae&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ii;var Ii;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,ae){this.text=$,this.alignment=ae}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,ae=[]){this.uri=$,this.provides=(0,m.asArray)(ae)}}e.NotebookRendererScript=Ri;let ni=class{constructor($,ae){this.label=$,this.timestamp=ae}};ni=je([R],ni),e.TimelineItem=ni;var Li;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,ae){this.ranges=$,this.wordPattern=ae}}e.LinkedEditingRanges=Oi;class Ni{constructor($,ae){this._port=$,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var se;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(se=e.TestResultState||(e.TestResultState={}));var ge;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ge=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor($=void 0,ae=void 0,Te=void 0){this.include=$,this.exclude=ae,this.profile=Te}};Re=je([R],Re),e.TestRunRequest=Re;let ut=d=class{constructor($){this.message=$}static diff($,ae,Te){const Ye=new d($);return Ye.expectedOutput=ae,Ye.actualOutput=Te,Ye}};ut=d=je([R],ut),e.TestMessage=ut;let Ct=class{constructor($){this.id=$}};Ct=je([R],Ct),e.TestTag=Ct;let Dt=class{constructor($,ae){this.covered=$,this.total=ae}};Dt=je([R],Dt),e.CoveredCount=Dt;let Ui=k=class{constructor($,ae,Te,Ye){this.uri=$,this.statementCoverage=ae,this.branchCoverage=Te,this.functionCoverage=Ye}static fromDetails($,ae){const Te=new Dt(0,0),Ye=new Dt(0,0),rt=new Dt(0,0);for(const ht of ae)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const kt of ht.branches)Ye.total+=1,Ye.covered+=kt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const lt=new k($,Te,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ae,lt}};Ui=k=je([R],Ui),e.FileCoverage=Ui;let Bi=class{constructor($,ae,Te=[]){this.executionCount=$,this.location=ae,this.branches=Te}};Bi=je([R],Bi),e.StatementCoverage=Bi;let xi=class{constructor($,ae){this.executionCount=$,this.location=ae}};xi=je([R],xi),e.BranchCoverage=xi;let Wi=class{constructor($,ae){this.executionCount=$,this.location=ae}};Wi=je([R],Wi),e.FunctionCoverage=Wi;var qi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,ae,Te,Ye,rt,lt){this.kind=$,this.name=ae,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(ve[122],we([0,1,56,10,8,149,109,7,16]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function L(h,p){p?I.set(h,p):I.delete(h)}e.setWordDefinitionFor=L;function T(h){return I.get(h)}e.getWordDefinitionFor=T;class l extends C.MirrorTextModel{constructor(p,v,A,w,s,o,g,a){super(v,A,w,s);this._proxy=p,this._languageId=o,this._isDirty=g,this._notebook=a,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,_.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===i.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(v){return v?p._getTextInRange(v):p.getText()},get eol(){return p._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(v){return p._lineAt(v)},offsetAt(v){return p._offsetAt(v)},positionAt(v){return p._positionAt(v)},validateRange(v){return p._validateRange(v)},validatePosition(v){return p._validatePosition(v)},getWordRangeAtPosition(v,A){return p._getWordRangeAtPosition(v,A)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,m.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,m.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const v=this._validateRange(p);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const A=this._eol,w=v.start.line,s=v.end.line,o=[];o.push(this._lines[w].substring(v.start.character));for(let g=w+1;g<s;g++)o.push(this._lines[g]);return o.push(this._lines[s].substring(0,v.end.character)),o.join(A)}_lineAt(p){let v;if(p instanceof D.Position?v=p.line:typeof p=="number"&&(v=p),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new E(v,this._lines[v],v===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(p),A=this._lines[v.index].length;return new D.Position(v.index,Math.min(v.remainder,A))}_validateRange(p){if(!(p instanceof D.Range))throw new Error("Invalid argument");const v=this._validatePosition(p.start),A=this._validatePosition(p.end);return v===p.start&&A===p.end?p:new D.Range(v.line,v.character,A.line,A.character)}_validatePosition(p){if(!(p instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:v,character:A}=p,w=!1;if(v<0)v=0,A=0,w=!0;else if(v>=this._lines.length)v=this._lines.length-1,A=this._lines[v].length,w=!0;else{const s=this._lines[v].length;A<0?(A=0,w=!0):A>s&&(A=s,w=!0)}return w?new D.Position(v,A):p}_getWordRangeAtPosition(p,v){const A=this._validatePosition(p);if(!v)v=T(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const w=(0,P.getWordAtText)(A.character+1,(0,P.ensureValidWordDefinition)(v),this._lines[A.line],0);if(w)return new D.Range(A.line,w.startColumn-1,A.line,w.endColumn-1)}}e.ExtHostDocumentData=l;class E{constructor(p,v,A){this._line=p,this._text=v,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(ve[201],we([0,1,7,3,111,6,82,24,2,32]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(l,E,h,p){this._notebook=h,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(A=>{const w=this._cellUris.get(A.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(A=>v(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const l=[],E=[];for(const h of this._notebook.getCells())h.kind===m.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),l.push(h.document.getText().length+1),E.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(l){if(!l){let w="";for(const s of this._cells)w+=s.document.getText()+`
`;return w=w.slice(0,-1),w}if(l.isEmpty)return"";const E=this.locationAt(l.start),h=this.locationAt(l.end),p=this._cellUris.get(E.uri),v=this._cellUris.get(h.uri);if(p===void 0||v===void 0)return"";if(p===v)return this._cells[p].document.getText(new m.Range(E.range.start,h.range.end));const A=[this._cells[p].document.getText(new m.Range(E.range.start,new m.Position(this._cells[p].document.lineCount,0)))];for(let w=p+1;w<v;w++)A.push(this._cells[w].document.getText());return A.push(this._cells[v].document.getText(new m.Range(new m.Position(0,0),h.range.end))),A.join(`
`)}offsetAt(l){const E=this._cellLines.getIndexOf(l.line),h=this._cellLengths.getPrefixSum(E.index-1),p=this._cells[E.index].document.offsetAt(l.with(E.remainder));return h+p}positionAt(l){if(typeof l=="number"){const h=this._cellLengths.getIndexOf(l),p=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(p)}const E=this._cellUris.get(l.uri);if(E!==void 0){const h=this._cellLines.getPrefixSum(E-1);return new m.Position(h+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const E=this._cellLines.getIndexOf(l.start.line);let h=E;l.isEmpty||(h=this._cellLines.getIndexOf(l.end.line));const p=new m.Position(E.remainder,l.start.character),v=new m.Position(h.remainder,l.end.character),A=new m.Range(p,v),w=this._cells[E.index];return new m.Location(w.document.uri,w.document.validateRange(A))}contains(l){return this._cellUris.has(l)}validateRange(l){const E=this.validatePosition(l.start),h=this.validatePosition(l.end);return l.with(E,h)}validatePosition(l){const E=this._cellLines.getIndexOf(l.line),h=new m.Position(E.remainder,l.character),p=this._cells[E.index].document.validatePosition(h),v=this._cellLines.getPrefixSum(E.index-1);return new m.Position(v+p.line,p.character)}}e.ExtHostNotebookConcatDocument=L}),define(ve[202],we([0,1,7,14,3]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(D){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?m.ColorThemeKind.Light:D==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ve[64],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class i{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=i}),define(ve[203],we([0,1,22]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function y(D,_){if(_.serializeBuffersForPostMessage){const I=new i,L=(E,h)=>{if(h instanceof ArrayBuffer){const p=I.add(h);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(h)){const p=C(h);if(p){const v=I.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:p,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},T=JSON.stringify(D,L),l=I.buffers.map(E=>{const h=new Uint8Array(E);return m.VSBuffer.wrap(h)});return{message:T,buffers:l}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=y;function C(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(D,_){const I=_.map(l=>{const E=new ArrayBuffer(l.byteLength);return new Uint8Array(E).set(l.buffer),E}),L=_.length?(l,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const h=E,{index:p}=h,v=I[p];if(h.view)switch(h.view.type){case 1:return new Int8Array(v,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return E}:void 0;return{message:JSON.parse(D,L),arrayBuffers:I}}e.deserializeWebviewMessage=P}),define(ve[204],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(i){function y(P){const D=new Map;return P.types.forEach((_,I)=>{D.set(_,{asString:async()=>P.items[I].asString})}),D}i.toITreeDataTransfer=y;async function C(P){const D={types:[],items:[]},_=Array.from(P.entries());for(const I of _)D.types.push(I[0]),D.items.push({asString:await I[1].asString()});return D}i.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[88],we([0,1,10,2]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(D,_){return D.scheme===m.Schemas.http||D.scheme===m.Schemas.https?D:(_&&_.authority&&_.isRemote&&D.scheme===m.Schemas.file&&(D=i.URI.from({scheme:m.Schemas.vscodeRemote,authority:_.authority,path:D.path})),i.URI.from({scheme:m.Schemas.https,authority:`${D.scheme}+${C(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=y;function C(D){return D.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function P(D){return D.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=P}),define(ve[205],we([0,1,3,6,88]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(D,_,I){this._proxy=D,this._editors=_,this._initData=I,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const L=_.getVisibleTextEditors();for(const T of this._insets.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,I,L,T){let l;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===D){l=s;break}if(!l)throw new Error("not a visible editor");const E=this,h=this._handlePool++,p=new m.Emitter,v=new m.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,y.asWebviewUri)(s,E._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(s){this._options=s,E._proxy.$setOptions(h,s)}get options(){return this._options}set html(s){this._html=s,E._proxy.$setHtml(h,s)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(s){return E._proxy.$postMessage(h,s)}},w=new class{constructor(){this.editor=D,this.line=_,this.height=I,this.webview=A,this.onDidDispose=v.event}dispose(){E._insets.has(h)&&(E._insets.delete(h),E._proxy.$disposeEditorInset(h),v.fire(),v.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,l.id,l.value.document.uri,_+1,I,L||{},T.identifier,T.extensionLocation),this._insets.set(h,{editor:D,inset:w,onDidReceiveMessage:p}),w}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const I=this._insets.get(D);I&&I.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(ve[206],we([0,1,171,13,2,6,4,61,51,42,16,10]),function(J,e,m,i,y,C,P,D,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new D.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new D.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new D.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(F,U,H){for(const x of H.visibleEditorPanes)if(x.group.id===U&&F.matches(x.input))return x.getViewState()}e.findViewStateForEditor=l;function E(F){if(g(F))return!1;const U=F;return y.URI.isUri(U?.resource)}e.isResourceEditorInput=E;function h(F){if(g(F))return!1;const U=F;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=h;function p(F){if(g(F)||h(F))return!1;const U=F;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function v(F){if(g(F))return!1;const U=F;return U?U.resource===void 0||U.resource.scheme===T.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var A;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(A=e.Verbosity||(e.Verbosity={}));var w;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var s;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends C.Disposable{}e.AbstractEditorInput=o;function g(F){return F instanceof o}e.isEditorInput=g;function a(F){const U=F;return y.URI.isUri(U?.preferredResource)}function S(F){const U=F;return g(U?.primary)&&g(U?.secondary)}e.isSideBySideEditorInput=S;function n(F){const U=F;return g(U?.modified)&&g(U?.original)}e.isDiffEditorInput=n;function t(F){return g(F?.editor)}e.isEditorInputWithOptions=t;function r(F){const U=F;return t(F)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function u(F){const U=F;return typeof U?.groupId=="number"&&g(U.editor)}e.isEditorIdentifier=u;var c;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(f=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var b;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(U,H){if(!U)return;if(H?.supportSideBySide){const{primary:M,secondary:W}=this.getSideEditors(U);if(M&&W){if(H?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===b.ANY)return this.getOriginalUri(M,{filterByScheme:H.filterByScheme})??this.getOriginalUri(W,{filterByScheme:H.filterByScheme});U=H.supportSideBySide===b.PRIMARY?M:W}}if(h(U)||p(U))return;const x=a(U)?U.preferredResource:U.resource;return!x||!H||!H.filterByScheme?x:this.filterUri(x,H.filterByScheme)}getSideEditors(U){return S(U)||p(U)?{primary:U.primary,secondary:U.secondary}:n(U)||h(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,H){if(!U)return;if(H?.supportSideBySide){const{primary:M,secondary:W}=this.getSideEditors(U);if(M&&W){if(H?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===b.ANY)return this.getCanonicalUri(M,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:H.filterByScheme});U=H.supportSideBySide===b.PRIMARY?M:W}}if(h(U)||p(U))return;const x=U.resource;return!x||!H||!H.filterByScheme?x:this.filterUri(x,H.filterByScheme)}filterUri(U,H){if(Array.isArray(H)){if(H.some(x=>U.scheme===x))return U}else if(H===U.scheme)return U}}e.EditorResourceAccessor=new d;var k;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(k=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const H=this.instantiationService=U.get(P.IInstantiationService);for(const[x,M]of this.editorSerializerConstructors)this.createEditorSerializer(x,M,H);this.editorSerializerConstructors.clear()}createEditorSerializer(U,H,x){const M=x.createInstance(H);this.editorSerializerInstances.set(U,M)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,H){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,H,this.instantiationService):this.editorSerializerConstructors.set(U,H),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new R);async function N(F,U){if(!F||!F.length)return[];const H=await Promise.all(F.map(async x=>{const M=y.URI.revive(x.fileUri);if(!M||!await U.canHandleResource(M))return;let z=x.exists,O=x.type;if(typeof z!="boolean"||typeof O!="number")try{O=(await U.resolve(M)).isDirectory?I.FileType.Directory:I.FileType.Unknown,z=!0}catch{z=!1}if(!z&&x.openOnlyIfExists||O===I.FileType.Directory)return;const V={selection:z?x.selection:void 0,pinned:!0,override:x.editorOverrideId};let K;return z?K={resource:M,options:V}:K={resource:M,options:V,forceUntitled:!0},K}));return(0,L.coalesce)(H)}e.pathsToEditors=N;var B;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[123],we([0,1,3,18,172]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,I,L){const T={command:D};if(_&&Object.keys(_).length>0&&(T.arguments=_),this.internalSend("request",T),typeof L=="number"){const l=setTimeout(()=>{clearTimeout(l);const E=this.pendingRequests.get(T.seq);if(E){this.pendingRequests.delete(T.seq);const h={type:"response",seq:0,request_seq:T.seq,success:!1,command:D,message:(0,y.localize)(0,null,L,D)};E(h)}},L)}return I&&this.pendingRequests.set(T.seq,I),T.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,i.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":{const _=D,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,I)=>D.set(I,_)),await(0,i.timeout)(500),D.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ve[207],we([0,1,8,2,9,25,10]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(n,t,r){return n.replace(D,function(u,c){return t&&c.length>0&&c[0]!=="_"?u:r&&r.hasOwnProperty(c)?r[c]:u})}e.formatPII=_;function I(n){const t={};for(const r of Object.keys(n))r.startsWith("!")||(t[r]=n[r]);return t}e.filterExceptionsFromTelemetry=I;function L(n){return n.configuration.request==="attach"&&!T(n)&&(!n.parentSession||L(n.parentSession))}e.isSessionAttach=L;function T(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?T(n.parentSession):void 0}e.getExtensionHostDebugSession=T;function l(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=l;function E(n,t,r){let u,c=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=f.exec(n);){let d=b.index+1,k=d+b[0].length;if(d<=t&&k>=r){u=b[0],c=d;break}}if(u){let d=/\w+/g,k=null;for(;(k=d.exec(u))&&!(k.index+1+c+k[0].length>=r););k&&(u=u.substring(0,d.lastIndex))}return u?{start:c,end:c+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(n){return!!(n&&n.match(h))}e.isUri=p;function v(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(p(n.path))return i.URI.parse(n.path);if((0,y.isAbsolute)(n.path))return i.URI.file(n.path)}return n.path}function A(n){if(typeof n.path=="object"){const t=i.URI.revive(n.path);if(t)return t.scheme===P.Schemas.file?t.fsPath:t.toString()}return n.path}function w(n,t){const r=t?v:A,u=(0,C.deepClone)(n);return o(u,(c,f)=>{c&&f&&(f.path=r(f))}),u}e.convertToDAPaths=w;function s(n,t){const r=t?v:A,u=(0,C.deepClone)(n);return o(u,(c,f)=>{!c&&f&&(f.path=r(f))}),u}e.convertToVSCPaths=s;function o(n,t){switch(n.type){case"event":{const r=n;switch(r.event){case"output":t(!1,r.body.source);break;case"loadedSource":t(!1,r.body.source);break;case"breakpoint":t(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=n;switch(r.command){case"setBreakpoints":t(!0,r.arguments.source);break;case"breakpointLocations":t(!0,r.arguments.source);break;case"source":t(!0,r.arguments.source);break;case"gotoTargets":t(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(u=>t(!1,u));break;default:break}break}case"response":{const r=n;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(u=>t(!1,u.source));break;case"loadedSources":r.body.sources.forEach(u=>t(!1,u));break;case"scopes":r.body.scopes.forEach(u=>t(!1,u.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(u=>t(!1,u.source));break;case"setBreakpoints":r.body.breakpoints.forEach(u=>t(!1,u.source));break;default:break}break}}}function g(n){return n.filter(t=>!t.presentation?.hidden).sort((t,r)=>t.presentation?r.presentation?t.presentation.group?r.presentation.group?t.presentation.group!==r.presentation.group?t.presentation.group.localeCompare(r.presentation.group):a(t.presentation.order,r.presentation.order):-1:r.presentation.group?1:a(t.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function a(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function S(n,t){const r=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(r!=="none"&&(await t.saveAll(),r==="allEditorsInActiveGroup")){const u=t.activeEditorPane;u&&await t.save({editor:u.input,groupId:u.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(ve[208],we([0,1,28,37,173,124,9,8,25,12,183,123]),function(J,e,m,i,y,C,P,D,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends T.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(w,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,w.on("data",o=>this.handleData(o))}sendMessage(w){if(this.outputStream){const s=JSON.stringify(w);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${l.TWO_CRLF}${s}`,"utf8")}}handleData(w){for(this.rawData=Buffer.concat([this.rawData,w]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.rawData.indexOf(l.TWO_CRLF);if(s!==-1){const g=this.rawData.toString("utf8",0,s).split(l.HEADER_LINESEPARATOR);for(const a of g){const S=a.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(s+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class E extends l{startSession(){return new Promise((w,s)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),w(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",g=>{o?this._onError.fire(g):s(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class h extends E{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",w)}}e.SocketDebugAdapter=h;class p extends E{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.path,w)}}e.NamedPipeDebugAdapter=p;class v extends l{constructor(w,s,o){super();this.adapterExecutable=w,this.debugType=s,this.outputService=o}async startSession(){const w=this.adapterExecutable.command,s=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(w)if(P.isAbsolute(w)){if(!await m.Promises.exists(w))throw new Error(y.localize(0,null,w))}else w.indexOf("/")<0&&w.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let g=process.env;if(o.env&&Object.keys(o.env).length>0&&(g=_.mixin(_.deepClone(process.env),o.env)),w==="node")if(Array.isArray(s)&&s.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:g,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(n.cwd=o.cwd);const t=i.fork(s[0],s.slice(1),n);if(!t.pid)throw new Error(y.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const S={env:g};o.cwd&&(S.cwd=o.cwd),this.serverProcess=i.spawn(w,s,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,n)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const a=this.outputService;if(a){const S=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=a.getChannel(L.ExtensionsChannelId);t&&t.append(S(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((w,s)=>{const o=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,a,S){if(g)return s(g)});o.on("exit",w),o.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(w,s){if(!w)return;const o=Object.create(null);w.runtime&&(w.runtime.indexOf("./")===0?o.runtime=P.join(s,w.runtime):o.runtime=w.runtime),w.runtimeArgs&&(o.runtimeArgs=w.runtimeArgs),w.program&&(P.isAbsolute(w.program)?o.program=w.program:o.program=P.join(s,w.program)),w.args&&(o.args=w.args);const g=w;return g.win&&(o.win=v.extract(g.win,s)),g.winx86&&(o.winx86=v.extract(g.winx86,s)),g.windows&&(o.windows=v.extract(g.windows,s)),g.osx&&(o.osx=v.extract(g.osx,s)),g.linux&&(o.linux=v.extract(g.linux,s)),o}static platformAdapterExecutable(w,s){let o=Object.create(null);s=s.toLowerCase();for(const r of w)if(r.contributes){const u=r.contributes.debuggers;u&&u.length>0&&u.filter(c=>typeof c.type=="string"&&D.equalsIgnoreCase(c.type,s)).forEach(c=>{const f=v.extract(c,r.extensionLocation.fsPath);o=_.mixin(o,f,r.isBuiltin)})}let g;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=o.winx86||o.win||o.windows:I.isWindows?g=o.win||o.windows:I.isMacintosh?g=o.osx:I.isLinux&&(g=o.linux),g=g||o;let a=g.program||o.program;const S=g.args||o.args;let n=g.runtime||o.runtime;const t=g.runtimeArgs||o.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(S||[])};if(a)return{type:"executable",command:a,args:S||[]}}}e.ExecutableDebugAdapter=v}),define(ve[209],we([0,1,37,12,30,185]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function P(l,E){return new Promise((h,p)=>{let v="";const A=m.spawn(l,E);A.pid&&A.stdout.on("data",w=>{v+=w.toString()}),A.on("error",w=>{p(w)}),A.on("close",w=>{h(v)})})}let D;function _(l,E){if(!D)if(i.isWindows)D=new C.WindowsExternalTerminalService;else if(i.isMacintosh)D=new C.MacExternalTerminalService;else if(i.isLinux)D=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=E.getConfiguration("terminal");return D.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}e.runInExternalTerminal=_;async function I(l){if(l)if(i.isWindows){const E=await new Promise((h,p)=>{J(["windows-process-tree"],h,p)});return new Promise(h=>{E.getProcessTree(l,p=>{h(p.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(l)]).then(E=>{const h=E.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var L;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(L||(L={}));function T(l,E,h,p){l=l.trim().toLowerCase();let v;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?v=1:l.indexOf("cmd.exe")>=0?v=0:l.indexOf("bash")>=0?v=2:i.isWindows?v=0:v=2;let A,w=" ";switch(v){case 1:if(A=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,y.getDriveLetter)(h);s&&(w+=`${s}:; `),w+=`cd ${A(h)}; `}if(p)for(let s in p){const o=p[s];o===null?w+=`Remove-Item env:${s}; `:w+=`\${env:${s}}='${o}'; `}if(E.length>0){const s=A(E.shift());w+=s[0]==="'"?`& ${s} `:`${s} `;for(let o of E)w+=`${A(o)} `}break;case 0:if(A=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,y.getDriveLetter)(h);s&&(w+=`${s}: && `),w+=`cd ${A(h)} && `}if(p){w+='cmd /C "';for(let s in p){let o=p[s];o===null?w+=`set "${s}=" && `:(o=o.replace(/[\^\&\|\<\>]/g,g=>`^${g}`),w+=`set "${s}=${o}" && `)}}for(let s of E)w+=`${A(s)} `;p&&(w+='"');break;case 2:{A=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const s=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(h&&(w+=`cd ${A(h)} ; `),p){w+="/usr/bin/env";for(let o in p){const g=p[o];g===null?w+=` -u ${s(o)}`:w+=` ${s(`${o}=${g}`)}`}w+=" "}for(let o of E)w+=`${A(o)} `;break}}return w}e.prepareCommand=T}),define(ve[125],we([0,1,31,77,101,10,9,12,61]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(d){d[d.Markup=1]="Markup",d[d.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(d){d[d.Running=1]="Running",d[d.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var T;(function(d){d[d.Pending=2]="Pending",d[d.Executing=3]="Executing"})(T=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(d){d[d.WithHardKernelDependency=0]="WithHardKernelDependency",d[d.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",d[d.Pure=2]="Pure",d[d.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(d){d.Always="always",d.Never="never",d.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(d){d[d.ModelChange=1]="ModelChange",d[d.Move=2]="Move",d[d.ChangeLanguage=5]="ChangeLanguage",d[d.Initialize=6]="Initialize",d[d.ChangeCellMetadata=7]="ChangeCellMetadata",d[d.Output=8]="Output",d[d.OutputItem=9]="OutputItem",d[d.ChangeCellContent=10]="ChangeCellContent",d[d.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",d[d.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",d[d.ChangeCellMime=13]="ChangeCellMime",d[d.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(d){d[d.Handle=0]="Handle",d[d.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(d){d[d.Replace=1]="Replace",d[d.Output=2]="Output",d[d.Metadata=3]="Metadata",d[d.CellLanguage=4]="CellLanguage",d[d.DocumentMetadata=5]="DocumentMetadata",d[d.Move=6]="Move",d[d.OutputItems=7]="OutputItems",d[d.PartialMetadata=8]="PartialMetadata",d[d.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var A;(function(d){d.scheme=C.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function R(x,M){return x.with({scheme:d.scheme,fragment:`ch${M.toString().padStart(7,"0")}${x.scheme!==C.Schemas.file?x.scheme:""}`})}d.generate=R;function N(x){if(x.scheme!==d.scheme)return;const M=k.exec(x.fragment);return M?{handle:Number(M[1]),notebook:x.with({scheme:x.fragment.substr(M[0].length)||C.Schemas.file,fragment:null})}:void 0}d.parse=N;function B(x,M,W){return x.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${M.toString().padStart(7,"0")},${W??""},${x.scheme!==C.Schemas.file?x.scheme:""}`})}d.generateCellOutputUri=B;function F(x){if(x.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const M=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!M)return;const W=Number(M[1]),z=M[2]&&M[2]!==""?M[2]:void 0,O=M[3];return{handle:W,outputId:z,notebook:x.with({scheme:O||C.Schemas.file,fragment:null})}}d.parseCellOutputUri=F;function U(x,M,W){return x.with({scheme:W,fragment:`ch${M.toString().padStart(7,"0")}${x.scheme!==C.Schemas.file?x.scheme:""}`})}d.generateCellUri=U;function H(x,M){if(x.scheme!==M)return;const W=k.exec(x.fragment);return W?{handle:Number(W[1]),notebook:x.with({scheme:x.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}d.parseCellUri=H})(A=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(d){return w.get(d)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function o(d){return w.get(d)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function g(d){return w.get(d)?.mergeable??!1}e.mimeTypeIsMergeable=g;const a=d=>D.isWindows?d.replace(/\//g,"\\"):d;class S{constructor(k=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(k)].map(N=>({pattern:N,matches:m.parse(a(N))}))}sort(k){const R=new Map(i.Iterable.map(k,B=>[B,a(B)]));let N=[];for(const{matches:B}of this.order)for(const[F,U]of R)if(B(U)){N.push(F),R.delete(F);break}return R.size&&(N=N.concat([...R.keys()].sort((B,F)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(F)))),N}prioritize(k,R){const N=this.findIndex(k);if(N===-1){this.order.unshift({pattern:k,matches:m.parse(a(k))});return}const B=new Set(R.map(U=>this.findIndex(U,N)));B.delete(-1);const F=Array.from(B).sort();this.order.splice(N+1,0,...F.map(U=>this.order[U]));for(let U=F.length-1;U>=0;U--)this.order.splice(F[U],1)}toArray(){return this.order.map(k=>k.pattern)}findIndex(k,R=this.order.length){const N=a(k);for(let B=0;B<R;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=S;function n(d,k,R,N=(B,F)=>B===F){const B=[];function F(x,M,W){if(M===0&&W.length===0)return;const z=B[B.length-1];z&&z.start+z.deleteCount===x?(z.deleteCount+=M,z.toInsert.push(...W)):B.push({start:x,deleteCount:M,toInsert:W})}let U=0,H=0;for(;;){if(U===d.length){F(U,0,k.slice(H));break}if(H===k.length){F(U,d.length-U,[]);break}const x=d[U],M=k[H];if(N(x,M)){U+=1,H+=1;continue}R(M)?(F(U,1,[]),U+=1):(F(U,0,[M]),H+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(d){d.default="default",d.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(d){const k=d;return!!((typeof k.include=="string"||m.isRelativePattern(k.include))&&(typeof k.exclude=="string"||m.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=r;function u(d,k,R){if(Array.isArray(d.viewType)&&d.viewType.indexOf(k)>=0||d.viewType===k)return!0;if(d.filenamePattern){let N=r(d.filenamePattern)?d.filenamePattern.include:d.filenamePattern,B=r(d.filenamePattern)?d.filenamePattern.exclude:void 0;if(m.match(N,(0,P.basename)(R.fsPath).toLowerCase()))return!(B&&m.match(B,(0,P.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class c{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)k[R]=this.textModel.cells[R].getHashValue();return k}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(d){d[d.Left=1]="Left",d[d.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class b{static create(k){return`${b._prefix}${k}`}static parse(k){if(k.startsWith(b._prefix))return k.substr(b._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=b,b._prefix="notebook/"}),define(ve[210],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(ve[211],we([0,1,4,61]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[212],we([0,1,175,4,61]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[213],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=m;function i(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=i}),define(ve[126],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var i;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable"})(i=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(T){T[T.Error=0]="Error",T[T.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(T,l)=>{l.expand!==void 0&&(T.expand=l.expand),l.item!==void 0&&(T.item=T.item?Object.assign(T.item,l.item):l.item)};e.applyTestItemUpdate=P;var D;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var _;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.Remove=2]="Remove",T[T.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",T[T.Retire=4]="Retire",T[T.AddTag=5]="AddTag",T[T.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(l){}update(l){}remove(l,E){}complete(){}}e.IncrementalChangeCollector=I;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const E=this.createChangeCollector();for(const h of l)switch(h[0]){case 0:{const p=h[1];if(p.parent){if(this.items.has(p.parent)){const v=this.items.get(p.parent);v.children.add(p.item.extId);const A=this.createItem(p,v);this.items.set(p.item.extId,A),E.add(A)}}else{const v=this.createItem(p);this.roots.add(v),this.items.set(p.item.extId,v),E.add(v)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=h[1],v=this.items.get(p.extId);if(!v)break;p.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,p),E.update(v);break}case 2:{const p=this.items.get(h[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const v=[[h[1]]];for(;v.length;)for(const A of v.pop()){const w=this.items.get(A);w&&(v.push(w.children),this.items.delete(A),E.remove(w,w!==p),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}E.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=L}),define(ve[89],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class y{constructor(P,D=P.length){if(this.path=P,this.viewEnd=D,P.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,D,_=P.parent){if(P.id===D)return new y([D]);let I=[P.id];for(let L=_;L&&L.id!==D;L=L.parent)I.push(L.id);return I.push(D),new y(I.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new y(P.split("\0"))}static join(P,D){return new y([...P.path,D])}static joinToString(P,D){return P.toString()+"\0"+D}static compare(P,D){return P===D?0:D.startsWith(P+"\0")?2:P.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new y(this.path,P)}compare(P){if(typeof P=="string")return y.compare(this.toString(),P);for(let D=0;D<P.viewEnd&&D<this.viewEnd;D++)if(P.path[D]!==this.path[D])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=y}),define(ve[214],we([0,1,9,40,13,25,12,80,176]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(T,l,E){this._contributedVariables=new Map,this._context=T,this._labelService=l,E&&(this._envVariablesPromise=E.then(h=>this.prepareEnv(h)))}prepareEnv(T){if(P.isWindows){const l=Object.create(null);return Object.keys(T).forEach(E=>{l[E.toLowerCase()]=T[E]}),l}return T}resolveWithEnvironment(T,l,E){return this.recursiveResolve(this.prepareEnv(T),l?l.uri:void 0,E)}async resolveAsync(T,l){return this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,l)}async resolveAnyBase(T,l,E,h){const p=C.deepClone(l);return P.isWindows&&p.windows?Object.keys(p.windows).forEach(v=>p[v]=p.windows[v]):P.isMacintosh&&p.osx?Object.keys(p.osx).forEach(v=>p[v]=p.osx[v]):P.isLinux&&p.linux&&Object.keys(p.linux).forEach(v=>p[v]=p.linux[v]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,p,E,h)}async resolveAnyAsync(T,l,E){return this.resolveAnyBase(T,l,E)}async resolveAnyMap(T,l,E){const h=new Map;return{newConfig:await this.resolveAnyBase(T,l,E,h),resolvedVariables:h}}resolveWithInteractionReplace(T,l,E,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,l,E,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,l){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,l)}recursiveResolve(T,l,E,h,p){if(y.isString(E))return this.resolveString(T,l,E,h,p);if(y.isArray(E))return E.map(v=>this.recursiveResolve(T,l,v,h,p));if(y.isObject(E)){let v=Object.create(null);return Object.keys(E).forEach(A=>{const w=this.resolveString(T,l,A,h,p);v[w]=this.recursiveResolve(T,l,E[A],h,p)}),v}return E}resolveString(T,l,E,h,p){return E.replace(I.VARIABLE_REGEXP,(A,w)=>{if(w.includes(I.VARIABLE_LHS))return A;let s=this.evaluateSingleVariable(T,A,w,l,h);return p&&p.set(w,s),s!==A&&y.isString(s)&&s.match(I.VARIABLE_REGEXP)&&(s=this.resolveString(T,l,s,h,p)),s})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,l,E,h,p){let v;const A=E.split(":");A.length>1&&(E=A[0],v=A[1]);const w=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,_.localize)(0,null,l))},s=()=>{const g=w();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,_.localize)(1,null,l,m.basename(g)))},o=()=>{if(v){const g=this._context.getFolderUri(v);if(g)return g;throw new Error((0,_.localize)(2,null,l,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(E){case"env":if(v){if(T){const g=T[P.isWindows?v.toLowerCase():v];if(y.isString(g))return g}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(v){const g=this._context.getConfigurationValue(h,v);if(y.isUndefinedOrNull(g))throw new Error((0,_.localize)(6,null,l,v));if(y.isObject(g))throw new Error((0,_.localize)(7,null,l,v));return g}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,v,p,"command");case"input":return this.resolveFromMap(l,v,p,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return h||v?(0,D.normalizeDriveLetter)(this.fsPath(o())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(o()));case"lineNumber":{const g=this._context.getLineNumber();if(g)return g;throw new Error((0,_.localize)(9,null,l))}case"selectedText":{const g=this._context.getSelectedText();if(g)return g;throw new Error((0,_.localize)(10,null,l))}case"file":return w();case"fileWorkspaceFolder":return s();case"relativeFile":return h||v?m.relative(this.fsPath(o()),w()):w();case"relativeFileDirname":{const g=m.dirname(w());if(h||v){const a=m.relative(this.fsPath(o()),g);return a.length===0?".":a}return g}case"fileDirname":return m.dirname(w());case"fileExtname":return m.extname(w());case"fileBasename":return m.basename(w());case"fileBasenameNoExtension":{const g=m.basename(w());return g.slice(0,g.length-m.extname(g).length)}case"fileDirnameBasename":return m.basename(m.dirname(w()));case"execPath":{const g=this._context.getExecPath();return g||l}case"execInstallFolder":{const g=this._context.getAppRoot();return g||l}case"pathSeparator":return m.sep;default:try{const g=v?`${E}:${v}`:E;return this.resolveFromMap(l,g,p,void 0)}catch{return l}}}}resolveFromMap(T,l,E,h){if(l&&E){const p=h===void 0?E[l]:E[h+":"+l];if(typeof p=="string")return p;throw new Error((0,_.localize)(11,null,T))}return T}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[127],we([0,1,4,206]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var D;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(h){const p=h;return(0,i.isEditorInput)(p?.editor)&&(0,i.isEditorInput)(p?.replacement)}e.isEditorReplacement=I;var L;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function l(h){const p=h;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=l;function E(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(ve[215],we([0,1,4,127]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const P=C;return typeof C=="number"||(0,i.isEditorGroup)(P)}e.isPreferredGroup=y}),define(ve[17],we([0,1,16,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(he){function De(X){const{selectionStartLineNumber:ke,selectionStartColumn:Le,positionLineNumber:Ze,positionColumn:qe}=X,dt=new w.Position(ke-1,Le-1),wt=new w.Position(Ze-1,qe-1);return new w.Selection(dt,wt)}he.to=De;function ce(X){const{anchor:ke,active:Le}=X;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}he.from=ce})(s=e.Selection||(e.Selection={}));var o;(function(he){function De(X){if(!X)return;const{start:ke,end:Le}=X;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}he.from=De;function ce(X){if(!X)return;const{startLineNumber:ke,startColumn:Le,endLineNumber:Ze,endColumn:qe}=X;return new w.Range(ke-1,Le-1,Ze-1,qe-1)}he.to=ce})(o=e.Range||(e.Range={}));var g;(function(he){function De(ce){switch(ce){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}he.to=De})(g=e.TokenType||(e.TokenType={}));var a;(function(he){function De(X){return new w.Position(X.lineNumber-1,X.column-1)}he.to=De;function ce(X){return{lineNumber:X.line+1,column:X.character+1}}he.from=ce})(a=e.Position||(e.Position={}));var S;(function(he){function De(ke,Le){return(0,m.coalesce)((0,m.asArray)(ke).map(Ze=>ce(Ze,Le)))}he.from=De;function ce(ke,Le){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:X(ke.scheme,Le),pattern:typeof ke.pattern=="undefined"?void 0:ee.from(ke.pattern),exclusive:ke.exclusive}}function X(ke,Le){return Le&&typeof ke=="string"?Le.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(he){function De(X){switch(X){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}he.from=De;function ce(X){switch(X){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}he.to=ce})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(he){function De(X){let ke;return X.code&&((0,_.isString)(X.code)||(0,_.isNumber)(X.code)?ke=String(X.code):ke={value:String(X.code.value),target:X.code.target}),{...o.from(X.range),message:X.message,source:X.source,code:ke,severity:u.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(r.from),tags:Array.isArray(X.tags)?(0,m.coalesce)(X.tags.map(n.from)):void 0}}he.from=De;function ce(X){const ke=new w.Diagnostic(o.to(X),X.message,u.to(X.severity));return ke.source=X.source,ke.code=(0,_.isString)(X.code)?X.code:X.code?.value,ke.relatedInformation=X.relatedInformation&&X.relatedInformation.map(r.to),ke.tags=X.tags&&(0,m.coalesce)(X.tags.map(n.to)),ke}he.to=ce})(t=e.Diagnostic||(e.Diagnostic={}));var r;(function(he){function De(X){return{...o.from(X.location.range),message:X.message,resource:X.location.uri}}he.from=De;function ce(X){return new w.DiagnosticRelatedInformation(new w.Location(X.resource,o.to(X)),X.message)}he.to=ce})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(he){function De(X){switch(X){case w.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}he.from=De;function ce(X){switch(X){case E.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}he.to=ce})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(he){function De(X){return typeof X=="number"&&X>=w.ViewColumn.One?X-1:X===w.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}he.from=De;function ce(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}he.to=ce})(c=e.ViewColumn||(e.ViewColumn={}));function f(he){return typeof he.range!="undefined"}function b(he){return he.length===0?!0:!!f(he[0])}e.isDecorationOptionsArr=b;var d;(function(he){function De(qe){return qe.map(he.from)}he.fromMany=De;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function X(qe){let dt;if(ce(qe)){const{language:ft,value:vt}=qe;dt={value:"```"+ft+`
`+vt+"\n```\n"}}else w.MarkdownString.isMarkdownString(qe)?dt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?dt={value:qe}:dt={value:""};const wt=Object.create(null);dt.uris=wt;const yt=ft=>{try{let vt=I.URI.parse(ft,!0);vt=vt.with({query:ke(vt.query,wt)}),wt[ft]=vt}catch{}return""},bt=new C.Renderer;return bt.link=yt,bt.image=ft=>yt(y.parseHrefAndDimensions(ft).href),C(dt.value,{renderer:bt}),dt}he.from=X;function ke(qe,dt){if(!qe)return qe;let wt;try{wt=(0,P.parse)(qe)}catch{}if(!wt)return qe;let yt=!1;return wt=(0,D.cloneAndChange)(wt,bt=>{if(I.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ft]=bt,yt=!0,ft}else return}),yt?JSON.stringify(wt):qe}function Le(qe){const dt=new w.MarkdownString(qe.value,qe.supportThemeIcons);return dt.isTrusted=qe.isTrusted,dt.supportHtml=qe.supportHtml,dt}he.to=Le;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:he.from(qe)}he.fromStrict=Ze})(d=e.MarkdownString||(e.MarkdownString={}));function k(he){return b(he)?he.map(De=>({range:o.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?d.fromMany(De.hoverMessage):De.hoverMessage?d.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):he.map(De=>({range:o.from(De)}))}e.fromRangeOrRangeWithMessage=k;function R(he){return typeof he=="undefined"?he:typeof he=="string"?I.URI.file(he):he}e.pathOrURIToURI=R;var N;(function(he){function De(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?R(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}he.from=De})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(he){function De(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?R(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?N.from(ce.before):void 0,after:ce.after?N.from(ce.after):void 0}}he.from=De})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(he){function De(ce){if(typeof ce=="undefined")return ce;switch(ce){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}he.from=De})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(he){function De(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?F.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?B.from(ce.light):void 0,dark:ce.dark?B.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?R(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?N.from(ce.before):void 0,after:ce.after?N.from(ce.after):void 0}}he.from=De})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(he){function De(X){return{text:X.newText,eol:X.newEol&&ct.from(X.newEol),range:o.from(X.range)}}he.from=De;function ce(X){const ke=new w.TextEdit(o.to(X.range),X.text);return ke.newEol=typeof X.eol=="undefined"?void 0:ct.to(X.eol),ke}he.to=ce})(H=e.TextEdit||(e.TextEdit={}));var x;(function(he){function De(X,ke,Le){const Ze={edits:[]};if(X instanceof w.WorkspaceEdit)for(let qe of X._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const dt=ke?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:H.from(qe.edit),modelVersionId:dt?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ue.from)}});return Ze}he.from=De;function ce(X){const ke=new w.WorkspaceEdit;for(const Le of X.edits)Le.edit?ke.replace(I.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):ke.renameFile(I.URI.revive(Le.oldUri),I.URI.revive(Le.newUri),Le.options);return ke}he.to=ce})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(he){const De=Object.create(null);De[w.SymbolKind.File]=0,De[w.SymbolKind.Module]=1,De[w.SymbolKind.Namespace]=2,De[w.SymbolKind.Package]=3,De[w.SymbolKind.Class]=4,De[w.SymbolKind.Method]=5,De[w.SymbolKind.Property]=6,De[w.SymbolKind.Field]=7,De[w.SymbolKind.Constructor]=8,De[w.SymbolKind.Enum]=9,De[w.SymbolKind.Interface]=10,De[w.SymbolKind.Function]=11,De[w.SymbolKind.Variable]=12,De[w.SymbolKind.Constant]=13,De[w.SymbolKind.String]=14,De[w.SymbolKind.Number]=15,De[w.SymbolKind.Boolean]=16,De[w.SymbolKind.Array]=17,De[w.SymbolKind.Object]=18,De[w.SymbolKind.Key]=19,De[w.SymbolKind.Null]=20,De[w.SymbolKind.EnumMember]=21,De[w.SymbolKind.Struct]=22,De[w.SymbolKind.Event]=23,De[w.SymbolKind.Operator]=24,De[w.SymbolKind.TypeParameter]=25;function ce(ke){return typeof De[ke]=="number"?De[ke]:6}he.from=ce;function X(ke){for(const Le in De)if(De[Le]===ke)return Number(Le);return w.SymbolKind.Property}he.to=X})(M=e.SymbolKind||(e.SymbolKind={}));var W;(function(he){function De(X){switch(X){case w.SymbolTag.Deprecated:return 1}}he.from=De;function ce(X){switch(X){case 1:return w.SymbolTag.Deprecated}}he.to=ce})(W=e.SymbolTag||(e.SymbolTag={}));var z;(function(he){function De(X){return{name:X.name,kind:M.from(X.kind),tags:X.tags&&X.tags.map(W.from),containerName:X.containerName,location:Q.from(X.location)}}he.from=De;function ce(X){const ke=new w.SymbolInformation(X.name,M.to(X.kind),X.containerName,Q.to(X.location));return ke.tags=X.tags&&X.tags.map(W.to),ke}he.to=ce})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(he){function De(X){const ke={name:X.name||"!!MISSING: name!!",detail:X.detail,range:o.from(X.range),selectionRange:o.from(X.selectionRange),kind:M.from(X.kind),tags:X.tags?.map(W.from)??[]};return X.children&&(ke.children=X.children.map(De)),ke}he.from=De;function ce(X){const ke=new w.DocumentSymbol(X.name,X.detail,M.to(X.kind),o.to(X.range),o.to(X.selectionRange));return(0,m.isNonEmptyArray)(X.tags)&&(ke.tags=X.tags.map(W.to)),X.children&&(ke.children=X.children.map(ce)),ke}he.to=ce})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var V;(function(he){function De(X){const ke=new w.CallHierarchyItem(M.to(X.kind),X.name,X.detail||"",I.URI.revive(X.uri),o.to(X.range),o.to(X.selectionRange));return ke._sessionId=X._sessionId,ke._itemId=X._itemId,ke}he.to=De;function ce(X,ke,Le){if(ke=ke??X._sessionId,Le=Le??X._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,name:X.name,detail:X.detail,kind:M.from(X.kind),uri:X.uri,range:o.from(X.range),selectionRange:o.from(X.selectionRange),tags:X.tags?.map(W.from)}}he.from=ce})(V=e.CallHierarchyItem||(e.CallHierarchyItem={}));var K;(function(he){function De(ce){return new w.CallHierarchyIncomingCall(V.to(ce.from),ce.fromRanges.map(X=>o.to(X)))}he.to=De})(K=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(he){function De(ce){return new w.CallHierarchyOutgoingCall(V.to(ce.to),ce.fromRanges.map(X=>o.to(X)))}he.to=De})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(he){function De(X){return{range:X.range&&o.from(X.range),uri:X.uri}}he.from=De;function ce(X){return new w.Location(I.URI.revive(X.uri),o.to(X.range))}he.to=ce})(Q=e.location||(e.location={}));var Y;(function(he){function De(X){const ke=X,Le=X;return{originSelectionRange:ke.originSelectionRange?o.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Le.uri,range:o.from(ke.targetRange?ke.targetRange:Le.range),targetSelectionRange:ke.targetSelectionRange?o.from(ke.targetSelectionRange):void 0}}he.from=De;function ce(X){return{targetUri:I.URI.revive(X.uri),targetRange:o.to(X.range),targetSelectionRange:X.targetSelectionRange?o.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?o.to(X.originSelectionRange):void 0}}he.to=ce})(Y=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(he){function De(X){return{range:o.from(X.range),contents:d.fromMany(X.contents)}}he.from=De;function ce(X){return new w.Hover(X.contents.map(d.to),o.to(X.range))}he.to=ce})(fe=e.Hover||(e.Hover={}));var me;(function(he){function De(X){return{range:o.from(X.range),expression:X.expression}}he.from=De;function ce(X){return new w.EvaluatableExpression(o.to(X.range),X.expression)}he.to=ce})(me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(he){function De(X){if(X instanceof w.InlineValueText)return{type:"text",range:o.from(X.range),text:X.text};if(X instanceof w.InlineValueVariableLookup)return{type:"variable",range:o.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}he.from=De;function ce(X){switch(X.type){case"text":return{range:o.to(X.range),text:X.text};case"variable":return{range:o.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:o.to(X.range),expression:X.expression}}}he.to=ce})(Se=e.InlineValue||(e.InlineValue={}));var Ie;(function(he){function De(X){return{frameId:X.frameId,stoppedLocation:o.from(X.stoppedLocation)}}he.from=De;function ce(X){return new w.InlineValueContext(X.frameId,o.to(X.stoppedLocation))}he.to=ce})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(he){function De(X){return{range:o.from(X.range),kind:X.kind}}he.from=De;function ce(X){return new w.DocumentHighlight(o.to(X.range),X.kind)}he.to=ce})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var We;(function(he){function De(ce){switch(ce){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}he.to=De})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var j;(function(he){function De(ce){return{triggerKind:We.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}he.to=De})(j=e.CompletionContext||(e.CompletionContext={}));var Z;(function(he){function De(X){switch(X){case w.CompletionItemTag.Deprecated:return 1}}he.from=De;function ce(X){switch(X){case 1:return w.CompletionItemTag.Deprecated}}he.to=ce})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(he){const De=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ce(Le){return De.get(Le)??9}he.from=ce;const X=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function ke(Le){return X.get(Le)??w.CompletionItemKind.Property}he.to=ke})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(he){function De(ce,X){const ke=new w.CompletionItem(ce.label);return ke.insertText=ce.insertText,ke.kind=re.to(ce.kind),ke.tags=ce.tags?.map(Z.to),ke.detail=ce.detail,ke.documentation=y.isMarkdownString(ce.documentation)?d.to(ce.documentation):ce.documentation,ke.sortText=ce.sortText,ke.filterText=ce.filterText,ke.preselect=ce.preselect,ke.commitCharacters=ce.commitCharacters,L.Range.isIRange(ce.range)?ke.range=o.to(ce.range):typeof ce.range=="object"&&(ke.range={inserting:o.to(ce.range.insert),replacing:o.to(ce.range.replace)}),ke.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?ke.insertText=new w.SnippetString(ce.insertText):(ke.insertText=ce.insertText,ke.textEdit=ke.range instanceof w.Range?new w.TextEdit(ke.range,ke.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(ke.additionalTextEdits=ce.additionalTextEdits.map(Le=>H.to(Le))),ke.command=X&&ce.command?X.fromInternal(ce.command):void 0,ke}he.to=De})(ue=e.CompletionItem||(e.CompletionItem={}));var te;(function(he){function De(X){return{label:X.label,documentation:X.documentation?d.fromStrict(X.documentation):void 0}}he.from=De;function ce(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?d.to(X.documentation):X.documentation}}he.to=ce})(te=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(he){function De(X){return{label:X.label,documentation:X.documentation?d.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(te.from):[],activeParameter:X.activeParameter}}he.from=De;function ce(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?d.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(te.to):[],activeParameter:X.activeParameter}}he.to=ce})(oe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(he){function De(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.from):[]}}he.from=De;function ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.to):[]}}he.to=ce})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Ne;(function(he){function De(X){return{text:X.text,position:a.from(X.position),kind:Ve.from(X.kind??w.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}he.from=De;function ce(X){const ke=new w.InlayHint(X.text,a.to(X.position),Ve.to(X.kind));return ke.whitespaceAfter=X.whitespaceAfter,ke.whitespaceBefore=X.whitespaceBefore,ke}he.to=ce})(Ne=e.InlayHint||(e.InlayHint={}));var Ve;(function(he){function De(X){return X}he.from=De;function ce(X){return X}he.to=ce})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ge;(function(he){function De(X){return{range:o.from(X.range),url:X.target,tooltip:X.tooltip}}he.from=De;function ce(X){let ke;if(X.url)try{ke=typeof X.url=="string"?I.URI.parse(X.url,!0):I.URI.revive(X.url)}catch{}return new w.DocumentLink(o.to(X.range),ke)}he.to=ce})(Ge=e.DocumentLink||(e.DocumentLink={}));var Je;(function(he){function De(X){const ke=new w.ColorPresentation(X.label);return X.textEdit&&(ke.textEdit=H.to(X.textEdit)),X.additionalTextEdits&&(ke.additionalTextEdits=X.additionalTextEdits.map(Le=>H.to(Le))),ke}he.to=De;function ce(X){return{label:X.label,textEdit:X.textEdit?H.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(ke=>H.from(ke)):void 0}}he.from=ce})(Je=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(he){function De(X){return new w.Color(X[0],X[1],X[2],X[3])}he.to=De;function ce(X){return[X.red,X.green,X.blue,X.alpha]}he.from=ce})(tt=e.Color||(e.Color={}));var ot;(function(he){function De(X){return{range:o.from(X.range)}}he.from=De;function ce(X){return new w.SelectionRange(o.to(X.range))}he.to=ce})(ot=e.SelectionRange||(e.SelectionRange={}));var et;(function(he){function De(ce){switch(ce){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}he.to=De})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(he){function De(X){switch(X){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}he.from=De;function ce(X){switch(X){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}he.to=ce})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(he){function De(X){if(X===w.EndOfLine.CRLF)return 1;if(X===w.EndOfLine.LF)return 0}he.from=De;function ce(X){if(X===1)return w.EndOfLine.CRLF;if(X===0)return w.EndOfLine.LF}he.to=ce})(ct=e.EndOfLine||(e.EndOfLine={}));var pt;(function(he){function De(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}he.from=De})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(he){function De(ce){const X={start:ce.start+1,end:ce.end+1};return ce.kind&&(X.kind=xe.from(ce.kind)),X}he.from=De})(Pt=e.FoldingRange||(e.FoldingRange={}));var xe;(function(he){function De(ce){if(ce)switch(ce){case w.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}he.from=De})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(he){function De(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?o.from(ce.selection):void 0,override:typeof ce.override=="boolean"?l.EditorResolution.DISABLED:void 0}}he.from=De})(Rt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ee;(function(he){function De(X){return X instanceof w.RelativePattern||typeof X=="string"?X:ce(X)?new w.RelativePattern(X.base,X.pattern):X}he.from=De;function ce(X){const ke=X;return ke&&typeof ke.base=="string"&&typeof ke.pattern=="string"}})(ee=e.GlobPattern||(e.GlobPattern={}));var ne;(function(he){function De(ce){if(ce){if(Array.isArray(ce))return ce.map(De);if(typeof ce=="string")return ce;{const X=ce;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:ee.from(X.pattern),exclusive:X.exclusive}}}else return}he.from=De})(ne=e.LanguageSelector||(e.LanguageSelector={}));var pe;(function(he){function De(X){return{start:X.start,end:X.end}}he.from=De;function ce(X){return new w.NotebookRange(X.start,X.end)}he.to=ce})(pe=e.NotebookRange||(e.NotebookRange={}));var ie;(function(he){function De(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}he.to=De;function ce(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}he.from=ce})(ie=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var _e;(function(he){function De(X){switch(X){case w.NotebookCellKind.Markup:return p.CellKind.Markup;case w.NotebookCellKind.Code:default:return p.CellKind.Code}}he.from=De;function ce(X){switch(X){case p.CellKind.Markup:return w.NotebookCellKind.Markup;case p.CellKind.Code:default:return w.NotebookCellKind.Code}}he.to=ce})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var Fe;(function(he){function De(X){const ke={metadata:X.metadata??Object.create(null),cells:[]};for(let Le of X.cells)w.NotebookCellData.validate(Le),ke.cells.push(Ue.from(Le));return ke}he.from=De;function ce(X){const ke=new w.NotebookData(X.cells.map(Ue.to));return(0,_.isEmptyObject)(X.metadata)||(ke.metadata=X.metadata),ke}he.to=ce})(Fe=e.NotebookData||(e.NotebookData={}));var Ue;(function(he){function De(X){return{cellKind:_e.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:ie.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ae.from):[]}}he.from=De;function ce(X){return new w.NotebookCellData(_e.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ae.to):void 0,X.metadata,X.internalMetadata?ie.to(X.internalMetadata):void 0)}he.to=ce})(Ue=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(he){function De(X){return{mime:X.mime,valueBytes:i.VSBuffer.wrap(X.data)}}he.from=De;function ce(X){return new w.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}he.to=ce})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(he){function De(X){return{outputId:X.id,items:X.items.map(Xe.from),metadata:X.metadata}}he.from=De;function ce(X){const ke=X.items.map(Xe.to);return new w.NotebookCellOutput(ke,X.outputId,X.metadata)}he.to=ce})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(he){function De(Le){if(Le!=null){if(Le instanceof w.RelativePattern||typeof Le=="string")return Le;if(ke(Le))return new w.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:ee.from(Le.include)||void 0,exclude:ee.from(Le.exclude)||void 0}}}he.from=De;function ce(Le){return typeof Le=="string"?Le:ke(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}he.to=ce;function X(Le){const Ze=Le,qe=ee.from(Ze.include);if(!(qe&&qe instanceof w.RelativePattern||typeof qe=="string"))return!1;const dt=ee.from(Ze.exclude);return!!(dt&&dt instanceof w.RelativePattern||typeof dt=="string")}function ke(Le){const Ze=Le;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(he){function De(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?N.from(ce.top):void 0}}he.from=De})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var le;(function(he){function De(ce,X,ke){const Le=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,ke),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}he.from=De})(le=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(he){function De(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}he.from=De})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(he){function De(X){return{uri:X.uri,provides:X.provides}}he.from=De;function ce(X){return new w.NotebookRendererScript(I.URI.revive(X.uri),X.provides)}he.to=ce})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ce;(function(he){function De(X){return{message:d.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?Q.from(X.location):void 0}}he.from=De;function ce(X){const ke=new w.TestMessage(typeof X.message=="string"?X.message:d.to(X.message));return ke.actualOutput=X.actual,ke.expectedOutput=X.expected,ke.location=X.location?Q.to(X.location):void 0,ke}he.to=ce})(Ce=e.TestMessage||(e.TestMessage={}));var Me;(function(he){let De;(function(ce){ce.Delimiter="\0"})(De||(De={})),he.namespace=(ce,X)=>ce+"\0"+X,he.denamespace=ce=>{const X=ce.indexOf("\0");return{ctrlId:ce.slice(0,X),tagId:ce.slice(X+1)}}})(Me=e.TestTag||(e.TestTag={}));var Ke;(function(he){function De(Le){const Ze=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:v.TestId.fromExtHostTestItem(Le,Ze).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Me.namespace(Ze,qe.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&d.fromStrict(Le.error)||null}}he.from=De;function ce(Le){return{parent:void 0,error:void 0,id:v.TestId.fromString(Le.extId).localId,label:Le.label,uri:I.URI.revive(Le.uri),tags:(Le.tags||[]).map(Ze=>{const{tagId:qe}=Me.denamespace(Ze);return new w.TestTag(qe)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}he.toPlain=ce;function X(Le){const Ze=v.TestId.fromString(Le.extId),qe=new h.TestItemImpl(Ze.controllerId,Ze.localId,Le.label,I.URI.revive(Le.uri));return qe.range=o.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function ke(Le){let Ze;for(const qe of Le.tests){const dt=X(qe.item);(0,h.getPrivateApiFor)(dt).parent=Ze,Ze=dt}return Ze}he.toItemFromContext=ke})(Ke=e.TestItem||(e.TestItem={})),function(he){function De(X){return{id:X.id}}he.from=De;function ce(X){return new w.TestTag(X.id)}he.to=ce}(Me=e.TestTag||(e.TestTag={}));var He;(function(he){const De=(X,ke)=>{const Le={...Ke.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(Ce.to)})),children:X.children.map(Ze=>ke.get(Ze)).filter(_.isDefined).map(Ze=>De(Ze,ke))};for(const Ze of Le.children)Ze.parent=Le;return Le};function ce(X){const ke=[],Le=new Map;for(const Ze of X.items)Le.set(Ze.item.extId,Ze),X.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&ke.push(Ze);return{completedAt:X.completedAt,results:ke.map(Ze=>De(Ze,Le))}}he.to=ce})(He=e.TestResults||(e.TestResults={}));var Qe;(function(he){function De(Le){return{covered:Le.covered,total:Le.covered}}function ce(Le){return"line"in Le?a.from(Le):o.from(Le)}function X(Le){return"branches"in Le?{count:Le.executionCount,location:ce(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Le.executionCount,location:ce(Le.location)}}he.fromDetailed=X;function ke(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(X)}}he.fromFile=ke})(Qe=e.TestCoverage||(e.TestCoverage={}));var st;(function(he){function De(ce){switch(ce){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}he.to=De})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(he){function De(X){const ke=new w.TypeHierarchyItem(M.to(X.kind),X.name,X.detail||"",I.URI.revive(X.uri),o.to(X.range),o.to(X.selectionRange));return ke._sessionId=X._sessionId,ke._itemId=X._itemId,ke}he.to=De;function ce(X,ke,Le){if(ke=ke??X._sessionId,Le=Le??X._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,kind:M.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:o.from(X.range),selectionRange:o.from(X.selectionRange),tags:X.tags?.map(W.from)}}he.from=ce})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[216],we([0,1,2,15,7,17,93]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(I,L,T,l={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=T,this._thresholds=l,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,T,l)=>{const h={dispose:this._callbacks.push([L,T,I])};return Array.isArray(l)&&l.push(h),h}}async $participateInSave(I,L){const T=m.URI.revive(I);let l=!1;const E=setTimeout(()=>l=!0,this._thresholds.timeout),h=[];try{for(let p of[...this._callbacks]){if(l)break;const v=this._documents.getDocument(T),A=await this._deliverEventAsyncAndBlameBadListeners(p,{document:v,reason:C.TextDocumentSaveReason.to(L)});h.push(A)}}finally{clearTimeout(E)}return h}_deliverEventAsyncAndBlameBadListeners([I,L,T],l){const E=this._badListeners.get(I);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,I,L,l).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const p=this._badListeners.get(I);this._badListeners.set(I,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,T,l){const E=[],h=Date.now(),{document:p,reason:v}=l,{version:A}=p,w=Object.freeze({document:p,reason:v,waitUntil(s){if(Object.isFrozen(E))throw(0,i.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(s))}});try{L.apply(T,[w])}catch(s){return Promise.reject(s)}return Object.freeze(E),new Promise((s,o)=>{const g=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(g),s(a)}).catch(a=>{clearTimeout(g),o(a)})}).then(s=>{const o={edits:[]};for(const g of s)if(Array.isArray(g)&&g.every(a=>a instanceof y.TextEdit))for(const{newText:a,newEol:S,range:n}of g)o.edits.push({_type:2,resource:p.uri,edit:{range:n&&C.Range.from(n),text:a,eol:S&&C.EndOfLine.from(S)}});if(o.edits.length!==0)return A===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[217],we([0,1,3,31,2,17,7]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(L,T,l,E,h){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),E&&(this._config+=2),h&&(this._config+=4);const p=(0,i.parse)(T),v=L(A=>{if(!l)for(let w of A.created){const s=y.URI.revive(w);p(s.fsPath)&&this._onDidCreate.fire(s)}if(!E)for(let w of A.changed){const s=y.URI.revive(w);p(s.fsPath)&&this._onDidChange.fire(s)}if(!h)for(let w of A.deleted){const s=y.URI.revive(w);p(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(L,T,l){this._logService=T,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(L,T,l,E){return new D(this._onFileSystemEvent.event,L,T,l,E)}$onFileEvent(L){this._onFileSystemEvent.fire(L)}$onDidRunFileOperation(L,T){switch(L){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(l=>({oldUri:y.URI.revive(l.source),newUri:y.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(l=>y.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:T.map(l=>y.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(L){return this._createWillExecuteEvent(L,this._onWillRenameFile)}getOnWillCreateFileEvent(L){return this._createWillExecuteEvent(L,this._onWillCreateFile)}getOnWillDeleteFileEvent(L){return this._createWillExecuteEvent(L,this._onWillDeleteFile)}_createWillExecuteEvent(L,T){return(l,E,h)=>{const p=function(A){l.call(E,A)};return p.extension=L,T.event(p,void 0,h)}}async $onWillRunFileOperation(L,T,l,E){switch(L){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},l,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(h=>y.URI.revive(h.target))},l,E);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(h=>y.URI.revive(h.target))},l,E)}}async _fireWillEvent(L,T,l,E){const h=new Set,p=[];if(await L.fireAsync(T,E,async(A,w)=>{const s=Date.now(),o=await Promise.resolve(A);o instanceof P.WorkspaceEdit&&(p.push(o),h.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-s>l&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),E.isCancellationRequested||p.length===0)return;const v={edits:[]};for(let A of p){let{edits:w}=C.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(w)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=_}),define(ve[218],we([0,1,10,25,2,17,7,125]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,E,h,p){this.start=l,this.deletedCount=E,this.deletedItems=h,this.items=p}static asApiEvents(l){return l.map(E=>({start:E.start,deletedCount:E.deletedCount,deletedItems:E.deletedItems,items:E.items.map(h=>h.apiCell)}))}}class I{constructor(l,E,h){this.notebook=l,this._extHostDocument=E,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(l,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return l._mime},set mime(h){l._mime=h},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(C.NotebookCellOutput.to)}setOutputItems(l,E,h){const p=h.map(C.NotebookCellOutputItem.to),v=this._outputs.find(A=>A.id===l);v&&(E||(v.items.length=0),v.items.push(...p))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=I;class L{constructor(l,E,h,p,v,A){this._proxy=l,this._textDocumentsAndEditors=E,this._textDocuments=h,this._emitter=p,this.uri=v,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(E){return E=l._validateIndex(E),l._cells[E].apiCell},getCells(E){return(E?l._getCells(E):l._cells).map(p=>p.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,E){this._versionId=l.versionId,this._isDirty=E;for(const h of l.rawEvents)h.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===D.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let E=l.start|0,h=l.end|0;return E<0&&(E=0),h>this._cells.length&&(h=this._cells.length),l.with({start:E,end:h})}_getCells(l){l=this._validateRange(l);const E=[];for(let h=l.start;h<l.end;h++)E.push(this._cells[h]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,E){if(this._disposed)return;const h=[],p=[],v=[];l.reverse().forEach(A=>{const s=A[2].map(a=>{const S=new I(this,this._textDocumentsAndEditors,a);return E||p.push(I.asModelAddData(this.apiNotebook,a)),S}),o=new _(A[0],A[1],[],s),g=this._cells.splice(A[0],A[1],...s);for(const a of g)v.push(a.uri),o.deletedItems.push(a.apiCell);h.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:v}),E||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_moveCell(l,E){const h=this._cells.splice(l,1);this._cells.splice(E,0,...h);const p=[new _(l,1,h.map(v=>v.apiCell),[]),new _(E,0,[],h)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(p)}))}_setCellOutputs(l,E){const h=this._cells[l];h.setOutputs(E),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(l,E,h,p){const v=this._cells[l];v.setOutputItems(E,h,p),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(l,E){const h=this._cells[l];h.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelModeChanged(h.uri,E)}_changeCellMime(l,E){const h=this._cells[l];h.apiCell.mime=E}_changeCellMetadata(l,E){const h=this._cells[l],p=h.apiCell.metadata;h.setMetadata(E);const v=h.apiCell.metadata;(0,i.equals)(p,v)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(l,E){const h=this._cells[l],p=h.internalMetadata;if(h.setInternalMetadata(E),p.runState!==E.runState){const v=E.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:v}))}}getCellFromApiCell(l){return this._cells.find(E=>E.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(E=>E.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(ve[128],we([0,1,7,17,15]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:I})}replaceCells(_,I,L){this._throwIfFinalized(),!(_===I&&L.length===0)&&this._collectedEdits.push({editType:1,index:_,count:I-_,cells:L.map(i.NotebookCellData.from)})}}class P{constructor(_,I,L,T,l,E){this.id=_,this._proxy=I,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=T,this._viewColumn=E}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(I){if(!Array.isArray(I)||!I.every(m.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");_._selections=I,_._trySetSelections(I)},get visibleRanges(){return _._visibleRanges},revealRange(I,L){_._proxy.$tryRevealRange(_.id,i.NotebookRange.from(I),L??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(I){const L=new C(this.document.version);return I(L),_._applyEdit(L.finalize())},setDecorations(I,L){return _.setDecorations(I,L)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(i.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const I=[];let L=-1;for(let T=0;T<_.cellEdits.length;T++){if(L<0){I.push(_.cellEdits[T]),L++;continue}const E=I[L],h=_.cellEdits[T];if(E.editType===1&&h.editType===1&&E.index===h.index){E.cells.push(..._.cellEdits[T].cells),E.count+=_.cellEdits[T].count;continue}I.push(_.cellEdits[T]),L++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,I)}setDecorations(_,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return I.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(I),_.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(ve[219],we([0,1,17,117,164,21,57,15]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,E,h){const p=this._handles++,{title:v,location:A,cancellable:w}=E,s={label:(0,y.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(p,{location:m.ProgressLocation.from(A),title:v,source:s,cancellable:w},l).catch(D.onUnexpectedExternalError),this._withProgress(p,h,!!w)}_withProgress(l,E,h){let p;h&&(p=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,p));const v=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),p&&p.dispose()};let A;try{A=E(new L(this._proxy,l),h&&p?p.token:C.CancellationToken.None)}catch(w){throw v(l),w}return A.then(w=>v(l),w=>v(l)),A}$acceptProgressCanceled(l){const E=this._mapHandleToCancellationSource.get(l);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=_;function I(T,l){return T.message=l.message,typeof l.increment=="number"&&(typeof T.increment=="number"?T.increment+=l.increment:T.increment=l.increment),T}class L extends i.Progress{constructor(l,E){super(h=>this.throttledReport(h));this._proxy=l,this._handle=E}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,P.throttle)(100,(T,l)=>I(T,l),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ve[129],we([0,1,56,15,76,17,7]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(l,E,h){const p=D._Keys.nextId();l.$registerTextEditorDecorationType(E.identifier,p,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:p,dispose(){l.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=D,D._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(l,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,E){this._throwIfFinalized();let h=null;if(l instanceof P.Position)h=new P.Range(l,l);else if(l instanceof P.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,E,!1)}insert(l,E){this._throwIfFinalized(),this._pushEdit(new P.Range(l,l),E,!0)}delete(l){this._throwIfFinalized();let E=null;if(l instanceof P.Range)E=l;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(l,E,h){const p=this._document.validateRange(l);this._collectedEdits.push({range:p,text:E,forceMoveMarkers:h})}setEndOfLine(l){if(this._throwIfFinalized(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class I{constructor(l,E,h,p){this._proxy=l,this._id=E,this._accept(h),this._logService=p;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(A){v._setTabSize(A)},get insertSpaces(){return v._insertSpaces},set insertSpaces(A){v._setInsertSpaces(A)},get cursorStyle(){return v._cursorStyle},set cursorStyle(A){v._setCursorStyle(A)},get lineNumbers(){return v._lineNumbers},set lineNumbers(A){v._setLineNumbers(A)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(l){const E=this._validateTabSize(l);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const E=this._validateInsertSpaces(l);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(l)})))}assign(l){const E={};let h=!1;if(typeof l.tabSize!="undefined"){const p=this._validateTabSize(l.tabSize);p==="auto"?(h=!0,E.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,h=!0,E.tabSize=p)}if(typeof l.insertSpaces!="undefined"){const p=this._validateInsertSpaces(l.insertSpaces);p==="auto"?(h=!0,E.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,h=!0,E.insertSpaces=p)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,h=!0,E.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,h=!0,E.lineNumbers=C.TextEditorLineNumbersStyle.from(l.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(l,E){E.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=I;class L{constructor(l,E,h,p,v,A,w,s){this.id=l,this._proxy=E,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new I(this._proxy,this.id,A,h),this._visibleRanges=w,this._viewColumn=s;const o=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,i.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(g){if(!(g instanceof P.Selection))throw(0,i.illegalArgument)("selection");o._selections=[g],o._trySetSelection()},get selections(){return o._selections},set selections(g){if(!Array.isArray(g)||g.some(a=>!(a instanceof P.Selection)))throw(0,i.illegalArgument)("selections");o._selections=g,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(g){throw(0,i.readonly)("visibleRanges")},get options(){return o._options.value},set options(g){o._disposed||o._options.assign(g)},get viewColumn(){return o._viewColumn},set viewColumn(g){throw(0,i.readonly)("viewColumn")},edit(g,a={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new _(p.getValue(),a);return g(S),o._applyEdit(S)},insertSnippet(g,a,S={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!a||Array.isArray(a)&&a.length===0)n=o._selections.map(t=>C.Range.from(t));else if(a instanceof P.Position){const{lineNumber:t,column:r}=C.Position.from(a);n=[{startLineNumber:t,startColumn:r,endLineNumber:t,endColumn:r}]}else if(a instanceof P.Range)n=[C.Range.from(a)];else{n=[];for(const t of a)if(t instanceof P.Range)n.push(C.Range.from(t));else{const{lineNumber:r,column:u}=C.Position.from(t);n.push({startLineNumber:r,startColumn:u,endLineNumber:r,endColumn:u})}}return E.$tryInsertSnippet(l,g.value,n,S)},setDecorations(g,a){const S=a.length===0;S&&!o._hasDecorationsForKey.has(g.key)||(S?o._hasDecorationsForKey.delete(g.key):o._hasDecorationsForKey.add(g.key),o._runOnProxy(()=>{if(C.isDecorationOptionsArr(a))return E.$trySetDecorations(l,g.key,C.fromRangeOrRangeWithMessage(a));{const n=new Array(4*a.length);for(let t=0,r=a.length;t<r;t++){const u=a[t];n[4*t]=u.start.line+1,n[4*t+1]=u.start.character+1,n[4*t+2]=u.end.line+1,n[4*t+3]=u.end.character+1}return E.$trySetDecorationsFast(l,g.key,n)}}))},revealRange(g,a){o._runOnProxy(()=>E.$tryRevealRange(l,C.Range.from(g),a||P.TextEditorRevealType.Default))},show(g){E.$tryShowEditor(l,C.ViewColumn.from(g))},hide(){E.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const E=l.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const h=E.edits.map(v=>v.range);h.sort((v,A)=>v.end.line===A.end.line?v.end.character===A.end.character?v.start.line===A.start.line?v.start.character-A.start.character:v.start.line-A.start.line:v.end.character-A.end.character:v.end.line-A.end.line);for(let v=0,A=h.length-1;v<A;v++){const w=h[v].end;if(h[v+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=E.edits.map(v=>({range:C.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,p,{setEndOfLine:typeof E.setEndOfLine=="number"?C.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=L}),define(ve[220],we([0,1,167,23,2,3,6,18,7,13,16,17,21,204]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(A,w){if((0,I.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let s;return Array.isArray(A.highlights)&&(s=A.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),s=s.length?s:void 0),{label:A.label,highlights:s}}}class p{constructor(w,s,o){this._proxy=w,this.commands=s,this.logService=o,this.treeViews=new Map;function g(a){return a&&a.$treeViewId&&a.$treeItemHandle}s.registerArgumentProcessor({processArgument:a=>g(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(S=>g(S)?this.convertArgument(S):S):a})}registerTreeDataProvider(w,s,o){const g=this.createTreeView(w,{treeDataProvider:s},o);return{dispose:()=>g.dispose()}}createTreeView(w,s,o){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=s.dragAndDropController?.supportedMimeTypes,a=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:g}),S=this.createExtHostTreeView(w,s,o);return{get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get message(){return S.message},set message(n){S.message=n},get title(){return S.title},set title(n){S.title=n},get description(){return S.description},set description(n){S.description=n},reveal:(n,t)=>S.reveal(n,t),dispose:async()=>{await a,this.treeViews.delete(w),S.dispose()}}}$getChildren(w,s){const o=this.treeViews.get(w);return o?o.getChildren(s):Promise.reject(new Error((0,m.localize)(0,null,w)))}async $onDrop(w,s,o,g,a){const S=this.treeViews.get(w);if(!S)return Promise.reject(new Error((0,m.localize)(1,null,w)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(s);if(g===w&&a){const t=await S.onWillDrop(a);t&&t.forEach((r,u)=>{r&&n.set(u,r)})}return S.onDrop(n,o)}async $hasResolve(w){const s=this.treeViews.get(w);if(!s)throw new Error((0,m.localize)(2,null,w));return s.hasResolve}$resolve(w,s,o){const g=this.treeViews.get(w);if(!g)throw new Error((0,m.localize)(3,null,w));return g.resolveTreeItem(s,o)}$setExpanded(w,s,o){const g=this.treeViews.get(w);if(!g)throw new Error((0,m.localize)(4,null,w));g.setExpanded(s,o)}$setSelection(w,s){const o=this.treeViews.get(w);if(!o)throw new Error((0,m.localize)(5,null,w));o.setSelection(s)}$setVisible(w,s){const o=this.treeViews.get(w);if(!o)throw new Error((0,m.localize)(6,null,w));o.setVisible(s)}createExtHostTreeView(w,s,o){const g=new v(w,s,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(w,g),g}convertArgument(w){const s=this.treeViews.get(w.$treeViewId);return s?s.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=p;class v extends P.Disposable{constructor(w,s,o,g,a,S){super();if(this.viewId=w,this.proxy=o,this.commands=g,this.logService=a,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,S.contributes&&S.contributes.views)for(const r in S.contributes.views)for(const u of S.contributes.views[r])u.id===w&&(this._title=u.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(r,u)=>(r||(r={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(c=>t=c),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(u.element)?r.elements.push(...u.element):r.elements.push(u.element)),u.message&&(r.message=!0),r),200,!0)(({message:r,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=t;return n=null,this.refresh(u).then(()=>c())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,I.isUndefinedOrNull)(w))}async getChildren(w){const s=w?this.getExtensionElement(w):void 0;if(w&&!s)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(w);return o||(o=await this.fetchChildrenNodes(s)),o?o.map(g=>g.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,s){s=s||{select:!0,focus:!1};const o=(0,I.isUndefinedOrNull)(s.select)?!0:s.select,g=(0,I.isUndefinedOrNull)(s.focus)?!1:s.focus,a=(0,I.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(S=>this.resolveTreeNode(w,S[S.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:S.map(t=>t.item)},{select:o,focus:g,expand:a})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:g,expand:a})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,s){const o=this.getExtensionElement(w);o&&(s?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(w){(0,L.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(w){const s=[];for(const o of w){const g=this.getExtensionElement(o);g&&s.push(g)}if(!(!this.dndController?.onWillDrop||s.length===0))return this.dndController.onWillDrop(s)}async onDrop(w,s){const o=this.getExtensionElement(s);if(!!o)return(0,D.asPromise)(()=>this.dndController?.onDrop(w,o))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,s){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(w);if(o){const g=this.nodes.get(o);if(g){const a=await this.dataProvider.resolveTreeItem(g.extensionItem,o,s)??g.extensionItem;return g.item.tooltip=this.getTooltip(a.tooltip),g.item.command=this.getCommand(g.disposableStore,a.command),g.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(s=>s?this.resolveUnknownParentChain(s).then(o=>this.resolveTreeNode(s,o[o.length-1]).then(g=>(o.push(g),o))):Promise.resolve([]))}resolveParent(w){const s=this.nodes.get(w);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,s){const o=this.nodes.get(w);return o?Promise.resolve(o):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(g=>this.createHandle(w,g,s,!0)).then(g=>this.getChildren(s?s.item.handle:void 0).then(()=>{const a=this.getExtensionElement(g);if(a){const S=this.nodes.get(a);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(w){if(w){let s;if(typeof w=="string"){const o=this.getExtensionElement(w);s=o?this.nodes.get(o):void 0}else s=w;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=w?this.nodes.get(w):void 0,g=await this.dataProvider.getChildren(w);if(s.token.isCancellationRequested)return;const a=await Promise.all((0,L.coalesce)(g||[]).map(async S=>{const n=await this.dataProvider.getTreeItem(S);return n&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(S,n,o):null}));return s.token.isCancellationRequested?void 0:(0,L.coalesce)(a)}finally{s.dispose()}}refresh(w){if(w.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(w);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const s=new Set,o=w.map(a=>this.nodes.get(a));for(const a of o)if(a&&!s.has(a.item.handle)){let S=a;for(;S&&S.parent&&o.findIndex(n=>S&&S.parent&&n&&n.item.handle===S.parent.item.handle)===-1;){const n=this.elements.get(S.parent.item.handle);S=n?this.nodes.get(n):void 0}S&&!S.parent&&s.add(a.item.handle)}const g=[];return s.forEach(a=>{const S=this.elements.get(a);if(S){const n=this.nodes.get(S);n&&(!n.parent||!s.has(n.parent.item.handle))&&g.push(a)}}),g}refreshHandles(w){const s={};return Promise.all(w.map(o=>this.refreshNode(o).then(g=>{g&&(s[o]=g.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(w){const s=this.getExtensionElement(w);if(s){const o=this.nodes.get(s);if(o)return this.clearChildren(s),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(g=>{if(g){const a=this.createTreeNode(s,g,o.parent);return this.updateNodeCache(s,a,o,o.parent),o.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,s,o){const g=this.createTreeNode(w,s,o);if(s.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,s.id));return this.addNodeToCache(w,g),this.addNodeToParentCache(g,o),g}getTooltip(w){return _.MarkdownString.isMarkdownString(w)?T.MarkdownString.from(w):w}getCommand(w,s){return s?this.commands.toInternal(s,w):void 0}createTreeNode(w,s,o){const g=new P.DisposableStore,a=this.createHandle(w,s,o),S=this.getLightIconPath(s);return{item:{handle:a,parentHandle:o?o.item.handle:void 0,label:h(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(g,s.command),contextValue:s.contextValue,icon:S,iconDark:this.getDarkIconPath(s)||S,themeIcon:this.getThemeIcon(s),collapsibleState:(0,I.isUndefinedOrNull)(s.collapsibleState)?_.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:o,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(w){return w.iconPath instanceof _.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:s,label:o,resourceUri:g},a,S){if(s)return`${v.ID_HANDLE_PREFIX}/${s}`;const n=h(o,this.extension),t=a?a.item.handle:v.LABEL_HANDLE_PREFIX;let r=n?n.label:g?(0,i.basename)(g):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const u=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,c=this.getChildrenNodes(a)||[];let f,b=0;do{if(f=`${t}/${b}:${r}`,S||!this.elements.has(f)||u===f)break;b++}while(b<=c.length);return f}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon))return typeof w.iconPath=="string"||y.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return y.URI.isUri(w)?w:y.URI.file(w)}addNodeToCache(w,s){this.elements.set(s.item.handle,w),this.nodes.set(w,s)}updateNodeCache(w,s,o,g){this.elements.delete(s.item.handle),this.nodes.delete(w),s.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(w,s);const a=this.getChildrenNodes(g)||[],S=a.filter(n=>n.item.handle===o.item.handle)[0];S&&a.splice(a.indexOf(S),1,s)}addNodeToParentCache(w,s){s?(s.children||(s.children=[]),s.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const s=this.nodes.get(w);if(s){if(s.children)for(const o of s.children){const g=this.elements.get(o.item.handle);g&&this.clear(g)}s.children=void 0}}else this.clearAll()}clear(w){const s=this.nodes.get(w);if(s){if(s.children)for(const o of s.children){const g=this.elements.get(o.item.handle);g&&this.clear(g)}this.nodes.delete(w),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(ve[221],we([0,1,18,3,6,13,63,17,126,89]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends y.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const E=this.diff[this.diff.length-1];if(E&&l[0]===1){if(E[0]===1&&E[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(E[1],l[1]);return}if(E[0]===0&&E[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(E[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,E){const h=this.tree.get(l);if(!!h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const p=this.resolveChildren(h);return p.isOpen()?this.expandChildren(h,E-1):p.wait().then(()=>this.expandChildren(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,E-1)):this.expandChildren(h,E-1)}}dispose(){for(const l of this.tree.values())(0,P.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,E){switch(E.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(l.fullId,E.id));break;case 0:this.upsertItem(E.item,l);break;case 4:for(const h of E.ops)this.onTestItemEvent(l,h);break;case 3:{const{key:h,value:p,previous:v}=E,A=l.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(p,v,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:D.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:D.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[h]:p??null}}]);break}break}default:(0,C.assertNever)(E)}}upsertItem(l,E){if(!(l instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const h=I.TestId.fromExtHostTestItem(l,this.root.id,E?.actual),p=(0,P.getPrivateApiFor)(l);p.parent&&p.parent!==E?.actual&&p.parent.children.delete(l.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:l,parent:E?h.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(l,E),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:D.TestItem.from(l)}]),this.connectItemAndChildren(l,v,E);return}if(v.actual===l){this.connectItem(l,v,E);return}const A=v.actual.children,w=v.actual,s=(0,P.diffTestItems)(w,l);(0,P.getPrivateApiFor)(w).listener=void 0,v.actual=l,v.expand=0;for(const[o,g]of s)this.onTestItemEvent(v,{op:3,key:o,value:g,previous:w[o]});this.connectItemAndChildren(l,v,E);for(const o of A)l.children.get(o.id)||this.removeItem(I.TestId.joinToString(h,o.id))}diffTagRefs(l,E,h){const p=new Set(E.map(v=>v.id));for(const v of l)p.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:h,item:{tags:l.map(v=>D.TestTag.namespace(this.controllerId,v.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const E=this.tags.get(l.id);E?E.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:D.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const E=this.tags.get(l);E&&!--E.refCount&&(this.tags.delete(l),this.pushDiff([6,D.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,E){(0,P.getPrivateApiFor)(l).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(l,E,h){this.setItemParent(l,h);const p=(0,P.getPrivateApiFor)(l);p.parent=h?.actual,p.listener=v=>this.onTestItemEvent(E,v),this.updateExpandability(E)}connectItemAndChildren(l,E,h){this.connectItem(l,E,h);for(const p of l.children)this.upsertItem(p,E)}updateExpandability(l){let E;this._resolveHandler?l.resolveBarrier?E=l.resolveBarrier.isOpen()?3:2:E=l.actual.canResolveChildren?1:0:E=0,E!==l.expand&&(l.expand=E,this.pushDiff([1,{extId:l.fullId.toString(),expand:E}]),E===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,E){if(E<0)return;const h=[];for(const p of l.actual.children){const v=this.expand(I.TestId.joinToString(l.fullId,p.id),E);(0,m.isThenable)(v)&&h.push(v)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const v=new m.Barrier;return v.open(),v}l.expand=2,this.pushExpandStateUpdate(l);const E=l.resolveBarrier=new m.Barrier,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=v.stack||v.message||String(v))};let p;try{p=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(v){h(v)}return(0,m.isThenable)(p)?p.catch(h).then(()=>{E.open(),this.updateExpandability(l)}):(E.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const E=this.tree.get(l);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const h=[E];for(;h.length;){const p=h.pop();if(!!p){(0,P.getPrivateApiFor)(p.actual).listener=void 0;for(const v of p.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(p.fullId.toString());for(const v of p.actual.children)h.push(this.tree.get(I.TestId.joinToString(p.fullId,v.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=L}),define(ve[222],we([0,1,4,182]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(i.IEnvironmentService)}),define(ve[223],we([0,1,27,3,9]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=C;class P{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let T of L.activationEvents)T==="onUri"&&(T=`onUri:${m.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(L)}}keepOnly(L){const T=new Set;L.forEach(l=>T.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>T.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,T){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const l=P._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(l.map(E=>E.identifier)),T.length>0){const E=new Set;T.forEach(h=>E.add(m.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!E.has(m.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(l)}static _findLoopingExtensions(L){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,A){this.addNode(v),this.addNode(A),this._arcs.has(v)?this._arcs.get(v).push(A):this._arcs.set(v,[A])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,A){const w=T.getArcs(v);for(let s=0;s<w.length;s++)if(!A.has(w[s]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let v of L){const A=m.ExtensionIdentifier.toKey(v.identifier);if(l.set(A,v),v.extensionDependencies)for(let w of v.extensionDependencies){const s=m.ExtensionIdentifier.toKey(w);T.addArc(A,s)}}let E=new Set;T.getNodes().filter(v=>T.getArcs(v).length===0).forEach(v=>E.add(v));let h=T.getNodes().filter(v=>!E.has(v)),p;do{p=!1;for(let v=0;v<h.length;v++){const A=h[v];T.hasOnlyGoodArcs(A,E)&&(h.splice(v,1),v--,E.add(A),p=!0)}}while(p);return h.map(v=>l.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const T=this._activationMap.get(L);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const T=this._extensionsMap.get(m.ExtensionIdentifier.toKey(L));return T||void 0}}e.ExtensionDescriptionRegistry=P;var D;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(D||(D={}));function _(I,L){const T=I.isBuiltin?0:I.isUnderDevelopment?2:1,l=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(T!==l)return T-l;const E=y.posix.basename(I.extensionLocation.path),h=y.posix.basename(L.extensionLocation.path);return E<h?-1:E>h?1:0}}),define(ve[224],we([0,1,22]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var i;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(i=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(D){const _=m.VSBuffer.alloc(1);switch(D){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function P(D,_){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=P}),define(ve[29],we([0,1,3,2,4,27,193]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var D;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(D=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class I{constructor(g){this.dependency=g}}e.MissingExtensionDependency=I;var L;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=T;function l(o,g){return o.enabledApiProposals?o.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=l;function E(o,g){if(!l(o,g))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=E;class h{constructor(g,a,S,n){this.codeLoadingTime=g,this.activateCallTime=a,this.activateResolvedTime=S,this.activationReason=n}}e.ActivationTimes=h;class p{constructor(g,a){this.description=g,this.value=a}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var v;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function A(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=A;function w(o,g){return{identifier:new C.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!g,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=w;class s{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,a){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,a,S,n,t){}_onDidActivateExtensionError(g,a){}_onExtensionRuntimeError(g,a){}_onExtensionHostExit(g){}}e.NullExtensionService=s}),define(ve[225],we([0,1,15,27,29,11]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class D{constructor(p,v,A,w){this.startup=p,this.codeLoadingTime=v,this.activateCallTime=A,this.activateResolvedTime=w}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class _{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,v){return p===-1||v===-1?-1:v-p}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class I{constructor(p,v,A,w,s,o){this.activationFailed=p,this.activationFailedError=v,this.activationTimes=A,this.module=w,this.exports=s,this.subscriptions=o}}e.ActivatedExtension=I;class L extends I{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class T extends I{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=T;class l extends I{constructor(p){super(!0,p,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let E=class{constructor(p,v,A,w,s){this._logService=s,this._isDisposed=!1,this._registry=p,this._resolvedExtensionsSet=new Set,v.forEach(o=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,A.forEach(o=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(o),o)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(p){const v=i.ExtensionIdentifier.toKey(p);return this._activatedExtensions.has(v)}getActivatedExtension(p){const v=i.ExtensionIdentifier.toKey(p),A=this._activatedExtensions.get(v);if(!A)throw new Error("Extension `"+p.value+"` is not known or not activated");return A}activateByEvent(p,v){if(this._alreadyActivatedEvents[p])return P;const A=this._registry.getExtensionDescriptionsForActivationEvent(p);return this._activateExtensions(A.map(w=>({id:w.identifier,reason:{startup:v,extensionId:w.identifier,activationEvent:p}}))).then(()=>{this._alreadyActivatedEvents[p]=!0})}activateById(p,v){const A=this._registry.getExtensionDescription(p);if(!A)throw new Error("Extension `"+p+"` is not known");return this._activateExtensions([{id:A.identifier,reason:v}])}_handleActivateRequest(p,v,A){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(p.id))){v[i.ExtensionIdentifier.toKey(p.id)]=p;return}const w=this._registry.getExtensionDescription(p.id);if(!w){const g=new Error(`Cannot activate unknown extension '${p.id.value}'`);this._host.onExtensionActivationError(p.id,g,new y.MissingExtensionDependency(p.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(p.id),new l(g));return}const s=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let o=!0;for(let g=0,a=s.length;g<a;g++){const S=s[g];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(S)))continue;const n=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(S));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const c=w.displayName||w.identifier.value,f=this._registry.getExtensionDescription(S),b=f&&f.displayName||S,d=new Error(`Cannot activate the '${c}' extension because its dependency '${b}' failed to activate`);d.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,d,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(w.identifier),new l(d));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(S))){o=!1,v[i.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(S)),reason:p.reason};continue}const t=this._registry.getExtensionDescription(S);if(t){if(!t.main&&!t.browser)continue;o=!1,v[i.ExtensionIdentifier.toKey(S)]={id:t.identifier,reason:p.reason};continue}const r=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(w.identifier,u,new y.MissingExtensionDependency(S)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(w.identifier),new l(u));return}o?v[i.ExtensionIdentifier.toKey(w.identifier)]=p:A.push(p)}_activateExtensions(p){if(p.length===0||(p=p.filter(s=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(s.id))),p.length===0))return Promise.resolve(void 0);const v=Object.create(null),A=[];for(let s=0,o=p.length;s<o;s++)this._handleActivateRequest(p[s],v,A);for(let s=0,o=A.length;s<o;s++){const g=i.ExtensionIdentifier.toKey(A[s].id);v[g]&&delete v[g]}const w=Object.keys(v).map(s=>v[s]);return A.length===0?Promise.all(w.map(s=>this._activateExtension(s.id,s.reason))).then(s=>{}):this._activateExtensions(w).then(s=>this._activateExtensions(A))}_activateExtension(p,v){const A=i.ExtensionIdentifier.toKey(p);if(this._activatedExtensions.has(A))return Promise.resolve(void 0);const w=this._activatingExtensions.get(A);if(w)return w;const s=this._host.actualActivateExtension(p,v).then(void 0,o=>{const g=new Error;return o&&o.name&&(g.name=o.name),o&&o.message?g.message=`Activating extension '${p.value}' failed: ${o.message}.`:g.message=`Activating extension '${p.value}' failed: ${o}.`,o&&o.stack&&(g.stack=o.stack),this._isDisposed&&m.isPromiseCanceledError(o)?new l(o):(this._host.onExtensionActivationError(p,g,null),this._logService.error(`Activating extension ${p.value} failed due to an error:`),this._logService.error(o),new l(o))}).then(o=>{this._activatedExtensions.set(A,o),this._activatingExtensions.delete(A)});return this._activatingExtensions.set(A,s),s}};E=je([ze(4,C.ILogService)],E),e.ExtensionsActivator=E}),define(ve[226],we([0,1,11,26,29]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(D,_){super(D.createLogger(_.logFile,{name:y.ExtensionHostLogFileName}))}};C=je([ze(0,m.ILoggerService),ze(1,i.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ve[227],we([0,1,15]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,P)=>{this._actualOk=C,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,P){return this._ensureActual().then(C,P)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=i}),define(ve[53],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(I,L){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=L,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const i=[];function y(_){const I=new m(!0,_);return i[I.nid]=I,I}e.createMainContextProxyIdentifier=y;function C(_){const I=new m(!1,_);return i[I.nid]=I,I}e.createExtHostContextProxyIdentifier=C;function P(_){return i[_].sid}e.getStringIdentifierForProxy=P;class D{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=D}),define(ve[5],we([0,1,59,2,53]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var P;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(s){s.name="$ident";function o(a,S){return Object.defineProperty(a,s.name,{value:S,enumerable:!0}),a}s.mixin=o;function g(a){return a[s.name]}s.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(o){return o._id=E._n++,o}}e.IdObject=E,E._n=0;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(s){if(s&&s.edits)for(const o of s.edits)typeof o.resource=="object"?o.resource=i.URI.revive(o.resource):(o.newUri=i.URI.revive(o.newUri),o.oldUri=i.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,m.revive)(o.metadata));return s}e.reviveWorkspaceEditDto=A;var w;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[90],we([0,1,5,3,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(D){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,I){return this._proxy.$setPassword(D,_,I)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(ve[65],we([0,1,4,11,5,14]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,I,L){const T=this.getUsageKey(_,I);this._reportedUsages.has(T)||(this._reportedUsages.add(T),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};P=je([ze(0,C.IExtHostRpcService),ze(1,i.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,I){}})}),define(ve[228],we([0,1,3,5,7,27]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,L,T={}){const l=C.ExtensionIdentifier.toKey(_.identifier),E=this._inFlightRequests.get(l)||[],h=[...L].sort().join(" ");let p=E.find(v=>v.scopes===h);if(p)return p.result;{const v=this._getSession(_,l,I,L,T);p={scopes:h,result:v},E.push(p),this._inFlightRequests.set(l,E);try{await v}finally{const A=E.findIndex(w=>w.scopes===h);A>-1&&(E.splice(A),this._inFlightRequests.set(l,E))}return v}}async _getSession(_,I,L,T,l={}){await this._proxy.$ensureProvider(L);const E=_.displayName||_.name;return this._proxy.$getSession(L,T,I,E,l)}async removeSession(_,I){const L=this._authenticationProviders.get(_);return L?L.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,L,T){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:L,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===_)||this._providers.push({id:_,label:I});const l=L.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(_,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,T?.supportsMultipleAccounts??!1),new y.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const E=this._providers.findIndex(h=>h.id===_);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(ve[229],we([0,1,5,14,17]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(D,_){this._extHostDocumentsAndEditors=_,this._proxy=D.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const _=y.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ve[230],we([0,1,5]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(C){const P=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(D){return P.$writeText(D)}})}}e.ExtHostClipboard=i}),define(ve[38],we([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,63,22,53,50]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(r,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=r.getProxy(P.MainContext.MainThreadCommands),this._logService=u,this.converter=new g(this,c=>{const f=this._apiCommands.get(c);return f?.result===S.Void?f:void 0},u),this._argumentProcessors=[{processArgument(c){return(0,I.revive)(c)}},{processArgument(c){return(0,C.cloneAndChange)(c,function(f){if(L.Range.isIRange(f))return y.Range.to(f);if(T.Position.isIPosition(f))return y.Position.to(f);if(L.Range.isIRange(f.range)&&l.URI.isUri(f.uri))return y.location.to(f);if(f instanceof A.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const u=this.registerCommand(!1,r.id,async(...c)=>{const f=r.args.map((d,k)=>{if(!d.validate(c[k]))throw new Error(`Invalid argument '${d.name}' when running '${r.id}', received: ${c[k]}`);return d.convert(c[k])}),b=await this.executeCommand(r.internalId,...f);return r.result.convert(b,c,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new i.Disposable(()=>{u.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,u,c,f,b,d){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:c,thisArg:f,description:b,extension:d}),r&&this._proxy.$registerCommand(u),new i.Disposable(()=>{this._commands.delete(u)&&r&&this._proxy.$unregisterCommand(u)})}executeCommand(r,...u){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,u,!0)}async _doExecuteCommand(r,u,c){if(this._commands.has(r))return this._executeContributedCommand(r,u,!1);{let f=!1;const b=(0,C.cloneAndChange)(u,function(d){if(d instanceof i.Position)return y.Position.from(d);if(d instanceof i.Range)return y.Range.from(d);if(d instanceof i.Location)return y.location.from(d);if(i.NotebookRange.isNotebookRange(d))return y.NotebookRange.from(d);if(d instanceof ArrayBuffer)return f=!0,A.VSBuffer.wrap(new Uint8Array(d));if(d instanceof Uint8Array)return f=!0,A.VSBuffer.wrap(d);if(!Array.isArray(d))return d});try{const d=await this._proxy.$executeCommand(r,f?new w.SerializableObjectWithBuffers(b):b,c);return(0,I.revive)(d)}catch(d){if(d instanceof Error&&d.message==="$executeCommand:retry")return this._doExecuteCommand(r,u,!1);throw d}}}async _executeContributedCommand(r,u,c){const f=this._commands.get(r);if(!f)throw new Error("Unknown command");let{callback:b,thisArg:d,description:k}=f;if(k)for(let R=0;R<k.args.length;R++)try{(0,m.validateConstraint)(u[R],k.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${k.args[R].name}' - ${k.args[R].description}`)}try{return await b.apply(d,u)}catch(R){if(r===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...u);N&&(r=N.command)}throw this._logService.error(R,r,f.extension?.identifier),c?new class extends Error{constructor(){super((0,s.toErrorMessage)(R));this.id=r,this.source=f.extension?.displayName??f.extension?.name}}:R}}$executeContributedCommand(r,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(u=u.map(c=>this._argumentProcessors.reduce((f,b)=>b.processArgument(f),c)),this._executeContributedCommand(r,u,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),this._proxy.$getCommands().then(u=>(r&&(u=u.filter(c=>c[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(let[u,c]of this._commands){let{description:f}=c;f&&(r[u]=f)}return Promise.resolve(r)}};o=je([ze(0,p.IExtHostRpcService),ze(1,_.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class g{constructor(r,u,c){this._commands=r,this._lookupApiCommand=u,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,u){if(!r)return;const c={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return c;const f=this._lookupApiCommand(r.command);if(f)c.id=f.internalId,c.arguments=f.args.map((b,d)=>b.convert(r.arguments&&r.arguments[d]));else if((0,D.isNonEmptyArray)(r.arguments)){const b=++this._cachIdPool;this._cache.set(b,r),u.add((0,E.toDisposable)(()=>{this._cache.delete(b),this._logService.trace("CommandsConverter#DISPOSE",b)})),c.$ident=b,c.id=this.delegatingCommandId,c.arguments=[b],this._logService.trace("CommandsConverter#CREATE",r.command,b)}return c}fromInternal(r){const u=P.ObjectIdentifier.of(r);return typeof u=="number"?this._cache.get(u):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const u=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class a{constructor(r,u,c,f){this.name=r,this.description=u,this.validate=c,this.convert=f}optional(){return new a(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,u){return new a(r??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",t=>l.URI.isUri(t),t=>t),a.Position=new a("position","A position in a text document",t=>i.Position.isPosition(t),y.Position.from),a.Range=new a("range","A range in a text document",t=>i.Range.isRange(t),y.Range.from),a.Selection=new a("selection","A selection in a text document",t=>i.Selection.isSelection(t),y.Selection.from),a.Number=new a("number","",t=>typeof t=="number",t=>t),a.String=new a("string","",t=>typeof t=="string",t=>t),a.CallHierarchyItem=new a("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,y.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,y.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,y.TestItem.from);class S{constructor(r,u){this.description=r,this.convert=u}}e.ApiCommandResult=S,S.Void=new S("no result",t=>t);class n{constructor(r,u,c,f,b){this.id=r,this.internalId=u,this.description=c,this.args=f,this.result=b}}e.ApiCommand=n}),define(ve[231],we([0,1,17,7,84,38,16,110]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,E)=>{if((0,P.isFalsyOrEmpty)(l))return;class h extends i.SymbolInformation{static to(v){const A=new h(v.name,m.SymbolKind.to(v.kind),v.containerName||"",new i.Location(E[0],m.Range.to(v.range)));return A.detail=v.detail,A.range=A.location.range,A.selectionRange=m.Range.to(v.selectionRange),A.children=v.children?v.children.map(h.to):[],A}}return l.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(E=>i.Position.isPosition(E)),l=>l.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(E=>{let h;for(const p of E.reverse())h=new i.SelectionRange(m.Range.to(p),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:m.Range.to(l.range),placeholder:l.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new i.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const E=(0,D.decodeSemanticTokensDto)(l);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new i.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const E=(0,D.decodeSemanticTokensDto)(l);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,E,h)=>{if(!l)return new i.CompletionList([]);const p=l.suggestions.map(v=>m.CompletionItem.to(v,h));return new i.CompletionList(p,l.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,E,h)=>L(p=>new i.CodeLens(m.Range.to(p.range),p.command&&h.fromInternal(p.command)))(l))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>i.Range.isRange(l),l=>i.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,E,h)=>L(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const v=new i.CodeAction(p.title,p.kind?new i.CodeActionKind(p.kind):void 0);return p.edit&&(v.edit=m.WorkspaceEdit.to(p.edit)),p.command&&(v.command=h.fromInternal(p.command)),v.isPreferred=p.isPreferred,v}})(l))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(E=>new i.ColorInformation(m.Range.to(E.range),m.Color.to(E.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",l=>l instanceof i.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.to(E))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class I{static register(E){_.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=I;function L(l){return E=>{if(Array.isArray(E))return E.map(l)}}function T(l){if(!Array.isArray(l))return;const E=[];for(const h of l)y.isLocationLink(h)?E.push(m.DefinitionLink.to(h)):E.push(m.location.to(h));return E}}),define(ve[232],we([0,1,18,57,3,6,2,84,27,17,7,5]),function(J,e,m,i,y,C,P,D,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(E,h,p){const v=E.getProxy(T.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const r=this._commentControllers.get(t.handle);return r||t}else if(t&&t.$mid===7){const r=this._commentControllers.get(t.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.commentThreadHandle);return u||t}else if(t&&t.$mid===8){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.thread.commentThreadHandle);return u?{thread:u,text:t.text}:t}else if(t&&t.$mid===9){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let c=t.commentUniqueId,f=u.getCommentByUniqueId(c);return f||t}else if(t&&t.$mid===10){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let c=t.text,f=t.commentUniqueId,b=u.getCommentByUniqueId(f);return b?(b.body=c,b):t}return t}})}createCommentController(t,r,u){const c=A.handlePool++,f=new s(t,c,r,u);this._commentControllers.set(f.handle,f);const b=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return b.push(f),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),b),f.value}$createCommentThreadTemplate(t,r,u){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(r,u)}async $updateCommentThreadTemplate(t,r,u){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(r,u)}$deleteCommentThread(t,r){const u=this._commentControllers.get(t);u&&u.$deleteCommentThread(r)}$provideCommentingRanges(t,r,u){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const f=p.getDocument(P.URI.revive(r));return(0,m.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(f,u)).then(b=>b?b.map(d=>I.Range.from(d)):void 0)}$toggleReaction(t,r,u,c,f){const b=this._commentControllers.get(t);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const d=b.getCommentThread(r);if(d){const k=d.getCommentByUniqueId(c.uniqueIdInThread);if(b!==void 0&&k&&b.reactionHandler)return b.reactionHandler(k,a(f))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class w{constructor(t,r,u,c,f,b,d){this._commentControllerHandle=r,this._id=u,this._uri=c,this._range=f,this._comments=b,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),v.$createCommentThread(r,this.handle,this._id,this._uri,I.Range.from(this._range),d),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(r,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(R){k.range=R},get comments(){return k.comments},set comments(R){k.comments=R},get collapsibleState(){return k.collapsibleState},set collapsibleState(R){k.collapsibleState=R},get canReply(){return k.canReply},set canReply(R){k.canReply=R},get contextValue(){return k.contextValue},set contextValue(R){k.contextValue=R},get label(){return k.label},set label(R){k.label=R},dispose:()=>{k.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),r={};t("range")&&(r.range=I.Range.from(this._range)),t("label")&&(r.label=this.label),t("contextValue")&&(r.contextValue=this.contextValue??null),t("comments")&&(r.comments=this._comments.map(u=>o(this,u,this._commentsMap))),t("collapsibleState")&&(r.collapseState=S(this._collapseState)),t("canReply")&&(r.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(t){for(let r of this._commentsMap){let u=r[0],c=r[1];if(t===c)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}w._handlePool=0,je([(0,i.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,r,u,c){this._extension=t,this._handle=r,this._id=u,this._label=c,this._threads=new Map,v.$registerCommentController(this.handle,u,c);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(b){f.options=b},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(b){f.commentingRangeProvider=b},get reactionHandler(){return f.reactionHandler},set reactionHandler(b){f.reactionHandler=b},createCommentThread(b,d,k){return f.createCommentThread(b,d,k).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,r,u,c){if(typeof t=="string"){const f=new w(this.id,this.handle,t,r,u,c,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new w(this.id,this.handle,void 0,t,r,u,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(t,r){const u=new w(this.id,this.handle,void 0,P.URI.revive(t),I.Range.to(r),[],this._extension.identifier);return u.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(t,r){let u=this._threads.get(t);u&&(u.range=I.Range.to(r))}$deleteCommentThread(t){let r=this._threads.get(t);r&&r.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function o(n,t,r){let u=r.get(t);u||(u=++n.commentHandle,r.set(t,u));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:u,body:I.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(f=>g(f)):void 0}}function g(n){return{label:n.label,iconPath:n.iconPath?I.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function a(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?P.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function S(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=l}),define(ve[130],we([0,1,2,5,7,4,14,11,16,8,9]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class bi{constructor(E,h){this._logService=h,this._provider=new Map,this._proxy=E.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,h){const p=bi._handlePool++;this._provider.set(p,{provider:E,extensionId:h}),this._proxy.$registerDecorationProvider(p,h.value);const v=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(p,null);return}let w=(0,_.asArray)(A);if(w.length<=bi._maxEventSize){this._proxy.$onDidChange(p,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,w.length);const s=w.map(a=>({uri:a,rank:(0,I.count)(a.path,"/")})),o=(0,_.groupBy)(s,(a,S)=>a.rank-S.rank||(0,I.compare)(a.uri.path,S.uri.path));let g=[];e:for(let a of o){let S;for(let n of a){let t=(0,L.dirname)(n.uri.path);if(S!==t&&(S=t,g.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new y.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(E,h,p){if(!this._provider.has(E))return Object.create(null);const v=Object.create(null),{provider:A,extensionId:w}=this._provider.get(E);return await Promise.all(h.map(async s=>{try{const{uri:o,id:g}=s,a=await Promise.resolve(A.provideFileDecoration(m.URI.revive(o),p));if(!a)return;try{y.FileDecoration.validate(a),v[g]=[a.propagate,a.tooltip,a.badge,a.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${w.value}': ${S}`)}}catch(o){this._logService.error(o)}})),v}};T._handlePool=0,T._maxEventSize=250,T=je([ze(0,P.IExtHostRpcService),ze(1,D.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[233],we([0,1,162,116,2,5,7,17,3,11,24,44]),function(J,e,m,i,y,C,P,D,_,I,L,T){"use strict";var l,E,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(w,s,o,g,a,S){this._name=w,this._owner=s,this._maxDiagnosticsPerFile=o,l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,nt(this,h,new L.ResourceMap(n=>g.getComparisonKey(n)),"f"),nt(this,l,a,"f"),nt(this,E,S,"f")}dispose(){this._isDisposed||(Be(this,E,"f").fire([...Be(this,h,"f").keys()]),Be(this,l,"f")&&Be(this,l,"f").$clear(this._owner),Be(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,s){if(!w){this.clear();return}this._checkDisposed();let o=[];if(y.URI.isUri(w)){if(!s){this.delete(w);return}Be(this,h,"f").set(w,s.slice()),o=[w]}else if(Array.isArray(w)){o=[];let a;w=[...w].sort(p._compareIndexedTuplesByUri);for(const S of w){const[n,t]=S;if((!a||n.toString()!==a.toString())&&(a&&Be(this,h,"f").get(a).length===0&&Be(this,h,"f").delete(a),a=n,o.push(n),Be(this,h,"f").set(n,[])),t){const r=Be(this,h,"f").get(n);r&&r.push(...t)}else{const r=Be(this,h,"f").get(n);r&&(r.length=0)}}}if(Be(this,E,"f").fire(o),!Be(this,l,"f"))return;const g=[];for(let a of o){let S=[];const n=Be(this,h,"f").get(a);if(n)if(n.length>this._maxDiagnosticsPerFile){S=[];const t=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let u of n)if(u.severity===t[r]&&S.push(D.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;S.push({severity:i.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=n.map(t=>D.Diagnostic.from(t));g.push([a,S])}Be(this,l,"f").$changeMany(this._owner,g)}delete(w){this._checkDisposed(),Be(this,E,"f").fire([w]),Be(this,h,"f").delete(w),Be(this,l,"f")&&Be(this,l,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Be(this,E,"f").fire([...Be(this,h,"f").keys()]),Be(this,h,"f").clear(),Be(this,l,"f")&&Be(this,l,"f").$clear(this._owner)}forEach(w,s){this._checkDisposed();for(let o of Be(this,h,"f").keys())w.apply(s,[o,this.get(o),this])}get(w){this._checkDisposed();const s=Be(this,h,"f").get(w);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Be(this,h,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,s){return w[0].toString()<s[0].toString()?-1:w[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=p,l=new WeakMap,E=new WeakMap,h=new WeakMap;let v=class ri{constructor(w,s,o){this._logService=s,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=w.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(w){const s=new L.ResourceMap;for(const o of w)s.set(o,o);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(w,s){const{_collections:o,_proxy:g,_onDidChangeDiagnostics:a,_logService:S,_fileSystemInfoService:n}=this,t=new class{$changeMany(c,f){g.$changeMany(c,f),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,c,f.length===0?"CLEARING":f)}$clear(c){g.$clear(c),S.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,c)}dispose(){g.dispose()}};let r;if(!s)s="_generated_diagnostic_collection_name_#"+ri._idPool++,r=s;else if(!o.has(s))r=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do r=s+ri._idPool++;while(o.has(r))}return new class extends p{constructor(){super(s,r,ri._maxDiagnosticsPerFile,n.extUri,t,a);o.set(r,this)}dispose(){super.dispose(),o.delete(r)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const s=new Map,o=[];for(const g of this._collections.values())g.forEach((a,S)=>{let n=s.get(a.toString());typeof n=="undefined"&&(n=o.length,s.set(a.toString(),n),o.push([a,[]])),o[n][1]=o[n][1].concat(...S)});return o}}_getDiagnostics(w){let s=[];for(let o of this._collections.values())o.has(w)&&(s=s.concat(o.get(w)));return s}$acceptMarkersChange(w){if(!this._mirrorCollection){const s="_generated_mirror",o=new p(s,s,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,o),this._mirrorCollection=o}for(const[s,o]of w)this._mirrorCollection.set(y.URI.revive(s),o.map(D.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([ze(1,I.ILogService),ze(2,T.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(ve[234],we([0,1,2,5]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(P){this._proxy=P.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(D=>D?D.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(D=>D?m.URI.revive(D):void 0)}}e.ExtHostDialogs=y}),define(ve[235],we([0,1,15,2,7,5,10,21,8]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(T,l,E){this._documentsAndEditors=l,this._logService=E,this._documentContentProviders=new Map,this._proxy=T.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,l){if(Object.keys(P.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const E=I._handlePool++;this._documentContentProviders.set(E,l),this._proxy.$registerTextContentProvider(E,T);let h;return typeof l.onDidChange=="function"&&(h=l.onDidChange(p=>{if(p.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(E,p).then(v=>{if(!v&&typeof v!="string")return;const A=this._documentsAndEditors.getDocument(p);if(!A)return;const w=(0,_.splitLines)(v);if(!A.equalLines(w))return this._proxy.$onVirtualDocumentChange(p,v)},m.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(T,l){const E=this._documentContentProviders.get(T);return E?Promise.resolve(E.provideTextDocumentContent(i.URI.revive(l),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(ve[236],we([0,1,3,6,2,5,122,17,13,25,7]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(E,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const v of p)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const v of p)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const h=this._documentsAndEditors.getDocument(E);if(h)return h}getDocument(E){const h=this.getDocumentData(E);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return h.document}ensureDocumentData(E){const h=this._documentsAndEditors.getDocument(E);if(h)return Promise.resolve(h);let p=this._documentLoader.get(E.toString());return p||(p=this._proxy.$tryOpenDocument(E).then(v=>{this._documentLoader.delete(E.toString());const A=y.URI.revive(v);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(A))},v=>(this._documentLoader.delete(E.toString()),Promise.reject(v))),this._documentLoader.set(E.toString(),p)),p}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(h=>y.URI.revive(h))}$acceptModelModeChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(h),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(E){const h=y.URI.revive(E),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");v._acceptIsDirty(h),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,h,p){const v=y.URI.revive(E),A=this._documentsAndEditors.getDocument(v);if(!A)throw new Error("unknown document");A._acceptIsDirty(p),A.onEvents(h);let w;h.isUndoing?w=L.TextDocumentChangeReason.Undo:h.isRedoing&&(w=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:A.document,contentChanges:h.changes.map(s=>({range:D.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:w}))}setWordDefinitionFor(E,h){(0,P.setWordDefinitionFor)(E,h)}}e.ExtHostDocuments=T}),define(ve[45],we([0,1,56,3,6,2,4,5,122,14,129,17,11,24,10,77,140]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(o,g){this._extHostRpc=o,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const g=[],a=[],S=[];if(o.removedDocuments)for(const n of o.removedDocuments){const t=C.URI.revive(n),r=this._documents.get(t);r?.unref()&&(this._documents.delete(t),g.push(r.value))}if(o.addedDocuments)for(const n of o.addedDocuments){const t=C.URI.revive(n.uri);let r=this._documents.get(t);if(r&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);r||(r=new A(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,r),a.push(r.value)),r.ref()}if(o.removedEditors)for(const n of o.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&S.push(t)}if(o.addedEditors)for(const n of o.addedEditors){const t=C.URI.revive(n.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const r=this._documents.get(t).value,u=new L.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),n.selections.map(T.Selection.to),n.options,n.visibleRanges.map(c=>T.Range.to(c)),typeof n.editorPosition=="number"?T.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,u)}o.newActiveEditor!==void 0&&(m.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,y.dispose)(g),(0,y.dispose)(S),o.removedDocuments&&this._onDidRemoveDocuments.fire(g),o.addedDocuments&&this._onDidAddDocuments.fire(a),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return o?g:g?.value}allEditors(){return[...this._editors.values()]}};w=je([ze(0,I.IExtHostRpcService),ze(1,l.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[54],we([0,1,17,5,2,3,4,14,18]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let I=class{constructor(T){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=T.getProxy(i.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(T){let l=-1;this._tabs=T.map((h,p)=>(h.isActive&&(l=p),Object.freeze({label:h.label,viewColumn:m.ViewColumn.to(h.viewColumn),index:p,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:v,viewId:A})=>({resource:y.URI.revive(v),viewId:A})),viewId:h.editorId,isActive:h.isActive,move:async(v,A)=>{this._proxy.$moveTab(h,v,m.ViewColumn.from(A)),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,p)=>h.viewColumn===p.viewColumn?h.index-p.index:h.viewColumn-p.viewColumn);const E=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};I=je([ze(0,D.IExtHostRpcService)],I),e.ExtHostEditorTabs=I}),define(ve[237],we([0,1,2,5,6,7,17,147,8,22,29]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const p=this._schemes.indexOf(h);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),p=[];let v,A,w=14,s=14;for(const o of h){let g=v?(0,_.commonPrefixLength)(v,o):0;for(g===0?A=1:A=s;g<o.length;g++)g+1===o.length?(w=s,s=9):s+=1,p.push([A,o.toUpperCase().charCodeAt(g),s]),p.push([A,o.toLowerCase().charCodeAt(g),s]),A=s;v=o,s=w}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new D.StateMachine(p)}}provideDocumentLinks(h){this._initStateMachine();const p=[],v=D.LinkComputer.computeLinks({getLineContent(A){return h.lineAt(A-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const A of v){const w=P.DocumentLink.to(A);w.target&&p.push(w)}return p}}class l{constructor(h,p){this._extHostLanguageFeatures=p,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,p,v,A={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(w,v);let s=2;A.isCaseSensitive&&(s+=1024),A.isReadonly&&(s+=2048),typeof v.copy=="function"&&(s+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(h,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(w,p,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${p}`),console.error(g)});const o=v.onDidChangeFile(g=>{const a=[];for(const S of g){let{uri:n,type:t}=S;if(n.scheme!==p)continue;let r;switch(t){case C.FileChangeType.Changed:r=0;break;case C.FileChangeType.Created:r=1;break;case C.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:r})}this._proxy.$onFileSystemChange(w,a)});return(0,y.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h){const{type:p,ctime:v,mtime:A,size:w,permissions:s}=h;return{type:p,ctime:v,mtime:A,size:w,permissions:s}}$stat(h,p){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(p))).then(v=>l._asIStat(v))}$readdir(h,p){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(p)))}$readFile(h,p){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(p))).then(v=>I.VSBuffer.wrap(v))}$writeFile(h,p,v,A){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(p),v.buffer,A))}$delete(h,p,v){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(p),v))}$rename(h,p,v,A){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(p),m.URI.revive(v),A))}$copy(h,p,v,A){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(m.URI.revive(p),m.URI.revive(v),A))}$mkdir(h,p){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(p)))}$watch(h,p,v,A){const w=this._getFsProvider(h).watch(m.URI.revive(v),A);this._watches.set(p,w)}$unwatch(h,p){const v=this._watches.get(p);v&&(v.dispose(),this._watches.delete(p))}$open(h,p,v){const A=this._getFsProvider(h);if(!A.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(A.open(m.URI.revive(p),v))}$close(h,p){const v=this._getFsProvider(h);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(p))}$read(h,p,v,A){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const s=I.VSBuffer.alloc(A);return Promise.resolve(w.read(p,v,s.buffer,0,A)).then(o=>s.slice(0,o))}$write(h,p,v,A){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(p,v,A.buffer,0,A.byteLength))}_getFsProvider(h){const p=this._fsProvider.get(h);if(!p){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return p}}e.ExtHostFileSystem=l}),define(ve[66],we([0,1,5,42,7,22,4,14,44,6]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class zt{constructor(l,E){this._fileSystemProvider=new Map,this._proxy=l.getProxy(m.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(p){try{const v=h._fileSystemProvider.get(p.scheme);if(!v)return await h._proxy.$stat(p);await h._proxy.$ensureActivation(p.scheme);const A=await v.stat(p);return{type:A.type,ctime:A.ctime,mtime:A.mtime,size:A.size,permissions:A.permissions}}catch(v){zt._handleError(v)}},async readDirectory(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readDirectory(p)).slice()):await h._proxy.$readdir(p)}catch(v){return zt._handleError(v)}},async createDirectory(p){try{return await h._proxy.$mkdir(p)}catch(v){return zt._handleError(v)}},async readFile(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readFile(p)).slice()):(await h._proxy.$readFile(p)).buffer}catch(v){return zt._handleError(v)}},async writeFile(p,v){try{return await h._proxy.$writeFile(p,C.VSBuffer.wrap(v))}catch(A){return zt._handleError(A)}},async delete(p,v){try{const A=h._fileSystemProvider.get(p.scheme);return A?(await h._proxy.$ensureActivation(p.scheme),await A.delete(p,{recursive:!1,...v})):await h._proxy.$delete(p,{recursive:!1,useTrash:!1,...v})}catch(A){return zt._handleError(A)}},async rename(p,v,A){try{return await h._proxy.$rename(p,v,{overwrite:!1,...A})}catch(w){return zt._handleError(w)}},async copy(p,v,A){try{return await h._proxy.$copy(p,v,{overwrite:!1,...A})}catch(w){return zt._handleError(w)}},isWritableFileSystem(p){const v=E.getCapabilities(p);if(typeof v=="number")return!(v&2048)}})}static _handleError(l){if(l instanceof y.FileSystemError)throw l;if(!(l instanceof Error))throw new y.FileSystemError(String(l));if(l.name==="ENOPRO")throw y.FileSystemError.Unavailable(l.message);switch(l.name){case i.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(l.message);case i.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(l.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(l.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(l.message);case i.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(l.message);case i.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(l.message);default:throw new y.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,E){return this._fileSystemProvider.set(l,E),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(l))}};L=je([ze(0,D.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([0,1,2,38]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(P,D,_,I){this._extHostNotebooks=D,this._textDocumentsAndEditors=_,this._commands=I;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new i.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new i.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new i.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new i.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:m.URI.revive(T.notebookUri),inputUri:m.URI.revive(T.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:m.URI.revive(T.notebookUri),inputUri:m.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(P,D,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:_,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=y}),define(ve[239],we([0,1,6,5]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(P){this._handlePool=0,this._proxy=P.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,P),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=y}),define(ve[240],we([0,1,2,25,17,7,5,8,41,16,13,144,6,110,76,87,46,15,3]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentSymbols(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideDocumentSymbols(re,Z);if(!(0,I.isFalsyOrEmpty)(ue))return ue[0]instanceof C.DocumentSymbol?ue.map(y.DocumentSymbol.from):s._asDocumentSymbolTree(ue)}static _asDocumentSymbolTree(j){j=j.slice(0).sort((ue,te)=>{let oe=ue.location.range.start.compareTo(te.location.range.start);return oe===0&&(oe=te.location.range.end.compareTo(ue.location.range.end)),oe});const Z=[],re=[];for(const ue of j){const te={name:ue.name||"!!MISSING: name!!",kind:y.SymbolKind.from(ue.kind),tags:ue.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:ue.containerName,range:y.Range.from(ue.location.range),selectionRange:y.Range.from(ue.location.range),children:[]};for(;;){if(re.length===0){re.push(te),Z.push(te);break}const oe=re[re.length-1];if(_.Range.containsRange(oe.range,te.range)&&!_.Range.equalsRange(oe.range,te.range)){oe.children&&oe.children.push(te),re.push(te);break}re.pop()}}return Z}}class o{constructor(j,Z,re){this._documents=j,this._commands=Z,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideCodeLenses(re,Z);if(!ue||Z.isCancellationRequested)return;const te=this._cache.add(ue),oe=new l.DisposableStore;this._disposables.set(te,oe);const Ee={cacheId:te,lenses:[]};for(let Ne=0;Ne<ue.length;Ne++)Ee.lenses.push({cacheId:[te,Ne],range:y.Range.from(ue[Ne].range),command:this._commands.toInternal(ue[Ne].command,oe)});return Ee}async resolveCodeLens(j,Z){const re=j.cacheId&&this._cache.get(...j.cacheId);if(!re)return;let ue;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ue=re:ue=await this._provider.resolveCodeLens(re,Z),ue||(ue=re),Z.isCancellationRequested)return;const te=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!te)return j.command=this._commands.toInternal(ue.command??o._badCmd,te),j}releaseCodeLenses(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(We){return Array.isArray(We)?We.map(y.DefinitionLink.from):We?[y.DefinitionLink.from(We)]:[]}class a{constructor(j,Z){this._documents=j,this._provider=Z}async provideDefinition(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideDefinition(ue,te,re);return g(oe)}}class S{constructor(j,Z){this._documents=j,this._provider=Z}async provideDeclaration(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideDeclaration(ue,te,re);return g(oe)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}async provideImplementation(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideImplementation(ue,te,re);return g(oe)}}class t{constructor(j,Z){this._documents=j,this._provider=Z}async provideTypeDefinition(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideTypeDefinition(ue,te,re);return g(oe)}}class r{constructor(j,Z){this._documents=j,this._provider=Z}async provideHover(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideHover(ue,te,re);if(!(!oe||(0,I.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ue.getWordRangeAtPosition(te)),oe.range||(oe.range=new C.Range(te,te)),y.Hover.from(oe)}}class u{constructor(j,Z){this._documents=j,this._provider=Z}async provideEvaluatableExpression(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideEvaluatableExpression(ue,te,re);if(oe)return y.EvaluatableExpression.from(oe)}}class c{constructor(j,Z){this._documents=j,this._provider=Z}async provideInlineValues(j,Z,re,ue){const te=this._documents.getDocument(j),oe=await this._provider.provideInlineValues(te,y.Range.to(Z),y.InlineValueContext.to(re),ue);if(Array.isArray(oe))return oe.map(Ee=>y.InlineValue.from(Ee))}}class f{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentHighlights(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideDocumentHighlights(ue,te,re);if(Array.isArray(oe))return oe.map(y.DocumentHighlight.from)}}class b{constructor(j,Z){this._documents=j,this._provider=Z}async provideLinkedEditingRanges(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideLinkedEditingRanges(ue,te,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,I.coalesce)(oe.ranges.map(y.Range.from)),wordPattern:oe.wordPattern}}}class d{constructor(j,Z){this._documents=j,this._provider=Z}async provideReferences(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=await this._provider.provideReferences(te,oe,re,ue);if(Array.isArray(Ee))return Ee.map(y.location.from)}}class k{constructor(j,Z,re,ue,te,oe,Ee){this._documents=j,this._commands=Z,this._diagnostics=re,this._provider=ue,this._logService=te,this._extension=oe,this._apiDeprecation=Ee,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(j,Z,re,ue){const te=this._documents.getDocument(j),oe=T.Selection.isISelection(Z)?y.Selection.to(Z):y.Range.to(Z),Ee=[];for(const ot of this._diagnostics.getDiagnostics(j))if(oe.intersection(ot.range)&&Ee.push(ot)>k._maxCodeActionsPerFile)break;const Ne={diagnostics:Ee,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:y.CodeActionTriggerKind.to(re.trigger)},Ve=await this._provider.provideCodeActions(te,oe,Ne,ue);if(!(0,I.isNonEmptyArray)(Ve)||ue.isCancellationRequested)return;const Ge=this._cache.add(Ve),Je=new l.DisposableStore;this._disposables.set(Ge,Je);const tt=[];for(let ot=0;ot<Ve.length;ot++){const et=Ve[ot];!et||(k._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Ne.only&&(et.kind?Ne.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ge,ot],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(y.Diagnostic.from),edit:et.edit&&y.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ge,actions:tt}}async resolveCodeAction(j,Z){const[re,ue]=j,te=this._cache.get(re,ue);if(!te||k._isCommand(te)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(te,Z)??te;return oe?.edit?y.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}k._maxCodeActionsPerFile=1e3;class R{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentFormattingEdits(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideDocumentFormattingEdits(ue,Z,re);if(Array.isArray(te))return te.map(y.TextEdit.from)}}class N{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentRangeFormattingEdits(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Range.to(Z),Ee=await this._provider.provideDocumentRangeFormattingEdits(te,oe,re,ue);if(Array.isArray(Ee))return Ee.map(y.TextEdit.from)}}class B{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,Z,re,ue,te){const oe=this._documents.getDocument(j),Ee=y.Position.to(Z),Ne=await this._provider.provideOnTypeFormattingEdits(oe,Ee,re,ue,te);if(Array.isArray(Ne))return Ne.map(y.TextEdit.from)}}class F{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(j,Z){const re=P.IdObject.mixin({symbols:[]}),ue=await this._provider.provideWorkspaceSymbols(j,Z);if((0,I.isNonEmptyArray)(ue))for(const te of ue){if(!te)continue;if(!te.name){this._logService.warn("INVALID SymbolInformation, lacks name",te);continue}const oe=P.IdObject.mixin(y.WorkspaceSymbol.from(te));this._symbolCache.set(oe._id,te),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const re=this._symbolCache.get(j._id);if(re){const ue=await this._provider.resolveWorkspaceSymbol(re,Z);return ue&&(0,i.mixin)(j,y.WorkspaceSymbol.from(ue),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[re,ue]=Z;re<=ue;re++)this._symbolCache.delete(re);this._resultCache.delete(j)}}}class U{constructor(j,Z,re){this._documents=j,this._provider=Z,this._logService=re}static supportsResolving(j){return typeof j.prepareRename=="function"}async provideRenameEdits(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z);try{const Ee=await this._provider.provideRenameEdits(te,oe,re,ue);return Ee?y.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Ne=U._asMessage(Ee);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(j,Z,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ue=this._documents.getDocument(j),te=y.Position.to(Z);try{const oe=await this._provider.prepareRename(ue,te,re);let Ee,Ne;if(C.Range.isRange(oe)?(Ee=oe,Ne=ue.getText(oe)):(0,L.isObject)(oe)&&(Ee=oe.range,Ne=oe.placeholder),!Ee||!Ne)return;if(Ee.start.line>te.line||Ee.end.line<te.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Ee),text:Ne}}catch(oe){const Ee=U._asMessage(oe);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class H{constructor(j,Z){this.resultId=j,this.tokens=Z}}class x{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(j,Z,re){const ue=this._documents.getDocument(j),te=Z!==0?this._previousResults.get(Z):null;let oe=typeof te?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ue,te.resultId,re):await this._provider.provideDocumentSemanticTokens(ue,re);return te&&this._previousResults.delete(Z),oe?(oe=x._fixProvidedSemanticTokens(oe),this._send(x._convertToEdits(te,oe),oe)):null}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return x._isSemanticTokens(j)?x._isCorrectSemanticTokens(j)?j:new C.SemanticTokens(new Uint32Array(j.data),j.resultId):x._isSemanticTokensEdits(j)?x._isCorrectSemanticTokensEdits(j)?j:new C.SemanticTokensEdits(j.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!x._isSemanticTokens(Z)||!j||!j.tokens)return Z;const re=j.tokens,ue=re.length,te=Z.data,oe=te.length;let Ee=0;const Ne=Math.min(ue,oe);for(;Ee<Ne&&re[Ee]===te[Ee];)Ee++;if(Ee===ue&&Ee===oe)return new C.SemanticTokensEdits([],Z.resultId);let Ve=0;const Ge=Ne-Ee;for(;Ve<Ge&&re[ue-Ve-1]===te[oe-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:Ee,deleteCount:ue-Ee-Ve,data:te.subarray(Ee,oe-Ve)}],Z.resultId)}_send(j,Z){if(x._isSemanticTokens(j)){const re=this._nextResultId++;return this._previousResults.set(re,new H(j.resultId,j.data)),(0,E.encodeSemanticTokensDto)({id:re,type:"full",data:j.data})}if(x._isSemanticTokensEdits(j)){const re=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(re,new H(Z.resultId,Z.data)):this._previousResults.set(re,new H(j.resultId)),(0,E.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(j.edits||[]).map(ue=>({start:ue.start,deleteCount:ue.deleteCount,data:ue.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class M{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentRangeSemanticTokens(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideDocumentRangeSemanticTokens(ue,y.Range.to(Z),re);return te?this._send(te):null}_send(j){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=M;class W{constructor(j,Z,re,ue,te){this._documents=j,this._commands=Z,this._provider=re,this._apiDeprecation=ue,this._extension=te,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=te.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Ne=Ee.with({end:oe}),Ve=new v.StopWatch(!0),Ge=await this._provider.provideCompletionItems(te,oe,ue,y.CompletionContext.to(re));if(!Ge||ue.isCancellationRequested)return;const Je=Array.isArray(Ge)?new C.CompletionList(Ge):Ge,tt=W.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),ot=new l.DisposableStore;this._disposables.set(tt,ot);const et=[],it={x:tt,b:et,a:{replace:y.Range.from(Ee),insert:y.Range.from(Ne)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const pt=Je.items[ct],Pt=this._convertCompletionItem(pt,[tt,ct],Ne,Ee);et.push(Pt)}return it}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...j);if(!re)return;const ue=await this._provider.resolveCompletionItem(re,Z);if(!!ue)return this._convertCompletionItem(ue,j)}releaseCompletionItems(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,re,ue){const te=this._disposables.get(Z[0]);if(!te)throw Error("DisposableStore is missing...");const oe={x:Z,a:j.label,b:j.kind!==void 0?y.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(y.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(j.command,te)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=j.textEdit.newText):typeof j.insertText=="string"?oe.h=j.insertText:j.insertText instanceof C.SnippetString&&(oe.h=j.insertText.value,oe.i|=4);let Ee;return j.textEdit?Ee=j.textEdit.range:j.range&&(Ee=j.range),C.Range.isRange(Ee)?oe.j=y.Range.from(Ee):Ee&&(!re?.isEqual(Ee.inserting)||!ue?.isEqual(Ee.replacing))&&(oe.j={insert:y.Range.from(Ee.inserting),replace:y.Range.from(Ee.replacing)}),oe}}class z{constructor(j,Z,re){this._documents=j,this._provider=Z,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=await this._provider.provideInlineCompletionItems(te,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:y.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:y.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},ue);if(!Ee||ue.isCancellationRequested)return;const Ne=(0,L.isArray)(Ee)?{items:Ee}:Ee,Ve=this._cache.add(Ne.items);let Ge;return{pid:Ve,items:Ne.items.map((Je,tt)=>{let ot;return Je.command&&(Ge||(Ge=new l.DisposableStore,this._disposables.set(Ve,Ge)),ot=this._commands.toInternal(Je.command,Ge)),{text:Je.text,range:Je.range?y.Range.from(Je.range):void 0,command:ot,idx:tt}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const re=this._cache.get(j,Z);re&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=O.map.get(j);return Z||(Z=new O,O.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=O,O.map=new WeakMap;class V{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=this.reviveContext(re),Ne=await this._provider.provideSignatureHelp(te,oe,ue,Ee);if(Ne){const Ve=this._cache.add([Ne]);return{...y.SignatureHelp.from(Ne),id:Ve}}}reviveContext(j){let Z;if(j.activeSignatureHelp){const re=y.SignatureHelp.to(j.activeSignatureHelp),ue=this._cache.get(j.activeSignatureHelp.id,0);ue?(Z=ue,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...j,activeSignatureHelp:Z}}releaseSignatureHelp(j){this._cache.delete(j)}}class K{constructor(j,Z){this._documents=j,this._provider=Z}async provideInlayHints(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideInlayHints(ue,y.Range.to(Z),re);return te?{hints:te.map(y.InlayHint.from)}:void 0}}class G{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new p.Cache("DocumentLink")}async provideLinks(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideDocumentLinks(re,Z);if(!(!Array.isArray(ue)||ue.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ue.filter(G._validateLink).map(y.DocumentLink.from)};{const te=this._cache.add(ue),oe={links:[],id:te};for(let Ee=0;Ee<ue.length;Ee++){if(!G._validateLink(ue[Ee]))continue;const Ne=y.DocumentLink.from(ue[Ee]);Ne.cacheId=[te,Ee],oe.links.push(Ne)}return oe}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...j);if(!re)return;const ue=await this._provider.resolveDocumentLink(re,Z);if(!(!ue||!G._validateLink(ue)))return y.DocumentLink.from(ue)}releaseLinks(j){this._cache.delete(j)}}class Q{constructor(j,Z){this._documents=j,this._provider=Z}async provideColors(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideDocumentColors(re,Z);return Array.isArray(ue)?ue.map(oe=>({color:y.Color.from(oe.color),range:y.Range.from(oe.range)})):[]}async provideColorPresentations(j,Z,re){const ue=this._documents.getDocument(j),te=y.Range.to(Z.range),oe=y.Color.to(Z.color),Ee=await this._provider.provideColorPresentations(oe,{document:ue,range:te},re);if(!!Array.isArray(Ee))return Ee.map(y.ColorPresentation.from)}}class Y{constructor(j,Z){this._documents=j,this._provider=Z}async provideFoldingRanges(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideFoldingRanges(ue,Z,re);if(!!Array.isArray(te))return te.map(y.FoldingRange.from)}}class fe{constructor(j,Z,re){this._documents=j,this._provider=Z,this._logService=re}async provideSelectionRanges(j,Z,re){const ue=this._documents.getDocument(j),te=Z.map(y.Position.to),oe=await this._provider.provideSelectionRanges(ue,te,re);if(!(0,I.isNonEmptyArray)(oe))return[];if(oe.length!==te.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Ne=0;Ne<te.length;Ne++){const Ve=[];Ee.push(Ve);let Ge=te[Ne],Je=oe[Ne];for(;;){if(!Je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(y.SelectionRange.from(Je)),!Je.parent)break;Ge=Je.range,Je=Je.parent}}return Ee}}class me{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.prepareCallHierarchy(ue,te,re);if(!oe)return;const Ee=this._idPool.nextId();return this._cache.set(Ee,new Map),Array.isArray(oe)?oe.map(Ne=>this._cacheAndConvertItem(Ee,Ne)):[this._cacheAndConvertItem(Ee,oe)]}async provideCallsTo(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyIncomingCalls(ue,re);if(!!te)return te.map(oe=>({from:this._cacheAndConvertItem(j,oe.from),fromRanges:oe.fromRanges.map(Ee=>y.Range.from(Ee))}))}async provideCallsFrom(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyOutgoingCalls(ue,re);if(!!te)return te.map(oe=>({to:this._cacheAndConvertItem(j,oe.to),fromRanges:oe.fromRanges.map(Ee=>y.Range.from(Ee))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){const re=this._cache.get(j),ue=y.CallHierarchyItem.from(Z,j,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(j,Z){return this._cache.get(j)?.get(Z)}}class Se{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.prepareTypeHierarchy(ue,te,re);if(!oe)return;const Ee=this._idPool.nextId();return this._cache.set(Ee,new Map),Array.isArray(oe)?oe.map(Ne=>this._cacheAndConvertItem(Ee,Ne)):[this._cacheAndConvertItem(Ee,oe)]}async provideSupertypes(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySupertypes(ue,re);if(!!te)return te.map(oe=>this._cacheAndConvertItem(j,oe))}async provideSubtypes(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySubtypes(ue,re);if(!!te)return te.map(oe=>this._cacheAndConvertItem(j,oe))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){const re=this._cache.get(j),ue=y.TypeHierarchyItem.from(Z,j,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(j,Z){return this._cache.get(j)?.get(Z)}}class Ie{constructor(j,Z){this.adapter=j,this.extension=Z}}class Oe{constructor(j,Z,re,ue,te,oe,Ee){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ue,this._diagnostics=te,this._logService=oe,this._apiDeprecation=Ee}_transformDocumentSelector(j){return y.DocumentSelector.from(j,this._uriTransformer)}_createDisposable(j){return new C.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Oe._handlePool++}_withAdapter(j,Z,re,ue,te=!1){const oe=this._adapter.get(j);if(!oe)return Promise.resolve(ue);if(oe.adapter instanceof Z){let Ee;oe.extension&&(Ee=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Ne=re(oe.adapter,oe.extension),Ve=oe.extension;return Ve&&Promise.resolve(Ne).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-Ee}ms`),Ge=>{te&&Ge instanceof A.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ge))}),Ne}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const re=this._nextHandle();return this._adapter.set(re,new Ie(j,Z)),re}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,re,ue){const te=this._addNewAdapter(new s(this._documents,re),j),oe=ue&&ue.label||Oe._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(te,this._transformDocumentSelector(Z),oe),this._createDisposable(te)}$provideDocumentSymbols(j,Z,re){return this._withAdapter(j,s,ue=>ue.provideDocumentSymbols(m.URI.revive(Z),re),void 0)}registerCodeLensProvider(j,Z,re){const ue=this._nextHandle(),te=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ie(new o(this._documents,this._commands.converter,re),j)),this._proxy.$registerCodeLensSupport(ue,this._transformDocumentSelector(Z),te);let oe=this._createDisposable(ue);if(te!==void 0){const Ee=re.onDidChangeCodeLenses(Ne=>this._proxy.$emitCodeLensEvent(te));oe=C.Disposable.from(oe,Ee)}return oe}$provideCodeLenses(j,Z,re){return this._withAdapter(j,o,ue=>ue.provideCodeLenses(m.URI.revive(Z),re),void 0)}$resolveCodeLens(j,Z,re){return this._withAdapter(j,o,ue=>ue.resolveCodeLens(Z,re),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,o,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,re){const ue=this._addNewAdapter(new a(this._documents,re),j);return this._proxy.$registerDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDefinition(j,Z,re,ue){return this._withAdapter(j,a,te=>te.provideDefinition(m.URI.revive(Z),re,ue),[])}registerDeclarationProvider(j,Z,re){const ue=this._addNewAdapter(new S(this._documents,re),j);return this._proxy.$registerDeclarationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDeclaration(j,Z,re,ue){return this._withAdapter(j,S,te=>te.provideDeclaration(m.URI.revive(Z),re,ue),[])}registerImplementationProvider(j,Z,re){const ue=this._addNewAdapter(new n(this._documents,re),j);return this._proxy.$registerImplementationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideImplementation(j,Z,re,ue){return this._withAdapter(j,n,te=>te.provideImplementation(m.URI.revive(Z),re,ue),[])}registerTypeDefinitionProvider(j,Z,re){const ue=this._addNewAdapter(new t(this._documents,re),j);return this._proxy.$registerTypeDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideTypeDefinition(j,Z,re,ue){return this._withAdapter(j,t,te=>te.provideTypeDefinition(m.URI.revive(Z),re,ue),[])}registerHoverProvider(j,Z,re,ue){const te=this._addNewAdapter(new r(this._documents,re),j);return this._proxy.$registerHoverProvider(te,this._transformDocumentSelector(Z)),this._createDisposable(te)}$provideHover(j,Z,re,ue){return this._withAdapter(j,r,te=>te.provideHover(m.URI.revive(Z),re,ue),void 0)}registerEvaluatableExpressionProvider(j,Z,re,ue){const te=this._addNewAdapter(new u(this._documents,re),j);return this._proxy.$registerEvaluatableExpressionProvider(te,this._transformDocumentSelector(Z)),this._createDisposable(te)}$provideEvaluatableExpression(j,Z,re,ue){return this._withAdapter(j,u,te=>te.provideEvaluatableExpression(m.URI.revive(Z),re,ue),void 0)}registerInlineValuesProvider(j,Z,re,ue){const te=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new c(this._documents,re),j);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Z),te);let Ee=this._createDisposable(oe);if(te!==void 0){const Ne=re.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(te));Ee=C.Disposable.from(Ee,Ne)}return Ee}$provideInlineValues(j,Z,re,ue,te){return this._withAdapter(j,c,oe=>oe.provideInlineValues(m.URI.revive(Z),re,ue,te),void 0)}registerDocumentHighlightProvider(j,Z,re){const ue=this._addNewAdapter(new f(this._documents,re),j);return this._proxy.$registerDocumentHighlightProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentHighlights(j,Z,re,ue){return this._withAdapter(j,f,te=>te.provideDocumentHighlights(m.URI.revive(Z),re,ue),void 0)}registerLinkedEditingRangeProvider(j,Z,re){const ue=this._addNewAdapter(new b(this._documents,re),j);return this._proxy.$registerLinkedEditingRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideLinkedEditingRanges(j,Z,re,ue){return this._withAdapter(j,b,async te=>{const oe=await te.provideLinkedEditingRanges(m.URI.revive(Z),re,ue);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Oe._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,re){const ue=this._addNewAdapter(new d(this._documents,re),j);return this._proxy.$registerReferenceSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideReferences(j,Z,re,ue,te){return this._withAdapter(j,d,oe=>oe.provideReferences(m.URI.revive(Z),re,ue,te),void 0)}registerCodeActionProvider(j,Z,re,ue){const te=new l.DisposableStore,oe=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,re,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Z),{providedKinds:ue?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:ue?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this._commands.converter.toInternal(Ee.command,te)}))},Oe._extLabel(j),Boolean(re.resolveCodeAction)),te.add(this._createDisposable(oe)),te}$provideCodeActions(j,Z,re,ue,te){return this._withAdapter(j,k,oe=>oe.provideCodeActions(m.URI.revive(Z),re,ue,te),void 0)}$resolveCodeAction(j,Z,re){return this._withAdapter(j,k,ue=>ue.resolveCodeAction(Z,re),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,k,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,re){const ue=this._addNewAdapter(new R(this._documents,re),j);return this._proxy.$registerDocumentFormattingSupport(ue,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(ue)}$provideDocumentFormattingEdits(j,Z,re,ue){return this._withAdapter(j,R,te=>te.provideDocumentFormattingEdits(m.URI.revive(Z),re,ue),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,re){const ue=this._addNewAdapter(new N(this._documents,re),j);return this._proxy.$registerRangeFormattingSupport(ue,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(ue)}$provideDocumentRangeFormattingEdits(j,Z,re,ue,te){return this._withAdapter(j,N,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(Z),re,ue,te),void 0)}registerOnTypeFormattingEditProvider(j,Z,re,ue){const te=this._addNewAdapter(new B(this._documents,re),j);return this._proxy.$registerOnTypeFormattingSupport(te,this._transformDocumentSelector(Z),ue,j.identifier),this._createDisposable(te)}$provideOnTypeFormattingEdits(j,Z,re,ue,te,oe){return this._withAdapter(j,B,Ee=>Ee.provideOnTypeFormattingEdits(m.URI.revive(Z),re,ue,te,oe),void 0)}registerWorkspaceSymbolProvider(j,Z){const re=this._addNewAdapter(new F(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(re,typeof Z.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(j,Z,re){return this._withAdapter(j,F,ue=>ue.provideWorkspaceSymbols(Z,re),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,re){return this._withAdapter(j,F,ue=>ue.resolveWorkspaceSymbol(Z,re),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,F,re=>re.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,re){const ue=this._addNewAdapter(new U(this._documents,re,this._logService),j);return this._proxy.$registerRenameSupport(ue,this._transformDocumentSelector(Z),U.supportsResolving(re)),this._createDisposable(ue)}$provideRenameEdits(j,Z,re,ue,te){return this._withAdapter(j,U,oe=>oe.provideRenameEdits(m.URI.revive(Z),re,ue,te),void 0)}$resolveRenameLocation(j,Z,re,ue){return this._withAdapter(j,U,te=>te.resolveRenameLocation(m.URI.revive(Z),re,ue),void 0)}registerDocumentSemanticTokensProvider(j,Z,re,ue){const te=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(te,new Ie(new x(this._documents,re),j)),this._proxy.$registerDocumentSemanticTokensProvider(te,this._transformDocumentSelector(Z),ue,oe);let Ee=this._createDisposable(te);if(oe){const Ne=re.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(oe));Ee=C.Disposable.from(Ee,Ne)}return Ee}$provideDocumentSemanticTokens(j,Z,re,ue){return this._withAdapter(j,x,te=>te.provideDocumentSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,x,re=>re.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,re,ue){const te=this._addNewAdapter(new M(this._documents,re),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(te,this._transformDocumentSelector(Z),ue),this._createDisposable(te)}$provideDocumentRangeSemanticTokens(j,Z,re,ue){return this._withAdapter(j,M,te=>te.provideDocumentRangeSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}registerCompletionItemProvider(j,Z,re,ue){const te=this._addNewAdapter(new W(this._documents,this._commands.converter,re,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(te,this._transformDocumentSelector(Z),ue,W.supportsResolving(re),`${j.identifier.value}(${ue.join("")})`),this._createDisposable(te)}$provideCompletionItems(j,Z,re,ue,te){return this._withAdapter(j,W,oe=>oe.provideCompletionItems(m.URI.revive(Z),re,ue,te),void 0)}$resolveCompletionItem(j,Z,re){return this._withAdapter(j,W,ue=>ue.resolveCompletionItem(Z,re),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,W,re=>re.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,re){const ue=this._addNewAdapter(new z(this._documents,re,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideInlineCompletions(j,Z,re,ue,te){return this._withAdapter(j,z,oe=>oe.provideInlineCompletions(m.URI.revive(Z),re,ue,te),void 0)}$handleInlineCompletionDidShow(j,Z,re){this._withAdapter(j,z,async ue=>{ue.handleDidShowCompletionItem(Z,re)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,z,async re=>{re.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,re,ue){const te=Array.isArray(ue)?{triggerCharacters:ue,retriggerCharacters:[]}:ue,oe=this._addNewAdapter(new V(this._documents,re),j);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Z),te),this._createDisposable(oe)}$provideSignatureHelp(j,Z,re,ue,te){return this._withAdapter(j,V,oe=>oe.provideSignatureHelp(m.URI.revive(Z),re,ue,te),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,V,re=>re.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,re){const ue=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new K(this._documents,re),j);this._proxy.$registerInlayHintsProvider(te,this._transformDocumentSelector(Z),ue);let oe=this._createDisposable(te);if(ue!==void 0){const Ee=re.onDidChangeInlayHints(Ne=>this._proxy.$emitInlayHintsEvent(ue));oe=C.Disposable.from(oe,Ee)}return oe}$provideInlayHints(j,Z,re,ue){return this._withAdapter(j,K,te=>te.provideInlayHints(m.URI.revive(Z),re,ue),void 0)}registerDocumentLinkProvider(j,Z,re){const ue=this._addNewAdapter(new G(this._documents,re),j);return this._proxy.$registerDocumentLinkProvider(ue,this._transformDocumentSelector(Z),typeof re.resolveDocumentLink=="function"),this._createDisposable(ue)}$provideDocumentLinks(j,Z,re){return this._withAdapter(j,G,ue=>ue.provideLinks(m.URI.revive(Z),re),void 0)}$resolveDocumentLink(j,Z,re){return this._withAdapter(j,G,ue=>ue.resolveLink(Z,re),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,G,re=>re.releaseLinks(Z),void 0)}registerColorProvider(j,Z,re){const ue=this._addNewAdapter(new Q(this._documents,re),j);return this._proxy.$registerDocumentColorProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentColors(j,Z,re){return this._withAdapter(j,Q,ue=>ue.provideColors(m.URI.revive(Z),re),[])}$provideColorPresentations(j,Z,re,ue){return this._withAdapter(j,Q,te=>te.provideColorPresentations(m.URI.revive(Z),re,ue),void 0)}registerFoldingRangeProvider(j,Z,re){const ue=this._nextHandle(),te=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ie(new Y(this._documents,re),j)),this._proxy.$registerFoldingRangeProvider(ue,this._transformDocumentSelector(Z),te);let oe=this._createDisposable(ue);if(te!==void 0){const Ee=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(te));oe=C.Disposable.from(oe,Ee)}return oe}$provideFoldingRanges(j,Z,re,ue){return this._withAdapter(j,Y,te=>te.provideFoldingRanges(m.URI.revive(Z),re,ue),void 0)}registerSelectionRangeProvider(j,Z,re){const ue=this._addNewAdapter(new fe(this._documents,re,this._logService),j);return this._proxy.$registerSelectionRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideSelectionRanges(j,Z,re,ue){return this._withAdapter(j,fe,te=>te.provideSelectionRanges(m.URI.revive(Z),re,ue),[])}registerCallHierarchyProvider(j,Z,re){const ue=this._addNewAdapter(new me(this._documents,re),j);return this._proxy.$registerCallHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareCallHierarchy(j,Z,re,ue){return this._withAdapter(j,me,te=>Promise.resolve(te.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,re,ue){return this._withAdapter(j,me,te=>te.provideCallsTo(Z,re,ue),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,re,ue){return this._withAdapter(j,me,te=>te.provideCallsFrom(Z,re,ue),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,me,re=>Promise.resolve(re.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(j,Z,re){const ue=this._addNewAdapter(new Se(this._documents,re),j);return this._proxy.$registerTypeHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareTypeHierarchy(j,Z,re,ue){return this._withAdapter(j,Se,te=>Promise.resolve(te.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideTypeHierarchySupertypes(j,Z,re,ue){return this._withAdapter(j,Se,te=>te.provideSupertypes(Z,re,ue),void 0)}$provideTypeHierarchySubtypes(j,Z,re,ue){return this._withAdapter(j,Se,te=>te.provideSubtypes(Z,re,ue),void 0)}$releaseTypeHierarchy(j,Z){this._withAdapter(j,Se,re=>Promise.resolve(re.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,D.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Oe._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Oe._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Oe._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Oe._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Oe._serializeRegExp(j.beforeText),afterText:j.afterText?Oe._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Oe._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Oe._serializeOnEnterRule)}setLanguageConfiguration(j,Z,re){let{wordPattern:ue}=re;if(ue&&(0,D.regExpLeadsToEndlessLoop)(ue))throw new Error(`Invalid language configuration: wordPattern '${ue}' is not allowed to match the empty string.`);ue?this._documents.setWordDefinitionFor(Z,ue):this._documents.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const te=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Oe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Oe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Oe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(te,Z,oe),this._createDisposable(te)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=Oe,Oe._handlePool=0}),define(ve[241],we([0,1,5,17,7,48,18,6]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(L,T,l,E){this._documents=T,this._commands=l,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,T){await this._proxy.$changeLanguage(L,T);const l=this._documents.getDocumentData(L);if(!l)throw new Error(`document '${L.toString}' NOT found`);return l.document}async tokenAtPosition(L,T){const l=L.version,E=i.Position.from(T),h=await this._proxy.$tokensAtPosition(L.uri,E),p={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new y.Range(T.line,T.character,T.line,T.character)};if(!h)return p;const v={range:i.Range.to(h.range),type:i.TokenType.to(h.type)};return!v.range.contains(T)||l!==L.version?p:v}createLanguageStatusItem(L,T,l){const E=this._handlePool++,h=this._proxy,p=this._ids,v=`${L.identifier.value}/${T}`;if(p.has(v))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);p.add(v);const A={selector:l,id:T,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w,s=new D.DisposableStore;const o=()=>{w?.dispose(),w=(0,P.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(E,{id:v,name:A.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(A.selector,this._uriTransformer),label:A.text,detail:A.detail??"",severity:A.severity===y.LanguageStatusSeverity.Error?C.default.Error:A.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:A.command&&this._commands.toInternal(A.command,s),accessibilityInfo:A.accessibilityInformation,busy:A.busy})},0)},g={dispose(){s.dispose(),w?.dispose(),h.$removeLanguageStatus(E),p.delete(v)},get id(){return A.id},get name(){return A.name},set name(a){A.name=a,o()},get selector(){return A.selector},set selector(a){A.selector=a,o()},get text(){return A.text},set text(a){A.text=a,o()},get detail(){return A.detail},set detail(a){A.detail=a,o()},get severity(){return A.severity},set severity(a){A.severity=a,o()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(a){A.accessibilityInformation=a,o()},get command(){return A.command},set command(a){A.command=a,o()},get busy(){return A.busy},set busy(a){A.busy=a,o()}};return o(),g}}e.ExtHostLanguages=_}),define(ve[131],we([0,1,11,5,26,14,3]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends m.AbstractLoggerService{constructor(L,T){const l=new P.Emitter;super(T.logLevel,l.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,T,l){return new _(this._proxy,L,T,l)}};D=je([ze(0,C.IExtHostRpcService),ze(1,y.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class _ extends m.AbstractMessageLogger{constructor(L,T,l,E){super(E?.always);this.proxy=L,this.file=T,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(T,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,T){const l=[[L,T]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(L){this.proxy.$log(this.file,L)}}}),define(ve[242],we([0,1,5,11,29]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(D){return D&&D.title}let P=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,I,L,T,l){const E={extension:_};let h;typeof T=="string"||C(T)?h=[T,...l]:(E.modal=T?.modal,E.useCustom=T?.useCustom,E.detail=T?.detail,h=l),E.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const p=[];for(let v=0;v<h.length;v++){const A=h[v];if(typeof A=="string")p.push({title:A,handle:v,isCloseAffordance:!1});else if(typeof A=="object"){let{title:w,isCloseAffordance:s}=A;p.push({title:w,isCloseAffordance:!!s,handle:v})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(I,L,E,p).then(v=>{if(typeof v=="number")return h[v]})}};P=je([ze(1,i.ILogService)],P),e.ExtHostMessageService=P}),define(ve[243],we([0,1,22,3,47,6,24,8,13,2,87,5,17,7,53,218,128]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(s,o,g,a,S){this._textDocumentsAndEditors=g,this._textDocuments=a,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new i.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,r=n.cell.handle,c=this._documents.get(t)?.getCell(r);if(c)return c.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,g]of this._editors)if(g.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const g=this._documents.get(s);if(!g&&!o)throw new Error(`NO notebook document for '${s}'`);return g}_getProviderData(s){const o=this._notebookContentProviders.get(s);if(!o)throw new Error(`NO provider for '${s}'`);return o}registerNotebookContentProvider(s,o,g,a,S){if((0,D.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:s,provider:g});let n;return g.onDidChangeNotebookContentOptions&&(n=g.onDidChangeNotebookContentOptions(()=>{const t=l.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(o,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},o,l.NotebookDocumentContentOptions.from(a),A._convertNotebookRegistrationData(s,S)),new E.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(s,o){if(!o)return;const g=o.filenamePattern.map(a=>l.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(o.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:g,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,g){const a=A._notebookStatusBarItemProviderHandlePool++,S=typeof g.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,S,o);let n;return S!==void 0&&(n=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(S))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,S),n&&n.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&l.NotebookData.from(s.content)});return I.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(s),a=this._documents.get(I.URI.revive(g));return(0,_.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(s,o){I.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof o=="object"?g={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:g={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,g),S=a&&this._editors.get(a)?.apiEditor;if(S)return S;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,g,a){const S=this._notebookStatusBarItemProviders.get(s),n=I.URI.revive(o),t=this._documents.get(n);if(!t||!S)return;const r=t.getCellFromIndex(g);if(!r)return;const u=await S.provideCellStatusBarItems(r.apiCell,a);if(!u)return;const c=new C.DisposableStore,f=this._statusBarCache.add([c]),d=(Array.isArray(u)?u:[u]).map(k=>l.NotebookStatusBarItem.from(k,this._commandsConverter,c));return{cacheId:f,items:d}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,g,a,S){if((0,D.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,g),this._notebookProxy.$registerNotebookSerializer(n,{id:s.identifier,location:s.extensionLocation},o,l.NotebookDocumentContentOptions.from(a),A._convertNotebookRegistrationData(s,S)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(s,o,g){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const S=await a.deserializeNotebook(o.buffer,g);return new h.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(s,o,g){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const S=await a.serializeNotebook(l.NotebookData.to(o.value),g);return m.VSBuffer.wrap(S)}async $openNotebook(s,o,g,a,S){const{provider:n}=this._getProviderData(s),t=await n.openNotebook(I.URI.revive(o),{backupId:g,untitledDocumentData:a?.buffer},S);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(l.NotebookCellData.from)})}async $saveNotebook(s,o,g){const a=this.getNotebookDocument(I.URI.revive(o)),{provider:S}=this._getProviderData(s);return await S.saveNotebook(a.apiNotebook,g),!0}async $saveNotebookAs(s,o,g,a){const S=this.getNotebookDocument(I.URI.revive(o)),{provider:n}=this._getProviderData(s);return await n.saveNotebookAs(I.URI.revive(g),S.apiNotebook,a),!0}async $backupNotebook(s,o,g){const a=this.getNotebookDocument(I.URI.revive(o)),S=this._getProviderData(s),n=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),t=String((0,y.hash)([a.uri.toString(),this._backupIdPool++])),r=I.URI.joinPath(n,t),u=await S.provider.backupNotebook(a.apiNotebook,{destination:r},g);return a.updateBackup(u),u.id}_createExtHostEditor(s,o,g){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const a=new v.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,g.visibleRanges.map(l.NotebookRange.to),g.selections.map(l.NotebookRange.to),typeof g.viewColumn=="number"?l.ViewColumn.to(g.viewColumn):void 0);this._editors.set(o,a)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const a=I.URI.revive(g),S=this._documents.get(a);S&&(S.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===a.toString()&&this._editors.delete(n.id)}if(s.value.addedDocuments){const g=[];for(const a of s.value.addedDocuments){const S=I.URI.revive(a.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const n=this,t=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){n._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){n._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){n._onDidChangeCellMetadata.fire(r)},emitCellExecutionStateChange(r){n._onDidChangeCellExecutionState.fire(r)}},S,a);g.push(...a.cells.map(r=>p.ExtHostCell.asModelAddData(t.apiNotebook,r))),this._documents.get(S)?.dispose(),this._documents.set(S,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this._editors.has(g.id))return;const a=I.URI.revive(g.documentUri),S=this._documents.get(a);S&&this._createExtHostEditor(S,g.id,g)}const o=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const a=this._editors.get(g);a&&(this._editors.delete(g),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),o.push(a))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const g=new Set;this._visibleNotebookEditors.forEach(a=>g.add(a.id));for(const a of this._editors.values()){const S=g.has(a.id);a._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(ve[244],we([0,1,3,76,11,5,14,17]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(T,l){const E=_._Keys.nextId();T.$registerNotebookEditorDecorationType(E,D.NotebookDecorationRenderOptions.from(l)),this.value={key:E,dispose(){T.$removeNotebookEditorDecorationType(E)}}}}_._Keys=new i.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(T,l,E){this._logService=T,this._extHostRpc=l,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,l);const E=this._notebooksAndEditors.getEditorById(T);l.visibleRanges&&E._acceptVisibleRanges(l.visibleRanges.ranges.map(D.NotebookRange.to)),l.selections&&E._acceptSelections(l.selections.selections.map(D.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const l in T)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(D.ViewColumn.to(T[l]))}};I=je([ze(0,y.ILogService),ze(1,P.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(ve[245],we([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,210,29,53]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(n,t,r,u,c){this._initData=t,this._extHostNotebook=r,this._commands=u,this._logService=c,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(T.MainContext.MainThreadNotebookKernels);const f=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const d=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:d}}else if(b&&"notebookEditor"in b){const d=this._extHostNotebook.getIdByEditor(b.notebookEditor);if(d===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.document.uri.toString()}`);return{notebookEditorId:d}}return b})],l.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(n,t,r,u,c,f){for(let V of this._kernelData.values())if(V.controller.id===t&&I.ExtensionIdentifier.equals(n.identifier,V.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const b=this._handlePool++,d=this;this._logService.trace(`NotebookController[${b}], CREATED by ${n.identifier.value}, ${t}`);const k=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${n.identifier}'`);let R=!1;const N=new P.DisposableStore,B=new C.Emitter,F=new C.Emitter,U={id:`${n.identifier.value}/${t}`,notebookType:r,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:u||n.identifier.value,preloads:f?f.map(E.NotebookRendererScript.from):[]};let H=c??k,x;this._proxy.$addKernel(b,U).catch(V=>{console.log(V),R=!0});let M=0;const W=()=>{if(R)return;const V=++M;Promise.resolve().then(()=>{V===M&&this._proxy.$updateKernel(b,U)})},z=new D.ResourceMap,O={get id(){return t},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(V){U.label=V??n.displayName??n.name,W()},get detail(){return U.detail??""},set detail(V){U.detail=V,W()},get description(){return U.description??""},set description(V){U.description=V,W()},get kind(){return(0,A.checkProposedApiEnabled)(n,"notebookControllerKind"),U.kind??""},set kind(V){(0,A.checkProposedApiEnabled)(n,"notebookControllerKind"),U.kind=V,W()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(V){U.supportedLanguages=V,W()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(V){U.supportsExecutionOrder=V,W()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(V){H=V??k},get interruptHandler(){return x},set interruptHandler(V){x=V,U.supportsInterrupt=Boolean(V),W()},createNotebookCellExecution(V){if(R)throw new Error("notebook controller is DISPOSED");if(!z.has(V.notebook.uri))throw d._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(K=>K.toString())),new Error(`notebook controller is NOT associated to notebook: ${V.notebook.uri.toString()}`);return d._createNotebookCellExecution(V)},dispose:()=>{R||(this._logService.trace(`NotebookController[${b}], DISPOSED`),R=!0,this._kernelData.delete(b),N.dispose(),B.dispose(),F.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(V,K){d._proxy.$updateNotebookPriority(b,V.uri,K)},onDidReceiveMessage:F.event,postMessage(V,K){return(0,A.checkProposedApiEnabled)(n,"notebookMessaging"),d._proxy.$postMessage(b,K&&d._extHostNotebook.getIdByEditor(K),V)},asWebviewUri(V){return(0,A.checkProposedApiEnabled)(n,"notebookMessaging"),(0,p.asWebviewUri)(V,d._initData.remote)}};return this._kernelData.set(b,{extensionId:n.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:z}),O}$acceptNotebookAssociation(n,t,r){const u=this._kernelData.get(n);if(u){const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));r?u.associatedNotebooks.set(c.uri,!0):u.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,c.uri.toString(),r),u.onDidChangeSelection.fire({selected:r,notebook:c.apiNotebook})}}async $executeCells(n,t,r){const u=this._kernelData.get(n);if(!u)return;const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),f=[];for(let b of r){const d=c.getCell(b);d&&f.push(d.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,c.uri.toString(),f.length),await u.controller.executeHandler.call(u.controller,f,c.apiNotebook,u.controller)}catch(b){this._logService.error(`NotebookController[${n}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(n,t,r){const u=this._kernelData.get(n);if(!u)return;const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,c.apiNotebook);else for(let f of r){const b=c.getCell(f);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,r){const u=this._kernelData.get(n);if(!u)return;const c=this._extHostNotebook.getEditorById(t);u.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:r}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const u=new g(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,u);const c=u.onDidChangeState(()=>{u.state===o.Resolved&&(u.dispose(),c.dispose(),this._activeExecutions.delete(r.uri))});return u.asApiObject()}};s=je([ze(4,L.ILogService)],s),e.ExtHostNotebookKernels=s;var o;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(o||(o={}));class g extends P.Disposable{constructor(n,t,r){super();this._document=n,this._cell=t,this._proxy=r,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new a(10,u=>this.update(u)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const r=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return r===t.items?E.NotebookCellOutput.from(t):E.NotebookCellOutput.from({items:r,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,r){const u=this.cellIndexToHandle(t),c=this.validateAndConvertOutputs((0,m.asArray)(n));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:u,append:r,outputs:c})}async updateOutputItems(n,t,r){return n=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(n),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(E.NotebookCellOutputItem.from),outputId:t.id,append:r})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(r){n._executionOrder=r,n.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(r){if(n._state===o.Resolved||n._state===o.Started)throw new Error("Cannot call start again");n._state=o.Started,n._onDidChangeState.fire(),n.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:r})},end(r,u){if(n._state===o.Resolved)throw new Error("Cannot call resolve twice");n._state=o.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:u,lastRunSuccess:r}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(r){return n.verifyStateForOutput(),n.updateOutputs([],r,!1)},appendOutput(r,u){return n.verifyStateForOutput(),n.updateOutputs(r,u,!0)},replaceOutput(r,u){return n.verifyStateForOutput(),n.updateOutputs(r,u,!1)},appendOutputItems(r,u){return n.verifyStateForOutput(),n.updateOutputItems(r,u,!0)},replaceOutputItems(r,u){return n.verifyStateForOutput(),n.updateOutputItems(r,u,!1)}})}}g.HANDLE=0;class a{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(ve[246],we([0,1,3,5,128,29]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(_,I){this._extHostNotebook=I,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,I,L){const T=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(I)?.fire({editor:T.apiEditor,message:L})}createRendererMessaging(_,I){if(!_.contributes?.notebookRenderer?.some(E=>E.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);const L=(0,C.isProposedApiEnabled)(_,"notebookEditor"),T=new WeakMap;return{onDidReceiveMessage:(E,h,p)=>{const v=L?E:A=>{const w={};T.set(w,A.editor),E({editor:w,message:A.message})};return this.getOrCreateEmitterFor(I).event(v,h,p)},postMessage:(E,h)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,h]=[h,E]);const p=L?h:T.get(h),v=p&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(p);return this.proxy.$postMessage(v?.id,I,E)}}}getOrCreateEmitterFor(_){let I=this._rendererMessageEmitters.get(_);return I||(I=new m.Emitter({onLastListenerRemove:()=>{I?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,I),I)}}e.ExtHostNotebookRenderers=P}),define(ve[132],we([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(J,e,m,i,y,C,P,D,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends i.Disposable{constructor(v,A,w,s){super();this.id=v,this.name=A,this.logger=w,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(v){this.append(v+`
`)}append(v){this.write(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,v)}replace(v){const A=this.offset;this.write(v),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,A),this.visible&&this.logger.flush()}show(v,A){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:A))}hide(){this.proxy.$close(this.id)}write(v){this.offset+=l.VSBuffer.fromString(v).byteLength,this.logger.info(v)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let h=class{constructor(v,A,w,s,o){this.extHostFileSystem=w,this.extHostFileSystemInfo=s,this.loggerService=o,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(A.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[A,w]of this.channels)w.visible=A===this.visibleChannelId}createOutputChannel(v,A){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(v,A);return w.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(v,w)}async doCreateOutputChannel(v,A){const w=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(v,!1,s,A.identifier.value);return new E(g,v,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(v,A){let w=!1;const s=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return v},append(o){s(),A.then(g=>g.append(o))},appendLine(o){s(),A.then(g=>g.appendLine(o))},clear(){s(),A.then(o=>o.clear())},replace(o){s(),A.then(g=>g.replace(o))},show(o,g){s(),A.then(a=>a.show(o,g))},hide(){s(),A.then(o=>o.hide())},dispose(){w=!0,A.then(o=>o.dispose())}}}};h=je([ze(0,C.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,_.IExtHostConsumerFileSystem),ze(3,L.IExtHostFileSystemInfo),ze(4,P.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ve[247],we([0,1,18,21,3,6,5,2,7,15,16,48,86,29]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(p,v,A){const w=p.getProxy(P.MainContext.MainThreadQuickOpen);class s{constructor(c,f){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=f}showQuickPick(c,f,b=i.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(c),k=++this._instances,R=w.$show(k,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},b),N={},B=R.then(()=>N);return Promise.race([B,d]).then(F=>{if(F!==N)return d.then(U=>{const H=[];for(let x=0;x<U.length;x++){const M=U[x];typeof M=="string"?H.push({label:M,handle:x}):M.kind===_.QuickPickItemKind.Separator?H.push({type:"separator",label:M.label}):H.push({label:M.label,description:M.description,detail:M.detail,picked:M.picked,alwaysShow:M.alwaysShow,handle:x})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{f.onDidSelectItem(U[x])}),w.$setItems(k,H),R.then(x=>{if(typeof x=="number")return U[x];if(Array.isArray(x))return x.map(M=>U[M])})})}).then(void 0,F=>{if(!(0,I.isPromiseCanceledError)(F))return w.$setError(k,F),Promise.reject(F)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,f=i.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,w.$input(c,typeof this._validateInput=="function",f).then(void 0,b=>{if(!(0,I.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(c){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,f=i.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!b)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(k=>k.uri.toString()===b.uri.toString())}createQuickPick(c){const f=new t(c,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(c){const f=new r(c,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(c,f){const b=this._sessions.get(c);b&&b._fireDidChangeValue(f)}$onDidAccept(c){const f=this._sessions.get(c);f&&f._fireDidAccept()}$onDidChangeActive(c,f){const b=this._sessions.get(c);b instanceof t&&b._fireDidChangeActive(f)}$onDidChangeSelection(c,f){const b=this._sessions.get(c);b instanceof t&&b._fireDidChangeSelection(f)}$onDidTriggerButton(c,f){const b=this._sessions.get(c);b&&b._fireDidTriggerButton(f)}$onDidTriggerItemButton(c,f,b){const d=this._sessions.get(c);d instanceof t&&d._fireDidTriggerItemButton(f,b)}$onDidHide(c){const f=this._sessions.get(c);f&&f._fireDidHide()}}class o{constructor(c,f){this._extensionId=c,this._onDidDispose=f,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((f,b)=>{const d=f===_.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(d,f)}),this.update({buttons:c.map((f,b)=>({...n(f),tooltip:f.tooltip,handle:f===_.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const f=this._handlesToButtons.get(c);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(c){if(!this._disposed){for(const f of Object.keys(c)){const b=c[f];this._pendingUpdate[f]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function g(u){if(u instanceof _.ThemeIcon)return{id:u.id};const c=S(u),f=a(u);return{dark:typeof c=="string"?D.URI.file(c):c,light:typeof f=="string"?D.URI.file(f):f}}function a(u){return typeof u=="object"&&"light"in u?u.light:u}function S(u){return typeof u=="object"&&"dark"in u?u.dark:u}function n(u){const c=g(u.iconPath);let f,b;return"id"in c?b=l.ThemeIcon.asClassName(c):f=c,{iconPath:f,iconClass:b}}class t extends o{constructor(c,f){super(c.identifier,f);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(b=>b.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((b,d)=>{this._handlesToItems.set(d,b),this._itemsToHandles.set(b,d)});const f=[];for(let b=0;b<c.length;b++){const d=c[b];d.kind===_.QuickPickItemKind.Separator?f.push({type:"separator",label:d.label}):f.push({handle:b,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((k,R)=>({...n(k),tooltip:k.tooltip,handle:R}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(c){const f=(0,L.coalesce)(c.map(b=>this._handlesToItems.get(b)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(c){const f=(0,L.coalesce)(c.map(b=>this._handlesToItems.get(b)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(c,f){const b=this._handlesToItems.get(c);if(!b||!b.buttons||!b.buttons.length)return;const d=b.buttons[f];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:b})}}class r extends o{constructor(c,f){super(c,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?T.default.Error:T.default.Ignore})}}return new s(v,A)}e.createExtHostQuickOpen=h}),define(ve[248],we([0,1,2,3,57,6,18,5,16,99,11,27,86,17,29]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(u){if(u)return typeof u.iconPath=="string"?m.URI.file(u.iconPath):m.URI.isUri(u.iconPath)||l.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,c){if(!u.iconPath&&!c.iconPath)return 0;if(u.iconPath){if(!c.iconPath)return 1}else return-1;const f=typeof u.iconPath=="string"?u.iconPath:m.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,b=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,I.comparePaths)(f,b)}function A(u,c){let f=0;if(u.strikeThrough!==c.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==c.faded)return u.faded?1:-1;if(u.tooltip!==c.tooltip)return(u.tooltip||"").localeCompare(c.tooltip||"");if(f=v(u,c),f!==0)return f;if(u.light&&c.light)f=v(u.light,c.light);else{if(u.light)return 1;if(c.light)return-1}if(f!==0)return f;if(u.dark&&c.dark)f=v(u.dark,c.dark);else{if(u.dark)return 1;if(c.dark)return-1}return f}function w(u,c){if(u.command!==c.command)return u.command<c.command?-1:1;if(u.title!==c.title)return u.title<c.title?-1:1;if(u.tooltip!==c.tooltip){if(u.tooltip!==void 0&&c.tooltip!==void 0)return u.tooltip<c.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(u.arguments===c.arguments)return 0;if(u.arguments)if(c.arguments){if(u.arguments.length!==c.arguments.length)return u.arguments.length-c.arguments.length}else return 1;else return-1;for(let f=0;f<u.arguments.length;f++){const b=u.arguments[f],d=c.arguments[f];if(b!==d)return b<d?-1:1}return 0}function s(u,c){let f=(0,I.comparePaths)(u.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(f!==0)return f;if(u.command&&c.command)f=w(u.command,c.command);else{if(u.command)return 1;if(c.command)return-1}if(f!==0)return f;if(u.decorations&&c.decorations)f=A(u.decorations,c.decorations);else{if(u.decorations)return 1;if(c.decorations)return-1}return f}function o(u,c){for(let f=0;f<u.length;f++)if(u[f]!==c[f])return!1;return!0}function g(u,c){return u.command===c.command&&u.title===c.title&&u.tooltip===c.tooltip&&(u.arguments&&c.arguments?o(u.arguments,c.arguments):u.arguments===c.arguments)}function a(u,c){return(0,_.equals)(u,c,g)}class S{constructor(c,f,b){this._extension=c,this._proxy=f,this._sourceControlHandle=b,this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){c=c??"",this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(c){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}showValidationMessage(c,f){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,c,f)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=S;class n{constructor(c,f,b,d,k){this._proxy=c,this._commands=f,this._sourceControlHandle=b,this._id=d,this._label=k,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,f){const b=this._resourceStatesCommandsMap.get(c);return b?(0,P.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(s),b=(0,_.sortedDiff)(this._resourceSnapshot,c,s).map(R=>{const N=R.toInsert.map(B=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,B);const U=B.resourceUri;let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const Y=new C.DisposableStore;H=this._commands.converter.toInternal(B.command,Y),this._resourceStatesDisposablesMap.set(F,Y)}else this._resourceStatesCommandsMap.set(F,B.command);const x=p(B.decorations),M=B.decorations&&p(B.decorations.light)||x,W=B.decorations&&p(B.decorations.dark)||x,z=[M,W],O=B.decorations&&B.decorations.tooltip||"",V=B.decorations&&!!B.decorations.strikeThrough,K=B.decorations&&!!B.decorations.faded,G=B.contextValue||"";return{rawResource:[F,U,z,O,V,K,G,H],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),d=b.map(({start:R,deleteCount:N,toInsert:B})=>[R,N,B.map(F=>F.rawResource)]),k=b.reverse();for(const{start:R,deleteCount:N,toInsert:B}of k){const F=B.map(H=>H.handle),U=this._handlesSnapshot.splice(R,N,...F);for(const H of U)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=c,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(c,f,b,d,k,R){this._extension=c,this._proxy=f,this._commands=b,this._id=d,this._label=k,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new S(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,d,k,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=c;const f=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(c){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=c;const f=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:f??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&a(this._statusBarCommands,c))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=c;const f=(c||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(c,f){const b=new n(this._proxy,this._commands,this.handle,c,f),d=i.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,d),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const c=[],f=[];for(const[b,d]of this.createdResourceGroups){d.dispose();const k=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});i.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),k.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),c.push([b.handle,b.id,b.label,b.features]);const R=b._takeResourceStateSnapshot();R.length>0&&f.push([b.handle,R]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,c,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(f=>{const b=f._takeResourceStateSnapshot();b.length!==0&&c.push([f.handle,b])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,je([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let r=class Hi{constructor(c,f,b){this._commands=f,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=c.getProxy(D.MainContext.MainThreadSCM),this._telemetry=c.getProxy(D.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===3){const k=this._sourceControls.get(d.sourceControlHandle);if(!k)return d;const R=k.getResourceGroup(d.groupHandle);return R?R.getResourceState(d.handle):d}else if(d&&d.$mid===4){const k=this._sourceControls.get(d.sourceControlHandle);return k?k.getResourceGroup(d.groupHandle):d}else if(d&&d.$mid===5){const k=this._sourceControls.get(d.handle);return k||d}return d}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,f,b,d){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,f,b,d),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const k=Hi._handlePool++,R=new t(c,this._proxy,this._commands,f,b,d);this._sourceControls.set(k,R);const N=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(c.identifier))||[];return N.push(R),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(c.identifier),N),R}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const f=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(c.identifier)),b=f&&f[f.length-1];return b&&b.inputBox}$provideOriginalResource(c,f,b){const d=m.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,d.toString());const k=this._sourceControls.get(c);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(d,b)).then(R=>R||null)}$onInputBoxValueChange(c,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const b=this._sourceControls.get(c);return b&&b.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(c,f,b,d){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,f,b);const k=this._sourceControls.get(c);if(!k)return Promise.resolve(void 0);const R=k.getResourceGroup(f);return R?R.$executeResourceCommand(b,d):Promise.resolve(void 0)}$validateInput(c,f,b){this.logService.trace("ExtHostSCM#$validateInput",c);const d=this._sourceControls.get(c);return!d||!d.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>d.inputBox.validateInput(f,b)).then(k=>{if(!k)return Promise.resolve(void 0);const R=E.MarkdownString.fromStrict(k.message);return R?Promise.resolve([R,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};r._handlePool=0,r=je([ze(2,L.ILogService)],r),e.ExtHostSCM=r});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[249],we([0,1,7,5,165,6,17,13]),function(J,e,m,i,y,C,P,D){"use strict";var _,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(h,p,v,A,w=m.StatusBarAlignment.Left,s){_.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,_,h,"f"),nt(this,I,p,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=A,this._alignment=w,this._priority=this.validatePriority(s)}validatePriority(h){if(!!(0,D.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!L.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,I,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,I,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let p;this._name?p=this._name:p=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const A=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,_,"f").$setEntry(this._entryId,h,p,this._text,A,this._command?.internal,v,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,_=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const p={message:h};return this._messages.unshift(p),this._update(),new m.Disposable(()=>{const v=this._messages.indexOf(p);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(h,p){this._proxy=h.getProxy(i.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new T(this)}createStatusBarEntry(h,p,v,A){return new L(this._proxy,this._commands,h,p,v,A)}setStatusBarMessage(h,p){const v=this._statusMessage.setMessage(h);let A;return typeof p=="number"?A=setTimeout(()=>v.dispose(),p):typeof p!="undefined"&&p.then(()=>v.dispose(),()=>v.dispose()),new m.Disposable(()=>{v.dispose(),clearTimeout(A)})}}e.ExtHostStatusBar=l}),define(ve[91],we([0,1,5,3,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(D){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}getValue(D,_,I){return this._proxy.$getValue(D,_).then(L=>L||I)}setValue(D,_,I){return this._proxy.$setValue(D,_,I)}$acceptValue(D,_,I){this._onDidChangeStorage.fire({shared:D,key:_,value:I})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(ve[67],we([0,1,4,26,11,66,2]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let D=class{constructor(I,L,T){this._logService=L,this._extHostFileSystem=T,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(I){return P.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(I){if(this._value)return P.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return P.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=je([ze(0,i.IExtHostInitDataService),ze(1,y.ILogService),ze(2,C.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[34],we([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,86,13,18]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class w{constructor(u,c,f,b){this._proxy=u,this._id=c,this._creationOptions=f,this._name=b,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(k=>this._pidPromiseComplete=k);const d=this;this.value={get name(){return d._name||""},get processId(){return d._pidPromise},get creationOptions(){return d._creationOptions},get exitStatus(){return d._exitStatus},get state(){return d._state},sendText(k,R=!0){d._checkDisposed(),d._proxy.$sendText(d._id,k,R)},show(k){d._checkDisposed(),d._proxy.$show(d._id,k)},hide(){d._checkDisposed(),d._proxy.$hide(d._id)},dispose(){d._disposed||(d._disposed=!0,d._proxy.$dispose(d._id))},get dimensions(){if(!(d._cols===void 0||d._rows===void 0))return{columns:d._cols,rows:d._rows}}}}async create(u,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,v.withNullAsUndefined)(u.shellPath),shellArgs:(0,v.withNullAsUndefined)(u.shellArgs),cwd:(0,v.withNullAsUndefined)(u.cwd),env:(0,v.withNullAsUndefined)(u.env),icon:(0,v.withNullAsUndefined)(n(u.iconPath)),color:p.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,v.withNullAsUndefined)(u.message),strictEnv:(0,v.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(u.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,v.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,c,f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:p.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(u,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,c){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,c){return u===this._cols&&c===this._rows||u===0||c===0?!1:(this._cols=u,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=w;class s{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,c){this._pty.setDimensions?.({columns:u,rows:c})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let o=1,g=class extends D.Disposable{constructor(u,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[f,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,c){const f=new w(this._proxy,(0,E.generateUuid)(),u,u.name),b=new s(u.pty);return f.createExtensionTerminal(u.location,this._serializeParentTerminal(u,c).resolvedExtHostIdentifier,n(u.iconPath),t(u.color)).then(d=>{const k=this._setupExtHostProcessListeners(d,b);this._terminalProcessDisposables[d]=k}),this._terminals.push(f),f.value}_serializeParentTerminal(u,c){if(c=c||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const f=u.location.parentTerminal;if(f){const b=this._terminals.find(d=>d.value===f);b&&(c.resolvedExtHostIdentifier=b._id)}}else u.location&&typeof u.location!="object"?c.location=u.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(u,c){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const b=new s(c),d=this._setupExtHostProcessListeners(u,b);this._terminalProcessDisposables[u]=d}async $acceptActiveTerminalChanged(u){const c=this._activeTerminal;if(u===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(u);f&&(this._activeTerminal=f,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,c){const f=this._getTerminalById(u);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:c})}async $acceptTerminalDimensions(u,c,f){const b=this._getTerminalById(u);b&&b.setDimensions(c,f)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(u,c,f){this._terminalProcesses.get(u)?.resize(c,f)}async $acceptTerminalTitleChange(u,c){const f=this._getTerminalById(u);f&&(f.name=c)}async $acceptTerminalClosed(u,c){const f=this._getTerminalObjectIndexById(this._terminals,u);if(f!==null){const b=this._terminals.splice(f,1)[0];b.setExitCode(c),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(u,c,f,b){if(c){const R=this._getTerminalObjectIndexById(this._terminals,c);if(R!==null){this._terminals[R]._id=u,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const d={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:C.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},k=new w(this._proxy,u,d,f);this._terminals.push(k),this._onDidOpenTerminal.fire(k.value),k.isOpen=!0}async $acceptTerminalProcessId(u,c){const f=this._getTerminalById(u);f&&f._setProcessId(c)}async $startExtensionTerminal(u,c){const f=this._getTerminalById(u);if(!f)return{message:(0,I.localize)(0,null,u)};f.isOpen||await new Promise(d=>{const k=this.onDidOpenTerminal(async R=>{R===f.value&&(k.dispose(),d())})});const b=this._terminalProcesses.get(u);b?b.startSendingEvents(c):this._extensionTerminalAwaitingStart[u]={initialDimensions:c}}_setupExtHostProcessListeners(u,c){const f=new D.DisposableStore;f.add(c.onProcessReady(d=>this._proxy.$sendProcessReady(u,d.pid,d.cwd))),f.add(c.onDidChangeProperty(d=>this._proxy.$sendProcessProperty(u,d))),this._bufferer.startBuffering(u,c.onProcessData),f.add(c.onProcessExit(d=>this._onProcessExit(u,d))),this._terminalProcesses.set(u,c);const b=this._extensionTerminalAwaitingStart[u];return b&&c instanceof s&&(c.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),f}$acceptProcessAckDataEvent(u,c){this._terminalProcesses.get(u)?.acknowledgeDataEvent(c)}$acceptProcessInput(u,c){this._terminalProcesses.get(u)?.input(c)}$acceptTerminalInteraction(u){const c=this._getTerminalById(u);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(u,c,f){try{this._terminalProcesses.get(u)?.resize(c,f)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(u,c){this._terminalProcesses.get(u)?.shutdown(c)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(c=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:c}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,c,f){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,f),this._proxy.$registerProfileProvider(c,u.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(u,c){const f=new l.CancellationTokenSource().token;let b=await this._profileProviders.get(u)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(b&&!("options"in b)&&(b={options:b}),!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,c);return}this.createTerminalFromOptions(b.options,c)}}async $provideLinks(u,c){const f=this._getTerminalById(u);if(!f)return[];this._terminalLinkCache.delete(u);const b=this._terminalLinkCancellationSource.get(u);b&&b.dispose(!0);const d=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,d);const k=[],R={terminal:f.value,line:c},N=[];for(const U of this._linkProviders)N.push(A.Promises.withAsyncBody(async H=>{d.token.onCancellationRequested(()=>H({provider:U,links:[]}));const x=await U.provideTerminalLinks(R,d.token)||[];d.token.isCancellationRequested||H({provider:U,links:x})}));const B=await Promise.all(N);if(d.token.isCancellationRequested)return[];const F=new Map;for(const U of B)U&&U.links.length>0&&k.push(...U.links.map(H=>{const x={id:o++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return F.set(x.id,{provider:U.provider,link:H}),x}));return this._terminalLinkCache.set(u,F),k}$activateLink(u,c){const f=this._terminalLinkCache.get(u)?.get(c);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(u,c){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const f=this._terminalProcessDisposables[u];f&&(f.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,c)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,c){const f=this._getTerminalObjectIndexById(u,c);return f!==null?u[f]:null}_getTerminalObjectIndexById(u,c){let f=null;return u.some((b,d)=>b._id===c?(f=d,!0):!1),f}getEnvironmentVariableCollection(u){let c=this._environmentVariableCollections.get(u.identifier.value);return c||(c=new a,this._setEnvironmentVariableCollection(u.identifier.value,c)),c}_syncEnvironmentVariableCollection(u,c){const f=(0,T.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(u,c.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(u){u.forEach(c=>{const f=c[0],b=new a(c[1]);this._setEnvironmentVariableCollection(f,b)})}$acceptDefaultProfile(u,c){this._defaultProfile=u,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(u,c){this._environmentVariableCollections.set(u,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,c)})}};g=je([ze(1,P.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class a{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,c){this._setIfDiffers(u,{value:c,type:_.EnvironmentVariableMutatorType.Replace})}append(u,c){this._setIfDiffers(u,{value:c,type:_.EnvironmentVariableMutatorType.Append})}prepend(u,c){this._setIfDiffers(u,{value:c,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,c){const f=this.map.get(u);(!f||f.value!==c.value||f.type!==c.type)&&(this.map.set(u,c),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,c){this.map.forEach((f,b)=>u.call(c,b,f,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let S=class extends g{constructor(u){super(!1,u)}createTerminal(u,c,f){throw new L.NotSupportedError}createTerminalFromOptions(u,c){throw new L.NotSupportedError}};S=je([ze(0,P.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function n(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function t(r){return p.ThemeColor.isThemeColor(r)?r:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[250],we([0,1,16,22,21,3,75,47,6,25,13,32,5,14,63,17,7,221,126,89]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(R,N){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(l.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new S(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?p.TestItem.toItemFromContext(B):B})}createTestController(R,N){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const B=new _.DisposableStore,F=B.add(new A.SingleUseTestCollection(R));F.root.label=N;const U=new Map,H=this.proxy,x={items:F.root.children,get label(){return N},set label(W){N=W,F.root.label=W,H.$updateControllerLabel(R,N)},get id(){return R},createRunProfile:(W,z,O,V,K)=>{let G=(0,D.hash)(W);for(;U.has(G);)G++;const Q=new b(this.proxy,R,G,W,z,O,V,K);return U.set(G,Q),Q},createTestItem(W,z,O){return new h.TestItemImpl(R,W,z,O)},createTestRun:(W,z,O=!0)=>this.runTracker.createTestRun(R,F,W,z,O),set resolveHandler(W){F.resolveHandler=W},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};x.createRunConfiguration=x.createRunProfile,H.$registerTestController(R,N),B.add((0,_.toDisposable)(()=>H.$unregisterTestController(R)));const M={controller:x,collection:F,profiles:U};return this.controllers.set(R,M),B.add((0,_.toDisposable)(()=>this.controllers.delete(R))),B.add(F.onDidGenerateDiff(W=>H.$publishDiff(R,W))),x}createTestObserver(){return this.observer.checkout()}async runTests(R,N=y.CancellationToken.None){const B=n(R);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(B.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(U=>U.id)??[F.collection.root.id],profileGroup:d[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:R.exclude?.map(U=>U.id)},N)}$provideFileCoverage(R,N,B){return(0,m.mapFind)(this.runTracker.trackers,U=>U.id===R?U.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(R,N,B,F){return(0,m.mapFind)(this.runTracker.trackers,H=>H.id===R?H.getCoverage(N):void 0)?.resolveFileCoverage(B,F)??Promise.resolve([])}$configureRunProfile(R,N){this.controllers.get(R)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(N=>(0,I.deepFreeze)(p.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,N){const B=this.controllers.get(s.TestId.fromString(R).controllerId)?.collection;B&&(await B.expand(R,N<0?1/0:N),B.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,N){const B=this.controllers.get(R.controllerId);if(!B)return;const{collection:F,profiles:U}=B,H=U.get(R.profileId);if(!H)return;const x=R.testIds.map(O=>F.tree.get(O)).filter(L.isDefined),M=R.excludeExtIds.map(O=>B.collection.tree.get(O)).filter(L.isDefined).filter(O=>x.some(V=>V.fullId.compare(O.fullId)===2));if(!x.length)return;const W=new v.TestRunRequest(x.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:x.map(O=>O.actual),M.map(O=>O.actual),H),z=this.runTracker.prepareForMainThreadTestRun(W,t.fromInternal(R,B.collection),N);try{await H.runHandler(W,N)}finally{z.isRunning&&!N.isCancellationRequested&&await C.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};g=je([ze(0,E.IExtHostRpcService)],g),e.ExtHostTesting=g;class a extends _.Disposable{constructor(R,N,B){super();this.dto=R,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const N=this.dto.id,B=this.dto.controllerId,F=(0,T.generateUuid)(),U=new r(this.proxy,N,F),H=z=>(O,...V)=>{if(M){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),z(O,...V))},x=(z,O)=>{const V=O instanceof Array?O.map(p.TestMessage.from):[p.TestMessage.from(O)];if(z.uri&&z.range){const K={range:p.Range.from(z.range),uri:z.uri};for(const G of V)G.location=G.location||K}this.proxy.$appendTestMessagesInRun(N,F,s.TestId.fromExtHostTestItem(z,B).toString(),V)};let M=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return U.coverageProvider},set coverageProvider(z){U.coverageProvider=z},enqueued:H(z=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(z,B).toString(),1)}),skipped:H(z=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(z,B).toString(),5)}),started:H(z=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(z,B).toString(),2)}),errored:H((z,O,V)=>{x(z,O),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(z,B).toString(),6,V)}),failed:H((z,O,V)=>{x(z,O),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(z,B).toString(),4,V)}),passed:H((z,O)=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,O)}),appendOutput:(z,O,V)=>{M||(V&&(this.dto.isIncluded(V)?this.ensureTestIsKnown(V):V=void 0),this.proxy.$appendOutputToRun(N,F,i.VSBuffer.fromString(z),O&&p.location.from(O),V&&s.TestId.fromExtHostTestItem(V,B).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:W,coverage:U}),this.proxy.$startedTestRunTask(N,{id:F,name:R,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const F=p.TestItem.from(R);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===B))break;R=R.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class S{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,N,B){return this.getTracker(R,N,B)}cancelRunById(R){for(const N of this.tracked.values())if(N.id===R){N.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,N,B,F,U){const H=this.tracked.get(B);if(H)return H.createRun(F);const x=t.fromPublic(R,N,B,U),M=n(B);this.proxy.$startedExtensionTestRun({controllerId:R,profile:M&&{group:d[M.kind],id:M.profileId},exclude:B.exclude?.map(z=>z.id)??[],id:x.id,include:B.include?.map(z=>z.id)??[N.root.id],persist:U});const W=this.getTracker(B,x);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),W.createRun(F)}getTracker(R,N,B){const F=new a(N,this.proxy,B);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=S;const n=k=>{if(!!k.profile){if(!(k.profile instanceof b))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class t{constructor(R,N,B,F,U,H){this.controllerId=R,this.id=N,this.isPersisted=U,this.colllection=H,this.includePrefix=B.map(x=>x+"\0"),this.excludePrefix=F.map(x=>x+"\0")}static fromPublic(R,N,B,F){return new t(R,(0,T.generateUuid)(),B.include?.map(U=>s.TestId.fromExtHostTestItem(U,R).toString())??[R],B.exclude?.map(U=>s.TestId.fromExtHostTestItem(U,R).toString())??[],F,N)}static fromInternal(R,N){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,N)}isIncluded(R){const N=s.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=t;class r{constructor(R,N,B){this.proxy=R,this.runId=N,this.taskId=B}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(R,N){const B=await this.fileCoverage;let F=B?.[R];return!this._coverageProvider||!B||!F?[]:(F.detailedCoverage||(F=B[R]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class u extends w.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,p.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:N,removed:B}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...B].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,N){return{...R,revived:p.TestItem.toPlain(R.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=c;class f{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(N=>N.revived)},dispose:(0,P.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class b{constructor(R,N,B,F,U,H,x=!1,M=void 0){this.controllerId=N,this.profileId=B,this._label=F,this.kind=U,this.runHandler=H,this._isDefault=x,this._tag=M,o.set(this,void 0),nt(this,o,R,"f");const W=d[U];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Be(this,o,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:M?p.TestTag.namespace(this.controllerId,M.id):null,label:F,group:W,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Be(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Be(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Be(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?p.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Be(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Be(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=b,o=new WeakMap;const d={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(ve[251],we([0,1,3,16,5,129,17,7]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(L,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const T=this._extHostDocumentsAndEditors.allEditors();return L?T:T.map(l=>l.value)}async showTextDocument(L,T,l){let E;typeof T=="number"?E={position:P.ViewColumn.from(T),preserveFocus:l}:typeof T=="object"?E={position:P.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?P.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:E={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(L.uri,E),p=h&&this._extHostDocumentsAndEditors.getEditor(h);if(p)return p.value;throw h?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new C.TextEditorDecorationType(this._proxy,L,T).value}$acceptEditorPropertiesChanged(L,T){const l=this._extHostDocumentsAndEditors.getEditor(L);if(!l)throw new Error("unknown text editor");if(T.options&&l._acceptOptions(T.options),T.selections){const E=T.selections.selections.map(P.Selection.to);l._acceptSelections(E)}if(T.visibleRanges){const E=i.coalesce(T.visibleRanges.map(P.Range.to));l._acceptVisibleRanges(E)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...T.options,lineNumbers:P.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const E=D.TextEditorSelectionChangeKind.fromValue(T.selections.source),h=T.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:h,kind:E})}if(T.visibleRanges){const E=i.coalesce(T.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const T in L){const l=this._extHostDocumentsAndEditors.getEditor(T);if(!l)throw new Error("Unknown text editor");const E=P.ViewColumn.to(L[T]);l.value.viewColumn!==E&&(l._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=_}),define(ve[252],we([0,1,2,4,5,6,7]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class D{constructor(L,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(y.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const E=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(E))?.get(l.handle)}return l}})}async $getTimeline(L,T,l,E,h){return this._providers.get(L)?.provideTimeline(m.URI.revive(T),l,E,h)}registerTimelineProvider(L,T,l,E){const h=new C.DisposableStore,p=this.convertTimelineItem(T.id,E,h).bind(this);let v;T.onDidChange&&(v=T.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:T.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:L,onDidChange:void 0,async provideTimeline(w,s,o,g){g?.resetCache&&(h.clear(),A.get(T.id)?.clear());const a=await T.provideTimeline(w,s,o);if(a==null)return;const S=p(w,g);return{...a,source:T.id,items:a.items.map(S)}},dispose(){for(const w of A.values())w.get(T.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(L,T,l){return(E,h)=>{let p;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(L);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(L,v));const A=_(E);p=v.get(A),p===void 0&&(p=new Map,v.set(A,p))}return v=>{const{iconPath:A,...w}=v,s=`${L}|${v.id??v.timestamp}`;p?.set(s,v);let o,g,a;return v.iconPath&&(A instanceof P.ThemeIcon?a={id:A.id,color:A.color}:m.URI.isUri(A)?(o=A,g=A):{light:o,dark:g}=A),{...w,id:w.id??void 0,handle:s,source:L,command:v.command?T.toInternal(v.command,l):void 0,icon:o,iconDark:g,themeIcon:a,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,C.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=D;function _(I){return I?.toString()}}),define(ve[253],we([0,1,6,10,2,5]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,L,T){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const l=T.schemes.find(E=>!P.supportedSchemes.has(E));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,T.schemes,_,T.label),(0,m.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,L){const T=this._openers.get(_);if(!T)throw new Error(`Unknown opener with id: ${_}`);const l=y.URI.revive(I);return T.canOpenExternalUri(l,L)}async $openUri(_,I,L){const T=this._openers.get(_);if(!T)throw new Error(`Unknown opener id: '${_}'`);return T.openExternalUri(y.URI.revive(I.resolvedUri),{sourceUri:y.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ve[254],we([0,1,5,2,6,15,27]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(P.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const T=D.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(I)),this.handlers.set(T,L),this._proxy.$registerUriHandler(T,I),(0,y.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(I)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(I,L){const T=this.handlers.get(I);if(!T)return Promise.resolve(void 0);try{T.handleUri(i.URI.revive(L))}catch(l){(0,C.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(I){return i.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=D,D.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[68],we([0,1,3,10,2,178,203,88,5]),function(J,e,m,i,y,C,P,D,_){"use strict";var I,L,T,l,E,h,p,v,A,w,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(f,b,d,k,R,N,B){I.set(this,void 0),L.set(this,void 0),T.set(this,void 0),l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,""),v.set(this,void 0),A.set(this,!1),w.set(this,!1),s.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new m.Emitter),this._onDidDispose=Be(this,o,"f").event,nt(this,I,f,"f"),nt(this,L,b,"f"),nt(this,v,d,"f"),nt(this,l,k,"f"),nt(this,E,R,"f"),nt(this,h,N,"f"),nt(this,s,a(N),"f"),nt(this,T,B,"f")}dispose(){nt(this,A,!0,"f"),Be(this,o,"f").fire(),Be(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return nt(this,w,!0,"f"),(0,D.asWebviewUri)(f,Be(this,l,"f").remote)}get cspSource(){const f=Be(this,h,"f").extensionLocation;if(f.scheme===i.Schemas.https||f.scheme===i.Schemas.http){let b=f.toString();return b.endsWith("/")||(b+="/"),b+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,p,"f")}set html(f){this.assertNotDisposed(),Be(this,p,"f")!==f&&(nt(this,p,f,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(nt(this,w,!0,"f"),Be(this,T,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,L,"f").$setHtml(Be(this,I,"f"),f))}get options(){return this.assertNotDisposed(),Be(this,v,"f")}set options(f){this.assertNotDisposed(),Be(this,L,"f").$setOptions(Be(this,I,"f"),t(Be(this,h,"f"),Be(this,E,"f"),f)),nt(this,v,f,"f")}async postMessage(f){if(Be(this,A,"f"))return!1;const b=(0,P.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Be(this,s,"f")});return Be(this,L,"f").$postMessage(Be(this,I,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Be(this,A,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,I=new WeakMap,L=new WeakMap,T=new WeakMap,l=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,A=new WeakMap,w=new WeakMap,s=new WeakMap,o=new WeakMap;function a(c){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class S{constructor(f,b,d,k,R){this.initData=b,this.workspace=d,this._logService=k,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=f.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(f,b,d){const k=this.getWebview(f);if(k){const{message:R}=(0,P.deserializeWebviewMessage)(b,d.value);k._onMessageEmitter.fire(R)}}$onMissingCsp(f,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,b,d){const k=new g(f,this._webviewProxy,r(b),this.initData,this.workspace,d,this._deprecationService);return this._webviews.set(f,k),k._onDidDispose(()=>{this._webviews.delete(f)}),k}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=S;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function t(c,f,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||u(c,f)}}e.serializeWebviewOptions=t;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>y.URI.from(f))}}e.reviveOptions=r;function u(c,f){return[...(f?.getWorkspaceFolders()||[]).map(b=>b.uri),c.extensionLocation]}}),define(ve[255],we([0,1,21,47,6,10,23,2,17,68,87,5,7]),function(J,e,m,i,y,C,P,D,_,I,L,T,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(a,S){this.document=a,this._storagePath=S,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,S){await this.getEdit(a).undo(),S||this.disposeBackup()}async redo(a,S){await this.getEdit(a).redo(),S||this.disposeBackup()}disposeEdits(a){for(const S of a)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=o(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const S=this._edits.get(a,0);if(!S)throw new Error("No edit found");return S}}class h{constructor(){this._documents=new Map}get(a,S){return this._documents.get(this.key(a,S))}add(a,S,n){const t=this.key(a,S.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${S.uri}`);const r=new E(S,n);return this._documents.set(t,r),r}delete(a,S){const n=this.key(a,S.uri);this._documents.delete(n)}key(a,S){return`${a}@@@${S}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class v{constructor(){this._providers=new Map}addTextProvider(a,S,n){return this.add(0,a,S,n)}addCustomProvider(a,S,n){return this.add(1,a,S,n)}get(a){return this._providers.get(a)}add(a,S,n,t){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:a,extension:n,provider:t}),new l.Disposable(()=>this._providers.delete(S))}}class A{constructor(a,S,n,t,r){this._extHostDocuments=S,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new h,this._proxy=a.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,S,n,t){const r=new y.DisposableStore;return w(n)?(r.add(this._editorProviders.addTextProvider(S,a,n)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(a),S,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(a))):(r.add(this._editorProviders.addCustomProvider(S,a,n)),this.supportEditing(n)&&r.add(n.onDidChangeCustomDocument(u=>{const c=this.getCustomDocumentEntry(S,u.document.uri);if(s(u)){const f=c.addEdit(u);this._proxy.$onDidEdit(u.document.uri,S,f,u.label)}else this._proxy.$onContentChange(u.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(a),S,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(a))),l.Disposable.from(r,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(a,S,n,t,r){const u=this._editorProviders.get(S);if(!u)throw new Error(`No provider found for '${S}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${S}'`);const c=D.URI.revive(a),f=await u.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:t?.buffer},r);let b;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(b=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(S,f,b),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(a,S){const n=this._editorProviders.get(S);if(!n)throw new Error(`No provider found for '${S}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${S}'`);const t=D.URI.revive(a),{document:r}=this.getCustomDocumentEntry(S,t);this._documents.delete(S,r),r.dispose()}async $resolveWebviewEditor(a,S,n,t,r,u){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const f=_.ViewColumn.to(r),b=this._extHostWebview.createNewWebview(S,t.webviewOptions,c.extension),d=this._extHostWebviewPanels.createNewWebviewPanel(S,n,t.title,f,t.panelOptions,b),k=D.URI.revive(a);switch(c.type){case 1:{const{document:R}=this.getCustomDocumentEntry(n,k);return c.provider.resolveCustomEditor(R,d,u)}case 0:{const R=this._extHostDocuments.getDocument(k);return c.provider.resolveCustomTextEditor(R,d,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,S,n){this.getCustomDocumentEntry(S,a).disposeEdits(n)}async $onMoveCustomEditor(a,S,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const r=this._extHostWebviewPanels.getWebviewPanel(a);if(!r)throw new Error("No webview found");const u=D.URI.revive(S),c=this._extHostDocuments.getDocument(u);await t.provider.moveCustomTextEditor(c,r,m.CancellationToken.None)}async $undo(a,S,n,t){return this.getCustomDocumentEntry(S,a).undo(n,t)}async $redo(a,S,n,t){return this.getCustomDocumentEntry(S,a).redo(n,t)}async $revert(a,S,n){const t=this.getCustomDocumentEntry(S,a);await this.getCustomEditorProvider(S).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(a,S,n){const t=this.getCustomDocumentEntry(S,a);await this.getCustomEditorProvider(S).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(a,S,n,t){const r=this.getCustomDocumentEntry(S,a);return this.getCustomEditorProvider(S).saveCustomDocumentAs(r.document,D.URI.revive(n),t)}async $backup(a,S,n){const t=this.getCustomDocumentEntry(S,a),u=await this.getCustomEditorProvider(S).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(u),u.id}getCustomDocumentEntry(a,S){const n=this._documents.get(a,D.URI.revive(S));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(a){const n=this._editorProviders.get(a)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function w(g){return typeof g.resolveCustomTextEditor=="function"}function s(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function o(g){const a=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,i.hash)(a)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[256],we([0,1,3,6,2,32,17,68,5,7]),function(J,e,m,i,y,C,P,D,_,I){"use strict";var L,T,l,E,h,p,v,A,w,s,o,g,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends i.Disposable{constructor(u,c,f,b,d,k,R){super();L.set(this,void 0),T.set(this,void 0),l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,void 0),v.set(this,void 0),A.set(this,void 0),w.set(this,!0),s.set(this,!0),o.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,g,"f").event,a.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Be(this,a,"f").event,nt(this,L,u,"f"),nt(this,T,c,"f"),nt(this,l,f,"f"),nt(this,h,k,"f"),nt(this,A,d,"f"),nt(this,p,b,"f"),nt(this,E,R,"f")}dispose(){Be(this,o,"f")||(nt(this,o,!0,"f"),Be(this,g,"f").fire(),Be(this,T,"f").$disposeWebview(Be(this,L,"f")),Be(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,E,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(u){this.assertNotDisposed(),Be(this,p,"f")!==u&&(nt(this,p,u,"f"),Be(this,T,"f").$setTitle(Be(this,L,"f"),u))}get iconPath(){return this.assertNotDisposed(),Be(this,v,"f")}set iconPath(u){this.assertNotDisposed(),Be(this,v,"f")!==u&&(nt(this,v,u,"f"),Be(this,T,"f").$setIconPath(Be(this,L,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Be(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,A,"f")=="number"&&Be(this,A,"f")<0))return Be(this,A,"f")}get active(){return this.assertNotDisposed(),Be(this,s,"f")}get visible(){return this.assertNotDisposed(),Be(this,w,"f")}_updateViewState(u){Be(this,o,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(nt(this,s,u.active,"f"),nt(this,w,u.visible,"f"),nt(this,A,u.viewColumn,"f"),Be(this,a,"f").fire({webviewPanel:this}))}reveal(u,c){this.assertNotDisposed(),Be(this,T,"f").$reveal(Be(this,L,"f"),{viewColumn:u?P.ViewColumn.from(u):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Be(this,o,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,l=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,A=new WeakMap,w=new WeakMap,s=new WeakMap,o=new WeakMap,g=new WeakMap,a=new WeakMap;class n{constructor(u,c,f){this.webviews=c,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(u,c,f,b,d={}){const k=typeof b=="object"?b.viewColumn:b,R={viewColumn:P.ViewColumn.from(k),preserveFocus:typeof b=="object"&&!!b.preserveFocus},N=(0,D.shouldSerializeBuffersForPostMessage)(u),B=n.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(u),B,c,{title:f,panelOptions:t(d),webviewOptions:(0,D.serializeWebviewOptions)(u,this.workspace,d),serializeBuffersForPostMessage:N},R);const F=this.webviews.createNewWebview(B,d,u);return this.createNewWebviewPanel(B,c,f,k,d,F)}$onDidChangeWebviewPanelViewStates(u){const c=Object.keys(u);c.sort((f,b)=>{const d=u[f],k=u[b];return d.active?1:k.active?-1:+d.visible-+k.visible});for(const f of c){const b=this.getWebviewPanel(f);if(!b)continue;const d=u[f];b._updateViewState({active:d.active,visible:d.visible,viewColumn:P.ViewColumn.to(d.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,c,f){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:f,extension:u}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(u)}),new I.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(u,c,f,b){const d=this._serializers.get(c);if(!d)throw new Error(`No serializer found for '${c}'`);const{serializer:k,extension:R}=d,N=this.webviews.createNewWebview(u,f.webviewOptions,R),B=this.createNewWebviewPanel(u,c,f.title,b,f.panelOptions,N);await k.deserializeWebviewPanel(B,f.state)}createNewWebviewPanel(u,c,f,b,d,k){const R=new S(u,this._proxy,c,f,b,d,k);return this._webviewPanels.set(u,R),R}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=n;function t(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[257],we([0,1,3,6,68,5,7]),function(J,e,m,i,y,C,P){"use strict";var D,_,I,L,T,l,E,h,p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends i.Disposable{constructor(o,g,a,S,n,t){super();D.set(this,void 0),_.set(this,void 0),I.set(this,void 0),L.set(this,void 0),T.set(this,!1),l.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Be(this,p,"f").event,v.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,v,"f").event,nt(this,I,a,"f"),nt(this,E,S,"f"),nt(this,D,o,"f"),nt(this,_,g,"f"),nt(this,L,n,"f"),nt(this,l,t,"f")}dispose(){Be(this,T,"f")||(nt(this,T,!0,"f"),Be(this,v,"f").fire(),Be(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,E,"f")}set title(o){this.assertNotDisposed(),Be(this,E,"f")!==o&&(nt(this,E,o,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,D,"f"),o))}get description(){return this.assertNotDisposed(),Be(this,h,"f")}set description(o){this.assertNotDisposed(),Be(this,h,"f")!==o&&(nt(this,h,o,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,D,"f"),o))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,L,"f")}get viewType(){return Be(this,I,"f")}_setVisible(o){o===Be(this,l,"f")||Be(this,T,"f")||(nt(this,l,o,"f"),Be(this,p,"f").fire())}show(o){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,D,"f"),!!o)}assertNotDisposed(){if(Be(this,T,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,I=new WeakMap,L=new WeakMap,T=new WeakMap,l=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap;class w{constructor(o,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,g,a,S){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:a,extension:o}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(o),g,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(o,g,a,S,n){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:r,extension:u}=t,c=this._extHostWebview.createNewWebview(o,{},u),f=new A(o,this._proxy,g,a,c,!0);this._webviewViews.set(o,f),await r.resolveWebviewView(f,{state:S},n)}async $onDidChangeWebviewViewVisibility(o,g){this.getWebviewView(o)._setVisible(g)}async $disposeWebviewView(o){const g=this.getWebviewView(o);this._webviewViews.delete(o),g.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const g=this._webviewViews.get(o);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=w}),define(ve[133],we([0,1,3,5,2,10,8,4,14]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class zi{constructor(T){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=T.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,l){let E;if(typeof T=="string"){E=T;try{T=y.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,P.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,E,l)}async asExternalUri(T,l){if((0,P.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(T,l);return y.URI.from(E)}};I.InitialState={focused:!0},I=je([ze(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[258],we([0,1,9,81,32,38,6,5,2,14]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(l,E){super();const h=l.getProxy(D.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async p=>{const v=_.URI.file((0,m.join)((0,i.tmpdir)(),(0,y.generateUuid)()));return await h.$download(p,v),v})}};L=je([ze(0,I.IExtHostRpcService),ze(1,C.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ve[259],we([0,1,131,10,187,32]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends m.ExtHostLoggerService{doCreateLogger(_,I,L){return _.scheme===i.Schemas.file?new y.SpdLogLogger(L?.name||(0,C.generateUuid)(),_.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.doCreateLogger(_,I,L)}}e.ExtHostLoggerService=P}),define(ve[260],we([0,1,60,9,2,67,6,10,18,28]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const S=await super._getWorkspaceStorageURI(a);if(S.scheme!==D.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const n=S.fsPath;let t=0;do{let r;t===0?r=n:r=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await T(r);const u=i.join(r,"vscode.lock"),c=await p(this._logService,u,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(r);t++}while(t<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const l=1e3,E=10*60*1e3;class h extends P.Disposable{constructor(a,S){super();this.logService=a,this.filename=S,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await v(a,S);(!n||n.pid!==process.pid)&&(a.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(S,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+a};await I.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function p(g,a,S){try{const t={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const n=await v(g,a);return!n||n.pid!==process.pid?S?(g.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),s(g,a)):(g.info(`Lock '${a}': Lock acquired.`),new h(g,a))}async function v(g,a){let S;try{S=await I.Promises.readFile(a)}catch(n){return g.error(n),null}try{return JSON.parse(String(S))}catch(n){return g.error(n),null}}async function A(g,a){let S;try{S=await I.Promises.stat(a)}catch(n){return g.error(n),0}return S.mtime.getTime()}function w(g){try{return process.kill(g,0),!0}catch{return!1}}async function s(g,a){const S=await v(g,a);if(!S)return g.info(`Lock '${a}': Could not read pid of lock holder.`),o(g,a);if(S.willReleaseAt){let c=S.willReleaseAt-Date.now();if(c<5e3){for(c>0?g.info(`Lock '${a}': The lockfile is scheduled to be released in ${c} ms.`):g.info(`Lock '${a}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,_.timeout)(Math.min(100,c)),await A(g,a)===0)return o(g,a);c=S.willReleaseAt-Date.now()}return o(g,a)}}if(!w(S.pid))return g.info(`Lock '${a}': The pid ${S.pid} appears to be gone.`),o(g,a);const n=await A(g,a),t=Date.now()-n;if(t<=E)return g.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const r=await A(g,a),u=Date.now()-r;return u<=E?(g.info(`Lock '${a}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(g.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),o(g,a))}async function o(g,a){g.info(`Lock '${a}': Deleting a stale lock.`);try{await I.Promises.unlink(a)}catch{}return p(g,a,!0)}}),define(ve[261],we([0,1,32,14,34]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,_,I){return this.createTerminalFromOptions({name:D,shellPath:_,shellArgs:I})}createTerminalFromOptions(D,_){const I=new y.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),D,D.name);return this._terminals.push(I),I.create(D,this._serializeParentTerminal(D,_)),I.value}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ve[262],we([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,78,11]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(f,b,d){this.remoteAddress=f,this.localAddress=b,this._dispose=d,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(c){const f=c.trim().split(`
`),b=[];return f.forEach(k=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(k);R&&R.length>=3&&b.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),b.reduce((k,R)=>(k[R.socket]=R,k),{})}e.getSockets=s;function o(...c){const f=[].concat(...c.map(a));return[...new Map(f.filter(b=>b.st==="0A").map(b=>{const d=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:g(d[0]),port:parseInt(d[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=o;function g(c){let f="";if(c.length===8)for(let b=c.length-2;b>=0;b-=2)f+=parseInt(c.substr(b,2),16),b!==0&&(f+=".");else for(let b=c.length-4;b>=0;b-=4)f+=parseInt(c.substr(b,4),16).toString(16),b!==0&&(f+=":");return f}e.parseIpAddress=g;function a(c){const f=c.trim().split(`
`),b=f.shift().trim().split(/\s+/).filter(k=>k!=="rx_queue"&&k!=="tm->when");return f.map(k=>k.trim().split(/\s+/).reduce((R,N,B)=>(R[b[B]||B]=N,R),{}))}e.loadConnectionTable=a;function S(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const f=c.trim().split(`
`),b=[];return f.forEach(d=>{const k=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(d);k&&k.length>=4&&b.push({pid:parseInt(k[1],10),ppid:parseInt(k[2]),cmd:k[3]})}),b}e.getRootProcesses=n;async function t(c,f,b){const d=b.reduce((R,N)=>(R[N.pid]=N,R),{}),k=[];return c.forEach(({socket:R,ip:N,port:B})=>{const F=f[R]?f[R].pid:void 0,U=F?d[F]?.cmd:void 0;F&&U&&!S(U)&&k.push({host:N,port:B,detail:U,pid:F})}),k}e.findPorts=t;function r(c,f,b){const d=new Map,k=n(f);for(const R of c){const N=b.get(R.port);if(N){d.set(R.port,N);continue}const B=k.find(F=>F.cmd.includes(`${R.port}`));if(B){let F=B,U;do U=k.find(H=>H.ppid===F.pid),U&&(F=U);while(U);d.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else d.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return d}e.tryFindRootPorts=r;let u=class extends C.Disposable{constructor(f,b,d){super();this.logService=d,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),l.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const d=await this._proxy.$openTunnel(b,f.displayName);if(d){const k=new w(d.remoteAddress,d.localAddress,()=>this._proxy.$closeTunnel(d.remoteAddress));return this._register(k),k}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,b){const d=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(d,{selector:f,provider:b}),this._proxy.$registerPortsAttributesProvider(f,d),new T.Disposable(()=>{this._portAttributesProviders.delete(d),this._proxy.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(f,b,d,k,R){const N=[];for(const F of f){const U=this._portAttributesProviders.get(F);if(!U)return[];N.push(...await Promise.all(b.map(async H=>U.provider.providePortAttributes(H,d,k,R))))}const B=N.filter(F=>!!F);return B.length>0?B.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let b=new v.MovingAverage,d;for(;this._candidateFindingEnabled;){const k=new Date().getTime(),R=(await this.findCandidatePorts()).filter(B=>(0,p.isLocalhost)(B.host)||(0,p.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-k;b.update(N),(!d||JSON.stringify(d)!==JSON.stringify(R))&&(d=R,await this._proxy.$onFoundNewCandidates(d)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let b=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&b.length===0&&(b=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:b})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,b){if(this._extensionTunnels.has(f.host)){const d=this._extensionTunnels.get(f.host);d.has(f.port)&&(b&&d.get(f.port).disposeListener.dispose(),await d.get(f.port).tunnel.dispose(),d.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this._forwardPortProvider(f,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const k=await d;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const R=this._register(k.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(k.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:k,disposeListener:R}),E.TunnelDto.fromApiTunnel(k)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const b=await Promise.all(f.map(k=>this._showCandidatePort(k.host,k.port,k.detail??""))),d=f.filter((k,R)=>b[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(k=>k.port).join(", ")} to ${d.map(k=>k.port).join(", ")}`),d}async findCandidatePorts(){let f="",b="";try{f=await L.Promises.readFile("/proc/net/tcp","utf8"),b=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const d=o(f,b),k=await new Promise(M=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,z,O)=>{M(z)})}),R=s(k),N=await L.Promises.readdir("/proc"),B=[];for(let M of N)try{const W=Number(M),z=I.joinPath(D.URI.file("/proc"),M);if((await L.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(W)){const V=await L.Promises.readlink(I.joinPath(z,"cwd").fsPath),K=await L.Promises.readFile(I.joinPath(z,"cmdline").fsPath,"utf8");B.push({pid:W,cwd:V,cmd:K})}}catch{}const F=[],U=d.filter(M=>{const W=R[M.socket];return W||F.push(M),W}),H=t(U,R,B);let x;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const M=await new Promise(W=>{(0,_.exec)("ps -F -A -l | grep root",(z,O,V)=>{W(O)})});this._foundRootPorts=r(F,M,this._foundRootPorts),x=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.join(", ")}`)}return H.then(M=>x?M.concat(x):M)}};u=je([ze(0,i.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,A.ILogService)],u),e.ExtHostTunnelService=u}),define(ve[263],we([0,1,18,22,21,15,3,6,102,227,53]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(d,k){try{return JSON.stringify(d,k)}catch{return"null"}}const E="$$ref$$",h={[E]:-1};class p{constructor(k,R){this.jsonString=k,this.referencedBuffers=R}}function v(d,k=null,R=!1){const N=[];return{jsonString:(R?l:JSON.stringify)(d,(F,U)=>{if(typeof U=="undefined")return h;if(typeof U=="object"){if(U instanceof i.VSBuffer){const H=N.push(U)-1;return{[E]:H}}if(k)return k(F,U)}return U}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=v;function A(d,k,R){return JSON.parse(d,(N,B)=>{if(B){const F=B[E];if(typeof F=="number")return k[F];if(R&&B.$mid===1)return R.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=A;function w(d,k){return JSON.stringify(d,k)}function s(d){return d?(k,R)=>R&&R.$mid===1?d.transformOutgoing(R):R:null}var o;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},S=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends D.Disposable{constructor(k,R=null,N=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=k,this._logger=R,this._uriTransformer=N,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,F=L.ProxyIdentifier.count;B<F;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(k=>{this._pendingRPCReplies[k].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(k){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(k){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(k){this._responsiveState!==k&&(this._responsiveState=k,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(k){return this._uriTransformer?(0,_.transformIncomingURIs)(k,this._uriTransformer):k}getProxy(k){const{nid:R,sid:N}=k;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,N)),this._proxies[R]}_createProxy(k,R){let N={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===36&&(B[F]=(...U)=>this._remoteCall(k,F,U)),F===n?R:B[F])};return new Proxy(Object.create(null),N)}set(k,R){return this._locals[k.nid]=R,R}assertRegistered(k){for(let R=0,N=k.length;R<N;R++){const B=k[R];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(k){if(this._isDisposed)return;const R=k.byteLength,N=r.read(k,0),B=N.readUInt8(),F=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:U,method:H,args:x}=c.deserializeRequestJSONArgs(N);this._uriTransformer&&(x=(0,_.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(R,F,U,H,x,B===2);break}case 3:case 4:{let{rpcId:U,method:H,args:x}=c.deserializeRequestMixedArgs(N);this._uriTransformer&&(x=(0,_.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(R,F,U,H,x,B===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let U=c.deserializeReplyOKJSON(N);this._uriTransformer&&(U=(0,_.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(R,F,U);break}case 10:{const U=c.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(R,F,U);break}case 8:{let U=c.deserializeReplyOKVSBuffer(N);this._receiveReply(R,F,U);break}case 11:{let U=c.deserializeReplyErrError(N);this._uriTransformer&&(U=(0,_.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(R,F,U);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(k)}}_receiveRequest(k,R,N,B,F,U){this._logger&&this._logger.logIncoming(k,R,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${B}(`,F);const H=String(R);let x,M;if(U){const z=new y.CancellationTokenSource;F.push(z.token),x=this._invokeHandler(N,B,F),M=()=>z.cancel()}else x=this._invokeHandler(N,B,F),M=a;this._cancelInvokedHandlers[H]=M;const W=c.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(W.byteLength,R,1,"ack"),this._protocol.send(W),x.then(z=>{delete this._cancelInvokedHandlers[H];const O=c.serializeReplyOK(R,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",z),this._protocol.send(O)},z=>{delete this._cancelInvokedHandlers[H];const O=c.serializeReplyErr(R,z);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",z),this._protocol.send(O)})}_receiveCancel(k,R){this._logger&&this._logger.logIncoming(k,R,1,"receiveCancel");const N=String(R);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(k,R,N){this._logger&&this._logger.logIncoming(k,R,0,"receiveReply:",N);const B=String(R);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],F.resolveOk(N)}_receiveReplyErr(k,R,N){this._logger&&this._logger.logIncoming(k,R,0,"receiveReplyErr:",N);const B=String(R);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let U;N&&(N.$isError?(U=new Error,U.name=N.name,U.message=N.message,U.stack=N.stack):U=N),F.resolveErr(U)}_invokeHandler(k,R,N){try{return Promise.resolve(this._doInvokeHandler(k,R,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(k,R,N){const B=this._locals[k];if(!B)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(k));let F=B[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,L.getStringIdentifierForProxy)(k));return F.apply(B,N)}_remoteCall(k,R,N){if(this._isDisposed)return Promise.reject(C.canceled());let B=null;if(N.length>0&&y.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(C.canceled());const F=c.serializeRequestArguments(N,this._uriReplacer),U=++this._lastMessageId,H=String(U),x=new I.LazyPromise;B&&B.onCancellationRequested(()=>{const W=c.serializeCancel(U);this._logger&&this._logger.logOutgoing(W.byteLength,U,0,"cancel"),this._protocol.send(c.serializeCancel(U))}),this._pendingRPCReplies[H]=x,this._onWillSendRequest(U);const M=c.serializeRequest(U,k,R,F,!!B);return this._logger&&this._logger.logOutgoing(M.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(k)}.${R}(`,N),this._protocol.send(M),x}}e.RPCProtocol=t,T=S,t.UNRESPONSIVE_TIME=3*1e3;class r{constructor(k,R){this._buff=k,this._offset=R}static alloc(k,R,N){let B=new r(i.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(k),B.writeUInt32(R),B}static read(k,R){return new r(k,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(k){this._buff.writeUInt8(k,this._offset),this._offset+=1}readUInt8(){const k=this._buff.readUInt8(this._offset);return this._offset+=1,k}writeUInt32(k){this._buff.writeUInt32BE(k,this._offset),this._offset+=4}readUInt32(){const k=this._buff.readUInt32BE(this._offset);return this._offset+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this._buff.writeUInt8(k.byteLength,this._offset),this._offset+=1,this._buff.set(k,this._offset),this._offset+=k.byteLength}readShortString(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,N}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readLongString(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,N}writeBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readVSBuffer(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+k);return this._offset+=k,R}static sizeMixedArray(k){let R=0;R+=1;for(let N=0,B=k.length;N<B;N++){const F=k[N];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let U=0;U<F.buffers.length;++U)R+=this.sizeVSBuffer(F.buffers[U]);break;case 4:break}}return R}writeMixedArray(k){this._buff.writeUInt8(k.length,this._offset),this._offset+=1;for(let R=0,N=k.length;R<N;R++){const B=k[R];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(k);for(let N=0;N<k;N++)switch(this.readUInt8()){case 1:R[N]=this.readLongString();break;case 2:R[N]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),U=this.readLongString(),H=[];for(let x=0;x<F;++x)H.push(this.readVSBuffer());R[N]=new L.SerializableObjectWithBuffers(A(U,H,null));break}case 4:R[N]=void 0;break}return R}}r.sizeUInt32=4;var u;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(u||(u={}));class c{static _useMixedArgSerialization(k){for(let R=0,N=k.length;R<N;R++)if(k[R]instanceof i.VSBuffer||k[R]instanceof L.SerializableObjectWithBuffers||typeof k[R]=="undefined")return!0;return!1}static serializeRequestArguments(k,R){if(this._useMixedArgSerialization(k)){const N=[];for(let B=0,F=k.length;B<F;B++){const U=k[B];if(U instanceof i.VSBuffer)N[B]={type:2,value:U};else if(typeof U=="undefined")N[B]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:x}=v(U.value,R);N[B]={type:3,value:i.VSBuffer.fromString(H),buffers:x}}else N[B]={type:1,value:i.VSBuffer.fromString(w(U,R))}}return{type:1,args:N}}return{type:0,args:w(k,R)}}static serializeRequest(k,R,N,B,F){switch(B.type){case 0:return this._requestJSONArgs(k,R,N,B.args,F);case 1:return this._requestMixedArgs(k,R,N,B.args,F)}}static _requestJSONArgs(k,R,N,B,F){const U=i.VSBuffer.fromString(N),H=i.VSBuffer.fromString(B);let x=0;x+=r.sizeUInt8(),x+=r.sizeShortString(U),x+=r.sizeLongString(H);let M=r.alloc(F?2:1,k,x);return M.writeUInt8(R),M.writeShortString(U),M.writeLongString(H),M.buffer}static deserializeRequestJSONArgs(k){const R=k.readUInt8(),N=k.readShortString(),B=k.readLongString();return{rpcId:R,method:N,args:JSON.parse(B)}}static _requestMixedArgs(k,R,N,B,F){const U=i.VSBuffer.fromString(N);let H=0;H+=r.sizeUInt8(),H+=r.sizeShortString(U),H+=r.sizeMixedArray(B);let x=r.alloc(F?4:3,k,H);return x.writeUInt8(R),x.writeShortString(U),x.writeMixedArray(B),x.buffer}static deserializeRequestMixedArgs(k){const R=k.readUInt8(),N=k.readShortString(),B=k.readMixedArray(),F=new Array(B.length);for(let U=0,H=B.length;U<H;U++){const x=B[U];typeof x=="string"?F[U]=JSON.parse(x):F[U]=x}return{rpcId:R,method:N,args:F}}static serializeAcknowledged(k){return r.alloc(5,k,0).buffer}static serializeCancel(k){return r.alloc(6,k,0).buffer}static serializeReplyOK(k,R,N){if(typeof R=="undefined")return this._serializeReplyOKEmpty(k);if(R instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(k,R);if(R instanceof L.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:F}=v(R.value,N,!0);return this._serializeReplyOKJSONWithBuffers(k,B,F)}else return this._serializeReplyOKJSON(k,l(R,N))}static _serializeReplyOKEmpty(k){return r.alloc(7,k,0).buffer}static _serializeReplyOKVSBuffer(k,R){let N=0;N+=r.sizeVSBuffer(R);let B=r.alloc(8,k,N);return B.writeVSBuffer(R),B.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static _serializeReplyOKJSON(k,R){const N=i.VSBuffer.fromString(R);let B=0;B+=r.sizeLongString(N);let F=r.alloc(9,k,B);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(k,R,N){const B=i.VSBuffer.fromString(R);let F=0;F+=r.sizeUInt32,F+=r.sizeLongString(B);for(const H of N)F+=r.sizeVSBuffer(H);let U=r.alloc(10,k,F);U.writeUInt32(N.length),U.writeLongString(B);for(const H of N)U.writeBuffer(H);return U.buffer}static deserializeReplyOKJSON(k){const R=k.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(k,R){const N=k.readUInt32(),B=k.readLongString(),F=[];for(let U=0;U<N;++U)F.push(k.readVSBuffer());return new L.SerializableObjectWithBuffers(A(B,F,R))}static serializeReplyErr(k,R){return R?this._serializeReplyErrEror(k,R):this._serializeReplyErrEmpty(k)}static _serializeReplyErrEror(k,R){const N=i.VSBuffer.fromString(l(C.transformErrorForSerialization(R),null));let B=0;B+=r.sizeLongString(N);let F=r.alloc(11,k,B);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(k){const R=k.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(k){return r.alloc(12,k,0).buffer}}var f;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var b;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(b||(b={}))}),define(ve[264],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(ve[265],we([0,1,10,9,12,2,4,62,43,222,264]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let T=class Vi{constructor(E,h,p,v){this.localUserHome=E,this.remoteAgentService=h,this.environmentService=p,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||E})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,h){if(E.remoteAuthority)return m.Schemas.vscodeRemote;const p=(0,D.getVirtualWorkspaceScheme)(h.getWorkspace());if(p)return p;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const A=h.getWorkspace().configuration;return A?A.scheme:m.Schemas.file}async userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?i.win32:i.posix)}async fileURI(E){let h="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const v=E.indexOf("/",2);v===-1?(h=E.substring(2),E="/"):(h=E.substring(2,v),E=E.substring(v)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:h,path:E,query:"",fragment:""})}};T=je([ze(1,L.IRemoteAgentService),ze(2,I.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(ve[69],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(P,D){this.line=P,this.character=D}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,D){return new m(0,0)}with(P){return new m(0,0)}}e.Position=m;class i{constructor(P,D,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(P,D),this.end=new m(_,I)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new i(0,0,0,0)}with(P){return new i(0,0,0,0)}}e.Range=i;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[33],we([0,1,16,31,25,30,8,4,9,15,69,13]),function(J,e,m,i,y,C,P,D,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",E=" characters skipped \u27EB",h=(l.length+E.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var p;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function A(W){return!!W.preview}e.resultIsMatch=A;function w(W){return!!W.resource}e.isFileMatch=w;function s(W){return!!W.message}e.isProgressMessage=s;var o;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=g;class a{constructor(z,O,V){this.ranges=O;const K=Array.isArray(O)?O:[O];if(V&&V.matchLines===1&&S(K)){z=(0,P.getNLines)(z,V.matchLines);let G="",Q=0,Y=0;const fe=Math.floor(V.charsPerLine/5),me=[];for(const Se of K){const Ie=Math.max(Se.startColumn-fe,0),Oe=Se.startColumn+V.charsPerLine;if(Ie>Y+fe+h){const We=l+(Ie-Y)+E;G+=We+z.slice(Ie,Oe),Q+=Ie-(Y+We.length)}else G+=z.slice(Y,Oe);me.push(new t(0,Se.startColumn-Q,Se.endColumn-Q)),Y=Oe}this.preview={text:G,matches:Array.isArray(this.ranges)?me:me[0]}}else{const G=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:z,matches:(0,m.mapArrayOrNot)(O,Q=>new n(Q.startLineNumber-G,Q.startColumn,Q.endLineNumber-G,Q.endColumn))}}}}e.TextSearchMatch=a;function S(W){const z=W[0].startLineNumber;for(const O of W)if(O.startLineNumber!==z||O.endLineNumber!==z)return!1;return!0}class n{constructor(z,O,V,K){this.startLineNumber=z,this.startColumn=O,this.endLineNumber=V,this.endColumn=K}}e.SearchRange=n;class t extends n{constructor(z,O,V){super(z,O,z,V)}}e.OneLineRange=t;var r;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function u(W,z=!0){const O=W&&W.files&&W.files.exclude,V=z&&W&&W.search&&W.search.exclude;if(!O&&!V)return;if(!O||!V)return O||V;let K=Object.create(null);return K=y.mixin(K,y.deepClone(O)),K=y.mixin(K,y.deepClone(V),!0),K}e.getExcludes=u;function c(W,z){return W.excludePattern&&i.match(W.excludePattern,z)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&i.match(W.includePattern,z)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(O=>{const V=O.folder.fsPath;if(C.isEqualOrParent(z,V)){const K=_.relative(V,z);return!O.includePattern||!!i.match(O.includePattern,K)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var f;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(z,O){super(z);this.code=O}}e.SearchError=b;function d(W){const z=W.message;if((0,I.isPromiseCanceledError)(W))return new b(z,f.canceled);try{const O=JSON.parse(z);return new b(O.message,O.code)}catch{return new b(z,f.other)}}e.deserializeSearchError=d;function k(W){const z={message:W.message,code:W.code};return new Error(JSON.stringify(z))}e.serializeSearchError=k;function R(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=R;function N(W){return W.type==="success"}e.isSerializedSearchSuccess=N;function B(W){return!!W.path}e.isSerializedFileMatch=B;function F(W,z){const O=W.searchPath?W.searchPath:W.relativePath;return(0,P.fuzzyContains)(O,z)}e.isFilePatternMatch=F;class U{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function H(W,z){const O={...W||{},...z||{}};return Object.keys(O).filter(V=>{const K=O[V];return typeof K=="boolean"&&K})}e.resolvePatternsForProvider=H;class x{constructor(z,O){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let V=z.includePattern;O.includePattern&&(V?V={...V,...O.includePattern}:V=O.includePattern),V&&(this._parsedIncludeExpression=i.parse(V))}matchesExcludesSync(z,O,V){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,V))}includedInQuerySync(z,O,V){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,V)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,O,V))}includedInQuery(z,O,V){const K=this._parsedExcludeExpression(z,O,V),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,O,V):!0;return(0,T.isPromise)(K)?K.then(Q=>Q?!1:G()):G()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=x;function M(W){for(const z in W)if(typeof W[z]!="boolean")return!0;return!1}}),define(ve[35],we([0,1,16,18,21,3,24,10,78,23,8,13,2,168,4,11,188,43,44,26,14,7,33,5]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s,o,g,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(k,R,N){return new I.ExtUri(B=>c(B,N)).isEqual(k,R)}function t(k,R,N){return n(k.uri,R.uri,N)?0:(0,L.compare)(k.uri.toString(),R.uri.toString())}function r(k,R,N){return k.index!==R.index?k.index<R.index?-1:1:n(k.uri,R.uri,N)?(0,L.compare)(k.name,R.name):(0,L.compare)(k.uri.toString(),R.uri.toString())}function u(k,R,N,B){const F=k.slice(0).sort((H,x)=>N(H,x,B)),U=R.slice(0).sort((H,x)=>N(H,x,B));return(0,m.delta)(F,U,(H,x)=>N(H,x,B))}function c(k,R){const N=R.getCapabilities(k.scheme);return!(N&&N&1024)}class f extends A.Workspace{constructor(R,N,B,F,U,H,x){super(R,B.map(M=>new A.WorkspaceFolder(M)),F,U,x);this._name=N,this._isUntitled=H,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(x),B.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(R,N,B,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:U,name:H,folders:x,configuration:M,transient:W,isUntitled:z}=R,O=[],V=N;N?x.forEach((Y,fe)=>{const me=l.URI.revive(Y.uri),Se=f._findFolder(B||N,me,F);Se?(Se.name=Y.name,Se.index=Y.index,O.push(Se)):O.push({uri:me,name:Y.name,index:fe})}):O.push(...x.map(({uri:Y,name:fe,index:me})=>({uri:l.URI.revive(Y),name:fe,index:me}))),O.sort((Y,fe)=>Y.index<fe.index?-1:1);const K=new f(U,H,O,!!W,M?l.URI.revive(M):null,!!z,Y=>c(Y,F)),{added:G,removed:Q}=u(V?V.workspaceFolders:[],K.workspaceFolders,t,F);return{workspace:K,added:G,removed:Q}}static _findFolder(R,N,B){for(let F=0;F<R.folders.length;F++){const U=R.workspaceFolders[F];if(n(U.uri,N,B))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,N){return N&&this._structure.get(R)&&(R=(0,I.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let b=class{constructor(R,N,B,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=B,this._requestIdProvider=new _.Counter,this._barrier=new i.Barrier,this._proxy=R.getProxy(S.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(S.MainContext.MainThreadMessageService);const U=N.workspace;this._confirmedWorkspace=U?new f(U.id,U.name,[],!!U.transient,U.configuration?l.URI.revive(U.configuration):null,!!U.isUntitled,H=>c(H,B)):void 0}$initializeWorkspace(R,N){this._trusted=N,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:D.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,N,B,...F){const U=[];if(Array.isArray(F)&&F.forEach(z=>{l.URI.isUri(z.uri)&&!U.some(O=>n(O.uri,z.uri,this._extHostFileSystemInfo))&&U.push({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[N,B].some(z=>typeof z!="number"||z<0)||B===0&&U.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>H.length)return!1;const x=H.slice(0);x.splice(N,B,...U.map(z=>({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<x.length;z++){const O=x[z];if(x.some((V,K)=>K!==z&&n(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}x.forEach((z,O)=>z.index=O);const{added:M,removed:W}=u(H,x,r,this._extHostFileSystemInfo);if(M.length===0&&W.length===0)return!1;if(this._proxy){const z=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(z,N,B,U).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,E.localize)(0,null,z,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(R,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,N)}async getWorkspaceFolder2(R,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,N)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,N){let B,F="";if(typeof R=="string"?(B=l.URI.file(R),F=R):typeof R!="undefined"&&(B=R,F=R.fsPath),!B)return F;const U=this.getWorkspaceFolder(B,!0);if(!U)return F;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let H=(0,I.relativePath)(U.uri,B);return N&&U.name&&(H=`${U.name}/${H}`),H}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:N,added:B,removed:F}=f.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:F}))}findFiles(R,N,B,F,U=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let H;if(N===null?H=!1:N&&(typeof N=="string"?H=N:H=N.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:M}=d(R);return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(x),(0,T.withUndefinedAsNull)(M),(0,T.withUndefinedAsNull)(H),(0,T.withUndefinedAsNull)(B),U).then(W=>Array.isArray(W)?W.map(z=>l.URI.revive(z)):[])}async findTextInFiles(R,N,B,F,U=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),x=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:M,folder:W}=d(N.include),z=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,O={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:x,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:M,excludePattern:z},V=!1;if(this._activeSearchCallbacks[H]=K=>{if(V)return;const G=l.URI.revive(K.resource);K.results.forEach(Q=>{(0,a.resultIsMatch)(Q)?B({uri:G,preview:{text:Q.preview.text,matches:(0,m.mapArrayOrNot)(Q.preview.matches,Y=>new g.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,m.mapArrayOrNot)(Q.ranges,Y=>new g.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):B({uri:G,text:Q.text,lineNumber:Q.lineNumber})})},U.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(R,(0,T.withUndefinedAsNull)(W),O,H,U);return delete this._activeSearchCallbacks[H],K||{}}catch(K){throw delete this._activeSearchCallbacks[H],K}}$handleTextSearchResult(R,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=je([ze(0,o.IExtHostRpcService),ze(1,s.IExtHostInitDataService),ze(2,w.IExtHostFileSystemInfo),ze(3,p.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function d(k){let R,N;return k&&(typeof k=="string"?R=k:(R=k.pattern,N=k.baseFolder||l.URI.file(k.base))),{includePattern:R,folder:N}}}),define(ve[36],we([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(S,n){if(n){const t=n.split(".");let r=S;for(let u=0;r&&u<t.length;u++)r=r[t[u]];return r}}function v(S){return S instanceof h.URI}function A(S){return S&&S.uri instanceof h.URI&&S.languageId&&typeof S.languageId=="string"}function w(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function s(S){return S&&S.uri instanceof h.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function o(S){if(v(S))return{resource:S};if(A(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(w(S))return{overrideIdentifier:S.languageId};if(s(S))return{resource:S.uri};if(S===null)return{resource:null}}let g=class{constructor(n,t,r){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new a(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(n,t))}};g=je([ze(0,l.IExtHostRpcService),ze(1,y.IExtHostWorkspace),ze(2,E.ILogService)],g),e.ExtHostConfiguration=g;class a{constructor(n,t,r,u){this._onDidChangeConfiguration=new i.Emitter,this._proxy=n,this._logService=u,this._extHostWorkspace=t,this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,r))}getConfiguration(n,t,r){const u=o(t)||{},c=this._toReadonlyValue(n?p(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,u,r?.identifier);function f(d){if(d==null)return null;if(typeof d=="boolean")return d?1:4;switch(d){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(d){return typeof p(c,d)!="undefined"},get:(d,k)=>{this._validateConfigurationAccess(n?`${n}.${d}`:d,u,r?.identifier);let R=p(c,d);if(typeof R=="undefined")R=k;else{let N;const B=(F,U)=>{let H;const x=()=>{N=N||(0,m.deepClone)(c),H=H||p(N,U)};return(0,I.isObject)(F)?new Proxy(F,{get:(M,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return x(),()=>H;if(N)return H=H||p(N,U),H[W];const z=M[W];return typeof W=="string"?B(z,`${U}.${W}`):z},set:(M,W,z)=>(x(),H&&(H[W]=z),!0),deleteProperty:(M,W)=>(x(),H&&delete H[W],!0),defineProperty:(M,W,z)=>(x(),H&&Object.defineProperty(H,W,z),!0)}):F};R=B(R,d)}return R},update:(d,k,R,N)=>{d=n?`${n}.${d}`:d;const B=f(R);return k!==void 0?this._proxy.$updateConfigurationOption(B,d,k,u,N):this._proxy.$removeConfigurationOption(B,d,u,N)},inspect:d=>{d=n?`${n}.${d}`:d;const k=(0,m.deepClone)(this._configuration.inspect(d,u,this._extHostWorkspace.workspace));if(k)return{key:d,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof c=="object"&&(0,m.mixin)(b,c,!1),Object.freeze(b)}_toReadonlyValue(n){const t=r=>(0,I.isObject)(r)?new Proxy(r,{get:(u,c)=>t(u[c]),set:(u,c,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(u,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(u,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return t(n)}_validateConfigurationAccess(n,t,r){const u=_.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),c=r?`[${r.value}] `:"";if(u===4){typeof t?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){t?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const r=new D.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,c)=>r.affectsConfiguration(u,o(c))})}_toMap(n){return n.reduce((t,r)=>(t.set(r[0],r[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[70],we([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s,o){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(U){function H(M){if(M!=null)return M}U.from=H;function x(M){if(M!=null)return M}U.to=x})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(U){function H(M){if(M!=null)return M}U.from=H;function x(M){if(M!=null)return M}U.to=x})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(U){function H(M){if(M!=null)return M}U.from=H;function x(M){if(M!=null)return M}U.to=x})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(U){function H(W){if(W){const z=W;return z&&!!z.process}else return!1}U.is=H;function x(W){if(W==null)return;const z={process:W.process,args:W.args};return W.options&&(z.options=n.from(W.options)),z}U.from=x;function M(W){if(W!=null)return new P.ProcessExecution(W.process,W.args,W.options)}U.to=M})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(U){function H(M){if(M!=null)return M}U.from=H;function x(M){if(M!=null)return M}U.to=x})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(U){function H(W){if(W){const z=W;return z&&(!!z.commandLine||!!z.command)}else return!1}U.is=H;function x(W){if(W==null)return;const z={};return W.commandLine!==void 0?z.commandLine=W.commandLine:(z.command=W.command,z.args=W.args),W.options&&(z.options=r.from(W.options)),z}U.from=x;function M(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new P.ShellExecution(W.commandLine,W.options):new P.ShellExecution(W.command,W.args?W.args:[],W.options)}U.to=M})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(U){function H(W){if(W){let z=W;return z&&z.customExecution==="customExecution"}else return!1}U.is=H;function x(W){return{customExecution:"customExecution"}}U.from=x;function M(W,z){return z.get(W)}U.to=M})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(U){function H(x,M){let W;return x.scope!==void 0&&typeof x.scope!="number"?W=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===P.TaskScope.Workspace&&M&&M.workspaceFile?W=M.workspaceFile:W=s.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:W}}U.from=H})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(U){function H(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}U.from=H})(b=e.TaskGroupDTO||(e.TaskGroupDTO={}));var d;(function(U){function H(W,z){if(W==null)return[];const O=[];for(let V of W){const K=x(V,z);K&&O.push(K)}return O}U.fromMany=H;function x(W,z){if(W==null)return;let O;W.execution instanceof P.ProcessExecution?O=t.from(W.execution):W.execution instanceof P.ShellExecution?O=u.from(W.execution):W.execution&&W.execution instanceof P.CustomExecution&&(O=c.from(W.execution));const V=a.from(W.definition);let K;return W.scope?typeof W.scope=="number"?K=W.scope:K=W.scope.uri:K=P.TaskScope.Workspace,!V||!K?void 0:{_id:W._id,definition:V,name:W.name,source:{extensionId:z.identifier.value,label:W.source,scope:K},execution:O,isBackground:W.isBackground,group:b.from(W.group),presentationOptions:S.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}U.from=x;async function M(W,z,O){if(W==null)return;let V;t.is(W.execution)?V=t.to(W.execution):u.is(W.execution)?V=u.to(W.execution):c.is(W.execution)&&(V=c.to(W._id,O));const K=a.to(W.definition);let G;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?G=W.source.scope:G=await z.resolveWorkspaceFolder(m.URI.revive(W.source.scope)):G=P.TaskScope.Workspace),!K||!G)return;const Q=new P.Task(K,G,W.name,W.source.label,V,W.problemMatchers);return W.isBackground!==void 0&&(Q.isBackground=W.isBackground),W.group!==void 0&&(Q.group=P.TaskGroup.from(W.group._id),Q.group&&W.group.isDefault&&(Q.group=new P.TaskGroup(Q.group.id,Q.group.label),W.group.isDefault&&(Q.group.isDefault=W.group.isDefault))),W.presentationOptions&&(Q.presentationOptions=S.to(W.presentationOptions)),W._id&&(Q._id=W._id),W.detail&&(Q.detail=W.detail),Q}U.to=M})(d=e.TaskDTO||(e.TaskDTO={}));var k;(function(U){function H(M){return M}U.from=H;function x(M){if(!!M)return Object.assign(Object.create(null),M)}U.to=x})(k=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(H,x,M){this._id=x,this._task=M,g.set(this,void 0),nt(this,g,H,"f")}get task(){return this._task}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}g=new WeakMap;var N;(function(U){function H(x){return{id:x._id,task:void 0}}U.from=H})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(H,x,M,W,z,O,V,K){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=H.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=W,this._configurationService=z,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,x,M){if(!M)return new P.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:x,provider:M,extension:H}),this._proxy.$registerTaskProvider(W,x),new P.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(H,x){this._proxy.$registerTaskSystem(H,x)}fetchTasks(H){return this._proxy.$fetchTasks(k.from(H)).then(async x=>{const M=[];for(let W of x){const z=await d.to(W,this._workspaceProvider,this._providedCustomExecutions2);z&&M.push(z)}return M})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(x=>H.push(x)),H}terminateTask(H){if(!(H instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,x,M){const W=this._providedCustomExecutions2.get(H.id);W&&(this._activeCustomExecutions2.set(H.id,W),this._terminalService.attachPtyToTerminal(x,await W.callback(M))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const x=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const x=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:x,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const x=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:H.exitCode})}$provideTasks(H,x){const M=this._handlers.get(H);if(!M)return Promise.reject(new Error("no handler found"));const W=[],z=(0,i.asPromise)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(O=>this.provideTasksInternal(x,W,M,O));return new Promise(O=>{z.then(V=>{Promise.all(W).then(()=>{O(V)})})})}async $resolveTask(H,x){const M=this._handlers.get(H);if(!M)return Promise.reject(new Error("no handler found"));if(x.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${M.type}].`);const W=await d.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const z=await M.provider.resolveTask(W,L.CancellationToken.None);if(!z)return;this.checkDeprecation(z,M);const O=d.from(z,M.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(O.execution)&&await this.addCustomExecution(O,z,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,x,M){const W=await this._proxy.$createTaskId(H);!M&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,x.execution)),this._providedCustomExecutions2.set(W,x.execution)}async getTaskExecution(H,x){if(typeof H=="string"){const z=this._taskExecutionPromises.get(H);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let M=this._taskExecutionPromises.get(H.id);if(M)return M;const W=new Promise((z,O)=>{function V(K,G,Q){Q?z(new R(K,G.id,Q)):O("Unexpected: Task does not exist.")}x?V(this,H,x):d.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>V(this,H,K))});return this._taskExecutionPromises.set(H.id,W),W.then(z=>(this._taskExecutions.set(H.id,z),z),z=>Promise.reject(z))}checkDeprecation(H,x){H._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let M=this._notProvidedCustomExecutions.values(),W=M.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=M.next()}};B=je([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,T.IExtHostTerminalService),ze(6,A.ILogService),ze(7,w.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let F=class extends B{constructor(H,x,M,W,z,O,V,K){super(H,x,M,W,z,O,V,K);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(H,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const M=d.from(x,H);if(M===void 0)throw new Error("Task is not valid");if(c.is(M.execution))await this.addCustomExecution(M,x,!1);else throw new o.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),x);return this._proxy.$executeTask(M).catch(z=>{throw new Error(z)}),W}provideTasksInternal(H,x,M,W){const z=[];if(W)for(let O of W){this.checkDeprecation(O,M),(!O.definition||!H[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const V=d.from(O,M.extension);V&&c.is(V.execution)?(z.push(V),x.push(this.addCustomExecution(V,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:M.extension}}async resolveTaskInternal(H){if(c.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,x,M){}};F=je([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,T.IExtHostTerminalService),ze(6,A.ILogService),ze(7,w.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(ve[266],we([0,1,16,74,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,33]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(f,b,d,k){this.configurationService=f,this.workspaceContextService=b,this.editorGroupsService=d,this.pathService=k}text(f,b,d={}){f=this.getContentPattern(f,d);const k=this.configurationService.getValue(),R=b&&b.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(b?.map(v.toWorkspaceFolder),d),type:2,contentPattern:f,previewOptions:d.previewOptions,maxFileSize:d.maxFileSize,usePCRE2:k.search.usePCRE2||R||!1,beforeContext:d.beforeContext,afterContext:d.afterContext,userDisabledExcludesAndIgnoreFiles:d.disregardExcludeSettings&&d.disregardIgnoreFiles}}getContentPattern(f,b){const d=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const k={...f,wordSeparators:d.editor.wordSeparators};return this.isCaseSensitive(f,b)&&(k.isCaseSensitive=!0),this.isMultiline(f)&&(k.isMultiline=!0),k}file(f,b={}){return{...this.commonQuery(f,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}handleIncludeExclude(f,b){return f?(f=Array.isArray(f)?f.map(t):t(f),b?this.parseSearchPaths(f):{pattern:a(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],b={}){const d=this.handleIncludeExclude(b.includePattern,b.expandPatterns),k=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),R=f.length>1,N=(d.searchPaths&&d.searchPaths.length?d.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,b,k)):f.map(U=>this.getFolderQueryForRoot(U,b,k,R))).filter(U=>!!U),B={_reason:b._reason,folderQueries:N,usingSearchPaths:!!(d.searchPaths&&d.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:k.pattern,includePattern:d.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const H=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(W=>W.resource)))).filter(M=>(0,s.pathIncludedInQuery)(B,M.fsPath)),x=this.commonQueryFromFileList(H);return{...B,...x}}const F=b.extraFileResources&&b.extraFileResources.filter(U=>(0,s.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=F&&F.length?F:void 0,B}commonQueryFromFileList(f){const b=[],d=new P.ResourceMap,k={};let R=!1;return f.forEach(N=>{if(N.scheme===D.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(N)){const F=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:_.dirname(N.fsPath)});let U=d.get(F);U||(R=!0,U={folder:F,includePattern:{}},b.push(U),d.set(F,U));const H=_.relative(F.fsPath,N.fsPath);(0,T.assertIsDefined)(U.includePattern)[H.replace(/\\/g,"/")]=!0}else N.fsPath&&(R=!0,k[N.fsPath]=!0)}),{folderQueries:b,includePattern:k,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(f,b){if(b.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,E.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const b=x=>_.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),k=(Array.isArray(f)?f:S(f)).map(x=>{const M=this.pathService.resolvedUserHome;return M?(0,C.untildify)(x,M.scheme===D.Schemas.file?M.fsPath:M.path):x}),R=i.groupBy(k,x=>b(x)?"searchPaths":"exprSegments"),N=(R.exprSegments||[]).map(x=>L.rtrim(x,"/")).map(x=>L.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),n(x))),B={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(B.searchPaths=F);const U=m.flatten(N),H=a(...U);return H&&(B.pattern=H),B}getExcludesForFolder(f,b){return b.disregardExcludeSettings?void 0:(0,s.getExcludes)(f,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const b=m.flatten(f.map(k=>{let{pathPortion:R,globPortion:N}=g(k);N&&(N=r(N));const B=this.expandOneSearchPath(R);return m.flatten(B.map(F=>this.resolveOneSearchPathPattern(F,N)))})),d=new Map;return b.forEach(k=>{const R=k.searchPath.toString(),N=d.get(R);N?k.pattern&&(N.pattern=N.pattern||{},N.pattern[k.pattern]=!0):d.set(R,{searchPath:k.searchPath,pattern:k.pattern?a(k.pattern):void 0})}),Array.from(d.values())}expandOneSearchPath(f){if(_.isAbsolute(f)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==D.Schemas.file?[{searchPath:b[0].uri.with({path:f})}]:[{searchPath:l.URI.file(_.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const k=_.posix.resolve(b.path,f);return[{searchPath:b.with({path:k})}]}const d=r(f);return[{searchPath:b,pattern:d}]}else{if(f==="./"||f===".\\")return[];{const b=f.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(R=>{const N=b.match(new RegExp(`^${L.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return N?{match:N,folder:R}:null}).filter(T.isDefined);if(k.length)return k.map(R=>{const N=R.match[1];return{searchPath:R.folder.uri,pattern:N&&r(N)}});{const R=f.match(/\.[\/\\](.+)[\/\\]?/),N=R?R[1]:f,B=h.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(f,b){const d=f.pattern&&b?`${f.pattern}/${b}`:f.pattern||b,k=[{searchPath:f.searchPath,pattern:d}];return d&&!d.endsWith("**")&&k.push({searchPath:f.searchPath,pattern:d+"/**"}),k}getFolderQueryForSearchPath(f,b,d){const k=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(f.searchPath),b,d,!1);return k?{...k,includePattern:f.pattern}:null}getFolderQueryForRoot(f,b,d,k){let R;const N=l.URI.isUri(f)?f:f.uri;if(d.searchPaths){const x=d.searchPaths.filter(M=>(0,I.isEqual)(M.searchPath,N))[0];if(x&&!x.pattern)return null;x&&(R=x.pattern)}const B=this.configurationService.getValue({resource:N}),U={...this.getExcludesForFolder(B,b)||{},...R||{}},H=l.URI.isUri(f)?(0,I.basename)(f):f.name;return{folder:N,folderName:k?H:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!B.search.followSymlinks}}};o=je([ze(0,p.IConfigurationService),ze(1,v.IWorkspaceContextService),ze(2,A.IEditorGroupsService),ze(3,w.IPathService)],o),e.QueryBuilder=o;function g(c){const f=c.match(/[\*\{\}\(\)\[\]\?]/);if(f){const b=f.index,d=c.substr(0,b).match(/[/|\\][^/\\]*$/);if(d){let k=c.substr(0,d.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:c.substr((d.index||0)+1)}}}return{pathPortion:c}}function a(...c){return c.length?c.reduce((f,b)=>(f[b]=!0,f),Object.create(null)):void 0}function S(c){return y.splitGlobAware(c,",").map(f=>f.trim()).filter(f=>!!f.length)}function n(c){return[`**/${c}/**`,`**/${c}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function t(c){return c.replace(/\\/g,"/")}function r(c){return t(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(c,f){c=m.distinct(c,k=>k.toString());const b=[],d=f.getWorkspace();return c&&c.forEach(k=>{let R;if(f.getWorkbenchState()===2)R=(0,I.relativePath)(d.folders[0].uri,k),R&&R!=="."&&(R="./"+R);else{const N=f.getWorkspaceFolder(k);if(N){const B=N.name;if(d.folders.filter(U=>U.name===B).length===1){const U=(0,I.relativePath)(N.uri,k);U===""?R=`./${N.name}`:R=`./${N.name}/${U}`}else R=k.fsPath}}R&&b.push(R)}),b}e.resolveResourcesForSearchIncludes=u}),define(ve[267],we([0,1,23,2,21,15,4,266,33,43]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(p,v){const A=v.activationEvents;if(!A)return Promise.resolve(void 0);const w=[],s=[];for(const t of A)if(/^workspaceContains:/.test(t)){const r=t.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||p.forceUsingSearch?s.push(r):w.push(r)}if(w.length===0&&s.length===0)return Promise.resolve(void 0);let o;const g=new Promise((t,r)=>{o=t}),a=t=>o({activationEvent:t}),S=Promise.all(w.map(t=>l(p,t,a))).then(()=>{}),n=E(p,v.identifier,s,a);return Promise.all([S,n]).then(()=>{o(void 0)}),g}e.checkActivateWorkspaceContainsExtension=T;async function l(p,v,A){for(const w of p.folders)if(await p.exists(m.joinPath(i.URI.revive(w),v))){A(`workspaceContains:${v}`);return}}async function E(p,v,A,w){if(A.length===0)return Promise.resolve(void 0);const s=new y.CancellationTokenSource,o=p.checkExists(p.folders,A,s.token),g=setTimeout(async()=>{s.cancel(),p.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${A.join(",")}`)},L);let a=!1;try{a=await o}catch(S){C.isPromiseCanceledError(S)||C.onUnexpectedError(S)}s.dispose(),clearTimeout(g),a&&w(`workspaceContains:${A.join(",")}`)}function h(p,v,A,w){const s=p.get(P.IInstantiationService),o=p.get(_.ISearchService),a=s.createInstance(D.QueryBuilder).file(v.map(S=>(0,I.toWorkspaceFolder)(i.URI.revive(S))),{_reason:"checkExists",includePattern:A,exists:!0});return o.fileSearch(a,w).then(S=>!!S.limitHit,S=>C.isPromiseCanceledError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=h});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[39],we([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s,o,g,a,S,n,t,r,u,c,f,b,d,k,R,N,B){"use strict";var F,U,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let x=class ji extends D.Disposable{constructor(O,V,K,G,Q,Y,fe,me,Se,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new d.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=K,this._initData=fe,this._extHostWorkspace=G,this._extHostConfiguration=Q,this._logService=Y,this._extHostTunnelService=Se,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=me,this._instaService=O.createChild(new c.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Oe=new Set;this._initData.hostExtensions.forEach(We=>Oe.add(s.ExtensionIdentifier.toKey(We))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,j,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,w.transformErrorForSerialization(j),Z)},actualActivateExtension:async(We,j)=>{if(Oe.has(s.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,j),new E.HostExtension;const Z=this._registry.getExtensionDescription(We);return this._activateExtension(Z,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){w.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch{}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const K=this._activator.getActivatedExtension(O);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==B.Schemas.file)return O;const V=await this._hostUtils.realpath(O.fsPath);return I.URI.file(V)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=_.TernarySearchTree.forUris(V=>C.extUriBiasedIgnorePathCase.ignorePathCasing(V));for(const V of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(V)){const K=await this._realPathExtensionUri(V.extensionLocation);O.set(K,V)}return O})()),this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const K=this._activator.getActivatedExtension(O);if(!K)return V;try{typeof K.module.deactivate=="function"&&(V=Promise.resolve(K.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(`An error occurred when deactivating the extension '${O.value}':`),this._logService.error(G)}try{(0,D.dispose)(K.subscriptions)}catch(G){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${O.value}':`),this._logService.error(G)}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(K=>{const G=K.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",G),K},K=>{throw this._logExtensionActivationTimes(O,V,"failure"),K})}_logExtensionActivationTimes(O,V,K,G){const Q=M(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...G||{},outcome:K})}_doActivateExtension(O,V){const K=M(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",K);const G=this._getEntryPoint(O);if(!G)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${O.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this._logService.flush();const Q=new E.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,C.joinPath)(O.extensionLocation,G),Q),this._loadExtensionContext(O)]).then(Y=>(y.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),ji._callActivate(this._logService,O.identifier,Y[0],Y[1],Q))).then(Y=>(y.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),Y))}_loadExtensionContext(O){const V=new g.ExtensionGlobalMemento(O,this._storage),K=new g.ExtensionMemento(O.identifier.value,!1,this._storage),G=new N.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,Y=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,K.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let me;return Object.freeze({globalState:V,workspaceState:K,secrets:G,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Se){return i.join(O.extensionLocation.fsPath,Se)},get storagePath(){return fe._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(O).fsPath},get logPath(){return i.join(fe._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return I.URI.joinPath(fe._initData.logsLocation,O.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(O)},get globalStorageUri(){return fe._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return me===void 0&&(me=new W(fe,O.identifier,O,Y)),me},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(O,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,K,G,Q){return K=K||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,K,G,Q).then(Y=>new E.ActivatedExtension(!1,null,Q.build(),K,Y,G.subscriptions))}static _callActivateOptional(O,V,K,G,Q){if(typeof K.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Y=typeof global=="object"?global:self,fe=K.activate.apply(Y,[G]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(fe).then(me=>(Q.activateResolveStop(),me))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(K)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,K=>{this._logService.error(K)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],K=this._handleWorkspaceContainsEagerExtensions(V),G=Promise.all([O,K]).then(()=>{});return Promise.race([G,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(this.isActivated(V.identifier))return;const K=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={logService:this._logService,folders:O.map(Y=>Y.uri),forceUsingSearch:K,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,fe,me)=>this._mainThreadWorkspaceProxy.$checkExists(Y,fe,me)},Q=await(0,k.checkActivateWorkspaceContainsExtension)(G,V);if(!!Q)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Q.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V)throw new Error(m.localize(0,null));const K=await this._loadCommonJSModule(null,V,new E.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(m.localize(1,null,V.toString()));return new Promise((G,Q)=>{const Y=(Se,Ie)=>{Se?Q(Se):G(typeof Ie=="number"&&Ie>0?1:0)},fe=(0,C.originalFSPath)(V),me=K.run(fe,Y);me&&me.then&&me.then(()=>{G(0)}).catch(Se=>{Q(Se.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,D.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const V=O.indexOf("+");if(V===-1)throw new Error("Not an authority that can be resolved!");const K=O.substr(0,V);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this._resolvers[K]}}async $resolveAuthority(O,V){const{authorityPrefix:K,resolver:G}=await this._activateAndGetResolver(O);if(!G)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${K}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),y.mark(`code/extHost/willResolveAuthority/${K}`);const Q=await G.resolve(O,{resolveAttempt:V});y.mark(`code/extHost/didResolveAuthorityOK/${K}`);const Y={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},fe={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted,authenticationSession:Q.authenticationSessionForInitializingExtensions?{id:Q.authenticationSessionForInitializingExtensions.id,providerId:Q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:fe,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(y.mark(`code/extHost/didResolveAuthorityError/${K}`),Q instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,V){const{authorityPrefix:K,resolver:G}=await this._activateAndGetResolver(O);if(!G)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${K}`);const Q=I.URI.revive(V);if(typeof G.getCanonicalURI=="undefined")return Q;const Y=await(0,P.asPromise)(()=>G.getCanonicalURI(Q));return Y||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(K=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(G=>G.extensionLocation=I.URI.revive(G.extensionLocation));const K=await this.getExtensionPathIndex();return await Promise.all(V.map(async G=>{const Q=this._registry.getExtensionDescription(G);Q&&K.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async G=>{const Q=await this._realPathExtensionUri(G.extensionLocation);K.set(Q,G)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=o.VSBuffer.alloc(O),K=Math.random()%256;for(let G=0;G<O;G++)V.writeUInt8(K,G);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};x=je([ze(0,n.IInstantiationService),ze(1,e.IHostUtils),ze(2,u.IExtHostRpcService),ze(3,p.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,L.ILogService),ze(6,t.IExtHostInitDataService),ze(7,r.IExtensionStoragePaths),ze(8,f.IExtHostTunnelService),ze(9,b.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function M(z,O){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class W{constructor(O,V,K,G){F.set(this,void 0),U.set(this,void 0),H.set(this,void 0),nt(this,F,O,"f"),nt(this,U,V,"f"),nt(this,H,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=i.normalize((0,C.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=G}get isActive(){return Be(this,F,"f").isActivated(Be(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,F,"f").getExtensionExports(Be(this,H,"f"))}activate(){return Be(this,F,"f").activateByIdWithErrors(Be(this,H,"f"),{startup:!1,extensionId:Be(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,F=new WeakMap,U=new WeakMap,H=new WeakMap}),define(ve[55],we([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let o=class{constructor(c,f,b,d,k,R){this._workspaceService=f,this._extensionService=b,this._editorsService=d,this._configurationService=k,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=c.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,f){const b=c;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let d=`debug:${encodeURIComponent(b.path||"")}`,k="?";return f&&(d+=`${k}session=${encodeURIComponent(f.id)}`,k="&"),d+=`${k}ref=${b.sourceReference}`,i.URI.parse(d)}else{if(b.path)return i.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const f=[];for(const b of c.getAllExtensionDescriptions())if(b.contributes){const d=b.contributes.debuggers;if(d&&d.length>0)for(const k of d)(0,h.isDebuggerMainContribution)(k)&&f.push(k.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(f=>c.push(f)),c}addBreakpoints(c){this.startBreakpoints();const f=c.filter(k=>{const R=k.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,k),!0)});this.fireBreakpointChanges(f,[],[]);const b=[],d=new Map;for(const k of f)if(k instanceof D.SourceBreakpoint){let R=d.get(k.location.uri.toString());R||(R={type:"sourceMulti",uri:k.location.uri,lines:[]},d.set(k.location.uri.toString(),R),b.push(R)),R.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof D.FunctionBreakpoint&&b.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(c){this.startBreakpoints();const f=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],f,[]);const b=f.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),d=f.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),k=f.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(b,d,k)}startDebugging(c,f,b){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,f,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,debugUI:b.debugUI,suppressSaveBeforeStart:b.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,f,b){if(!f)return new D.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:d,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,b,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,d),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(c,f,b){if(!b)return new D.Disposable(()=>{});if(!this.definesDebugType(c,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:d,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,d),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(c,f){if(!f)return new D.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:b,factory:f}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==f)})}async $runInTerminal(c,f){return Promise.resolve(void 0)}async $substituteVariables(c,f){if(!this._variableResolver){const[k,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,R)}let b;const d=await this.getFolder(c);return d&&(b={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,f)}createDebugAdapter(c,f){if(c.type==="implementation")return new t(c.implementation)}createSignService(){}async $startDASession(c,f){const b=this,d=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const R=this.convertToDto(k),N=this.createDebugAdapter(R,d);if(!N)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const B=N;return this._debugAdapters.set(c,B),this.getDebugAdapterTrackers(d).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),B.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const H=U,x={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(H.arguments.value);x.body={signature:M},B.sendResponse(x)}else throw new Error("no signer")}catch(M){x.success=!1,x.message=M.message,B.sendResponse(x)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(U),U=(0,h.convertToVSCPaths)(U,!0),b._debugServiceProxy.$acceptDAMessage(c,U)}),B.onError(U=>{F&&F.onError&&F.onError(U),this._debugServiceProxy.$acceptDAError(c,U.name,U.message,U.stack)}),B.onExit(U=>{F&&F.onExit&&F.onExit((0,A.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,A.withNullAsUndefined)(U),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),B.startSession()))})}$sendDAMessage(c,f){f=(0,h.convertToDAPaths)(f,!1);const b=this._debugAdaptersTrackers.get(c);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(f);const d=this._debugAdapters.get(c);d&&d.sendMessage(f)}$stopDASession(c){const f=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),f&&f.onWillStopSession&&f.onWillStopSession();const b=this._debugAdapters.get(c);return this._debugAdapters.delete(c),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const f=[],b=[],d=[];if(c.added)for(const k of c.added){const R=k.id;if(R&&!this._breakpoints.has(R)){let N;if(k.type==="function")N=new D.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")N=new D.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const B=i.URI.revive(k.uri);N=new D.SourceBreakpoint(new D.Location(B,new D.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}N._id=R,this._breakpoints.set(R,N),f.push(N)}}if(c.removed)for(const k of c.removed){const R=this._breakpoints.get(k);R&&(this._breakpoints.delete(k),b.push(R))}if(c.changed){for(const k of c.changed)if(k.id){const R=this._breakpoints.get(k.id);if(R){if(R instanceof D.FunctionBreakpoint&&k.type==="function"){const N=R;N.enabled=k.enabled,N.condition=k.condition,N.hitCondition=k.hitCondition,N.logMessage=k.logMessage,N.functionName=k.functionName}else if(R instanceof D.SourceBreakpoint&&k.type==="source"){const N=R;N.enabled=k.enabled,N.condition=k.condition,N.hitCondition=k.hitCondition,N.logMessage=k.logMessage,N.location=new D.Location(i.URI.revive(k.uri),new D.Position(k.line,k.character))}d.push(R)}}}this.fireBreakpointChanges(f,b,d)}$provideDebugConfigurations(c,f,b){return(0,C.asPromise)(async()=>{const d=this.getConfigProviderByHandle(c);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(f);return d.provideDebugConfigurations(k,b)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(c,f,b,d){return(0,C.asPromise)(async()=>{const k=this.getConfigProviderByHandle(c);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(f);return k.resolveDebugConfiguration(R,b,d)})}$resolveDebugConfigurationWithSubstitutedVariables(c,f,b,d){return(0,C.asPromise)(async()=>{const k=this.getConfigProviderByHandle(c);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(f);return k.resolveDebugConfigurationWithSubstitutedVariables(R,b,d)})}async $provideDebugAdapter(c,f){const b=this.getAdapterDescriptorFactoryByHandle(c);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(f);return this.getAdapterDescriptor(b,d).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(c){const f=await this.getSession(c);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(c){const f=await this.getSession(c);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,f){const b=await this.getSession(c);b&&b._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(c,f){const d={session:await this.getSession(c),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(c){if(c instanceof D.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof D.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const f=this._adapterFactories.filter(b=>b.type===c);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(c){const f=this._adapterFactories.filter(b=>b.handle===c);if(f.length>0)return f[0].factory}getConfigProviderByHandle(c){const f=this._configProviders.filter(b=>b.handle===c);if(f.length>0)return f[0].provider}definesDebugType(c,f){if(c.contributes){const b=c.contributes.debuggers;if(b&&b.length>0){for(const d of b)if(d.label&&d.type&&d.type===f)return!0}}return!1}getDebugAdapterTrackers(c){const b=c.configuration.type,d=this._trackerFactories.filter(k=>k.type===b||k.type==="*").map(k=>(0,C.asPromise)(()=>k.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(d).then(k=>{const R=k.filter(N=>!!N);if(R.length>0)return new n(R)}),new Promise((k,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(c,f){const b=f.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new D.DebugAdapterServer(b));if(c){const k=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>c.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,k))).then(R=>{if(R)return R})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,d))}daExecutableFromPackage(c,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,f,b){(c.length>0||f.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:f,changed:b}))}async getSession(c){if(c)if(typeof c=="string"){const f=this._debugSessions.get(c);if(f)return f}else{let f=this._debugSessions.get(c.id);if(!f){const b=await this.getFolder(c.folderUri),d=c.parent?this._debugSessions.get(c.parent):void 0;f=new g(this._debugServiceProxy,c.id,c.type,c.name,b,c.configuration,d),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(c){if(c){const f=i.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};o=je([ze(0,p.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,T.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,s.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class g{constructor(c,f,b,d,k,R,N){this._debugServiceProxy=c,this._id=f,this._type=b,this._name=d,this._workspaceFolder=k,this._configuration=R,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,f)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=g;class a{constructor(c){this.value=Object.freeze({append(f){c.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=a;class S extends l.AbstractVariableResolverService{constructor(c,f,b,d,k){function R(){if(f){const N=f.activeEditor();if(N)return N.document.uri;const B=d.tabs.filter(F=>F.isActive);if(B.length>0){const F=B[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=c.filter(F=>F.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(N,B)=>b.getConfiguration(void 0,N).get(B),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=R();if(N)return m.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const N=R();if(N){const B=k.getWorkspaceFolder(N);if(B)return m.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(f){const N=f.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(f){const N=f.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=S;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(f=>f.onError?f.onError(c):void 0)}onExit(c,f){this.trackers.forEach(b=>b.onExit?b.onExit(c,f):void 0)}}class t extends _.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(c,f,b,d,k,R){super(c,f,b,d,k,R)}createVariableResolver(c,f,b){return new S(c,f,b,this._editorTabs)}};r=je([ze(0,p.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,T.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,s.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[268],we([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(s,o,g,a,S,n,t){this._apiFactory=s,this._extensionRegistry=o,this._instaService=g,this._extHostConfiguration=a,this._extHostExtensionService=S,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,o,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(v,o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,o,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let o of s.nodeModuleName)this._factories.set(o,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(o=>s.alternativeModuleName(o))}};h=je([ze(2,L.IInstantiationService),ze(3,C.IExtHostConfiguration),ze(4,T.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,E.ILogService)],h),e.RequireInterceptor=h;class p{constructor(s,o,g,a,S){this._apiFactory=s,this._extensionPaths=o,this._extensionRegistry=g,this._configProvider=a,this._logService=S,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,o){const g=this._extensionPaths.findSubstr(o);if(g){let a=this._extApiImpl.get(D.ExtensionIdentifier.toKey(g.identifier));return a||(a=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(g.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((S,n)=>a+=`	${n} -> ${S.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(s,o,g){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=g,S=o.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;l.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>S.$getPassword(n,t),setPassword:(n,t,r)=>S.$setPassword(n,t,r),deletePassword:(n,t)=>S.$deletePassword(n,t),findPassword:n=>S.$findPassword(n),findCredentials(n){return S.$findCredentials(n)}}}load(s,o){const g=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const o=s.length;if(o<=7||!this.alternativeNames)return;const g=o-7;if((s.charAt(g)==="/"||s.charAt(g)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};v=je([ze(1,_.IExtHostRpcService),ze(2,I.IExtHostInitDataService)],v);let A=class{constructor(s,o,g){this._extensionPaths=s,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(y.MainContext.MainThreadTelemetry);const a=g.getProxy(y.MainContext.MainThreadWindow);this._impl=(S,n)=>{const t=i.URI.parse(S);return n?this.callOriginal(S,n):t.scheme==="http"||t.scheme==="https"?a.$openUri(t,S,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?a.$openUri(t,S,{}):this.callOriginal(S,n)}}load(s,o,g){const a=this._extensionPaths.findSubstr(o);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=g(s),this._impl}callOriginal(s,o){return this.sendNoForwardTelemetry(),this._original(s,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=je([ze(2,_.IExtHostRpcService)],A)}),define(ve[269],we([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends l.ExtHostDebugServiceBase{constructor(o,g,a,S,n,t,r){super(o,g,a,S,n,r);this._terminalService=t,this._integratedTerminalInstances=new w}createDebugAdapter(o,g){switch(o.type){case"server":return new C.SocketDebugAdapter(o);case"pipeServer":return new C.NamedPipeDebugAdapter(o);case"executable":return new C.ExecutableDebugAdapter(o,g.type)}return super.createDebugAdapter(o,g)}daExecutableFromPackage(o,g){const a=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),o.type);if(a)return new y.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new E.SignService}async $runInTerminal(o,g){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const a=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=o.title||m.localize(0,null),r=JSON.stringify({shell:S,shellArgs:n});let u=await this._integratedTerminalInstances.checkout(r,t),c,f=!1;if(u)c=o.cwd;else{const R={shellPath:S,shellArgs:n,cwd:o.cwd,name:t,iconPath:new y.ThemeIcon("debug")};f=!0,u=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,r)}u.show(!0);const b=await u.processId;f?await new Promise(R=>setTimeout(R,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?u.sendText("cls"):S.indexOf("bash")>=0?u.sendText("clear"):i.isWindows?u.sendText("cls"):u.sendText("clear"));const d=(0,p.prepareCommand)(S,o.args,c,o.env);u.sendText(d);const k=this.onDidTerminateDebugSession(R=>{R.id===g&&(this._integratedTerminalInstances.free(u),k.dispose())});return b}else if(o.kind==="external")return(0,p.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,g)}createVariableResolver(o,g,a){return new l.ExtHostVariableResolverService(o,g,a,this._editorTabs,this._workspaceService)}};A=je([ze(0,T.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,D.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,v.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class w{constructor(){this._terminalInstances=new Map}async checkout(o,g){const S=[...this._terminalInstances.entries()].map(([n,t])=>(0,h.createCancelablePromise)(async r=>{if(n.name!==g||t.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await n.processId))return null;const u=Date.now();return t.lastUsedAt+w.minUseDelay>u||r.isCancellationRequested||t.config!==o?null:(t.lastUsedAt=u,n)}));return await(0,h.firstParallel)(S,n=>!!n)}insert(o,g){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:g})}free(o){const g=this._terminalInstances.get(o);g&&(g.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}w.minUseDelay=1e3}),define(ve[270],we([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends E.ExtHostTaskBase{constructor(a,S,n,t,r,u,c,f,b){super(a,S,n,t,r,u,c,f);this.workspaceService=n,this.editorTabs=b,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,S){const n=S;if(!S.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=E.TaskHandleDTO.from(n,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(r,S);return this._proxy.$executeTask(t).catch(()=>{}),u}else{const t=E.TaskDTO.from(S,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,S,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),S);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(a,S,n,t){const r=[];if(t)for(let u of t){this.checkDeprecation(u,n),(!u.definition||!a[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const c=E.TaskDTO.from(u,n.extension);c&&(r.push(c),E.CustomExecutionDTO.is(c.execution)&&S.push(this.addCustomExecution(c,u,!0)))}return{tasks:r,extension:n.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(a,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(a){let S=a&&a.length>0?a[0]:void 0;if(!S){const n=i.URI.file((0,s.homedir)());S=new I.WorkspaceFolder({uri:n,name:w.basename(n),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,S){const n=i.URI.revive(a),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(n),u=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(u),f=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let b of S.variables)t.variables[b]=await c.resolveAsync(f,b);if(S.process!==void 0){let b;if(S.process.path!==void 0){b=S.process.path.split(m.delimiter);for(let d=0;d<b.length;d++)b[d]=await c.resolveAsync(f,b[d])}t.process=await y.win32.findExecutable(await c.resolveAsync(f,S.process.name),S.process.cwd!==void 0?await c.resolveAsync(f,S.process.cwd):void 0,b)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,S,n){return y.win32.findExecutable(a,S,n)}};o=je([ze(0,T.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,_.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,p.ILogService),ze(7,v.IExtHostApiDeprecationService),ze(8,A.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(ve[271],we([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(o,g,a,S){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new _.RPCProtocol(o,null,S),g=w._transform(g,this._rpcProtocol);const n=new T.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());n.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...g}),n.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),n.set(p.IURITransformerService,new p.URITransformerService(S)),n.set(v.IHostUtils,a);const t=new E.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(f=>f.get(A.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(f=>f.get(v.IExtHostExtensionService))),this._logService=t.invokeFunction(f=>f.get(I.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(f=>f.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(b,d)=>{let k="",R,N;for(const B of d)k+=`
	at ${B.toString()}`,N=B.getFileName(),!R&&N&&(R=f.findSubstr(P.URI.file(N)));return r.set(b,R),`${b.name||"Error"}: ${b.message||""}${k}`}});const u=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),c=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(f=>{const b=i.transformErrorForSerialization(f),d=r.get(f);d?u.$onExtensionRuntimeError(d.identifier,b):c.$onUnexpectedError(b)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(o,g){o.extensions.forEach(S=>S.extensionLocation=P.URI.revive(g.transformIncomingURIs(S.extensionLocation))),o.environment.appRoot=P.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const a=o.environment.extensionDevelopmentLocationURI;return a&&(o.environment.extensionDevelopmentLocationURI=a.map(S=>P.URI.revive(g.transformIncomingURIs(S)))),o.environment.extensionTestsLocationURI=P.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=P.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=P.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=P.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=P.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=w}),define(ve[272],we([0,1,9,21,50,31,23,46,33]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(l,E,h){this.config=l,this.provider=E,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&C.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&C.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const E=this.config.folderQueries||[];return new Promise((h,p)=>{const v=A=>{this.resultCount++,l(A)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const w=A.toString(),s=m.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,s)||this.matchFile(v,{base:A,basename:s})}),Promise.all(E.map(A=>this.searchInFolder(A,v))).then(A=>{h({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{p(new Error((0,y.toErrorMessage)(A)))})})}async searchInFolder(l,E){const h=new i.CancellationTokenSource,p=this.getSearchOptionsForFolder(l),v=this.initDirectoryTree(),A=new _.QueryGlobTester(this.config,l),w=!A.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(h),s=D.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,h.token),g=s.elapsed(),a=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(S=>{const n=m.posix.relative(l.folder.path,S.path);if(w){const t=m.basename(S.path);this.matchFile(E,{base:l.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(v,l.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,A,E),{providerTime:g,postProcessTime:a.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(l){const E=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),h=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:h,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},E,h,p){if(h===this.filePattern){const A=m.basename(this.filePattern);this.matchFile(p,{base:E,relativePath:this.filePattern,basename:A})}function v(A){const w=m.basename(A),s=m.dirname(A);let o=l[s];o||(o=l[s]=[],v(s)),o.push({base:E,relativePath:A,basename:w})}v(h)}matchDirectoryTree({rootEntries:l,pathToEntries:E},h,p){const v=this,A=this.filePattern;function w(s){const o=C.hasSiblingFn(()=>s.map(g=>g.basename));for(let g=0,a=s.length;g<a;g++){const S=s[g],{relativePath:n,basename:t}=S;if(h.matchesExcludesSync(n,t,A!==t?o:void 0))continue;const r=E[n];if(r)w(r);else{if(n===A)continue;v.matchFile(p,S)}if(v.isLimitHit)break}}w(l)}matchFile(l,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(E))}}class L{constructor(){this.sessions=new Map}fileSearch(l,E,h,p){const v=this.getSessionTokenSource(l.cacheKey),A=new I(l,E,v&&v.token);let w=0;const s=o=>{w+=o.length,h(o.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(A,L.BATCH_SIZE,s,p).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:o.stats}}))}clearCache(l){const E=this.getSessionTokenSource(l);E&&E.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new i.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:P.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,E,h,p){p.onCancellationRequested(()=>{l.cancel()});const v=w=>{w&&(A.push(w),E>0&&A.length>=E&&(h(A),A=[]))};let A=[];return l.search(v).then(w=>(A.length&&h(A),w),w=>(A.length&&h(A),Promise.reject(w)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(ve[134],we([0,1,16,21,50,31,10,9,23,13,2,33]),function(J,e,m,i,y,C,P,D,_,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(s,o,g,a){this.query=s,this.provider=o,this.fileUtils=g,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,o){const g=this.query.folderQueries||[],a=new i.CancellationTokenSource;return o.onCancellationRequested(()=>a.cancel()),new Promise((S,n)=>{this.collector=new h(s);let t=!1;const r=(u,c)=>{if(!t&&!this.isLimitHit){const f=this.resultSize(u);v(u)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,t=!0,a.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const b=this.resultSize(u);this.resultCount+=b,(b>0||!v(u))&&this.collector.add(u,c)}};Promise.all(g.map((u,c)=>this.searchInFolder(u,f=>r(f,c),a.token))).then(u=>{a.dispose(),this.collector.flush();const c=u.some(f=>!!f&&!!f.limitHit);S({limitHit:this.isLimitHit||c,messages:(0,m.flatten)(u.map(f=>f?.message?(0,I.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},u=>{a.dispose();const c=(0,y.toErrorMessage)(u);n(new Error(c))})})}resultSize(s){return v(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,o){const g=Array.isArray(s.ranges)?s.ranges:[s.ranges],a=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:g.slice(0,o),preview:{matches:a.slice(0,o),text:s.preview.text},uri:s.uri}}async searchInFolder(s,o,g){const a=new T.QueryGlobTester(this.query,s),S=[],n={report:u=>{if(!this.validateProviderResult(u))return;const c=s.folder.scheme===P.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(u.uri))):void 0,f=_.relativePath(s.folder,u.uri);if(f){const b=a.includedInQuery(f,D.basename(f),c);(0,I.isPromise)(b)?S.push(b.then(d=>{d&&o(u)})):b&&o(u)}}},t=this.getSearchOptionsForFolder(s),r=await this.provider.provideTextSearchResults(E(this.query.contentPattern),t,n,g);return S.length&&await Promise.all(S),r}validateProviderResult(s){if(v(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const o=(0,T.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),g=(0,T.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),a={folder:L.URI.from(s.folder),excludes:g,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=l;function E(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class h{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,o=>this.sendItems(o))}add(s,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!_.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(p(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=h;function p(w){return v(w)?{preview:{matches:(0,m.mapArrayOrNot)(w.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:w.preview.text},ranges:(0,m.mapArrayOrNot)(w.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function v(w){return!!w.preview}e.extensionResultIsMatch=v;class A{constructor(s,o){this.maxBatchSize=s,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,o){!s||this.addItemToBatch(s,o)}addItems(s,o){!s||this.addItemsToBatch(s,o)}addItemToBatch(s,o){this.batch.push(s),this.batchSize+=o,this.onUpdate()}addItemsToBatch(s,o){this.batch=this.batch.concat(s),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(ve[72],we([0,1,6,5,4,272,14,64,11,2,134]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let T=class{constructor(p,v,A){this.extHostRpc=p,this._uriTransformer=v,this._logService=A,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,v){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const A=this._handlePool++;return this._textSearchProvider.set(A,v),this._proxy.$registerTextSearchProvider(A,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(p,v){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const A=this._handlePool++;return this._fileSearchProvider.set(A,v),this._proxy.$registerFileSearchProvider(A,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(p,v,A,w){const s=l(A),o=this._fileSearchProvider.get(p);if(o)return this._fileSearchManager.fileSearch(s,o,g=>{this._proxy.$handleFileMatch(p,v,g.map(a=>a.resource))},w);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,v,A,w){const s=this._textSearchProvider.get(p);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const o=l(A);return this.createTextSearchManager(o,s).search(a=>this._proxy.$handleTextMatch(p,v,a),w)}$enableExtensionHostSearch(){}createTextSearchManager(p,v){return new L.TextSearchManager(p,v,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};T=je([ze(0,P.IExtHostRpcService),ze(1,D.IURITransformerService),ze(2,_.ILogService)],T),e.ExtHostSearch=T;function l(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(E),extraFileResources:h.extraFileResources&&h.extraFileResources.map(p=>I.URI.revive(p))}}e.reviveQuery=l;function E(h){return{...h,folder:I.URI.revive(h.folder)}}}),define(ve[273],we([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,17,7,254,68,133,35,74,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s,o,g,a,S,n,t,r,u,c,f,b,d,k,R,N,B,F,U,H,x,M,W,z,O,V,K,G,Q,Y,fe,me,Se,Ie,Oe,We,j,Z,re,ue,te,oe,Ee,Ne,Ve,Ge,Je,tt,ot,et,it,ct,pt,Pt,xe,Rt,ee,ne,pe,ie,_e,Fe,Ue,Xe,Ae,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function le(de){const be=de.get(Z.IExtHostInitDataService),Ce=de.get(ct.IExtHostFileSystemInfo),Me=de.get(Je.IExtHostConsumerFileSystem),Ke=de.get(n.IExtHostExtensionService),He=de.get(V.IExtHostWorkspace),Qe=de.get(ee.IExtHostTelemetry),st=de.get(A.IExtHostConfiguration),at=de.get(We.IURITransformerService),he=de.get(j.IExtHostRpcService),De=de.get(B.IExtHostStorage),ce=de.get(Ge.IExtensionStoragePaths),X=de.get(Oe.ILoggerService),ke=de.get(Oe.ILogService),Le=de.get(te.IExtHostTunnelService),Ze=de.get(oe.IExtHostApiDeprecationService),qe=de.get(O.IExtHostWindow),dt=de.get(xe.IExtHostSecretState),wt=de.get(Rt.IExtHostEditorTabs);he.set(l.ExtHostContext.ExtHostFileSystemInfo,Ce),he.set(l.ExtHostContext.ExtHostLogLevelServiceShape,X),he.set(l.ExtHostContext.ExtHostWorkspace,He),he.set(l.ExtHostContext.ExtHostConfiguration,st),he.set(l.ExtHostContext.ExtHostExtensionService,Ke),he.set(l.ExtHostContext.ExtHostStorage,De),he.set(l.ExtHostContext.ExtHostTunnelService,Le),he.set(l.ExtHostContext.ExtHostWindow,qe),he.set(l.ExtHostContext.ExtHostSecretState,dt),he.set(l.ExtHostContext.ExtHostTelemetry,Qe),he.set(l.ExtHostContext.ExtHostEditorTabs,wt);const yt=he.set(l.ExtHostContext.ExtHostDecorations,de.get(fe.IExtHostDecorations)),bt=he.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=he.set(l.ExtHostContext.ExtHostCommands,de.get(p.IExtHostCommands)),vt=he.set(l.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),_t=he.set(l.ExtHostContext.ExtHostDebugService,de.get(Se.IExtHostDebugService)),Ot=he.set(l.ExtHostContext.ExtHostSearch,de.get(Ie.IExtHostSearch)),It=he.set(l.ExtHostContext.ExtHostTask,de.get(me.IExtHostTask)),Tt=he.set(l.ExtHostContext.ExtHostOutputService,de.get(b.IExtHostOutputService)),Lt=he.set(l.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(he)),St=he.set(l.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(he,bt)),Mt=he.set(l.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(he,bt,ke)),Nt=he.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(ke,St,he.getProxy(l.MainContext.MainThreadBulkEdits))),Et=he.set(l.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(he,ft,bt,St,ce)),Wt=he.set(l.ExtHostContext.ExtHostNotebookDocuments,new Xe.ExtHostNotebookDocuments(ke,Et)),jt=he.set(l.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(ke,he,Et)),si=he.set(l.ExtHostContext.ExtHostNotebookKernels,new ne.ExtHostNotebookKernels(he,be,Et,ft,ke)),oi=he.set(l.ExtHostContext.ExtHostNotebookRenderers,new ie.ExtHostNotebookRenderers(he,Et)),At=he.set(l.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(he,bt)),Xt=he.set(l.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(he.getProxy(l.MainContext.MainThreadTreeViews),ft,ke)),ai=he.set(l.ExtHostContext.ExtHostEditorInsets,new G.ExtHostEditorInsets(he.getProxy(l.MainContext.MainThreadEditorInsets),At,be)),Yt=he.set(l.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(he,ke,Ce)),Vt=he.set(l.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(he,St,ft.converter,at)),gt=he.set(l.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(he,at,St,ft,Yt,ke,Ze)),ci=he.set(l.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(he,gt)),Ut=he.set(l.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(he,ke,bt)),qt=he.set(l.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(he,He,ft)),Jt=he.set(l.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(he,ft,ke)),li=he.set(l.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(he,ft,St)),fi=he.set(l.ExtHostContext.ExtHostProgress,new d.ExtHostProgress(he.getProxy(l.MainContext.MainThreadProgress))),Ei=he.set(l.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(he)),mi=he.set(l.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(he)),Zt=he.set(l.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(he)),Si=he.set(l.ExtHostContext.ExtHostTimeline,new Ne.ExtHostTimeline(he,ft)),Gt=he.set(l.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(he,{remote:be.remote},He,ke,Ze)),Kt=he.set(l.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(he,Gt,He)),_i=he.set(l.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(he,St,ce,Gt,Kt)),Ci=he.set(l.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(he,Gt)),Qt=he.set(l.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(he,ft)),yi=he.set(l.ExtHostContext.ExtHostUriOpeners,new Pt.ExtHostUriOpeners(he));he.set(l.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(he,Et,bt,ft));const ei=(0,K.values)(l.ExtHostContext);he.assertRegistered(ei);const Di=new it.ExtHostBulkEdits(he,bt),ki=new h.ExtHostClipboard(he),ui=new f.ExtHostMessageService(he,ke),ti=new s.ExtHostDialogs(he),gi=new N.ExtHostStatusBar(he,ft.converter);return E.ExtHostApiCommands.register(ft),function($e,Bt,pi){const mt=function(){let se=!$e.isUnderDevelopment;function ge(){se||(ke.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ut){if(Array.isArray(ut))ut.forEach(Re);else if(typeof ut=="string")ge();else{const Ct=ut;typeof Ct.scheme=="undefined"&&ge(),typeof Ct.exclusive=="boolean"&&(0,ye.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ut}}(),ii={getSession(se,ge,Re){return Zt.getSession($e,se,ge,Re)},async hasSession(se,ge){return(0,ye.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,se,ge,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,ge,Re,ut){return Zt.registerAuthenticationProvider(se,ge,Re,ut)}},Ii={registerCommand(se,ge,Re){return ft.registerCommand(!0,se,ge,Re,void 0,$e)},registerTextEditorCommand(se,ge,Re){return ft.registerCommand(!0,se,(...ut)=>{const Ct=At.getActiveTextEditor();if(!Ct){ke.warn("Cannot execute "+se+" because there is no active text editor.");return}return Ct.edit(Dt=>{ge.apply(Re,[Ct,Dt,...ut])}).then(Dt=>{Dt||ke.warn("Edits from command "+se+" were not applied.")},Dt=>{ke.warn("An error occurred while running command "+se,Dt)})},void 0,void 0,$e)},registerDiffInformationCommand:(se,ge,Re)=>((0,ye.checkProposedApiEnabled)($e,"diffCommand"),ft.registerCommand(!0,se,async(...ut)=>{const Ct=bt.activeEditor(!0);if(!Ct){ke.warn("Cannot execute "+se+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(Ct.id);ge.apply(Re,[Dt,...ut])},void 0,void 0,$e)),executeCommand(se,...ge){return ft.executeCommand(se,...ge)},getCommands(se=!1){return ft.getCommands(se)}},vi={get machineId(){return be.telemetryInfo.machineId},get sessionId(){return be.telemetryInfo.sessionId},get language(){return be.environment.appLanguage},get appName(){return be.environment.appName},get appRoot(){return be.environment.appRoot?.fsPath??""},get appHost(){return be.environment.appHost},get uriScheme(){return be.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Qe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Qe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const se=Date.now()-new Date(be.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,ge){return qe.openUri(se,{allowTunneling:!!be.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===be.environment.appUriScheme)return Lt.createAppUri(se);try{return await qe.asExternalUri(se,{allowTunneling:!!be.remote.authority})}catch(ge){if((0,Fe.matchesScheme)(se,_e.Schemas.http)||(0,Fe.matchesScheme)(se,_e.Schemas.https))return se;throw ge}},get remoteName(){return(0,Y.getRemoteName)(be.remote.authority)},get remoteAuthority(){return(0,ye.checkProposedApiEnabled)($e,"resolvers"),be.remote.authority},get uiKind(){return be.uiKind}};be.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=be.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pi={createTestController(se,ge){return Qt.createTestController(se,ge)},createTestObserver(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.createTestObserver()},runTests(se){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.runTests(se)},get onDidChangeTestResults(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.results}},Ti={getExtension(se){const ge=Bt.getExtensionDescription(se);if(ge)return new n.Extension(Ke,$e.identifier,ge,wi)},get all(){return Bt.getAllExtensionDescriptions().map(se=>new n.Extension(Ke,$e.identifier,se,wi))},get onDidChange(){return Bt.onDidChange}},Ai={createDiagnosticCollection(se){return Yt.createDiagnosticCollection($e.identifier,se)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:se=>Yt.getDiagnostics(se),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(se,ge){return Vt.changeLanguage(se.uri,ge)},match(se,ge){return(0,L.score)(x.LanguageSelector.from(se),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(se,ge,Re){return gt.registerCodeActionProvider($e,mt(se),ge,Re)},registerCodeLensProvider(se,ge){return gt.registerCodeLensProvider($e,mt(se),ge)},registerDefinitionProvider(se,ge){return gt.registerDefinitionProvider($e,mt(se),ge)},registerDeclarationProvider(se,ge){return gt.registerDeclarationProvider($e,mt(se),ge)},registerImplementationProvider(se,ge){return gt.registerImplementationProvider($e,mt(se),ge)},registerTypeDefinitionProvider(se,ge){return gt.registerTypeDefinitionProvider($e,mt(se),ge)},registerHoverProvider(se,ge){return gt.registerHoverProvider($e,mt(se),ge,$e.identifier)},registerEvaluatableExpressionProvider(se,ge){return gt.registerEvaluatableExpressionProvider($e,mt(se),ge,$e.identifier)},registerInlineValuesProvider(se,ge){return gt.registerInlineValuesProvider($e,mt(se),ge,$e.identifier)},registerDocumentHighlightProvider(se,ge){return gt.registerDocumentHighlightProvider($e,mt(se),ge)},registerLinkedEditingRangeProvider(se,ge){return gt.registerLinkedEditingRangeProvider($e,mt(se),ge)},registerReferenceProvider(se,ge){return gt.registerReferenceProvider($e,mt(se),ge)},registerRenameProvider(se,ge){return gt.registerRenameProvider($e,mt(se),ge)},registerDocumentSymbolProvider(se,ge,Re){return gt.registerDocumentSymbolProvider($e,mt(se),ge,Re)},registerWorkspaceSymbolProvider(se){return gt.registerWorkspaceSymbolProvider($e,se)},registerDocumentFormattingEditProvider(se,ge){return gt.registerDocumentFormattingEditProvider($e,mt(se),ge)},registerDocumentRangeFormattingEditProvider(se,ge){return gt.registerDocumentRangeFormattingEditProvider($e,mt(se),ge)},registerOnTypeFormattingEditProvider(se,ge,Re,...ut){return gt.registerOnTypeFormattingEditProvider($e,mt(se),ge,[Re].concat(ut))},registerDocumentSemanticTokensProvider(se,ge,Re){return gt.registerDocumentSemanticTokensProvider($e,mt(se),ge,Re)},registerDocumentRangeSemanticTokensProvider(se,ge,Re){return gt.registerDocumentRangeSemanticTokensProvider($e,mt(se),ge,Re)},registerSignatureHelpProvider(se,ge,Re,...ut){return typeof Re=="object"?gt.registerSignatureHelpProvider($e,mt(se),ge,Re):gt.registerSignatureHelpProvider($e,mt(se),ge,typeof Re=="undefined"?[]:[Re,...ut])},registerCompletionItemProvider(se,ge,...Re){return gt.registerCompletionItemProvider($e,mt(se),ge,Re)},registerInlineCompletionItemProvider(se,ge){return(0,ye.checkProposedApiEnabled)($e,"inlineCompletions"),gt.registerInlineCompletionsProvider($e,mt(se),ge)},registerDocumentLinkProvider(se,ge){return gt.registerDocumentLinkProvider($e,mt(se),ge)},registerColorProvider(se,ge){return gt.registerColorProvider($e,mt(se),ge)},registerFoldingRangeProvider(se,ge){return gt.registerFoldingRangeProvider($e,mt(se),ge)},registerSelectionRangeProvider(se,ge){return gt.registerSelectionRangeProvider($e,se,ge)},registerCallHierarchyProvider(se,ge){return gt.registerCallHierarchyProvider($e,se,ge)},registerTypeHierarchyProvider(se,ge){return gt.registerTypeHierarchyProvider($e,se,ge)},setLanguageConfiguration:(se,ge)=>gt.setLanguageConfiguration($e,se,ge),getTokenInformationAtPosition(se,ge){return(0,ye.checkProposedApiEnabled)($e,"tokenInformation"),Vt.tokenAtPosition(se,ge)},registerInlayHintsProvider(se,ge){return(0,ye.checkProposedApiEnabled)($e,"inlayHints"),gt.registerInlayHintsProvider($e,se,ge)},createLanguageStatusItem(se,ge){return(0,ye.checkProposedApiEnabled)($e,"languageStatus"),Vt.createLanguageStatusItem($e,se,ge)}},Ri={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(se,ge,Re){const ut=await(P.URI.isUri(se)?Promise.resolve(ni.openTextDocument(se)):Promise.resolve(se));return At.showTextDocument(ut,ge,Re)},createTextEditorDecorationType(se){return At.createTextEditorDecorationType($e,se)},onDidChangeActiveTextEditor(se,ge,Re){return At.onDidChangeActiveTextEditor(se,ge,Re)},onDidChangeVisibleTextEditors(se,ge,Re){return At.onDidChangeVisibleTextEditors(se,ge,Re)},onDidChangeTextEditorSelection(se,ge,Re){return At.onDidChangeTextEditorSelection(se,ge,Re)},onDidChangeTextEditorOptions(se,ge,Re){return At.onDidChangeTextEditorOptions(se,ge,Re)},onDidChangeTextEditorVisibleRanges(se,ge,Re){return At.onDidChangeTextEditorVisibleRanges(se,ge,Re)},onDidChangeTextEditorViewColumn(se,ge,Re){return At.onDidChangeTextEditorViewColumn(se,ge,Re)},onDidCloseTerminal(se,ge,Re){return vt.onDidCloseTerminal(se,ge,Re)},onDidOpenTerminal(se,ge,Re){return vt.onDidOpenTerminal(se,ge,Re)},onDidChangeActiveTerminal(se,ge,Re){return vt.onDidChangeActiveTerminal(se,ge,Re)},onDidChangeTerminalDimensions(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"terminalDimensions"),vt.onDidChangeTerminalDimensions(se,ge,Re)},onDidChangeTerminalState(se,ge,Re){return vt.onDidChangeTerminalState(se,ge,Re)},onDidWriteTerminalData(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(se,ge,Re)},get state(){return qe.state},onDidChangeWindowState(se,ge,Re){return qe.onDidChangeWindowState(se,ge,Re)},showInformationMessage(se,...ge){return ui.showMessage($e,C.default.Info,se,ge[0],ge.slice(1))},showWarningMessage(se,...ge){return ui.showMessage($e,C.default.Warning,se,ge[0],ge.slice(1))},showErrorMessage(se,...ge){return ui.showMessage($e,C.default.Error,se,ge[0],ge.slice(1))},showQuickPick(se,ge,Re){return Array.isArray(se)&&se.some(ut=>ut.kind!==void 0)&&(0,ye.checkProposedApiEnabled)($e,"quickPickSeparators"),qt.showQuickPick(se,ge,Re)},showWorkspaceFolderPick(se){return qt.showWorkspaceFolderPick(se)},showInputBox(se,ge){return qt.showInput(se,ge)},showOpenDialog(se){return ti.showOpenDialog(se)},showSaveDialog(se){return ti.showSaveDialog(se)},createStatusBarItem(se,ge,Re){let ut,Ct,Dt;return typeof se=="string"?(ut=se,Ct=ge,Dt=Re):(Ct=se,Dt=ge),gi.createStatusBarEntry($e,ut,Ct,Dt)},setStatusBarMessage(se,ge){return gi.setStatusBarMessage(se,ge)},withScmProgress(se){return Ze.report("window.withScmProgress",$e,"Use 'withProgress' instead."),fi.withProgress($e,{location:M.ProgressLocation.SourceControl},(ge,Re)=>se({report(ut){}}))},withProgress(se,ge){return fi.withProgress($e,se,ge)},createOutputChannel(se){return Tt.createOutputChannel(se,$e)},createWebviewPanel(se,ge,Re,ut){return Kt.createWebviewPanel($e,se,ge,Re,ut)},createWebviewTextEditorInset(se,ge,Re,ut){return(0,ye.checkProposedApiEnabled)($e,"editorInsets"),ai.createWebviewEditorInset(se,ge,Re,ut,$e)},createTerminal(se,ge,Re){return typeof se=="object"?"pty"in se?vt.createExtensionTerminal(se):vt.createTerminalFromOptions(se):vt.createTerminal(se,ge,Re)},registerTerminalLinkProvider(se){return vt.registerLinkProvider(se)},registerTerminalProfileProvider(se,ge){return vt.registerProfileProvider($e,se,ge)},registerTreeDataProvider(se,ge){return Xt.registerTreeDataProvider(se,ge,$e)},createTreeView(se,ge){return Xt.createTreeView(se,ge,$e)},registerWebviewPanelSerializer:(se,ge)=>Kt.registerWebviewPanelSerializer($e,se,ge),registerCustomEditorProvider:(se,ge,Re={})=>_i.registerCustomEditorProvider($e,se,ge,Re),registerFileDecorationProvider(se){return yt.registerFileDecorationProvider(se,$e.identifier)},registerUriHandler(se){return Lt.registerUriHandler($e.identifier,se)},createQuickPick(){return qt.createQuickPick($e)},createInputBox(){return qt.createInputBox($e.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(se,ge,Re){return mi.onDidChangeActiveColorTheme(se,ge,Re)},registerWebviewViewProvider(se,ge,Re){return Ci.registerWebviewViewProvider($e,se,ge,Re?.webviewOptions)},get activeNotebookEditor(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(se,ge,Re)},get visibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(se,ge,Re)},onDidChangeNotebookEditorVisibleRanges(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(se,ge,Re)},showNotebookDocument(se,ge){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.showNotebookDocument(se,ge)},registerExternalUriOpener(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"externalUriOpener"),yi.registerExternalUriOpener($e.identifier,se,ge,Re)},get tabs(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.tabs},get activeTab(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(se){return(0,ye.checkProposedApiEnabled)($e,"inlineCompletions"),u.InlineCompletionController.get(se)}},ni={get rootPath(){return Ze.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),He.getPath()},set rootPath(se){throw i.readonly()},getWorkspaceFolder(se){return He.getWorkspaceFolder(se)},get workspaceFolders(){return He.getWorkspaceFolders()},get name(){return He.name},set name(se){throw i.readonly()},get workspaceFile(){return He.workspaceFile},set workspaceFile(se){throw i.readonly()},updateWorkspaceFolders:(se,ge,...Re)=>He.updateWorkspaceFolders($e,se,ge||0,...Re),onDidChangeWorkspaceFolders:function(se,ge,Re){return He.onDidChangeWorkspace(se,ge,Re)},asRelativePath:(se,ge)=>He.getRelativePath(se,ge),findFiles:(se,ge,Re,ut)=>He.findFiles(x.GlobPattern.from(se),x.GlobPattern.from(ge),Re,$e.identifier,ut),findTextInFiles:(se,ge,Re,ut)=>{(0,ye.checkProposedApiEnabled)($e,"findTextInFiles");let Ct,Dt;return typeof ge=="object"?(Ct=ge,Dt=Re):(Ct={},Dt=ge,ut=Re),He.findTextInFiles(se,Ct||{},Dt,$e.identifier,ut)},saveAll:se=>He.saveAll(se),applyEdit(se){return Di.applyWorkspaceEdit(se)},createFileSystemWatcher:(se,ge,Re,ut)=>Ut.createFileSystemWatcher(x.GlobPattern.from(se),ge,Re,ut),get textDocuments(){return St.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw i.readonly()},openTextDocument(se){let ge;const Re=se;if(typeof se=="string")ge=Promise.resolve(P.URI.file(se));else if(P.URI.isUri(se))ge=Promise.resolve(se);else if(!Re||typeof Re=="object")ge=St.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ut=>St.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(se,ge,Re)=>St.onDidAddDocument(se,ge,Re),onDidCloseTextDocument:(se,ge,Re)=>St.onDidRemoveDocument(se,ge,Re),onDidChangeTextDocument:(se,ge,Re)=>St.onDidChangeDocument(se,ge,Re),onDidSaveTextDocument:(se,ge,Re)=>St.onDidSaveDocument(se,ge,Re),onWillSaveTextDocument:(se,ge,Re)=>Nt.getOnWillSaveTextDocumentEvent($e)(se,ge,Re),get notebookDocuments(){return Et.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,ge){let Re;if(P.URI.isUri(se))Re=se,await Et.openNotebookDocument(se);else if(typeof se=="string")Re=P.URI.revive(await Et.createNotebookDocument({viewType:se,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(se,ge,Re,ut){return Et.registerNotebookSerializer($e,se,ge,Re,(0,ye.isProposedApiEnabled)($e,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(se,ge,Re,ut)=>((0,ye.checkProposedApiEnabled)($e,"notebookContentProvider"),Et.registerNotebookContentProvider($e,se,ge,Re,(0,ye.isProposedApiEnabled)($e,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(se,ge,Re)=>pi.onDidChangeConfiguration(se,ge,Re),getConfiguration(se,ge){return ge=arguments.length===1?void 0:ge,pi.getConfiguration(se,ge,$e)},registerTextDocumentContentProvider(se,ge){return Mt.registerTextDocumentContentProvider(se,ge)},registerTaskProvider:(se,ge)=>(Ze.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider($e,se,ge)),registerFileSystemProvider(se,ge,Re){return(0,Pe.combinedDisposable)(ci.registerFileSystemProvider($e,se,ge,Re),Me.addFileSystemProvider(se,ge))},get fs(){return Me.value},registerFileSearchProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"fileSearchProvider"),Ot.registerFileSearchProvider(se,ge)),registerTextSearchProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"textSearchProvider"),Ot.registerTextSearchProvider(se,ge)),registerRemoteAuthorityResolver:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Ke.registerRemoteAuthorityResolver(se,ge)),registerResourceLabelFormatter:se=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Ei.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,ge,Re)=>Ut.onDidCreateFile(se,ge,Re),onDidDeleteFiles:(se,ge,Re)=>Ut.onDidDeleteFile(se,ge,Re),onDidRenameFiles:(se,ge,Re)=>Ut.onDidRenameFile(se,ge,Re),onWillCreateFiles:(se,ge,Re)=>Ut.getOnWillCreateFileEvent($e)(se,ge,Re),onWillDeleteFiles:(se,ge,Re)=>Ut.getOnWillDeleteFileEvent($e)(se,ge,Re),onWillRenameFiles:(se,ge,Re)=>Ut.getOnWillRenameFileEvent($e)(se,ge,Re),openTunnel:se=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Le.openTunnel($e,se).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,ye.checkProposedApiEnabled)($e,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(se,ge,Re)=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Le.onDidChangeTunnels(se,ge,Re)),registerPortAttributesProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"portsAttributes"),Le.registerPortsAttributesProvider(se,ge)),registerTimelineProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"timeline"),Si.registerTimelineProvider(se,ge,$e.identifier,ft.converter)),get isTrusted(){return He.trusted},requestWorkspaceTrust:se=>((0,ye.checkProposedApiEnabled)($e,"workspaceTrust"),He.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,ge,Re)=>He.onDidGrantWorkspaceTrust(se,ge,Re)},Li={get inputBox(){return Ze.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox($e)},createSourceControl(se,ge,Re){return Jt.createSourceControl($e,se,ge,Re)}},Fi={createCommentController(se,ge){return li.createCommentController($e,se,ge)}},Mi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(se,ge,Re){return _t.onDidStartDebugSession(se,ge,Re)},onDidTerminateDebugSession(se,ge,Re){return _t.onDidTerminateDebugSession(se,ge,Re)},onDidChangeActiveDebugSession(se,ge,Re){return _t.onDidChangeActiveDebugSession(se,ge,Re)},onDidReceiveDebugSessionCustomEvent(se,ge,Re){return _t.onDidReceiveDebugSessionCustomEvent(se,ge,Re)},onDidChangeBreakpoints(se,ge,Re){return _t.onDidChangeBreakpoints(se,ge,Re)},registerDebugConfigurationProvider(se,ge,Re){return _t.registerDebugConfigurationProvider(se,ge,Re||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,ge){return _t.registerDebugAdapterDescriptorFactory($e,se,ge)},registerDebugAdapterTrackerFactory(se,ge){return _t.registerDebugAdapterTrackerFactory(se,ge)},startDebugging(se,ge,Re){return!Re||typeof Re=="object"&&"configuration"in Re?_t.startDebugging(se,ge,{parentSession:Re}):_t.startDebugging(se,ge,Re||{})},stopDebugging(se){return _t.stopDebugging(se)},addBreakpoints(se){return _t.addBreakpoints(se)},removeBreakpoints(se){return _t.removeBreakpoints(se)},asDebugSourceUri(se,ge){return _t.asDebugSourceUri(se,ge)}},Oi={registerTaskProvider:(se,ge)=>It.registerTaskProvider($e,se,ge),fetchTasks:se=>It.fetchTasks(se),executeTask:se=>It.executeTask($e,se),get taskExecutions(){return It.taskExecutions},onDidStartTask:(se,ge,Re)=>It.onDidStartTask(se,ge,Re),onDidEndTask:(se,ge,Re)=>It.onDidEndTask(se,ge,Re),onDidStartTaskProcess:(se,ge,Re)=>It.onDidStartTaskProcess(se,ge,Re),onDidEndTaskProcess:(se,ge,Re)=>It.onDidEndTaskProcess(se,ge,Re)},Ni={createNotebookController(se,ge,Re,ut,Ct){return si.createNotebookController($e,se,ge,Re,ut,(0,ye.isProposedApiEnabled)($e,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(se,ge)=>Et.registerNotebookCellStatusBarItemProvider($e,se,ge),get onDidSaveNotebookDocument(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(se){return(0,ye.checkProposedApiEnabled)($e,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(se)},createRendererMessaging(se){return oi.createRendererMessaging($e,se)},onDidChangeNotebookDocumentMetadata(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(se,ge,Re)},onDidChangeNotebookCells(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeNotebookCells(se,ge,Re)},onDidChangeNotebookCellExecutionState(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(se,ge,Re)},onDidChangeCellOutputs(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeCellOutputs(se,ge,Re)},onDidChangeCellMetadata(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeCellMetadata(se,ge,Re)},createConcatTextDocument(se,ge){return(0,ye.checkProposedApiEnabled)($e,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(Et,St,se,ge)}};return{version:be.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:I.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:l.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:M.TreeDataTransfer,TreeDataTransferItem:M.TreeDataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=le}),define(ve[274],we([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w,s,o,g,a,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(S.ILoggerService,a.ExtHostLoggerService),(0,m.registerSingleton)(S.ILogService,n.ExtHostLogService),(0,m.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,m.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,m.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,m.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,m.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,m.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,m.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,m.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,m.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,m.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,m.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,m.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(ve[92],we([0,1,16,11,33,69]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=P;function D(T,l,E,h){const p=(0,m.mapArrayOrNot)(E,_),v=new y.TextSearchMatch(l,p,h),A=v.preview.matches;return{ranges:(0,m.mapArrayOrNot)(p,I),uri:T,preview:{text:v.preview.text,matches:(0,m.mapArrayOrNot)(A,I)}}}e.createTextSearchResult=D;function _(T){return new y.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function I(T){return new C.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(l,E){this.prefix=l,this.logService=E}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};L=je([ze(1,i.ILogService)],L),e.OutputChannel=L}),define(ve[275],we([0,1,95,22]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===n)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,P=512,D=512*8,_=512*128;var I;(function(n){n[n.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(t,r){super(t);this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class T{constructor(t){this.iconvLiteDecoder=t}static async create(t){let r;if(t!==e.UTF8)r=(await new Promise((c,f)=>{J(["iconv-lite-umd"],c,f)})).getDecoder(p(t));else{const u=new TextDecoder;r={write(c){return u.decode(c,{stream:!0})},end(){return u.decode()}}}return new T(r)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function l(n,t){const r=t.minBytesRequiredForDetection??t.guessEncoding?D:P;return new Promise((u,c)=>{const f=(0,m.newWriteableStream)(B=>B.join("")),b=[];let d=0,k,R;const N=async()=>{try{const B=await S({buffer:i.VSBuffer.concat(b),bytesRead:d},t.guessEncoding);if(B.seemsBinary&&t.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);B.encoding=await t.overwriteEncoding(B.encoding),k=await T.create(B.encoding);const F=k.write(i.VSBuffer.concat(b).buffer);f.write(F),b.length=0,d=0,u({stream:f,detected:B})}catch(B){R?.dispose(),f.destroy(),c(B)}};R=(0,m.listenStream)(n,{onData:async B=>{k?f.write(k.write(B.buffer)):(b.push(B),d+=B.byteLength,d>=r&&(n.pause(),await N(),setTimeout(()=>n.resume())))},onError:B=>f.error(B),onEnd:async()=>{k||await N(),f.end(k?.end())}})})}e.toDecodeStream=l;async function E(n,t,r){const c=(await new Promise((d,k)=>{J(["iconv-lite-umd"],d,k)})).getEncoder(p(t),r);let f=!1,b=!1;return{read(){if(b)return null;const d=n.read();if(typeof d!="string"){if(b=!0,!f&&r?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const k=c.end();return k&&k.length>0?(f=!0,i.VSBuffer.wrap(k)):null}return f=!0,i.VSBuffer.wrap(c.write(d))}}}e.toEncodeReadable=E;async function h(n){return(await new Promise((r,u)=>{J(["iconv-lite-umd"],r,u)})).encodingExists(p(n))}e.encodingExists=h;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function v(n,t){if(!n||t<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),u=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const c=n.readUInt8(2);return r===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const A=["ascii","utf-16","utf-32"];async function w(n){const t=await new Promise((b,d)=>{J(["jschardet"],b,d)}),r=n.slice(0,_),u=g(r.buffer),c=t.detect(u);if(!c||!c.encoding)return null;const f=c.encoding.toLowerCase();return 0<=A.indexOf(f)?null:o(c.encoding)}const s={ibm866:"cp866",big5:"cp950"};function o(n){const t=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[t]||t}function g(n){let t="";for(let r=0;r<n.length;r++)t+=String.fromCharCode(n[r]);return t}function a(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=n.match(/windows(\d+)/);return t?"windows-"+t[1]:n}}}e.toCanonicalName=a;function S({buffer:n,bytesRead:t},r){let u=v(n,t),c=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&n){let f=!0,b=!0,d=!1;for(let k=0;k<t&&k<C;k++){const R=k%2==1,N=n.readUInt8(k)===0;if(N&&(d=!0),f&&(R&&!N||!R&&N)&&(f=!1),b&&(R&&N||!R&&!N)&&(b=!1),N&&!f&&!b)break}d&&(f?u=e.UTF16le:b?u=e.UTF16be:c=!0)}return r&&!c&&!u&&n?w(n.slice(0,t)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:c,encoding:u}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[135],we([0,1,275,28,134]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(D,_,I=i,L="searchProcess"){super(D,_,{readdir:T=>I.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,m.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=C}),define(ve[276],we([0,1,277,291,292,2,293]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(T,l,E,h,p,v){const A=v.environment.useHostProxy,w=typeof A=="boolean"?A:!v.remote.isRemote,s=(0,P.createProxyResolver)({resolveProxy:g=>T.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,a,...S)=>{switch(g){case P.LogLevel.Trace:h.trace(a,...S);break;case P.LogLevel.Debug:h.debug(a,...S);break;case P.LogLevel.Info:h.info(a,...S);break;case P.LogLevel.Warning:h.warn(a,...S);break;case P.LogLevel.Error:h.error(a,...S);break;case P.LogLevel.Critical:h.critical(a,...S);break;case P.LogLevel.Off:break;default:n(g,a,S);break}function n(t,r,...u){h.error("Unknown log level",t),h.error(r,...u)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:g=>{p.$publicLog2("resolveProxy",g)},useHostProxy:w,env:process.env}),o=_(l,s);return L(E,o)}e.connectProxyResolver=D;function _(T,l){const E={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(p=>{E.config=T.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(p=>{h.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,P.createHttpPatch)(m,l,{config:"off"},h,!0)),on:Object.assign({},m,(0,P.createHttpPatch)(m,l,{config:"on"},h,!0)),override:Object.assign({},m,(0,P.createHttpPatch)(m,l,{config:"override"},h,!0)),onRequest:Object.assign({},m,(0,P.createHttpPatch)(m,l,E,h,!0)),default:Object.assign(m,(0,P.createHttpPatch)(m,l,E,h,!1))},https:{off:Object.assign({},i,(0,P.createHttpPatch)(i,l,{config:"off"},h,!0)),on:Object.assign({},i,(0,P.createHttpPatch)(i,l,{config:"on"},h,!0)),override:Object.assign({},i,(0,P.createHttpPatch)(i,l,{config:"override"},h,!0)),onRequest:Object.assign({},i,(0,P.createHttpPatch)(i,l,E,h,!0)),default:Object.assign(i,(0,P.createHttpPatch)(i,l,E,h,!1))},tls:Object.assign(y,(0,P.createTlsPatch)(y))}}const I=new Map;function L(T,l){return T.getExtensionPathIndex().then(E=>{const h=J.__$__nodeRequire("module"),p=h._load;h._load=function(A,w,s){if(A==="tls")return l.tls;if(A!=="http"&&A!=="https")return p.apply(this,arguments);const o=l[A],g=E.findSubstr(C.URI.file(w.filename));let a=I.get(g);if(a||I.set(g,a={}),!a[A]){let S=o.default;a[A]={...S}}return a[A]}})}}),define(ve[278],we([0,1,37,9,79,30,12,8,92,279]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(s,o,g,a){const S=l(s,o,g,a),n=o.folder.fsPath;return{cmd:m.spawn(L,S.args,{cwd:n}),rgDiskPath:L,siblingClauses:S.siblingClauses,rgArgs:S,cwd:n}}e.spawnRipgrepCmd=T;function l(s,o,g,a){const S=["--files","--hidden","--case-sensitive"];h([o],g,!1).forEach(t=>{const r=(0,_.anchorGlob)(t);if(S.push("-g",r),P.isMacintosh){const u=(0,y.normalizeNFD)(r);u!==r&&S.push("-g",u)}});const n=E([o],a,void 0,!1);return n.globArgs.forEach(t=>{const r=`!${(0,_.anchorGlob)(t)}`;if(S.push("-g",r),P.isMacintosh){const u=(0,y.normalizeNFD)(r);u!==r&&S.push("-g",u)}}),o.disregardIgnoreFiles!==!1?S.push("--no-ignore"):S.push("--no-ignore-parent"),o.ignoreSymlinks||S.push("--follow"),s.exists&&S.push("--quiet"),S.push("--no-config"),o.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:n.siblingClauses}}function E(s,o,g,a=!0){const S=[];let n={};return s.forEach(t=>{const r=Object.assign({},t.excludePattern||{},o||{}),u=p(r,a?t.folder.fsPath:void 0,g);S.push(...u.globArgs),u.siblingClauses&&(n=Object.assign(n,u.siblingClauses))}),{globArgs:S,siblingClauses:n}}e.foldersToRgExcludeGlobs=E;function h(s,o,g=!0){const a=[];return s.forEach(S=>{const n=Object.assign({},o||{},S.includePattern||{}),t=p(n,g?S.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=h;function p(s,o,g){const a=[],S={};return Object.keys(s).forEach(n=>{if(g&&g.has(n)||!n)return;const t=s[n];n=A(o?v(o,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),a.push(w(n))):t&&t.when&&(S[n]=t)}),{globArgs:a,siblingClauses:S}}function v(s,o){return i.isAbsolute(o)?o:i.join(s,o)}e.getAbsoluteGlob=v;function A(s){return s=D.rtrim(s,"\\"),D.rtrim(s,"/")}function w(s){return C.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=w}),define(ve[280],we([0,1,37,60,9,103,16,50,31,79,30,12,46,8,13,28,33,278,100]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(n=>n())});class o{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,w.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(r=>{const u=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),c=r.folder.fsPath;t.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==c).forEach(f=>{(0,L.isEqualOrParent)(f,c)&&(u[y.relative(c,f)]=!0)}),this.folderExcludePatterns.set(c,new a(u,c))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,r,u,c,f){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);r.forEach(b=>{const d=y.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,d)||this.matchFile(u,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(t,(b,d)=>{this.call(this.cmdTraversal,this,b,u,c,k=>{if(k){const R=(0,D.toErrorMessage)(k);console.error(R),this.errors.push(R),d(k,void 0)}else d(null,void 0)})},(b,d)=>{this.fileWalkSW.stop();const k=b?P.coalesce(b)[0]:null;f(k,this.isLimitHit)})}parallel(t,r,u){const c=new Array(t.length),f=new Array(t.length);let b=!1,d=0;if(t.length===0)return u(null,[]);t.forEach((k,R)=>{r(k,(N,B)=>{if(N?(b=!0,c[R]=null,f[R]=N):(c[R]=B,f[R]=null),++d===t.length)return u(b?f:null,c)})})}call(t,r,...u){try{t.apply(r,u)}catch(c){u[u.length-1](c)}}cmdTraversal(t,r,u,c){const f=t.folder.fsPath,b=T.isMacintosh;let d;const k=()=>d&&d.kill();s.add(k);let R=M=>{s.delete(k),R=()=>{},c(M)},N="";const B=this.initDirectoryTree();let F;const U=(0,A.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);d=U.cmd,F=!Object.keys(U.siblingClauses).length;const H=U.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let x=`${U.rgDiskPath} ${H}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),u({message:x}),this.cmdResultCount=0,this.collectStdout(d,"utf8",u,(M,W,z)=>{if(M){R(M);return}if(this.isLimitHit){R();return}const V=(N+(b?I.normalizeNFC(W||""):W)).split(`
`);if(z){const K=V.length;V[K-1]=V[K-1].trim(),V[K-1]||V.pop()}else N=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,F){for(const K of V)if(this.matchFile(r,{base:f,relativePath:K,searchPath:this.getSearchPath(t,K)}),this.isLimitHit){k();break}(z||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,B,f,V,r),z&&(this.matchDirectoryTree(B,f,r),R())})}spawnFindCmd(t){const r=this.folderExcludePatterns.get(t.folder.fsPath),u=r.getBasenameTerms(),c=r.getPathTerms(),f=["-L","."];if(u.length||c.length){f.push("-not","(","(");for(const b of u)f.push("-name",b),f.push("-o");for(const b of c)f.push("-path",b),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),m.spawn("find",f,{cwd:t.folder.fsPath})}readStdout(t,r,u){let c="";this.collectStdout(t,r,()=>{},(f,b,d)=>{if(f){u(f);return}c+=b,d&&u(null,c)})}collectStdout(t,r,u,c){let f=(k,R,N)=>{(k||N)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),c(k,R,N)},b=!1;t.stdout?(this.forwardData(t.stdout,r,f),t.stdout.once("data",()=>b=!0)):u({message:"stdout is null"});let d;t.stderr?d=this.collectData(t.stderr):u({message:"stderr is null"}),t.on("error",k=>{f(k)}),t.on("close",k=>{let R;!b&&(R=this.decodeData(d,r))&&S(R)?f(new Error(`command failed with error code ${k}: ${this.decodeData(d,r)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(t,r,u){const c=new C.StringDecoder(r);return t.on("data",f=>{u(null,c.write(f))}),c}collectData(t){const r=[];return t.on("data",u=>{r.push(u)}),r}decodeData(t,r){const u=new C.StringDecoder(r);return t.map(c=>u.write(c)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:r},u,c,f){c.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const b=d=>{const k=y.basename(d),R=y.dirname(d);let N=r[R];N||(N=r[R]=[],b(R)),N.push({base:u,relativePath:d,basename:k,searchPath:this.getSearchPath(t,d)})};c.forEach(b)}matchDirectoryTree({rootEntries:t,pathToEntries:r},u,c){const f=this,b=this.folderExcludePatterns.get(u),d=this.filePattern;function k(R){f.directoriesWalked++;const N=_.hasSiblingFn(()=>R.map(B=>B.basename));for(let B=0,F=R.length;B<F;B++){const U=R[B],{relativePath:H,basename:x}=U;if(b.test(H,x,d!==x?N:void 0))continue;const M=r[H];if(M)k(M);else{if(f.filesWalked++,H===d)continue;f.matchFile(c,U)}if(f.isLimitHit)break}}k(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,r,u,c,f){const b=t.folder,d=_.hasSiblingFn(()=>u);this.parallel(u,(k,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const N=r?[r,k].join(y.sep):k;if(this.folderExcludePatterns.get(t.folder.fsPath).test(N,k,this.config.filePattern!==k?d:void 0))return R(null);const B=[b.fsPath,N].join(y.sep);i.lstat(B,(F,U)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(B,U,(H,x)=>H||this.isCanceled||this.isLimitHit?R(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(B,U,(M,W)=>M||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?R(null):(this.walkedPaths[W]=!0,p.Promises.readdir(B).then(z=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,N,z,c,O=>R(O||null))},z=>{R(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&h.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(c,{base:b.fsPath,relativePath:N,searchPath:this.getSearchPath(t,N)}),R(null,void 0)))})},k=>{const R=k&&P.coalesce(k);return f(R&&R.length>0?R[0]:void 0)})}matchFile(t,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,y.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(r))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,r,u){return r.isSymbolicLink()?i.stat(t,u):u(null,r)}realPathIfNeeded(t,r,u){return r.isSymbolicLink()?i.realpath(t,(c,f)=>c?u(c):u(null,f)):u(null,t)}getSearchPath(t,r){return t.folderName?y.join(t.folderName,r):r}}e.FileWalker=o;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new o(t)}search(t,r,u){this.walker.walk(this.folderQueries,this.extraFiles,t,r,(c,f)=>{u(c,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class a{constructor(t,r){this.expression=t,this.root=r,this.init(t)}init(t){let r,u;Object.keys(t).filter(c=>t[c]).forEach(c=>{y.isAbsolute(c)?(r=r||_.getEmptyExpression(),r[c]=t[c]):(u=u||_.getEmptyExpression(),u[c]=t[c])}),this.absoluteParsedExpr=r&&_.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=u&&_.parse(u,{trimForExclusions:!0})}test(t,r,u){return this.relativeParsedExpr&&this.relativeParsedExpr(t,r,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),r,u)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function S(n){const t=n.trim().split(`
`),r=t[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return E.uppercaseFirstLetter(t[t.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=S}),define(ve[136],we([0,1,37,294,103,16,74,31,9,8,2,33,69,295,279,92]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(b){this.outputChannel=b}provideTextSearchResults(b,d,k,R){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...d,folder:d.folder.toString()})}`),new Promise((N,B)=>{R.onCancellationRequested(()=>O());const F=S(b,d),U=d.folder.fsPath,H=F.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");this.outputChannel.appendLine(`${v} ${H}
 - cwd: ${U}`);let x=m.spawn(v,F,{cwd:U});x.on("error",Y=>{console.error(Y),this.outputChannel.appendLine("Error: "+(Y&&Y.message)),B((0,T.serializeSearchError)(new T.SearchError(Y&&Y.message,T.SearchErrorCode.rgProcessError)))});let M=!1;const W=new o(d.maxResults,U,d.previewOptions);W.on("result",Y=>{M=!0,K="",k.report(Y)});let z=!1;const O=()=>{z=!0,x&&x.kill(),W&&W.cancel()};let V=!1;W.on("hitLimit",()=>{V=!0,O()});let K="";x.stdout.on("data",Y=>{W.handleData(Y),M||(K+=Y)});let G=!1;x.stdout.once("data",()=>G=!0);let Q="";x.stderr.on("data",Y=>{const fe=Y.toString();this.outputChannel.appendLine(fe),Q+=fe}),x.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),z)N({limitHit:V});else{W.flush(),x=null;let Y;Q&&!G&&(Y=w(Q))?B((0,T.serializeSearchError)(new T.SearchError(Y.message,Y.code))):N({limitHit:V})}})})}}e.RipgrepTextSearchEngine=A;function w(f){const b=f.split(`
`),d=b[0].trim();if(b.some(R=>R.startsWith("regex parse error")))return new T.SearchError(s(b),T.SearchErrorCode.regexParseError);const k=d.match(/grep config error: unknown encoding: (.*)/);if(k)return new T.SearchError(`Unknown encoding: ${k[1]}`,T.SearchErrorCode.unknownEncoding);if(d.startsWith("error parsing glob"))return new T.SearchError(d.charAt(0).toUpperCase()+d.substr(1),T.SearchErrorCode.globParseError);if(d.startsWith("the literal"))return new T.SearchError(d.charAt(0).toUpperCase()+d.substr(1),T.SearchErrorCode.invalidLiteral);if(d.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(d,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function s(f){const b=["Regex parse error"],d=f.filter(k=>k.startsWith("PCRE2:"));if(d.length>=1){const k=d[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const R=k.split(":")[1];b.push(":"+R)}}return b.join("")}e.buildRegexParseError=s;class o extends i.EventEmitter{constructor(b,d,k){super();this.maxResults=b,this.rootFolder=d,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,d){return super.on(b,d),this}handleData(b){if(this.isDone)return;const d=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(d)}handleDecodedData(b){let d=b.indexOf(`
`);const k=this.remainder+b;if(d>=0)d+=this.remainder.length;else{this.remainder=k;return}let R=0;for(;d>=0;)this.handleLine(k.substring(R,d).trim()),R=d+1,d=k.indexOf(`
`,R);this.remainder=k.substring(R)}handleLine(b){if(this.isDone||!b)return;let d;try{d=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(d.type==="match"){const k=g(d.data.path),R=L.URI.file(_.join(this.rootFolder,k)),N=this.createTextSearchMatch(d.data,R);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(d.type==="context"){const k=g(d.data.path),R=L.URI.file(_.join(this.rootFolder,k));this.createTextSearchContext(d.data,R).forEach(B=>this.onResult(B))}}createTextSearchMatch(b,d){const k=b.line_number-1,R=g(b.lines),N=Buffer.from(R);let B=0,F=0,U=k;b.submatches.length===0&&b.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const H=(0,C.coalesce)(b.submatches.map((x,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const W=g(x.match),z=N.slice(B,x.start).toString().length,O=F+z,V=a(W),K=U,G=V.numLines+K,Q=V.numLines>0?V.lastLineLength:V.lastLineLength+O;return B=x.end,F=Q,U=G,new l.Range(K,O,G,Q)}));return(0,p.createTextSearchResult)(d,R,H,this.previewOptions)}createTextSearchContext(b,d){const k=g(b.lines),R=b.line_number;return k.replace(/\r?\n$/,"").split(`
`).map((N,B)=>({text:N,uri:d,lineNumber:R+B}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=o;function g(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function a(f){const b=/\n/g;let d=0,k=-1,R;for(;R=b.exec(f);)d++,k=R.index;const N=k>=0?f.length-k-1:f.length;return{numLines:d,lastLineLength:N}}function S(f,b){const d=["--hidden"];d.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:R}=(0,P.groupBy)(b.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const B=new Set;R.forEach(F=>{B.add(F)}),d.push("-g","!*"),B.forEach(F=>{n(F).map(p.anchorGlob).forEach(U=>{d.push("-g",U)})})}k&&k.length&&k.forEach(B=>{d.push("-g",B)}),b.excludes.map(p.anchorGlob).forEach(B=>d.push("-g",`!${B}`)),b.maxFileSize&&d.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?d.push("--no-ignore-parent"):d.push("--no-ignore"),b.followSymlinks&&d.push("--follow"),b.encoding&&b.encoding!=="utf8"&&d.push("--encoding",b.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,I.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),b.usePCRE2&&d.push("--pcre2"),d.push("--crlf"),f.isRegExp&&(f.pattern=t(f.pattern),d.push("--auto-hybrid-regex"));let N;if(f.isWordMatch){const F=(0,I.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");d.push("--regexp",F)}else if(f.isRegExp){let B=u(f.pattern);B=c(B),d.push("--regexp",B)}else N=f.pattern,d.push("--fixed-strings");return d.push("--no-config"),b.useGlobalIgnoreFiles||d.push("--no-ignore-global"),d.push("--json"),f.isMultiline&&d.push("--multiline"),b.beforeContext&&d.push("--before-context",b.beforeContext+""),b.afterContext&&d.push("--after-context",b.afterContext+""),d.push("--"),N&&d.push(N),d.push("."),d}function n(f){const b=(0,D.splitGlobAware)(f,"/");return b.map((d,k)=>b.slice(0,k+1).join("/"))}e.spreadGlobComponents=n;function t(f){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(b);)f=f.replace(b,"$1\\x{$2}");const d=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(d);)f=f.replace(d,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=t;const r=f=>f.type==="Assertion"&&f.kind==="lookbehind";function u(f){let b;try{b=new E.RegExpParser().parsePattern(f)}catch{return f}let d="",k=0;const R=(F,U,H)=>{d+=f.slice(k,F)+H,k=U},N=[];return new E.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const U=N[0];if(!U)R(F.start,F.end,"\\r?\\n");else if(!N.some(r))if(U.type==="CharacterClass")if(U.negate){const H=f.slice(U.start+2,F.start)+f.slice(F.end,U.end-1);if(U.parent?.type==="Quantifier"){const x=U.parent;R(x.start,x.end,(H?`[^${H}]`:".")+(x.greedy?"+":"*"))}else R(U.start,U.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=f.slice(U.start+1,F.start)+f.slice(F.end,U.end-1);R(U.start,U.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else U.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){r(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(b),d+=f.slice(k),d}e.fixRegexNewline=u;function c(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(ve[281],we([0,1,21,136,117,10]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,L,T,l){const E=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===C.Schemas.userData){const h={...L,folder:L.folder.with({scheme:C.Schemas.file})},p=new y.Progress(v=>T.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(l,v=>E.provideTextSearchResults(I,h,p,v))}else return this.withToken(l,h=>E.provideTextSearchResults(I,L,T,h))}async withToken(I,L){const T=D(I);this.inProgress.add(T);const l=await L(T.token);return this.inProgress.delete(T),l}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=P;function D(_){const I=new m.CancellationTokenSource;return _.onCancellationRequested(()=>I.cancel()),I}}),define(ve[282],we([0,1,28,136,135]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,I,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(E){L({message:E})}},l=new y.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(T),m);return new Promise((E,h)=>l.search(p=>{I(p.map(P))},_).then(p=>E({limitHit:p.limitHit,type:"success",stats:p.stats}),h))}}e.TextSearchEngineAdapter=C;function P(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((_,I)=>{if(I.ranges){const L=I;return _+(Array.isArray(L.ranges)?L.ranges.length:1)}else return _+1},0)}}}),define(ve[283],we([0,1,16,18,15,3,100,9,46,2,42,33,280,282]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(o="searchProcess"){this.processType=o,this.caches=Object.create(null)}fileSearch(o){let g;const a=A(o),S=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(n=>this.doFileSearchWithEngine(l.Engine,a,t=>S.fire(t),n)),g.then(n=>S.fire(n),n=>S.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return S.event}textSearch(o){let g;const a=A(o),S=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(n=>this.ripgrepTextSearch(a,t=>S.fire(t),n)),g.then(n=>S.fire(n),n=>S.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return S.event}ripgrepTextSearch(o,g,a){return o.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(o).search(a,g,g)}doFileSearch(o,g,a){return this.doFileSearchWithEngine(l.Engine,o,g,a)}doFileSearchWithEngine(o,g,a,S,n=h.BATCH_SIZE){let t=0;const r=c=>{Array.isArray(c)?(t+=c.length,a(c.map(f=>this.rawMatchToSearchItem(f)))):c.relativePath?(t++,a(this.rawMatchToSearchItem(c))):a(c)};if(g.sortByScore){let c=this.trySortedSearchFromCache(g,r,S);if(!c){const f=g.maxResults?Object.assign({},g,{maxResults:null}):g,b=new o(f);c=this.doSortedSearch(b,g,a,r,S)}return new Promise((f,b)=>{c.then(([d,k])=>{const R=k.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(R,a,n),f(d)},b)})}const u=new o(g);return this.doSearch(u,r,n,S).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(o){return{path:o.base?(0,D.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,g,a,S,n){const t=new C.Emitter;let r=(0,i.createCancelablePromise)(c=>{let f=[];const b=d=>{Array.isArray(d)?f=d:(S(d),t.fire(d))};return this.doSearch(o,b,-1,c).then(d=>[d,f])}),u;if(g.cacheKey){u=this.getOrCreateCache(g.cacheKey);const c={promise:r,event:t.event,resolved:!1};u.resultsToSearchCache[g.filePattern||""]=c,r.then(()=>{c.resolved=!0},f=>{delete u.resultsToSearchCache[g.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([c,f])=>{const b=u?u.scorerCache:Object.create(null),d=(typeof g.maxResults!="number"||g.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(g,f,b,n).then(k=>{const R=d?d.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:k.length},messages:c.messages,limitHit:c.limitHit||typeof g.maxResults=="number"&&f.length>g.maxResults},k]})})}getOrCreateCache(o){const g=this.caches[o];return g||(this.caches[o]=new p)}trySortedSearchFromCache(o,g,a){const S=o.cacheKey&&this.caches[o.cacheKey];if(!S)return;const n=this.getResultsFromCache(S,o.filePattern||"",g,a);if(n)return n.then(([t,r,u])=>{const c=_.StopWatch.create(!1);return this.sortResults(o,r,S.scorerCache,a).then(f=>{const b=c.elapsed(),d={fromCache:!0,detailStats:u,type:this.processType,resultCount:r.length,sortingTime:b};return[{type:"success",limitHit:t.limitHit||typeof o.maxResults=="number"&&r.length>o.maxResults,stats:d},f]})})}sortResults(o,g,a,S){const n=(0,P.prepareQuery)(o.filePattern||""),t=(u,c)=>(0,P.compareItemsByFuzzyScore)(u,c,n,!0,v,a),r=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,r,1e4,S)}sendProgress(o,g,a){if(a&&a>0)for(let S=0;S<o.length;S+=a)g(o.slice(S,S+a));else g(o)}getResultsFromCache(o,g,a,S){const n=_.StopWatch.create(!1),t=g.indexOf(D.sep)>=0;let r;for(const b in o.resultsToSearchCache)if(g.startsWith(b)){if(t&&b.indexOf(D.sep)<0&&b!=="")continue;const d=o.resultsToSearchCache[b];r={promise:this.preventCancellation(d.promise),event:d.event,resolved:d.resolved};break}if(!r)return null;const u=n.elapsed(),c=_.StopWatch.create(!1),f=r.event(a);return S&&S.onCancellationRequested(()=>{f.dispose()}),r.promise.then(([b,d])=>{if(S&&S.isCancellationRequested)throw(0,y.canceled)();const k=[],R=(0,P.prepareQuery)(g).normalizedLowercase;for(const N of d)!(0,T.isFilePatternMatch)(N,R)||k.push(N);return[b,k,{cacheWasResolved:r.resolved,cacheLookupTime:u,cacheFilterTime:c.elapsed(),cacheEntryCount:d.length}]})}doSearch(o,g,a,S){return new Promise((n,t)=>{let r=[];S&&S.onCancellationRequested(()=>o.cancel()),o.search(u=>{u&&(a?(r.push(u),a>0&&r.length>=a&&(g(r),r=[])):g(u))},u=>{g(u)},(u,c)=>{r.length&&g(r),u?t(u):n(c)})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,a){return o.then(g,a)}catch(g){return this.then(void 0,g)}finally(g){return o.finally(g)}}}}e.SearchService=h,h.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(s){return(0,D.basename)(s.relativePath)}getItemDescription(s){return(0,D.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function A(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(w),extraFileResources:s.extraFileResources&&s.extraFileResources.map(o=>I.URI.revive(o))}}function w(s){return{...s,folder:I.URI.revive(s.folder)}}}),define(ve[284],we([0,1,6,10,2,28,11,26,14,72,64,33,283,281,92,135]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends I.ExtHostSearch{constructor(w,s,o,g){super(w,o,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new E.RipgrepSearchProvider(a)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const w=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new E.RipgrepSearchProvider(w)),this.registerInternalFileSearchProvider(i.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(w,s){const o=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(w,s,o,g){const a=(0,I.reviveQuery)(o);return w===this._internalFileSearchHandle?this.doInternalFileSearch(w,s,a,g):super.$provideFileSearchResults(w,s,o,g)}doInternalFileSearch(w,s,o,g){const a=S=>{if((0,T.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(w,s,S.map(n=>y.URI.file(n.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,a,g)}$clearCache(w){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(w),super.$clearCache(w)}createTextSearchManager(w,s){return new p.NativeTextSearchManager(w,s,void 0,"textSearchProvider")}};v=je([ze(0,_.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,L.IURITransformerService),ze(3,P.ILogService)],v),e.NativeExtHostSearch=v}),define(ve[137],we([0,1,296,124,81,22,15,3,6,9,12,32,105,106,297]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(d,k=""){this.debugLabel=k,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,P.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener)}traceSocketEvent(d,k){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,k)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const k=R=>{this.traceSocketEvent("read",R),d(C.VSBuffer.wrap(R))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(d){const k=R=>{this.traceSocketEvent("close",{hadError:R}),d({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(d){const k=()=>{this.traceSocketEvent("nodeEndReceived"),d()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(d){if(!this.socket.destroyed)try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=p;var v;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var A;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(A||(A={}));class w extends _.Disposable{constructor(d,k,R,N){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:R?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new s(this,k,R,N,this._onData,(B,F)=>this._write(B,F))),this._register(this._flowManager.onError(B=>{console.error(B),(0,P.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,k){this.socket.traceSocketEvent(d,k)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._flowManager.writeMessage(d)}_write(d,k){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let R=2;d.byteLength<126?R+=0:d.byteLength<2**16?R+=2:R+=8;const N=C.VSBuffer.alloc(R);if(k?N.writeUInt8(194,0):N.writeUInt8(130,0),d.byteLength<126)N.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){N.writeUInt8(126,1);let B=1;N.writeUInt8(d.byteLength>>>8&255,++B),N.writeUInt8(d.byteLength>>>0&255,++B)}else{N.writeUInt8(127,1);let B=1;N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(d.byteLength>>>24&255,++B),N.writeUInt8(d.byteLength>>>16&255,++B),N.writeUInt8(d.byteLength>>>8&255,++B),N.writeUInt8(d.byteLength>>>0&255,++B)}this.socket.write(C.VSBuffer.concat([N,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),N=(R&128)>>>7,B=(R&64)>>>6,F=k.readUInt8(1),U=(F&128)>>>7,H=F&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),N=(R&128)>>>7;let B=R&127,F=1;B===126?B=k.readUInt8(++F)*2**8+k.readUInt8(++F):B===127&&(B=k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F));let U=0;N&&(U=k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F)),this._state.state=3,this._state.readLen=B,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),a(k,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(k,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class s extends _.Disposable{constructor(d,k,R,N,B,F){super();this._tracer=d,this._onData=B,this._writeFn=F,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,k?(this._zlibInflateStream=this._register(new o(this._tracer,N,R,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(d){this._writeQueue.push(d),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const d=this._writeQueue.shift();if(this._zlibDeflateStream){const k=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(k,!0)}else this._writeFn(d,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,k){return new Promise((R,N)=>{d.write(k),d.flush(B=>R(B))})}acceptFrame(d,k,R){this._readQueue.push({data:d,isCompressed:k,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const k=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(k)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1}}_inflateFrame(d,k,R){return new Promise((N,B)=>{d.write(k),R&&d.write(C.VSBuffer.fromByteArray([0,0,255,255])),d.flush(F=>N(F))})}}class o extends _.Disposable{constructor(d,k,R,N){super();this._tracer=d,this._recordInflateBytes=k,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(C.VSBuffer.wrap(B))}),R&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const k=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(k)})}}class g extends _.Disposable{constructor(d,k){super();this._tracer=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent("zlibDeflateData",R),this._pendingDeflateData.push(C.VSBuffer.wrap(R))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let k=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.byteLength-4),d(k)})}}function a(b,d){if(d===0)return;let k=b.byteLength>>>2;for(let H=0;H<k;H++){const x=b.readUInt32BE(H*4);b.writeUInt32BE(x^d,H*4)}let R=k*4,N=b.byteLength-R;const B=d>>>24&255,F=d>>>16&255,U=d>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(R)^B,R),N>=2&&b.writeUInt8(b.readUInt8(R+1)^F,R+1),N>=3&&b.writeUInt8(b.readUInt8(R+2)^U,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function n(){const b=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${b}.sock`):d=(0,I.join)((0,y.tmpdir)(),`vscode-ipc-${b}.sock`),r(d),d}e.createRandomIPCHandle=n;function t(b,d,k){const R=(0,m.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${d}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${d}.sock`):N=(0,I.join)(b,`${k}-${d}.sock`),r(N),N}e.createStaticIPCHandle=t;function r(b){const d=S[L.platform];typeof d=="number"&&b.length>=d&&console.warn(`WARNING: IPC handle "${b}" is longer than ${d} chars, try a shorter --user-data-dir`)}class u extends l.IPCServer{constructor(d){super(u.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const k=D.Event.fromNodeEventEmitter(d,"connection");return D.Event.map(k,R=>({protocol:new E.Protocol(new p(R,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function c(b){return new Promise((d,k)=>{const R=(0,i.createServer)();R.on("error",k),R.listen(b,()=>{R.removeListener("error",k),d(new u(R))})})}e.serve=c;function f(b,d){return new Promise((k,R)=>{const N=(0,i.createConnection)(b,()=>{N.removeListener("error",R),k(E.Client.fromSocket(new p(N,`ipc-client${d}`),d))});N.once("error",R)})}e.connect=f}),define(ve[285],we([0,1,137,277,60,38,2,197,11]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(l,E,h){this._commands=l,this.logService=E,this._ipcHandlePath=h,this._server=i.createServer((p,v)=>this.onRequest(p,v)),this.setup().catch(p=>(E.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,E){const h=[];l.setEncoding("utf8"),l.on("data",p=>h.push(p)),l.on("end",()=>{const p=JSON.parse(h.join(""));switch(p.type){case"open":this.open(p,E);break;case"openExternal":this.openExternal(p,E);break;case"status":this.getStatus(p,E);break;case"extensionManagement":this.manageExtensions(p,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${p.type}`,v=>{v&&this.logService.error(v)}),E.end();break}})}open(l,E){const{fileURIs:h,folderURIs:p,forceNewWindow:v,diffMode:A,addMode:w,forceReuseWindow:s,gotoLineMode:o,waitMarkerFilePath:g,remoteAuthority:a}=l,S=[];if(Array.isArray(p))for(const u of p)try{S.push({folderUri:P.URI.parse(u)})}catch{}if(Array.isArray(h))for(const u of h)try{(0,D.hasWorkspaceFileExtension)(u)?S.push({workspaceUri:P.URI.parse(u)}):S.push({fileUri:P.URI.parse(u)})}catch{}const n=g?P.URI.file(g):void 0,r={forceNewWindow:v,diffMode:A,addMode:w,gotoLineMode:o,forceReuseWindow:s,preferNewWindow:!s&&!n&&!w,waitMarkerFileURI:n,remoteAuthority:a};this._commands.executeCommand("_remoteCLI.windowOpen",S,r),E.writeHead(200),E.end()}async openExternal(l,E){for(const h of l.uris){const p=P.URI.parse(h),v=p.scheme==="file"?p:h;await this._commands.executeCommand("_remoteCLI.openExternal",v)}E.writeHead(200),E.end()}async manageExtensions(l,E){try{const h=A=>A?.map(w=>/\.vsix$/i.test(w)?P.URI.parse(w):w),p={list:l.list,install:h(l.install),uninstall:h(l.uninstall),force:l.force},v=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);E.writeHead(200),E.write(v)}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)})}E.end()}async getStatus(l,E){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(h),E.end()}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let L=class extends I{constructor(l,E){super(l,E,(0,m.createRandomIPCHandle)())}};L=je([ze(0,C.IExtHostCommands),ze(1,_.ILogService)],L),e.CLIServer=L}),define(ve[286],we([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const A=this,w=J.__$__nodeRequire("module"),s=w._load;w._load=function(g,a,S){for(let n of A._alternatives){let t=n(g);if(t){g=t;break}}return A._factories.has(g)?A._factories.get(g).load(g,I.URI.file((0,E.realpathSync)(a.filename)),n=>s.apply(this,[n,a,S])):s.apply(this,arguments)}}}class p extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(h,A,this._registry).install(),m.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const o=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?o.apply(process,a):(g.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,w,s){if(w.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();try{A&&m.mark(`code/extHost/willLoadExtensionCode/${A.value}`),o=J.__$__nodeRequire(w.fsPath)}catch(g){return Promise.reject(g)}finally{A&&m.mark(`code/extHost/didLoadExtensionCode/${A.value}`),s.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const w in A){const s=A[w];s===null?delete process.env[w]:process.env[w]=s}}}e.ExtHostExtensionService=p}),define(ve[287],we([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService),(0,m.registerSingleton)(w.ILoggerService,A.ExtHostLoggerService),(0,m.registerSingleton)(p.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,m.registerSingleton)(I.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(T.IExtHostSearch,P.NativeExtHostSearch),(0,m.registerSingleton)(l.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(E.IExtHostTerminalService,i.ExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,_.ExtHostTunnelService)}),define(ve[288],we([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(J,e,m,i,y,C,P,D,_,I,L,T,l,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const A=i(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=J.__$__nodeRequire("module"),r=t._load;t._load=function(u){if(u==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function s(t){process.exit=function(r){if(t)w(r);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let o=function(t){w()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,r)=>{let u=null,c=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,b=3e5,d=new p.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),f),k=new p.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),b);process.on("message",(N,B)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=T.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let U;if(N.skipWebSocketFrames)U=new D.NodeSocket(B,"extHost-socket");else{const H=T.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));U=new D.WebSocketNodeSocket(new D.NodeSocket(B,"extHost-socket"),N.permessageDeflate,H,!1)}u?(d.cancel(),k.cancel(),u.beginAcceptReconnection(U,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(c),u=new P.PersistentProtocol(U,F),u.sendResume(),u.onDidDispose(()=>o("renderer disconnected")),t(u),u.onSocketClose(()=>{d.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(k.isScheduled())return;d.isScheduled()&&k.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,u)=>{const c=m.createConnection(t,()=>{c.removeListener("error",u),r(new P.PersistentProtocol(new D.NodeSocket(c,"extHost-renderer")))});c.once("error",u),c.on("close",()=>{o("renderer closed the socket")})})}}async function a(){const t=await g();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(r=>{(0,I.isMessageOfType)(r,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||t.send(r)}drain(){return t.drain()}}}function S(t){return new Promise(r=>{const u=t.onMessage(c=>{u.dispose();const f=JSON.parse(c.toString()),b=f.commit,d=_.default.commit;b&&d&&b!==d&&w(55);let k=0;setInterval(function(){try{process.kill(f.parentPid,0),k=0}catch(N){N&&N.code==="EPERM"?(k++,k>=3&&o(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):o(`parent process ${f.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let R;try{R=J.__$__nodeRequire("native-watchdog"),R.start(f.parentPid)}catch(N){(0,C.onUnexpectedError)(N)}t.send((0,I.createMessageOfType)(0)),r({protocol:t,initData:f})});t.send((0,I.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(k,R)=>{t.push(R),setTimeout(()=>{const N=t.indexOf(R);N>=0&&R.catch(B=>{t.splice(N,1),(0,C.isPromiseCanceledError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),k&&(0,C.onUnexpectedError)(k))})},1e3)}),process.on("rejectionHandled",k=>{const R=t.indexOf(k);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(k){(0,C.onUnexpectedError)(k)}),y.mark("code/extHost/willConnectToRenderer");const r=await a();y.mark("code/extHost/didConnectToRenderer");const u=await S(r);y.mark("code/extHost/didWaitForInitData");const{initData:c}=u;s(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,v.boolean)(A.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(R){w(R)}exists(R){return E.Promises.exists(R)}realpath(R){return(0,h.realpath)(R)}};let b=null;if(c.remote.authority&&A.uriTransformerPath)try{const R=J.__$__nodeRequire(A.uriTransformerPath)(c.remote.authority);b=new l.URITransformer(R)}catch(k){console.error(k)}const d=new L.ExtensionHostMain(u.protocol,c,f,b);o=k=>d.terminate(k)}e.startExtensionHostProcess=n}),define(ve[299],we([0,1,288]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f67a8b753f55e452f38b61497662839c4691fb12/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
